CREATE OR REPLACE FUNCTION create_or_drop_majetek_changes_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE mdannakl IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mdanodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mleasing IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mmajetek IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msazby IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE msplatkal IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypleas IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mtypmaj IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mucetodpisy IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mudalosti IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mumisteni IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE mzapujcky IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER mdannaklchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mdannakl FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mdanodpisychanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mdanodpisy FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mleasingchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mleasing FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mmajetekchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mmajetek FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER msazbychanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON msazby FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER msplatkalchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON msplatkal FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mtypleaschanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mtypleas FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mtypmajchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mtypmaj FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mucetodpisychanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mucetodpisy FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mudalostichanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mudalosti FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mumistenichanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mumisteni FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER mzapujckychanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON mzapujcky FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

  ELSE
    DROP TRIGGER IF EXISTS mdannaklchanges ON mdannakl;
    DROP TRIGGER IF EXISTS mdannaklextidsaver ON mdannakl;
    DROP TRIGGER IF EXISTS mdanodpisychanges ON mdanodpisy;
    DROP TRIGGER IF EXISTS mdanodpisyextidsaver ON mdanodpisy;
    DROP TRIGGER IF EXISTS mleasingchanges ON mleasing;
    DROP TRIGGER IF EXISTS mleasingextidsaver ON mleasing;
    DROP TRIGGER IF EXISTS mmajetekchanges ON mmajetek;
    DROP TRIGGER IF EXISTS mmajetekextidsaver ON mmajetek;
    DROP TRIGGER IF EXISTS msazbychanges ON msazby;
    DROP TRIGGER IF EXISTS msazbyextidsaver ON msazby;
    DROP TRIGGER IF EXISTS msplatkalchanges ON msplatkal;
    DROP TRIGGER IF EXISTS msplatkalextidsaver ON msplatkal;
    DROP TRIGGER IF EXISTS mtypleaschanges ON mtypleas;
    DROP TRIGGER IF EXISTS mtypleasextidsaver ON mtypleas;
    DROP TRIGGER IF EXISTS mtypmajchanges ON mtypmaj;
    DROP TRIGGER IF EXISTS mtypmajextidsaver ON mtypmaj;
    DROP TRIGGER IF EXISTS mucetodpisychanges ON mucetodpisy;
    DROP TRIGGER IF EXISTS mucetodpisyextidsaver ON mucetodpisy;
    DROP TRIGGER IF EXISTS mudalostichanges ON mudalosti;
    DROP TRIGGER IF EXISTS mudalostiextidsaver ON mudalosti;
    DROP TRIGGER IF EXISTS mumistenichanges ON mumisteni;
    DROP TRIGGER IF EXISTS mumisteniextidsaver ON mumisteni;
    DROP TRIGGER IF EXISTS mzapujckychanges ON mzapujcky;
    DROP TRIGGER IF EXISTS mzapujckyextidsaver ON mzapujcky;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
