CREATE OR REPLACE FUNCTION create_or_drop_mzdy_changes_triggers(docreate boolean)
  RETURNS void AS
$BODY$
BEGIN
  -- Na nektere z tabulek muze byt uvalen zamek (napr. typu AccessShareLock)
  LOCK TABLE pcismzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pdite IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pmzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pmzdvazbazav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pnepritomnost IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE posoba IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE posobahlav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE ppracpom IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE ppracpomhlav IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pskuposob IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE psmeny IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE psrazka IN ACCESS EXCLUSIVE MODE NOWAIT;
  LOCK TABLE pstalamzdsloz IN ACCESS EXCLUSIVE MODE NOWAIT;
  
  IF docreate THEN
    CREATE TRIGGER pcismzdslozchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pcismzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pditechanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pdite FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pmzdslozchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pmzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pmzdvazbazavchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pmzdvazbazav FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pnepritomnostchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pnepritomnost FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER posobachanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON posoba FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER posobahlavchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON posobahlav FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER ppracpomchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON ppracpom FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER ppracpomhlavchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON ppracpomhlav FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pskuposobchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pskuposob FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER psmenychanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON psmeny FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER psrazkachanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON psrazka FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

    CREATE TRIGGER pstalamzdslozchanges
        BEFORE UPDATE OR INSERT OR DELETE
        ON pstalamzdsloz FOR EACH ROW
        EXECUTE PROCEDURE logchanges();

  ELSE
    DROP TRIGGER IF EXISTS pcismzdslozchanges ON pcismzdsloz;
    DROP TRIGGER IF EXISTS pcismzdslozextidsaver ON pcismzdsloz;
    DROP TRIGGER IF EXISTS pditechanges ON pdite;
    DROP TRIGGER IF EXISTS pditeextidsaver ON pdite;
    DROP TRIGGER IF EXISTS pmzdslozchanges ON pmzdsloz;
    DROP TRIGGER IF EXISTS pmzdslozextidsaver ON pmzdsloz;
    DROP TRIGGER IF EXISTS pmzdvazbazavchanges ON pmzdvazbazav;
    DROP TRIGGER IF EXISTS pmzdvazbazavextidsaver ON pmzdvazbazav;
    DROP TRIGGER IF EXISTS pnepritomnostchanges ON pnepritomnost;
    DROP TRIGGER IF EXISTS pnepritomnostextidsaver ON pnepritomnost;
    DROP TRIGGER IF EXISTS posobachanges ON posoba;
    DROP TRIGGER IF EXISTS posobaextidsaver ON posoba;
    DROP TRIGGER IF EXISTS posobahlavchanges ON posobahlav;
    DROP TRIGGER IF EXISTS posobahlavextidsaver ON posobahlav;
    DROP TRIGGER IF EXISTS ppracpomchanges ON ppracpom;
    DROP TRIGGER IF EXISTS ppracpomextidsaver ON ppracpom;
    DROP TRIGGER IF EXISTS ppracpomhlavchanges ON ppracpomhlav;
    DROP TRIGGER IF EXISTS ppracpomhlavextidsaver ON ppracpomhlav;
    DROP TRIGGER IF EXISTS pskuposobchanges ON pskuposob;
    DROP TRIGGER IF EXISTS pskuposobextidsaver ON pskuposob;
    DROP TRIGGER IF EXISTS psmenychanges ON psmeny;
    DROP TRIGGER IF EXISTS psmenyextidsaver ON psmeny;
    DROP TRIGGER IF EXISTS psrazkachanges ON psrazka;
    DROP TRIGGER IF EXISTS psrazkaextidsaver ON psrazka;
    DROP TRIGGER IF EXISTS pstalamzdslozchanges ON pstalamzdsloz;
    DROP TRIGGER IF EXISTS pstalamzdslozextidsaver ON pstalamzdsloz;
  END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;
