-- Vytvořeno pomocí IntrastatCZSqlGenerator
create or replace function runupgrade()
    returns void as $$
declare
    jednotky integer[];
begin

    ALTER TABLE iobchtrans DISABLE TRIGGER USER;

    INSERT INTO iobchtrans(kod, nazev, nazeva, platiod, platido) VALUES
    ('1', 'Transakce zahrnující skutečné nebo zamýšlené převody vlastnictví za protiplnění (finanční nebo jiné) - kromě obchodních operací označených kódy 2,7 a 8', 'Transactions involving actual or intended transfer of ownership against compensation (financial or otherwise) (except the transactions listed under 2, 7 and 8)', 2005, 2008),
    ('11', 'Transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění, s výjimkou transakcí patřících pod kódy začínající číslem 2, 7, 8 nebo 9, jedná-li se o přímý prodej nebo nákup jiný než označovaný kódy 12 a', 'Transaction involving actual or intended transfer of ownership against compensation (financial or otherwise), except the transactions listed under number 2,7,8 or 9, if transaction is outright purchase/sale other than marked under codes 12-', 2009, 2999),
    ('12', 'Transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění, s výjimkou transakcí patřících pod kódy začínající číslem  2, 7, 8 nebo 9, jedná-li se o dodávku pro prodej po schválení či po vyzkoušení neb', 'Transaction involving actual or intended transfer of ownership against compensation (financial or otherwise), except the transactions listed under number 2,7,8 or 9, if transaction is supply for sale on approval or after trial for consignme', 2009, 2999),
    ('13', 'Transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění, s výjimkou transakcí patřících pod kódy začínající číslicí 2, 7, 8 nebo 9, jedná-li se o výměnný obchod (například barterový)', 'Transaction involving actual or intended transfer of ownership against compensation (financial or otherwise), except the transactions listed under number 2, 7, 8 or 9, if transaction is barter trade (compensation in kind)', 2009, 2999),
    ('14', 'Transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění, s výjimkou transakcí patřících pod kódy začínající číslem 2, 7, 8 nebo 9, jedná-li se o finanční leasing (prodej či nákup na splátky)', 'Transaction involving actual or intended transfer of ownership against compensation financial or otherwise, except the transaction beginning with number 2,7,8 or 9, provided it is a financial leasing (hire-purchase).', 2009, 2999),
    ('15', 'Transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění, s výjimkou transakcí patřících pod kódy začínající číslem 2, 7, 8 nebo 9,  jedná-li se o finanční leasing  (prodej či nákup na splátky).', 'Transaction involving actual or intended transfer of ownership against compensation (financial or otherwise), except the transactions listed under number 2,7,8 or 9, if transaction is financial leasing (sale or purchase on part payment)', 2009, 2010),
    ('19', 'Ostatní transakce zahrnující skutečný nebo zamýšlený převod vlastnictví za finanční nebo jiné protiplnění neoznačované kódy 11 až 14, s výjimkou transakcí patřících pod kódy začínající číslem 2, 7, 8 nebo 9 (například odeslání zboží prodané', 'Other transaction involving actual or intended transfer of ownership against financial or other compensation not marked under the codes 11 to 14, except the transaction listed under codes belonging under the codes 2,7,8 or 9 (e.g.dispatch o', 2011, 2999),
    ('2', 'Vrácení zboží z původní transakce označené kódem 1, náhrada zboží zdarma, bezplatná výměna zboží', 'Return of goods after registration of the original transaction under code 1; replacement of goods free of charge', 2005, 2008),
    ('21', 'Vrácení zboží, jehož předchozí odeslání nebo přijetí se označuje kódem  povahy transakce začínajícím číslicí "1"', 'Return of goods, which preceding dispatch or arrival, is marked under code nature of transaction beginning by figure "1"', 2009, 2999),
    ('22', 'Bezplatná náhrada za vrácené zboží, jehož předchozí odeslání nebo přijetí se označuje kódem povahy transakce začínajícím číslem "1"', 'Free of charge replacement for returned goods, which preceding dispatch or arrival, is marked under code nature of transaction beginning by figure "1"', 2009, 2999),
    ('23', 'Bezplatná náhrada za nevrácené zboží (například při reklamaci), jehož předchozí odeslání nebo přijetí se označuje kódem povahy transakce začínajícím číslem "1"', 'Free of charge replacement for not returned goods (e.g. by complaint), which preceding dispatch or arrival, is marked under code nature of transaction beginning  by figure "1"', 2009, 2999),
    ('29', 'Vrácení zboží, jehož předchozí odeslání nebo přijetí se označuje kódem povahy transakce „91“', 'Return of goods, which previous dispatch or arrival was marked under nature of transaction "91".', 2011, 2999),
    ('3', 'Transakce, které nejsou přechodné povahy (nejedná se o dočasné přijetí/odeslání zboží), zahrnující převod vlastnictví zboží bez finančního nebo jiného protiplnění (bezúplatné přijetí/odeslání s převodem vlastnických práv)', 'Transactions (not temporary) involving transfer of ownership but without compensation (financial or other)', 2005, 2008),
    ('30', 'Transakce zahrnující převod vlastnictví zboží bez finančního či jiného protiplnění (například zásilky s pomocí)', 'Transaction involving transfer of ownership without financial or in kind of compensation (e.g. aid shipment)', 2011, 2999),
    ('31', 'Transakce  zahrnující  převod  vlastnictví zboží bez protiplnění, pokud je zboží dodávané v rámci podpůrných programů uskutečňovaných nebo financovaných částečně anebo úplně Společenstvím', 'Transaction involving transfer of ownership but without compensation, when goods is delivered under programmes or financed partly or wholly by the European Community', 2009, 2010),
    ('32', 'Transakce zahrnující převod vlastnictví zboží bez protiplnění, jedná-li se o dodávky veřejné vládní pomoci, jiné než uskutečňované a financované Společenstvím.', 'Transaction involving transfer of ownership but without compensation, when shipment of public governmental aid is other than accomplished and financed by Community', 2009, 2010),
    ('33', 'Transakce zahrnující převod vlastnictví zboží bez protiplnění, jedná-li se o dodávky pomoci jednotlivých osob a nevládních organizací.', 'Transaction involving transfer of ownership but without compensation in case aid shipment of individual person or non-governmental organisation', 2009, 2010),
    ('34', 'Ostatní transakce zahrnující převod vlastnictví bez protiplnění', 'Other transaction involving transfer of ownership without compensation', 2009, 2010),
    ('4', 'Transakce, kromě těch, které se označují kódem 7, jejichž účelem je zprac. na základě smluvního vztahu (přijetí/odeslání zboží k provedení zprac. operací podle smlouvy o akt./pas. zušlechtění), při kterých zprac. operací není oprava nebo úd', 'Operations with a view to processing under contract (except those recorded under 7)', 2005, 2008),
    ('40', 'Dočasný vývoz, odeslání, dovoz nebo přijetí zboží za účelem jeho zpracování podle  smlouvy (pasivního nebo aktivního zušlechtění) a následného zpětného dovozu, přijetí, vývozu nebo odeslání ve formě výrobku, který prošel zpracovatelskou ope', 'Temporary export, dispatch, import or arrival goods with a view to processing under contract (inward or outward processing) and subsequent import, arrival, export or dispatch in shape of product, which undertake processing operation with ex', 2009, 2010),
    ('41', 'Dočasné odeslání nebo přijetí zboží za účelem jeho zpracování dle smlouvy (bez převodu vlastnictví na zpracovatele), pokud se má po zpracování vrátit zpět do České republiky nebo do členského státu  Evropské unie, ze kterého bylo ke zpracov', 'Goods dispatched or arrived temporarily for processing under contract (without transfer ownership to the processor), in case of  their subsequently return back to the Czech republic or to the Member State of European union, from which arriv', 2011, 2999),
    ('42', 'Dočasné přijetí zboží za účelem jeho zpracování dle smlouvy (bez převodu vlastnictví na zpracovatele), pokud se nemá po zpracování vrátit zpět do členského státu  Evropské unie, ze kterého bylo ke zpracování poprvé přijato', 'Goods arrived temporarily for the processing under contract  (without transfer of ownership to the processor), in case that they after processing didn''t return to the initial state of European union', 2009, 2999),
    ('49', 'Vrácení zboží, které bylo odeslané nebo přijaté za účelem jeho zpracování dle smlouvy (bez převodu vlastnictví na zpracovatele), a neprošlo žádnou zpracovatelskou operací', 'Returned goods, which were dispatched or arrived for the processing under the contract (without transfer of ownership to the processor) and have not gone through any processing operation', 2011, 2999),
    ('5', 'Transakce prováděné po zpracování podle smlouvy, kterým nebyla oprava nebo údržba zboží ani operace označená kódem 7 (přijetí/odeslání zboží po jeho pas./akt. zušlechtění, při kterém zpracovatelskou operací nebyla oprava nebo údržba)', 'Operations following processing under contract (except those recorded under 7)', 2005, 2008),
    ('50', 'Zpětný dovoz, přijetí, vývoz  nebo odeslání zboží po jeho zpracování podle smlouvy (po  pasivním nebo aktivním zušlechtění), následující po transakci označené kódem 40, s výjimkou transakcí patřících pod kód 70', 'Return import, arrival, export or dispatch of goods after their processing under contract (after outward or inward processing) come after transaction marked by code 40, with exception transaction under code 70', 2009, 2010),
    ('51', 'Zpětné odeslání zboží po jeho zpracování dle smlouvy do členského státu Evropské unie, ze kterého bylo ke zpracování přijato, a  zpětné přijetí zboží po jeho zpracování dle smlouvy z členského státu Evropské unie, do kterého bylo ke zpracov', 'Reacceptance of goods after their processing under contract to Member State of European Union, from which was arrived for processing and reacceptance of goods after their processing under contract from the Member State, to which were from t', 2011, 2999),
    ('52', 'Zpětné odeslání zboží po jeho zpracování dle smlouvy do členského státu Evropské unie, ze kterého nebylo ke zpracování přijato, a  zpětné přijetí zboží po jeho zpracování dle smlouvy z členského státu Evropské unie, do kterého nebylo ke zpr', 'Return dispatch of goods after their processing under contract into Member State of European Union, from which did not be arrived for processing and return arrival of goods after their processing under contract from Member State of European', 2009, 2999),
    ('59', 'Vrácení zboží zpět přijatého nebo zpět odeslaného po provedení jedné nebo více zpracovatelských operací při jeho zpracování podle smlouvy', 'Return of goods arrived or back dispatched after carrying out one or more processing operations by their processing under contract', 2011, 2999),
    ('6', 'Transakce nezahrnující převod vlastnictví, například pronájem, výpůjčka,operační leasing a ost. dočasná použití, kromě zpracování,oprav nebo údržby zboží podle smlouvy, to je kromě přijetí/odeslání zboží k/po akt. zušlechtění nebo po/k pasi', 'not available', 2005, 2005),
    ('7', 'Transakce podle společných obranných projektů nebo jiných společných mezivládních výrobních programů (např. Airbus)', 'not available', 2005, 2005),
    ('70', 'Odeslání a  přijetí zboží podle projektů společné obrany či jiných společných mezivládních výrobních programů', 'Dispatch or arrival of goods under joint defence project or other joint intergovernmental production programmes', 2009, 2999),
    ('8', 'Dodávka stavebních materiálů a zařízení pro práce, které jsou součástí obecné stavební nebo inženýrské smlouvy (všeobecné dodavatelské smlouvy)', 'Supply of building materials and equipment for works that are part of a general construction or engineering contract', 2005, 2008),
    ('80', 'Dodávky stavebních materiálů a technického zařízení pro práce pozemního a inženýrského stavitelství v rámci všeobecné dodavatelské smlouvy, které nevyžadují vystavení faktury za jednotlivé položky smlouvy, ale za její celek', 'Transaction involving the supply of building materials and technical equipment under a general construction or civil engineering contract for which no separate invoicing of the goods is required and an invoice for the total contract is issu', 2009, 2999),
    ('82', 'Vrácení zboží, které bylo přijato nebo odesláno v rámci dodávky stavebních materiálů a inženýrského stavitelství v rámci všeobecné dodavatelské smlouvy, které nevyžadují vystavení faktury za jednotlivé položky smlouvy, ale za její celek', 'Return of goods received or dispatched with respect to supply of building materials and equipment for works making a part of general construction or engineering contracts for which no separate invoicing of the goods is required and an invoi', 2009, 2999),
    ('83', 'Odeslání nebo přijetí zboží dodávaného náhradou za původně odeslané nebo přijaté zboží označené kódem povahy transakce "80"', 'Dispatch or arrival of the goods which was supplied as replacement of originally dispatched or arrived marked by code nature of transaction "80"', 2009, 2999),
    ('9', 'Ostatní obchodní operace (transakce)', 'Other transactions', 2005, 2008),
    ('91', 'Odeslání zboží vyváženého zpravodajskou jednotkou mimo území Evropské unie, které není propouštěno do vývozního celního režimu v České republice, ale v jiném členském státě Evropské unie cestou k výstupnímu celnímu úřadu. Přijetí zboží dová', 'Dispatch of goods exported by PSI outside European union, which are not put to the custom regime free circulation in the Czech Republic, but in different European union Member State on the way to an exit custom office. Arrival of goods impo', 2009, 2999),
    ('92', 'Odeslání nebo přijetí vlastního majetku přemísťovaného do jiného členského státu Evropské unie nebo z takového státu jednou osobou registrovanou k dani z přidané hodnoty ve státě určení i odeslání', 'Dispatch or arrival of own property transferred into different European union Member State or from such state by the person registered for VAT purposes in both states (destination and dispatch)', 2009, 2999),
    ('93', 'Odeslání nebo přijetí zboží  v souvislosti s jeho prodejem nebo nákupem za finanční nebo jiné protiplnění mezi ovládající a ovládanou osobou nebo osobami  majetkově provázanými, při kterém dochází k převodu vlastnictví.', 'Dispatch or arrival of goods in connection with their sell or purchase against compensation (financial or otherwise) between ascendant and controlled person or persons connected by property, in case of property transfer', 2009, 2010),
    ('94', 'Odeslání nebo přijetí částí nebo součástí  zboží, které jeho vlastník dodává osobě, od níž následně nakoupí zboží, při jehož výrobě požaduje použití těchto částí nebo součástí', 'Dispatch or arrival parts or components of goods, which owner dispatches to person, from which subsequently buy the goods by which production requests usage these parts or components', 2009, 2999),
    ('95', 'Odeslání a přijetí zboží nakoupeného zpravodajskou jednotkou v jednom členském státě Společenství za účelem prodeje do druhého takového státu, do kterého je  dopravováno přes území České republiky, kde je přiznáváno zvlášť k dani z přidané', 'Dispatch or arrival goods bought by PSI in one Community Member State for purpose of sell to the second such state, to which is transported through territory of the Czech Republic, where are declare separately to VAT as the goods acquired i', 2009, 2010),
    ('96', 'Dočasné odeslání nebo přijetí zboží, při kterém nedochází ke změně vlastnictví, je spojeno s poskytnutím náhrady  a  předpokládaná doba zpětného přijetí nebo odeslání zboží přesahuje 24 měsíců, přičemž se neoznačuje kódem 41, 42 nebo 70 (ze', 'Temporary dispatch or arrival goods, by which no transfer of ownership occurred, is connected with rendition of replacement and presumed time of back arrival or dispatch of goods exceed 24 months, not marked codes 40 or 70 (especially tempo', 2009, 2999),
    ('97', 'Dočasné odeslání nebo přijetí zboží, při kterém nedochází ke změně  vlastnictví, není spojeno s poskytnutím náhrady a předpokládaná doba zpětného přijetí nebo odeslání zboží přesahuje 24 měsíců, přičemž se  neoznačuje kódem 41, 42 nebo 70 (', 'Temporary dispatch or arrival goods, which is not connected with rendition of replacement and presumed time of back arrival or dispatch of goods exceed 24 months, not marked codes 41, 42 or 70 (especially temporary hire free of charge)', 2009, 2999),
    ('99', 'Ostatní transakce, které nelze označit některým z výše uvedených kódů', 'Other transaction, which nor possible to mark some above mentioned codes', 2009, 2999);

    ALTER TABLE iobchtrans ENABLE TRIGGER USER;

end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();
