/*
  Při mazání dokladu provede vrácení čísla tak, aby nedošlo k narušení kontinuity dokladové řady.
  Pokud se jedná o doklad na vrchodu dokladové řady, je číslo zahozeno a čítač řady je snížen
  o jedničku. V opačném případě je číslo uloženo do seznamu děr, odkud je nabízeno.  

  Autor: Pavel Cvrček
*/

create or replace function dDoklDelete() returns trigger as $$
declare
  _idUcetObdobi integer;
  _navratHodnota boolean;
begin
  /* !!! Důležité !!! Podmínka na následující řádce nutná kvůli importu z W6 na W10. */
  if (OLD.idRady is not null and OLD.idPolRady is not null) then
    /* Podle idPolRady na dokladu vyhledej příslušné účetní období */
    select idUcetobdobi into _idUcetObdobi from dRadyRok where idRadyRok = OLD.idPolRady limit 1;
    if (_idUcetObdobi is not null) then
      _navratHodnota:= (select dVratCisDokl (OLD.idRady, _idUcetObdobi, OLD.kod));
    else
      raise exception 'dDoklDelete(): Nebylo nalezeno platné účetní období pro datum zaúčtování.';
    end if;
  end if;

  return OLD;
end;
$$ LANGUAGE plpgsql;


drop trigger if exists dDoklFakDelete on ddoklfak;
drop trigger if exists dDoklIntDelete on ddoklint;
drop trigger if exists dDoklSkladDelete on ddoklsklad;

create trigger dDoklFakDelete before delete on ddoklfak 
for each row execute procedure dDoklDelete();

create trigger dDoklIntDelete before delete on ddoklint
for each row execute procedure dDoklDelete();

create trigger dDoklSkladDelete before delete on ddoklsklad
for each row execute procedure dDoklDelete();