-- trigger mazajici obchodni vazby na polozkach
CREATE OR REPLACE FUNCTION dpoldokldeleteobchvazba()
  RETURNS trigger AS $$
declare
  _postfix varchar(20);
  _idPolDokl bigint;
begin
  select getDoklNamePostfixByModul(OLD.modul) into _postfix;
  if (_postfix = 'Fak') then
    _idPolDokl := OLD.idPolFak;
  else
    if (_postfix = 'Obch') then
      _idPolDokl := OLD.idPolObch;
    else
      if (_postfix = 'Sklad') then
        _idPolDokl := OLD.idPolSklad;
      end if;
    end if;
  end if;
  
  delete from dVazebTab where (typvazbyk in ('typVazbyDokl.obchod_obchod_pol', 'typVazbyDokl.obchod_faktura_pol',
                                             'typVazbyDokl.obchod_zaloha_pol', 'typVazbyDokl.obchod_sklad_pol'))
                              and ((idTabA = _idPolDokl and modulA = OLD.modul) or
                                   (idTabB = _idPolDokl and modulB = OLD.modul));
  
  return OLD;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION dpoldokldeleteobchvazba() OWNER TO %firmaRole%;

-- naveseni na tabulky polozek
CREATE TRIGGER dpolobchdeleteobchvazba BEFORE DELETE ON dpolobch
  FOR EACH ROW EXECUTE PROCEDURE dpoldokldeleteobchvazba();
CREATE TRIGGER dpolfakdeleteobchvazba BEFORE DELETE ON dpolfak
  FOR EACH ROW EXECUTE PROCEDURE dpoldokldeleteobchvazba();
CREATE TRIGGER dpolskladdeleteobchvazba BEFORE DELETE ON dpolsklad
  FOR EACH ROW EXECUTE PROCEDURE dpoldokldeleteobchvazba();
