-- Funkce odrezervujici dane mnozstvi z pro danou cenikou polozku na sklade
CREATE OR REPLACE FUNCTION odrezervuj(_idFirmy integer, _idCenik integer, _idSkladu integer, vyskladni numeric(19,6))
  RETURNS void AS $$
declare
  _idRezer integer;
  _mnozstvi numeric(19,6);
  _vyskl numeric(19,6);
begin
  _vyskl = vyskladni;

  for _idRezer, _mnozstvi in select idRezervace, mnozstvi from sRezervace where idfirmy = _idFirmy and idCenik = _idCenik and idSklad = _idSkladu order by idrezervace loop
    if _vyskl < _mnozstvi then
      update sRezervace set mnozstvi = (mnozstvi-_vyskl) where idRezervace = _idRezer;
      
      return;
    else
      delete from sRezervace where idRezervace = _idRezer;
      
      _vyskl = _vyskl - _mnozstvi;
    end if;
   
  end loop;
end; 
$$ LANGUAGE plpgsql;
