-- funkce pro prepocet obratu
CREATE OR REPLACE FUNCTION prepoctiobraty(iducetobd integer) RETURNS void AS $$ 
CREATE OR REPLACE FUNCTION prepoctiobraty(iducetobd integer) RETURNS void AS $$ 
declare 
  _platiOd date; 
  _platiDo date; 
begin 
  select platioddata, platidodata into _platiOd, _platiDo from nucetobdobi where iducetobdobi = idUcetObd; 
 
  if (_platiOd is not null and _platiDo is not null) then 
    delete from uobraty where obdobi > 0 and (iducetobdobi = idUcetObd or 
      (obdobi < 99 and date(rok || '-' || obdobi || '-02') between _platiOd and _platiDo)); 
     
    -- zauctovani polozek faktur 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolfak as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     -- zauctovani polozek internich dokladu 
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolint as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
                                 
     -- zauctovani polozek skladovych dokladu                      
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idZklMdUcet, P.idZklDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumZkl, P.sumZklMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
        
     perform createOrUpdateObraty(P.ucetni, P.storno, P.datucto, P.idDphMdUcet, P.idDphDalUcet, P.idMeny, P.idStred, 
         P.idCinnost, P.sumDph, P.sumDphMen) from dpolsklad as P  
         where P.ucetni = true and P.storno = false and P.datUcto between _platiOd and _platiDo; 
     
     -- danove naklady 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from mdannakl as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     -- danove odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mdanodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- splatkovy kalendar 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, L.idMeny, P.idStred,  
          P.sumZkl, P.sumZklMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
           
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, L.idMeny, P.idStred,  
          P.sumDph, P.sumDphMen) from msplatkal as P left outer join mleasing as L on L.idleasing = P.idleasing  
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- ucetni odpisy 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mucetodpisy as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
      
     -- udalosti 
     -- odpisy majetku jsou vedeny vzdy v mistni mene, proto za menu dosazujeme -1 a za sumZklMen 0.0 
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idZklMdUcet, P.idZklDalUcet, -1, P.idStred,  
          P.sumZkl, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo; 
     
     perform createOrUpdateObraty(P.ucetni, false, P.datUcto, P.idDphMdUcet, P.idDphDalUcet, -1, P.idStred,  
          P.sumDph, 0.0) from mudalosti as P 
          where P.ucetni = true and P.datUcto between _platiOd and _platiDo;
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.prepoctiobraty(iducetobd integer) OWNER TO %firmaRole%;