-----------------------------------------------------------------------
-- Bug 46269 - Pokud je u ceníkové položky nastavena správa do 999999 nelze provést Inicializaci účetního období 
-----------------------------------------------------------------------

CREATE OR REPLACE FUNCTION skladprevedskladkarty(i_iducetobdobizdroj integer, i_iducetobdobicil integer, i_idskladkarty integer, i_limit integer, i_vynechatNulove boolean, i_minDatPosl date)
  RETURNS integer AS
$BODY$
declare
  _skladKartaZdroj record;
  _skladKartaCil record;
  _pocet integer;
  _resultId integer;
  _pocetSkladKaret integer;

  _sumPohybMj numeric(19,6);
  _sumPohybTuz numeric(19,6);
  _sumPohybMen numeric(19,6);
  _pozadavkyCil numeric(19,6);

  _pocatMj numeric(19,6);
  _pocatTuz numeric(19,6);
  _pocatMen numeric(19,6);
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _pozadavkyMj numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _stavMjSPozadavky numeric(19,6);
  _datPosl date;
  _rezervmj numeric(19,6);

  _skladPlatiDo date;
  _ucetObdobiCilOd date;
  _cenikPlatiDo integer;
begin
  _pocet = 0;
  _resultId = null;

  if(i_idskladkarty = -1) then
    -- nejprve pokud v minulém účetním období došlo ke smazání skladové karty s nenulovým zůstatkem upravíme počátek
    -- skladové karty v novém účetním období
    update skarty set stavMj = stavMj - pocatMj, stavMjSPozadavky = stavMjSPozadavky - pocatMj, stavTuz = stavTuz - pocatTuz, stavMen = stavMen - pocatMen, pocatMj = 0.0, pocatTuz = 0.0, pocatMen = 0.0
    where idkarty in
          (select s2.idkarty
           from skarty s2
             left join skarty s1 on s2.idcenik = s1.idcenik and s2.idskladu = s1.idskladu and s1.iducetobdobi = i_iducetobdobizdroj
           where s2.iducetobdobi = i_iducetobdobicil and s1.iducetobdobi is null and (s2.pocatMj <> 0.0 or s2.pocatTuz <> 0.0));
  end if;

  for _skladKartaZdroj in (
    select * from skarty k where k.iducetobdobi = i_iducetobdobizdroj and k.idkarty > i_idskladkarty
    order by idkarty limit i_limit) loop
    --select 1 into _pocetSkladKaret from sKarty k where k.idKarty = _skladKartaZdroj.idKarty limit 1; 
    --continue when _pocetSkladKaret is null; 

    _pocet = _pocet + 1;
    --exit when _pocet > i_limit; 
    _resultId = _skladKartaZdroj.idKarty;

    -- zjistime zda v novem obdobi existuje karta
    select * into _skladKartaCil from skarty k
    where k.idcenik = _skladKartaZdroj.idcenik and k.idskladu = _skladKartaZdroj.idskladu and k.iducetobdobi = i_iducetobdobicil;
    --raise exception '%', _skladKartaCil;
    if(_skladKartaCil.idKarty is not null) then
      _sumPohybMj = _skladKartaCil.stavMj - _skladKartaCil.pocatMj;
      _sumPohybTuz = _skladKartaCil.stavTuz - _skladKartaCil.pocatTuz;
      _sumPohybMen = _skladKartaCil.stavMen - _skladKartaCil.pocatMen;
      select coalesce(sum(p.mnozMjPlan), 0.0) into _pozadavkyCil from dpolsklad p
      where p.mnozMj = 0.0 and p.mnozMjPlan <> 0.0 and p.idkarty = _skladKartaCil.idkarty and p.storno = false;

      _stavMj = _skladKartaZdroj.stavMj + _sumPohybMj;
      _pocatMj = _skladKartaZdroj.stavMj;
      _pocatTuz = _skladKartaZdroj.stavTuz;
      _pocatMen = _skladKartaZdroj.stavMen;
      _stavTuz = _skladKartaZdroj.stavTuz + _sumPohybTuz;
      _stavMen = _skladKartaZdroj.stavMen + _sumPohybMen;
      _pozadavkyMj = _skladKartaZdroj.pozadavkyMj + _pozadavkyCil;
      _prumCenaTuz = (case when _stavMj is null or _stavMj = 0 then _skladKartaCil.prumCenaTuz else round((_skladKartaZdroj.stavTuz + _sumPohybTuz) / _stavMj, 6) end);
      _prumCenaMen = (case when _stavMj is null or _stavMj = 0 then _skladKartaCil.prumCenaMen else round((_skladKartaZdroj.stavMen + _sumPohybMen) / _stavMj, 6) end);
      _stavMjSPozadavky = _stavMj - (_skladKartaZdroj.pozadavkyMj + _pozadavkyCil);
      _datPosl = greatest((select max(datVyst) from dpolsklad where idkarty = _skladKartaCil.idKarty), _skladKartaZdroj.datPosl);
      _rezervmj = _skladKartaZdroj.rezervmj;

      if(
        (not comparenumeric(_pocatMj, _skladKartaCil.pocatMj)) or
        (not comparenumeric(_pocatTuz, _skladKartaCil.pocatTuz)) or
        (not comparenumeric(_pocatMen, _skladKartaCil.pocatMen)) or
        (not comparenumeric(_stavMj, _skladKartaCil.stavMj)) or
        (not comparenumeric(_stavTuz, _skladKartaCil.stavTuz)) or
        (not comparenumeric(_stavMen, _skladKartaCil.stavMen)) or
        (not comparenumeric(_pozadavkyMj, _skladKartaCil.pozadavkyMj)) or
        (not comparenumeric(_prumCenaTuz, _skladKartaCil.prumCenaTuz)) or
        (not comparenumeric(_prumCenaMen, _skladKartaCil.prumCenaMen)) or
        (not comparenumeric(_stavMjSPozadavky, _skladKartaCil.stavMjSPozadavky)) or
        (not comparedate(_datPosl, _skladKartaCil.datPosl)) or
        (not comparenumeric(_rezervmj, _skladKartaCil.rezervmj))
      ) then
        update skarty k set
          pocatMj = _pocatMj,
          pocatTuz = _pocatTuz,
          pocatMen = _pocatMen,
          stavMj = _stavMj,
          stavTuz = _stavTuz,
          stavMen = _stavMen,
          pozadavkyMj = _pozadavkyMj,
          prumCenaTuz = _prumCenaTuz,
          prumCenaMen = _prumCenaMen,
          stavMjSPozadavky = _stavMjSPozadavky,
          datPosl = _datPosl,
          rezervmj = _rezervmj
        where k.idkarty = _skladKartaCil.idKarty;
      end if;
    else
      -- podmínka "_skladKartaZdroj.datPosl is null" je tu, protože se mi při nenaskladnění na jeden ze skladů povedlo mít datPosl null
      if(i_vynechatNulove and _skladKartaZdroj.stavMj = 0.0 and i_minDatPosl is not null and (_skladKartaZdroj.datPosl is null or _skladKartaZdroj.datPosl <= i_minDatPosl)) then
      --raise notice 'vynechavam - stavMj %, datPosl %, i_minDatPosl %', _skladKartaZdroj.stavMj, _skladKartaZdroj.datPosl, i_minDatPosl;
      -- vynechame nulove, ktere maji posledni pohyb pred vice nez x dny (bug 41190)
      else

        select platiOdData into _ucetObdobiCilOd from nucetobdobi where iducetobdobi = i_iducetobdobicil;
        select platiDoData into _skladPlatiDo from nucetobdobi where iducetobdobi = (select iducetobdobido from dbsp where idbsp = _skladKartaZdroj.idskladu);
        if((_skladPlatiDo is not null) and (_skladPlatiDo < _ucetObdobiCilOd)) then
          -- pokud sklad již v novém účetním období neplatí nebudeme pro něj vytváře skladovou kartu
          continue;
        end if;

        select platiDo into _cenikPlatiDo from ccenik where idcenik = _skladKartaZdroj.idcenik;
        _cenikPlatiDo := least(_cenikPlatiDo, 9999);
        if(to_date(_cenikPlatiDo || '-12-31', 'YYYY-MM-DD') < _ucetObdobiCilOd) then
          -- pokud ceník již v novém účetním období neplatí nebudeme pro něj vytváře skladovou kartu
          continue;
        end if;

        --raise notice 'stavMj %, datPosl %, i_minDatPosl %', _skladKartaZdroj.stavMj, _skladKartaZdroj.datPosl, i_minDatPosl;
        insert into skarty(idskladu, idcenik, iducetobdobi,
                           stavmj, stavmjspozadavky, pozadavkymj, stavmen, stavtuz,
                           pocatmj, pocatmen, pocattuz, prumcenatuz, prumcenamen,
                           datposl, maxmj, minmj, poslcenamen, poslcenatuz,
                           nazev, nazeva, nazevb, nazevc,
                           popis, popisa, popisb, popisc, poznamvelka,
                           cenpopis, cenpopisa, cenpopisb, cenpopisc, cenpoznam,
                           idmistnost, idregal, idpolice, rezervmj )
        values (_skladKartaZdroj.idskladu, _skladKartaZdroj.idcenik, i_iducetobdobicil,
                                           _skladKartaZdroj.stavmj, _skladKartaZdroj.stavmjspozadavky, _skladKartaZdroj.pozadavkymj, _skladKartaZdroj.stavmen, _skladKartaZdroj.stavtuz,
                                           _skladKartaZdroj.stavmj, _skladKartaZdroj.stavmen, _skladKartaZdroj.stavtuz, _skladKartaZdroj.prumcenatuz, _skladKartaZdroj.prumcenamen,
                                                                                                                        _skladKartaZdroj.datposl, _skladKartaZdroj.maxmj, _skladKartaZdroj.minmj, _skladKartaZdroj.poslcenamen, _skladKartaZdroj.poslcenatuz,
                                                                                                                        _skladKartaZdroj.nazev, _skladKartaZdroj.nazeva, _skladKartaZdroj.nazevb, _skladKartaZdroj.nazevc,
                                                                                                                                                                                                  _skladKartaZdroj.popis, _skladKartaZdroj.popisa, _skladKartaZdroj.popisb, _skladKartaZdroj. popisc, _skladKartaZdroj.poznamvelka,
                                                                                                                                                                                                  _skladKartaZdroj.cenpopis, _skladKartaZdroj.cenpopisa, _skladKartaZdroj.cenpopisb, _skladKartaZdroj.cenpopisc, _skladKartaZdroj.cenpoznam,
                _skladKartaZdroj.idmistnost, _skladKartaZdroj.idregal, _skladKartaZdroj.idpolice, _skladKartaZdroj.rezervmj
        );
      end if;
    end if;

  end loop;

  return _resultId;
end;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION skladprevedskladkarty(integer, integer, integer, integer, boolean, date) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
 values (nextval('seq_dbversion'), 1090, 't', %appVersion%, clock_timestamp());