--------------------------------------------------------------------------------
-- Bug 44905 - Přehled o peněžních tocích (cash flow) 
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION vytvorSestavaCashflow()
RETURNS void AS $$
DECLARE
  _idtyporgread integer;
BEGIN
  select idtyporg into _idtyporgread from nnastav limit 1;

  -- sestavy aktualizujeme jen pro cechy
  IF (_idtyporgread = 1) THEN
  
  
    INSERT INTO usestavy (idsestavy, lastupdate, kod, nazev, show, platiod, platido, typsesk, standard, vypminobd, nazevsloup1, zobrazit1, zobrazit2, zobrazit3, nazevsloup4, zobrazit4, zobrazit5, zobrazit6, sloupec3sum12, sloupec6sum45, rokod, rokdo, mesicod, mesicdo, predrokod, predrokdo, predmesicod, predmesicdo, datvypocet, typvypsestavyk, typjednotkymikro, idtyporg, idseszdroj, idradzdroj, uuid)
      VALUES (8, '2017-09-18 00:00:00.000', 'CASH FLOW 2017', 'Cash flow 2017', true, 2017, 9999, 'typSestavy.cashflow', true, true, 'Běžné období', true, false, false, 'Minulé období', true, false, false, false, false, 0, 0, 0, 0, 0, 0, 0, 0, null, 'typVypSestavy.vKcPresne', false, 1, 7, 392, 'CZ_PODNIKATELE_CASH_FLOW_2017');
 
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (400, '2017-09-06 00:00:00.000', 1, 'P', 'Stav peněžních prostředků a peněžních ekvivalentů na začátku účetního období', 'Balance of cash on hand and financial equivalents as at the beginning of reporting period', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (401, '2017-09-05 00:00:00.000', 2, '#header#', 'Peněžní toky z hlavní výdělečné činnosti (provozní činnosti)', 'Cash flows from running activities', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, poznam, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (402, '2017-09-14 00:00:00.000', 3, 'Z.', 'Účetní zisk nebo ztráta před zdaněním', 'Accounting profit/loss from running activities before taxation', false, false, 'Plní se z VZZ', 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (403, '2017-09-05 00:00:00.000', 4, 'A.1.', 'Úpravy o nepeněžní operace', 'Adjustments by non-cash operations', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (404, '2017-09-18 00:00:00.000', 5, 'A.1.1.', 'Odpisy stálých aktiv (+) s výjimkou zůstatkové ceny prodaných stálých aktiv, a dále umořování oceňovacího rozdílu k nabytému majetku a goodwillu (+/-)', 'Depreciation of fixed assets and amortization of adjustments to acquired assets  ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (405, '2017-09-06 00:00:00.000', 6, 'A.1.2.', 'Změna stavu opravných položek, rezerv', 'Change in balance of adjustments, reserves ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (406, '2017-09-06 00:00:00.000', 7, 'A.1.3.', 'Zisk (ztráta) z prodeje stálých aktiv (-/+)', 'Profit from sales of fixed assets', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (407, '2017-09-06 00:00:00.000', 8, 'A.1.4.', 'Výnosy z podílů na zisku (-)', 'Revenue from dividends and shares in profit', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (408, '2017-09-06 00:00:00.000', 9, 'A.1.5.', 'Vyúčtované nákladové úroky (+) s výjimkou úroků zahrnovaných do ocenění dlouhodobého majetku, a vyúčtované výnosové úroky (-)', 'Accounted for interest expense, exclusive of interest capitalization and accounted for credit interest ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (409, '2017-09-07 00:00:00.000', 10, 'A.1.6.', 'Případné úpravy o ostatní nepeněžní operace', 'Any adjustments to other non-cash transactions', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (410, '2017-09-08 00:00:00.000', 11, 'A.*', 'Čistý peněžní tok z provozní činnosti před zdaněním a změnami pracovního kapitálu', 'Net cash flow from running activities before taxation, changes in working capital and unusual/extraordinary items ', false, false, 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (411, '2017-09-18 00:00:00.000', 12, 'A.2.', 'Změny stavu nepeněžních složek pracovního kapitálu', 'Change in non-cash items of working capital ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (412, '2017-09-08 00:00:00.000', 13, 'A.2.1.', 'Změna stavu pohledávek z provozní činnosti (+/-), aktivních účtů časového rozlišení a dohadných účtů aktivních', 'Change in balance of receivables from running activities, temporary assets accounts ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (414, '2017-09-06 00:00:00.000', 15, 'A.2.3.', 'Změna stavu zásob (+/-)', 'Change in balance of inventory ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (415, '2017-09-05 00:00:00.000', 16, 'A.2.4.', 'Změna stavu krátkodobého finančního majetku nespadajícího do peněžních prostředků a peněžních ekvivalentů', 'Change in balance of current liquid assets not included in cash or equivalents ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (416, '2017-09-08 00:00:00.000', 17, 'A.**', 'Čistý peněžní tok z provozní činnosti před zdaněním', 'Net cash flow from running activities before taxation and unusual/extraordinary items ', false, false, 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (417, '2017-09-06 00:00:00.000', 18, 'A.3.', 'Vyplacené úroky s výjimkou úroků zahrnovaných do ocenění dlouhodobého majetku (-)', 'Interests paid exclusive of interest capitalization ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (418, '2017-09-06 00:00:00.000', 19, 'A.4.', 'Přijaté úroky (+)', 'Interests received ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (419, '2017-09-14 00:00:00.000', 20, 'A.5.', 'Zaplacená daň z příjmů a za doměrky daně za minulá období (-)', 'Income tax for running activities and additional tax assessments for previous periods ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (420, '2017-09-06 00:00:00.000', 21, 'A.7.', 'Přijaté podíly na zisku (+)', 'Profits earned (+)', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (421, '2017-09-08 00:00:00.000', 22, 'A.***', 'Čistý peněžní tok z provozní činnosti', 'Net cash flow from running activities ', false, false, 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (422, '2017-09-05 00:00:00.000', 23, '#header#', 'Peněžní toky z investiční činnosti', 'Cash flows from investment activities ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (423, '2017-09-07 00:00:00.000', 24, 'B.1.', 'Výdaje spojené s nabytím stálých aktiv', 'Expense on fixed assets acquisition ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (424, '2017-09-06 00:00:00.000', 25, 'B.2.', 'Příjmy z prodeje stálých aktiv', 'Income from fixed assets sales ', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (425, '2017-09-05 00:00:00.000', 26, 'B.3.', 'Zápůjčky a úvěry spřízněným osobám', 'Loans to related parties', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (426, '2017-09-05 00:00:00.000', 27, 'B.***', 'Čistý peněžní tok vztahující se k investiční činnosti', 'Net cash flow from investing activities', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (427, '2017-09-05 00:00:00.000', 28, '#header#', 'Peněžní toky z finančních činností', 'Cash flows from financing activities', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (428, '2017-09-18 00:00:00.000', 29, 'C.1.', 'Dopady změn dlouhodobých závazků, popřípadě takových krátkodobých závazků, které spadají do oblasti finanční činnosti  na peněžní prostředky a peněžní ekvivalenty', 'Change in balance of long-term or short-term payables', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (429, '2017-09-05 00:00:00.000', 30, 'C.2.', 'Dopady změn vlastního kapitálu na peněžní prostředky a peněžní ekvivalenty', 'Impact of changes in equity on cash on hand and financial equivalents', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (430, '2017-09-18 00:00:00.000', 31, 'C.2.1.', 'Zvýšení peněžních prostředků a peněžních ekvivalentů z titulu zvýšení základního kapitálu, ážia, popřípadě fondů ze zisku včetně složených záloh na toto zvýšení (+)', 'Increase in cash on hand as a result of increased registered capital, share premium etc.', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (431, '2017-09-06 00:00:00.000', 32, 'C.2.2.', 'Vyplacení podílu na vlastním kapitálu společníkům (-)', 'Payment of share in equity to partners', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (432, '2017-09-18 00:00:00.000', 33, 'C.2.3.', 'Další vklady peněžních prostředků společníků a akcionárů (+)', 'Other contributions of cash by partners and shareholders', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (433, '2017-09-06 00:00:00.000', 34, 'C.2.4.', 'Úhrada ztráty společníky', 'Loss coverage by partners', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (434, '2017-09-05 00:00:00.000', 35, 'C.2.5.', 'Přímé platby na vrub fondů (-)', 'Direct debit fund payments', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (435, '2017-09-06 00:00:00.000', 36, 'C.2.6.', 'Vyplacené podíly na zisku včetně zaplacené srážkové daně vztahující se k těmto nárokům a včetně finančního vypořádání se společníky veřejné obchodní společnosti a komplementáři u komanditních společností (-)', 'Dividends paid or shares in profit, including taxes paid', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (436, '2017-09-05 00:00:00.000', 37, 'C.***', 'Čistý peněžní tok vztahující se k finanční činnosti', 'Net cash flow from financing activities', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (437, '2017-09-08 00:00:00.000', 38, 'F.', 'Čisté zvýšení nebo snížení peněžních prostředků', 'Net increase/decrease in cash on hand', false, false, 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (438, '2017-09-08 00:00:00.000', 39, 'R.', 'Stav peněžních prostředků a peněžních ekvivalentů na konci účetního období', 'Balance of cash on hand and financial equivalents as at the end of reporting period', false, false, 0.0, 0.0, 10000.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (439, '2017-09-06 00:00:00.000', 40, '#nonprintable#', 'účet 641 patřící do CF', 'Account 641 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (440, '2017-09-06 00:00:00.000', 41, '#nonprintable#', 'účet 661 patřící do CF', 'Account 661 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (441, '2017-09-07 00:00:00.000', 46, '#nonprintable#', 'Pomocný k "A.1.3. Zisk (ztráta) z prodeje stálých aktiv (-/+) vyúčt. do výnosů- do nákladů+"', 'Auxiliary to "A.1.3. Amortization of adjustments for acquired assets"', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (444, '2017-09-18 00:00:00.000', 47, '#nonprintable#', 'Pomocný k A.2.1 (otočené znaménko)', 'Auxiliary to A.2.1. (inverse sign)', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (445, '2017-09-18 00:00:00.000', 14, 'A.2.2.', 'Změna stavu krátkodobých závazků z provozní činnosti (+/-), pasivních účtů časového rozlišení a dohadných účtů pasivních', 'Change in balance of short-term payables from running activities, temporary liability accounts', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (450, '2017-09-18 00:00:00.000', 100, '#nonprintable#', 'Účty nespadající do CF', 'Accounts not belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (452, '2017-09-18 00:00:00.000', 49, '#nonprintable#', 'Účet 640 patřící do CF', 'Account 640 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (453, '2017-09-20 00:00:00.000', 48, '#nonprintable#', 'Pohledávky do řádku B.2', 'Receibables to B.2.', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (454, '2017-09-27 00:00:00.000', 42, '#nonprintable#', 'Účet 560 patřící do CF', 'Account 560 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (455, '2017-09-27 00:00:00.000', 43, '#nonprintable#', 'Účet 562 patřící do CF', 'Account 562 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (456, '2017-09-27 00:00:00.000', 44, '#nonprintable#', 'Účet 660 patřící do CF', 'Account 660 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
    INSERT INTO usesradky (idsesradky, lastupdate, cisrad, oznaceni, nazev, nazeva, zjednodusena, zakladni, hod1, hod2, hod3, hod4, hod5, hod6, idsestavy)
     VALUES (457, '2017-09-27 00:00:00.000', 45, '#nonprintable#', 'Účet 662 patřící do CF', 'Account 662 belonging to CF', false, false, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 8);
     
     INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1129, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_210'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1130, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_211'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1131, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_213'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1132, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_221'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1133, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_220'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1134, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_260'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1135, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_261'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1136, '2017-09-04 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.stavPoc', false, false, 400, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_262'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1137, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_551'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1138, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_543'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1139, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_557'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1140, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_550'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1142, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_552'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1143, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_554'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1144, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_558'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1145, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_559'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1146, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_570'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1147, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_574'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1148, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_579'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1149, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_589'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1150, '2017-09-04 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 439, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_641'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1151, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 441, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_541'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1152, '2017-09-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 441, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_561'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1158, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 419, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_341'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1165, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_310'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1166, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_311'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1167, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_312'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1168, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_313'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1169, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_314'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1170, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_315'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1171, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_316'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1172, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_335'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1173, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_336'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1174, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_342'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1175, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_343'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1176, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_345'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1177, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_346'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1178, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_347'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1179, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_350'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1180, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_354'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1181, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1183, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_371'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1184, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_374'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1185, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_375'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1186, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_378'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1187, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_373'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1188, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_380'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1189, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_381'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1190, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_382'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1191, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_385'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1192, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_386'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1193, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_388'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1194, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, true, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_398'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1195, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_320'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1196, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_321'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1197, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_322'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1198, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_323'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1199, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_324'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1200, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_325'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1201, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_326'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1202, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_330'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1203, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_331'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1204, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_333'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1205, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_336'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1206, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_340'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1207, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_342'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1208, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_343'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1209, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_346'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1210, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_347'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1211, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_366'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1212, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_365'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1213, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_383'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1214, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_384'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1215, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_387'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1216, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_389'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1217, '2017-09-07 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, true, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_398'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1218, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_110'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1219, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_111'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1220, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_112'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1221, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_119'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1222, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_120'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1223, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_121'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1224, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_122'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1225, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_123'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1226, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_124'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1227, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_130'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1228, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_131'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1229, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_132'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1230, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_139'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1231, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_150'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1232, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_151'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1233, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_152'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1234, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_153'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1235, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_155'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1236, '2017-09-08 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 414, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_156'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1237, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_250'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1238, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_251'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1239, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_252'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1240, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_253'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1241, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_254'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1242, '2017-09-05 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_255'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1243, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_256'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1244, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_257'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1245, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 415, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_259'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1246, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_350'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1247, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_351'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1248, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_352'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1249, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1250, '2017-09-05 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_358'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1261, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_353'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1262, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 431, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_365'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1263, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 434, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_420'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1264, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 434, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_421'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1265, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 434, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_422'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1266, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 434, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_423'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1267, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 434, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_427'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1268, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 435, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_364'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1269, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 440, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_661'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1270, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_010'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1271, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_011'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1272, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_012'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1273, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_013'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1274, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_014'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1275, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_015'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1276, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_016'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1277, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_019'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1278, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_020'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1279, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_021'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1280, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_022'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1281, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_025'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1282, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_026'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1283, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_027'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1284, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_029'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1285, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_030'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1286, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_031'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1287, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_032'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1288, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_040'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1289, '2017-09-12 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_041'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1290, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_042'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1291, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_043'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1292, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_050'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1293, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_051'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1294, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_052'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1295, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_053'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1296, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_060'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1297, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_061'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1298, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_062'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1299, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_063'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1300, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_065'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1301, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_066'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1302, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_067'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1303, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_068'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1304, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_069'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1305, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_350'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1306, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_351'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1307, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_352'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1308, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_354'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1309, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1310, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', true, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_358'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1318, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_350'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1319, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_351'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1320, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_352'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1321, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_353'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1322, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_354'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1323, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_355'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1324, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 433, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_358'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1325, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 409, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_560'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1326, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 409, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_563'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1327, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 409, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1328, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 409, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_663'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1329, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_540'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1330, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_640'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1331, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_550'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1332, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 405, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_580'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1334, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 419, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_340'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1337, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 431, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_360'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1338, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratMd', true, false, 435, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_360'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1339, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 439, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_640'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1340, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 440, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1341, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 441, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_540'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1342, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 441, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_560'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1347, '2017-09-06 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratMd', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_064'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1348, '2017-09-07 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_376'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1349, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_377'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1350, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_379'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1351, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_370'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1352, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_372'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1353, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 432, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_410'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1354, '2017-09-12 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 432, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_413'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1356, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_230'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1357, '2017-09-06 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_420'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1358, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_540'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1359, '2017-09-06 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_580'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1361, '2017-09-06 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 452, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_640'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1366, '2017-09-13 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_590'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1367, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_330'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1368, '2017-09-14 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_370'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1369, '2017-09-14 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 444, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_390'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1382, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_230'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1383, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_231'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1384, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_460'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1385, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_461'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1386, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_470'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1387, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_471'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1388, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_472'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1389, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_473'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1390, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_474'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1391, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_475'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1392, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_476'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1393, '2017-09-14 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_478'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1394, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_232'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1395, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_361'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1396, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_362'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1397, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_361'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1398, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_362'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1399, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 445, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_368'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1400, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_368'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1401, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 432, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_491'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1402, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 432, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_490'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1403, '2017-09-18 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 404, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_647'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1404, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_462'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1405, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_479'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1406, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratDal', false, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_410'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1407, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratDal', false, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_411'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1408, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratDal', false, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_412'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1409, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obratDal', false, false, 430, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_419'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1410, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_360'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1411, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 428, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_367'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1412, '2017-09-18 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_410'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1413, '2017-09-18 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_550'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1414, '2017-09-18 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_560'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1415, '2017-09-18 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1422, '2017-09-20 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 453, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_311'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1423, '2017-09-20 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 453, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_310'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1424, '2017-09-20 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 453, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_315'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1425, '2017-09-20 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 453, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_378'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1426, '2017-09-20 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obrat', false, false, 453, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_370'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1427, '2017-09-20 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_320'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1428, '2017-09-20 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_321'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1429, '2017-09-20 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_325'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1430, '2017-09-20 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_370'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1431, '2017-09-20 00:00:00.000', 'druhUctu.pasivni', 1, 'zpusobVypo.obrat', true, false, 423, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_379'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1432, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 407, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1433, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 407, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1434, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 407, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_666'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1435, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 407, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_668'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1436, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 420, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1437, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 420, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_665'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1438, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 420, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_666'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1439, '2017-09-22 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', true, false, 420, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_668'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1440, '2017-09-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_066'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1441, '2017-09-22 00:00:00.000', 'druhUctu.aktivni', 1, 'zpusobVypo.obratDal', false, false, 425, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_068'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1442, '2017-09-27 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 454, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_560'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1443, '2017-09-27 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 455, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_562'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1444, '2017-09-27 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 456, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_660'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1445, '2017-09-27 00:00:00.000', 'druhUctu.vynosy', 1, 'zpusobVypo.obrat', false, false, 457, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_662'));
    INSERT INTO usesstdpred (idsesstdpred, lastupdate, druhuctuk, cissloup, zpusobvypk, prevratznam, jenkladne, idsesradky, idstducet)
     VALUES (1446, '2017-10-04 00:00:00.000', 'druhUctu.naklady', 1, 'zpusobVypo.obrat', false, false, 450, (select IdStdUcet from uStdUcty where uuid = 'CZ_POD_591')); 
     
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (611, '2017-09-04 00:00:00.000', false, 403, 404);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (612, '2017-09-04 00:00:00.000', false, 403, 405);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (613, '2017-09-04 00:00:00.000', false, 403, 406);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (614, '2017-09-04 00:00:00.000', false, 403, 407);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (615, '2017-09-04 00:00:00.000', false, 403, 408);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (616, '2017-09-04 00:00:00.000', false, 403, 409);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (617, '2017-09-04 00:00:00.000', false, 406, 441);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (618, '2017-09-04 00:00:00.000', false, 406, 439);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (619, '2017-09-04 00:00:00.000', false, 406, 440);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (622, '2017-09-05 00:00:00.000', false, 410, 402);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (623, '2017-09-05 00:00:00.000', false, 410, 403);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (624, '2017-09-05 00:00:00.000', false, 411, 412);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (626, '2017-09-05 00:00:00.000', false, 411, 414);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (627, '2017-09-05 00:00:00.000', false, 411, 415);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (635, '2017-09-06 00:00:00.000', false, 416, 410);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (636, '2017-09-05 00:00:00.000', false, 416, 411);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (637, '2017-09-05 00:00:00.000', true, 412, 444);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (639, '2017-09-05 00:00:00.000', true, 424, 439);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (640, '2017-09-05 00:00:00.000', true, 424, 440);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (641, '2017-09-05 00:00:00.000', false, 426, 423);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (642, '2017-09-05 00:00:00.000', false, 426, 424);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (643, '2017-09-05 00:00:00.000', false, 426, 425);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (644, '2017-09-05 00:00:00.000', false, 436, 428);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (645, '2017-09-05 00:00:00.000', false, 436, 429);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (646, '2017-09-05 00:00:00.000', false, 429, 430);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (647, '2017-09-05 00:00:00.000', false, 429, 431);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (648, '2017-09-05 00:00:00.000', false, 429, 432);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (649, '2017-09-05 00:00:00.000', false, 429, 433);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (650, '2017-09-05 00:00:00.000', false, 429, 434);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (651, '2017-09-05 00:00:00.000', false, 429, 435);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (652, '2017-09-06 00:00:00.000', false, 421, 416);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (653, '2017-09-06 00:00:00.000', false, 421, 417);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (654, '2017-09-06 00:00:00.000', false, 421, 418);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (655, '2017-09-06 00:00:00.000', false, 421, 419);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (656, '2017-09-06 00:00:00.000', false, 421, 420);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (657, '2017-09-06 00:00:00.000', false, 437, 421);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (658, '2017-09-06 00:00:00.000', false, 437, 426);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (659, '2017-09-06 00:00:00.000', false, 437, 436);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (660, '2017-09-06 00:00:00.000', false, 438, 400);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (661, '2017-09-06 00:00:00.000', false, 438, 437);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (662, '2017-09-06 00:00:00.000', false, 406, 456);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (668, '2017-09-06 00:00:00.000', true, 424, 456);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (669, '2017-09-12 00:00:00.000', true, 424, 452);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (670, '2017-09-06 00:00:00.000', false, 406, 452);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (674, '2017-09-18 00:00:00.000', false, 411, 445);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (675, '2017-09-20 00:00:00.000', true, 424, 453);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (676, '2017-09-27 00:00:00.000', false, 408, 454);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (677, '2017-09-27 00:00:00.000', false, 408, 455);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (678, '2017-09-27 00:00:00.000', false, 408, 456);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (679, '2017-09-27 00:00:00.000', false, 408, 457);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (680, '2017-09-27 00:00:00.000', true, 417, 454);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (681, '2017-09-27 00:00:00.000', true, 417, 455);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (682, '2017-09-27 00:00:00.000', true, 418, 456);
    INSERT INTO usessumace (idsessumace, lastupdate, prevratznam, idsesradky, idsesradkysum)
     VALUES (683, '2017-09-27 00:00:00.000', true, 418, 457);
         

     
    update usestavy set idradcil = 402, idradzaokr1 = 438 where uuid = 'CZ_PODNIKATELE_CASH_FLOW_2017'; 
 
  
  END IF;
  RETURN;
 END;
 $$ LANGUAGE plpgsql;
 ALTER FUNCTION vytvorSestavaCashflow() OWNER TO %firmaRole%;
   
select vytvorSestavaCashflow();
drop function vytvorSestavaCashflow();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
values (nextval('seq_dbversion'), 1110, 't', %appVersion%, clock_timestamp());
