------------------------------------------------------------------------------------
-- FB-439 Nezapočítávat pomocné složky odměn do sloupce Odměny v Aktualizaci mezd
-- FB-466 Při hrubé mzdě bez prohlášení se vypočte navíc zálohová daň z -100
-- FB-467 Z PP Praktický výcvik se nemá odvádět srážková daň
----------------------------------------------

create or replace function runupgrade()
   returns void as $$
 declare
   stat character varying(10);
 begin
   select a.uuid into stat from nnastav n 
     left join utyporg u on u.idtyporg = n.idtyporg
     left join astaty a on a.idstatu = u.idstatu
   order by coalesce(n.platioddata, '1900-01-01') desc limit 1;
 
   if (stat = 'CZ_CZ') then
    -- FB-439
    update pcismzdsloz set skupslozkyk = 'skupinaSlozky.hrubaMzda', vyznamK = null where uuid in ('POM.SLOZ.ODM-VM', 'POM.SLOZ.ODM-CTVRT');

    -- FB-466
    UPDATE pmzdcalc SET zaokrjakk = null, zaokrnak = null WHERE idmzdcalc = 10387;
    UPDATE pmzdcalc SET zaokrjakk = 'zaokrJak.matem', zaokrnak = 'zaokrNa.jednotky' WHERE idmzdcalc = 10065;

    -- FB-467
    INSERT INTO ptyppracpomparam (idtyppracpomparam, lastupdate, kod, nazev, popis, show, cisrad, odhodnoty, dohodnoty, koeficient, poletest, polenuluj, actmalyroz, actvelkyroz, actmaprohl, actnemaprohl, actdannerez, actdanrez, actzdrdopl, actzdrnedopl, idmzdcalchlav, idtyppracpom, idcismzdsloz)
      VALUES (408, '2018-02-22 00:00:00.000', 'ZÁKLAD SRÁŽ.DANĚ', 'Základ pro výpočet srážkové daně pro pracovní poměr', 'praktický výcvik se nedaní nikdy', true, 29, 0.0, 9.99999999999E11, 0.0, 'zaklMzd', 'zaklMzd;procMzd', true, true, true, true, true, true, true, true, 12, 6, 159);
        PERFORM pg_catalog.setval('seq_ptyppracpomparam', 408, true);
   end if;
 end;
  $$ LANGUAGE plpgsql;
 ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;
 
 select runupgrade();
 
 drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 1123, 't', %appVersion%, clock_timestamp());
