--------------------------------------------------------------------------------
-- Bug 14926 – [WinStrom] Příkaz k úhradě - tiskne se s 0,- Kč
--------------------------------------------------------------------------------

-- oprava existujících příkazů
update dprikazuhr as D set celcastka =
    (coalesce((select sum(castka) from dpolprikazuhr where idprikazuhr = D.idprikazuhr), 0));


-- Trigger přepočítávající celkovou částku příkazu při změně jeho položky
CREATE OR REPLACE FUNCTION dpolprikazuhrupdateprikaz()
  RETURNS trigger AS $$
declare
  ZAZNAM record;
begin
  if (tg_op = 'DELETE') then  
    ZAZNAM := OLD;  
  else  
    ZAZNAM := NEW;  
  end if;

  update dprikazuhr set celcastka =
    (coalesce((select sum(castka) from dpolprikazuhr where idprikazuhr = ZAZNAM.idprikazuhr), 0));
  
  return ZAZNAM;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolprikazuhrupdateprikaz() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek příkazů k úhradě
CREATE TRIGGER dpolprikazuhrupdateprikaz AFTER INSERT OR UPDATE OR DELETE ON dpolprikazuhr
  FOR EACH ROW EXECUTE PROCEDURE dpolprikazuhrupdateprikaz();


-- Trigger přepočítávající celkovou částku příkazu při jeho změně
CREATE OR REPLACE FUNCTION dprikazuhrupdatecastka()
  RETURNS trigger AS $$
begin
  NEW.celcastka = coalesce((select sum(castka) from dpolprikazuhr where idprikazuhr = NEW.idprikazuhr), 0);

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dprikazuhrupdatecastka() OWNER TO %firmaRole%;

-- navěšení triggeru na tabulku položek příkazů k úhradě
CREATE TRIGGER dprikazuhrupdatecastka BEFORE UPDATE ON dprikazuhr
  FOR EACH ROW EXECUTE PROCEDURE dprikazuhrupdatecastka();

-- zvýšení verze databáze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 128, 't');
