--------------------------------------------------------------------------------
-- Bug 17159 – [winstrom] - tvorba dobropisu s výrobními čísly
--------------------------------------------------------------------------------
-- Function: svyrobnicisloinsertupdate()
-- DROP FUNCTION svyrobnicisloinsertupdate();
CREATE OR REPLACE FUNCTION svyrobnicisloinsertupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolSklad integer; 
begin 
  if(NEW.idPolSkladPrijem is null) then 
    if(tg_op = 'INSERT') then 
      if(NEW.idPolFakPrijem is not null) then  
        select findParovanyPolSklad(NEW.idPolFakPrijem, 'FAP') into _idPolSklad; 
        if(_idPolSklad is null) then
          select findParovanyPolSklad(NEW.idPolFakPrijem, 'FAV') into _idPolSklad; 
        end if;
      elsif(NEW.idPolIntPrijem is not null) then 
        select findParovanyPolSklad(NEW.idPolIntPrijem, 'POK') into _idPolSklad; 
      end if; 
      if(_idPolSklad is not null) then 
        NEW.idPolSkladPrijem = _idPolSklad; 
      end if; 
    elsif(tg_op = 'UPDATE') then 
      if(NEW.idPolFakPrijem <> OLD.idPolFakPrijem) then 
        select findParovanyPolSklad(NEW.idPolFakPrijem, 'FAP') into _idPolSklad; 
        if(_idPolSklad is null) then
          select findParovanyPolSklad(NEW.idPolFakPrijem, 'FAV') into _idPolSklad; 
        end if;
      elsif(NEW.idPolIntPrijem <> OLD.idPolIntPrijem) then 
        select findParovanyPolSklad(NEW.idPolIntPrijem, 'POK') into _idPolSklad; 
      end if; 
      if(_idPolSklad is not null) then 
        NEW.idPolSkladPrijem = _idPolSklad; 
      end if; 
    end if; 
  end if;  
  _idPolSklad = null;  
  if(NEW.idPolSkladVydej is null) then  
    if(tg_op = 'INSERT') then  
      if(NEW.idPolFakVydej is not null) then   
        select findParovanyPolSklad(NEW.idPolFakVydej, 'FAV') into _idPolSklad;
        if(_idPolSklad is null) then
          select findParovanyPolSklad(NEW.idPolFakVydej, 'FAP') into _idPolSklad; 
        end if;  
      elsif(NEW.idPolIntVydej is not null) then  
        select findParovanyPolSklad(NEW.idPolIntVydej, 'POK') into _idPolSklad;  
      end if;  
      if(_idPolSklad is not null) then  
        NEW.idPolSkladVydej = _idPolSklad;  
      end if;  
    elsif(tg_op = 'UPDATE') then  
      if((NEW.idPolFakVydej is not null and OLD.idPolFakVydej is null) or (NEW.idPolFakVydej <> OLD.idPolFakVydej)) then  
        select findParovanyPolSklad(NEW.idPolFakVydej, 'FAV') into _idPolSklad;
        if(_idPolSklad is null) then
          select findParovanyPolSklad(NEW.idPolFakVydej, 'FAP') into _idPolSklad; 
        end if;  
      elsif((NEW.idPolIntVydej is not null and OLD.idPolIntVydej is null) or (NEW.idPolIntVydej <> OLD.idPolIntVydej)) then  
        select findParovanyPolSklad(NEW.idPolIntVydej, 'POK') into _idPolSklad;  
      end if;  
      if(_idPolSklad is not null) then  
        NEW.idPolSkladVydej = _idPolSklad;  
      end if;  
    end if;  
  end if;  
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloinsertupdate() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 216, 't');
