--------------------------------------------------------------------------------
-- Bug 14356 – [WinStrom] Další tabulky a formuláře pro mzdy
--------------------------------------------------------------------------------

-- doplneni volby mzdy na stitky
ALTER TABLE wvybklice ADD COLUMN vsbmzd boolean DEFAULT false;
-- nastaveni standartnich stitku, aby byli pristupne i na mzdach
update wvybklice set vsbmzd = true where uuid is not null;


-- odstraneni pole poctu deti pro odpocet z osoby a pridani vazebni tabulky
ALTER TABLE posoba DROP COLUMN odpocetdeti;
ALTER TABLE posoba ADD COLUMN slevapoplat boolean DEFAULT false;

CREATE TABLE pdite_posoba
(
  idosoba integer NOT NULL,
  iddite integer NOT NULL,
  CONSTRAINT pdite_posoba_pkey PRIMARY KEY (idosoba, iddite),
  CONSTRAINT fk71cdca735928fc02 FOREIGN KEY (iddite)
      REFERENCES pdite (iddite) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT fk71cdca73cd357b3e FOREIGN KEY (idosoba)
      REFERENCES posoba (idosoba) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE pdite_posoba OWNER TO %firmaRole%;

-- pridani na ciselnik slozek chybejici nastaveni viditelnosti hodin ve svatek
ALTER TABLE pcismzdsloz ADD COLUMN vshodinysvatek boolean DEFAULT false;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 220, 't');
