--------------------------------------------------------------------------------
-- Sjednocení databází po založení nové firmy a upgradu staré
--------------------------------------------------------------------------------


CREATE OR REPLACE FUNCTION drop_column_if_exists(table_name character varying, column_name character varying)
  RETURNS void AS $$    
declare    
  _pocetColumnu integer;  
begin
  select count(*) into _pocetColumnu from pg_attribute as a where  
    a.attname = column_name and   
    a.attrelid = (  
        SELECT c.oid  
        FROM pg_catalog.pg_class c  
            LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace  
        WHERE c.relname ~ ('^('||table_name||')$')  
            AND pg_catalog.pg_table_is_visible(c.oid)  
    ); 
  
 if(_pocetColumnu > 0) then  
   execute 'Alter table '||table_name||' drop column '||column_name||';';  
 end if;  
end;    
$$ LANGUAGE plpgsql;
ALTER FUNCTION drop_column_if_exists(character varying, character varying) OWNER TO %firmaRole%;


select drop_column_if_exists('nnastav', 'mzdproczdpojneplvol');

select add_constraint_if_not_exists('pmzdcalc', 'fk3193ccbcffa57876', 
 'FOREIGN KEY (idmzdslozin2) REFERENCES pcismzdsloz (idcismzdsloz) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION');

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 225, 't');
