--------------------------------------------------------------------------------
-- Bug 17557 – [WinStrom] Aktualizace kalkulačky na rok 2010
--------------------------------------------------------------------------------

CREATE TABLE wreport
(
  idreport integer NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  name character varying(255) NOT NULL,
  description character varying(255) NOT NULL,
  forminfocode character varying(255) NOT NULL,
  CONSTRAINT wreport_pkey PRIMARY KEY (idreport)
);

ALTER TABLE wreport OWNER TO %firmaRole%;

CREATE TABLE wreportdata
(
  idreportdata integer NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  name character varying(255) NOT NULL,
  content oid,
  idreport integer,
  CONSTRAINT wreportdata_pkey PRIMARY KEY (idreportdata),
  CONSTRAINT fk2037f2d57f0ebd6b FOREIGN KEY (idreport)
      REFERENCES wreport (idreport) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wreportdata OWNER TO %firmaRole%;

CREATE INDEX wreportdata_idreport_index
  ON wreportdata
  USING btree
  (idreport);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 246, 't');
