--------------------------------------------------------------------------------
-- Bug 18074 – [WinStrom] Podklady pro výstupy daňové evidence
--------------------------------------------------------------------------------

-- pridani sloupce
ALTER TABLE udanevid ADD COLUMN idtypucop integer;
ALTER TABLE udanevid ADD CONSTRAINT fk32c69288d2470365 FOREIGN KEY (idtypucop)
  REFERENCES utypucop (idtypucop) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
CREATE INDEX uDanEvid_IdTypUcOp_index ON uDanEvid USING btree (IdTypUcOp);

create or replace function uUpdateDanEvid (in _idDoklInt integer) returns void as $$
declare
  doklInt record;
  tempRec record;
  podvoj boolean;
  navazaneDotaz varchar;
  vazeb integer;
  _danEvidK character varying(50);
  _idTypUcOp integer;
  nespadaDph character varying(50);
  _idDanEvid integer;
  _idDoklFak integer;
  castka numeric(15,2);
  castkaMen numeric(15,2);
  castkaZbyva numeric(15,2);
  castkaZbyvaMen numeric(15,2);
  castkaOdpocet numeric(15,2);
  castkaOdpocetMen numeric(15,2);
  zapocteno numeric(15,2);
  zapoctenoMen numeric(15,2);
  domaciMena integer;
  ciziMena boolean;
begin
  nespadaDph := 'danEvid.NeDanEvid';

  select * into doklInt from ddoklint where iddoklint = _idDoklInt;
  select podvojucto, idmeny into podvoj, domaciMena from nnastav where (platioddata is null or platioddata <= doklInt.datUcto) 
    order by coalesce(platioddata, '0001-01-01') desc limit 1;
  
  ciziMena := (doklInt.idMeny is not null and domaciMena <> doklInt.idMeny);
  
  if (doklInt.modul not in ('BAN', 'POK')) then
    return;
  end if;

  if (podvoj = false and doklInt.ucetni = true) then
    -- dotaz ktery nalezne veschny navazane faktury a navazane castky
    navazaneDotaz := '(select V.idDoklFak, sum(V.castka) as castka from
         (select idTabA as idDoklFak, castka, 1 as unionId from dvazebtab where typvazbyk = ''typVazbyDokl.uhrada'' and idtabb = ' || doklInt.idDoklInt || '
          union
          select P.idDoklFak, V.castka, 2 as unionId from dpolfak as P join dVazebTab as V on 
            (V.typvazbyk = ''typVazbyDokl.uhradaZALOHY'' and V.idTabB = ' || doklInt.idDoklInt || ' and V.idTabA in 
              (select idTabB from dVazebTab where typVazbyK = ''typVazbyDokl.odpocetZALOHY'' and idTabA = P.idPolFak))
          union
          select P.idDoklFak, V.castka, 3 as unionId from dpolfak as P join dVazebTab as V on 
            (V.typvazbyk = ''typVazbyDokl.vazbaZDD'' and V.idTabB = ' || doklInt.idDoklInt || ' and V.idTabA in 
              (select idTabB from dVazebTab where typVazbyK = ''typVazbyDokl.odpocetZDD'' and idTabA = P.idPolFak))
          ) as V group by V.idDoklFak)';
    
    execute 'select count(*) from ' || navazaneDotaz || ' as D' into vazeb;
  
    if (vazeb = 0) then			-- pro interni doklad neni vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is not null;           -- vymazeme ty co byli vytvorene pres vazbu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
             
      -- DPH
      select idDanEvid into _idDanEvid from uDanEvid where danEvidK = nespadaDph and idDoklInt = doklInt.idDoklInt;  -- zjistime zda uz zaznam existuje
      select coalesce(sum(sumDph),0),coalesce(sum(sumDphMen),0) into castka,castkaMen from dPolInt 
        where idDoklInt = doklInt.idDoklInt and danEvidK is not null and storno = false;      -- secteme dane
      
      if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
        INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
          VALUES (nespadaDph, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
      else                                     -- zaznam jiz byl vytvoren, vynulujeme i zaklad pokud by jiz nebyl pouzit
        UPDATE uDanEvid SET sumDph = castka, sumDphMen = castkaMen, sumZkl = 0, sumZklMen = 0, kurz = doklInt.kurz, 
          kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
      end if;
    
      -- Zaklad
      for _danEvidK, _idTypUcOp, castka, castkaMen in select danEvidK, idTypUcOp, sum(sumZkl), sum(sumZklMen) 
                from dPolInt where idDoklInt = doklInt.idDoklInt and storno = false and danEvidK is not null group by danEvidK, idTypUcOp loop 
        select idDanEvid into _idDanEvid from uDanEvid where danEvidK = _danEvidK and idDoklInt = doklInt.idDoklInt
          and ((_idTypUcOp is null and idTypUcOp is null) or (_idTypUcOp = idTypUcOp));  -- zjistime zda uz zaznam existuje
        
        if (_idDanEvid is null) then              -- zaznam jeste nebyl vytvoren
          INSERT into uDanEvid (danEvidK, idTypUcOp, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        else                                     -- zaznam jiz byl vytvoren
          UPDATE uDanEvid SET sumZkl = castka, sumZklMen = castkaMen, kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi,
            idMeny = doklInt.idMeny, idDoklFak = null WHERE idDanEvid = _idDanEvid;
        end if;
      end loop; 
    else				            -- pro interni doklad je vazba
      DELETE from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak is null;           -- smazeme polozky co nemaji vazbu na fakturu
      UPDATE uDanEvid set sumZkl = 0, sumDph = 0, sumZklMen = 0, sumDphMen = 0 where idDoklInt = doklInt.idDoklInt;     -- vynulujeme ostatni
      
      drop table if exists tempDanEvid;
      
      CREATE TEMPORARY TABLE tempDanEvid
        (idDoklFak integer NOT NULL,
         danEvidK character varying(50),
         idTypUcOp integer,
         kUhrade numeric(15,2) DEFAULT 0.0 NOT NULL,
         kUhradeMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazeno numeric(15,2) DEFAULT 0.0 NOT NULL,
         uhrazenoMen numeric(15,2) DEFAULT 0.0 NOT NULL,
         vazbaFak numeric(15,2) DEFAULT 0.0 NOT NULL
        );

      for tempRec in execute 'select * from ' || navazaneDotaz || ' as D' loop
        _idDoklFak = tempRec.idDoklFak;
        castka = tempRec.castka;
      
        select * into tempRec from dDoklFak where idDoklFak = _idDoklFak;
        if ((ciziMena = true and (tempRec.idMeny is null or tempRec.idMeny <> doklInt.idMeny)) 
         or (ciziMena = false and tempRec.idMeny is not null and tempRec.idMeny <> domaciMena)) then
          raise exception 'uUpdateDanEvid: Nesouhlasi meny dokladu';
        end if;
      
        -- zjistime kolik je treba na fakture uhradit a kolik je uhrazeno
        insert into tempDanEvid (idDoklFak, danEvidK, idTypUcOp, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) 
          select _idDoklFak, danEvidK, idTypUcOp, castka, sum(sumZkl), sum(sumZklMen), 
               (select coalesce(sum(sumZkl),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK),
               (select coalesce(sum(sumZklMen),0) from uDanEvid where idDoklFak = _idDoklFak and danEvidK = P.danEvidK)
           from dPolFak as P where idDoklFak = _idDoklFak and danEvidK is not null and storno = false
             and typPolozkyK not in ('typPolozky.odpocetZdd', 'typPolozky.odpocetZalohy') group by danEvidK, idTypUcOp;
           
        -- dan
        insert into tempDanEvid (idDoklFak, danEvidK, vazbaFak, kUhrade, kUhradeMen, uhrazeno, uhrazenoMen) values (_idDoklFak, null, castka,   -- dan si oznacime jako null
           (select coalesce(sum(sumDph),0) from dPolFak where idDoklFak = _idDoklFak and danEvidK is not null and storno = false 
              and typPolozkyK not in ('typPolozky.odpocetZdd', 'typPolozky.odpocetZalohy')),     -- castka dane dokladu
           (select coalesce(sum(sumDphMen),0) from dPolFak where idDoklFak = _idDoklFak and danEvidK is not null and storno = false
              and typPolozkyK not in ('typPolozky.odpocetZdd', 'typPolozky.odpocetZalohy')),  -- castka dane dokladu v mene
           (select coalesce(sum(sumDph),0) from uDanEvid where idDoklFak = _idDoklFak),                             -- uhrazena dan dokladu
           (select coalesce(sum(sumDphMen),0) from uDanEvid where idDoklFak = _idDoklFak)                           -- uhrazena dan dokladu v mene
          );
      end loop;
      
      zapocteno := 0;
      zapoctenoMen := 0;
      
      for _idDoklFak,castka in select idDoklFak,vazbaFak from tempDanEvid group by idDoklFak,vazbaFak loop           -- prochazime navazene faktury
        castkaMen := castka;

        for tempRec in select * from tempDanEvid where idDoklFak = _idDoklFak order by (case when (kUhrade-uhrazeno) < 0 then -1 else 1 end), -- napred zaporny 
                                                                                              danEvidK desc loop    -- sestupne aby null (dan) bylo prvni
        
          if ((ciziMena = false and castka <> 0) or (ciziMena = true and castkaMen <> 0)) then                -- pokud jeste mame nejakou castku
            castkaZbyva := tempRec.kUhrade - tempRec.uhrazeno;
            castkaZbyvaMen := tempRec.kUhradeMen - tempRec.uhrazenoMen;
            
            if ((ciziMena = false and castkaZbyva <> 0) or (ciziMena = true and castkaZbyvaMen <> 0)) then    -- pokud na aktualnim zaznamu zbyva neco uhradit
              if ((ciziMena = false and castka > 0 and castkaZbyva > 0) or (ciziMena = true and castkaMen > 0 and castkaZbyvaMen > 0)) then
                castkaOdpocet := minValue(castka, castkaZbyva);      -- spocteme kolik budeme "odpocitavat"
                castkaOdpocetMen := minValue(castkaMen, castkaZbyvaMen);
              else
                if ((ciziMena = false and castka < 0 and castkaZbyva < 0) or (ciziMena = true and castkaMen < 0 and castkaZbyvaMen < 0)) then
                  castkaOdpocet := maxValue(castka, castkaZbyva);
                  castkaOdpocetMen := maxValue(castkaMen, castkaZbyvaMen);
                else
                  castkaOdpocet := castkaZbyva;
                  castkaOdpocetMen := castkaZbyvaMen;
                end if;
              end if;
              
              castka := castka - castkaOdpocet;                    -- odebereme to z odpocitatelne castky
              castkaMen := castkaMen - castkaOdpocetMen;
              zapocteno := zapocteno + castkaOdpocet;
              zapoctenoMen := zapoctenoMen + castkaOdpocetMen;
              
              if (ciziMena = true) then
                castkaOdpocet := castkaOdpocetMen * doklInt.kurz / doklInt.kurzmnozstvi;
              else
                castkaOdpocetMen := 0;
              end if;
              
              if (tempRec.danEvidK is null) then        -- pokud se jedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and danEvidK = nespadaDph;  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, sumDph, sumDphMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (nespadaDph, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumDph = castkaOdpocet, sumDphMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              else                                      -- pokud se nejedna o dan
                select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and danEvidK = tempRec.danEvidK
                  and ((tempRec.idTypUcOp is null and idTypUcOp is null) or (tempRec.idTypUcOp = idTypUcOp));  -- zjistime zda uz zaznam existuje
                
                if (_idDanEvid is null) then            -- zaznam jeste nebyl vytvoren
                  INSERT into uDanEvid (danEvidK, idTypUcOp, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idDoklFak, idMeny) 
                    VALUES (tempRec.danEvidK, tempRec.idTypUcOp, castkaOdpocet, castkaOdpocetMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, tempRec.idDoklFak, doklInt.idMeny);
                else                                    -- zaznam jiz byl vytvoren
                  UPDATE uDanEvid SET sumZkl = castkaOdpocet, sumZklMen = castkaOdpocetMen, 
                    kurz = doklInt.kurz, kurzMnozstvi = doklInt.kurzmnozstvi, idMeny = doklInt.idMeny WHERE idDanEvid = _idDanEvid;
                end if;
              end if;
            
              select idDanEvid into _idDanEvid from uDanEvid where idDoklInt = doklInt.idDoklInt and idDoklFak = tempRec.idDoklFak and
                 ((tempRec.danEvidK is not null and danEvidK = tempRec.danEvidK) or (tempRec.danEvidK is null and danEvidK = nespadaDph));  -- zjistime zda uz zaznam existuje
            end if;
          end if;
        
        end loop;
      end loop;
      
      if ((ciziMena = false and zapocteno < doklInt.sumCelkem) or (ciziMena = true and zapoctenoMen < doklInt.sumCelkemMen)) then     -- pokud neni komplet sparovan
        castka = doklInt.sumCelkem - zapocteno;
        castkaMen = doklInt.sumCelkemMen - zapoctenoMen;
        if (ciziMena = true) then
          castka := castkaMen * doklInt.kurz / doklInt.kurzmnozstvi;
        else
          castkaMen := 0;
        end if;
        
        -- vybereme typ pro ktery je nejvetsi castka, pokud takovy neni nechame castku viset, protoze se jedna o celou castku
        select danEvidK, idTypUcOp into _danEvidK, _idTypUcOp from uDanEvid where idDoklInt = doklInt.idDoklInt order by sumZkl desc limit 1;
        if _danEvidK is not null then
          INSERT into uDanEvid (danEvidK, idTypUcOp, sumZkl, sumZklMen, kurz, kurzMnozstvi, idDoklInt, idMeny) 
            VALUES (_danEvidK, _idTypUcOp, castka, castkaMen, doklInt.kurz, doklInt.kurzmnozstvi, doklInt.idDoklInt, doklInt.idMeny);
        end if;
        
      end if;
      
    end if;
  end if;
  
  DELETE from uDanEvid WHERE idDoklInt = doklInt.idDoklInt and sumZkl = 0 and sumZklMen = 0 and sumDph = 0 and sumDphMen = 0;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.uUpdateDanEvid(integer) OWNER TO %firmaRole%;



create or replace function runupgrade()
    returns void as $$
declare
    _podvojUcto boolean;
begin
  select podvojucto into _podvojUcto from nnastav
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);
  
  -- prepocet danove evidence provedeme jen pro DE
  if (_podvojUcto = false) then
    perform uUpdateDanEvid(idDoklInt) from dDoklInt;
  end if; 
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 251, 't');
