------------------------------------------------------------------------------------------
-- Bug 18417 – [Winstrom] Převodka včetně aktualizace cen
------------------------------------------------------------------------------------------

create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = 0.0;
          _sumZkl = 0.0;
          for _navazanaPolSklad in (select * from dPolSklad
	        where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
	        if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _navazanaPolSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;
          end loop;
        else
          if(_navazanaPolSklad.mnozMj <> 0.0) then
            _cenaMj = (_navazanaPolSklad.sumZkl / _navazanaPolSklad.mnozMj) / _kurzDokladu;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _navazanaPolSklad.sumZkl;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum));  
      if (not _sklfifo) then
        update dPolSklad set
          cenaMj = _cenaMj,
          sumZkl = _sumZkl,
          sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;

      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0) then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a\\n _skladkarta je % \\na _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = 0.0;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if;

  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idTypDokl, _rozsirenaPolozka.datum));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavTuz = _stavTuz,
      stavMen = _stavTuz / _kurzSkladKarty,
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;


-- Function: skladgenerujrozsirenepolozky(date, integer, integer)

DROP FUNCTION skladgenerujrozsirenepolozky(date, integer, integer);

CREATE OR REPLACE FUNCTION skladgenerujrozsirenepolozky(i_datum date, i_idpolsklad integer, i_idskladkarty integer)
  RETURNS boolean AS
$BODY$ 
declare 
  tmp_skladovekarty_exists boolean; 
  tmp_rozsirenepolozky_exists boolean; 
  _polSklad record; 
  _skladKarta record; 
  _pocetSkladKarty integer; 
  _result boolean;
begin 
  -- pokud se zde nebyli tabulky vytvoreny tak se vrati false a pokud ano tak se true
  _result = false;

  -- vytvoreni temporary tabulky pro ulozeni seznamu skladovych karet na kterych dochazi k prepoctu 
  tmp_skladovekarty_exists := (select istableexist('tmp_SkladoveKarty')); 
  if(tmp_skladovekarty_exists <> true) then 
    --raise exception 'tmp_skladoveKarty se vytvari'; 
    CREATE TEMPORARY TABLE tmp_SkladoveKarty ( 
      idskladkarty integer 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 
  end if; 
 
  -- vytvoreni temporary tabulky pro ulozeni seznamu polozek, ktere budou prepocitavat skladove karty 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists <> true) then 
    CREATE TEMPORARY TABLE tmp_RozsirenePolozky ( 
      idpolsklad integer, 
      iddoklskladMaster integer, 
      iddoklskladpolozky integer, 
      datum date, 
      skupina integer, 
      typPohybuK character varying, 
      idskladkarty integer, 
      storno boolean 
      --mnozMj numeric(19,6), 
      --cenaMj numeric(19,6), 
      --sumZkl numeric(19,6) 
    ) WITH (OIDS=TRUE) ON COMMIT DROP; 

    -- tabulky zde byli vytvoreny tim padem se musi vracet true
    _result = true;
  end if; 
   
  if(i_idSkladKarty is not null and i_idSkladKarty <> -1) then 
    -- pokud se jedna o prepocet po vlozeni jedna polozky nebo o rekurzi tak se vse dela jen s jednou skladovou kartou 
    select count(*) into _pocetSkladKarty from tmp_SkladoveKarty where idskladkarty = i_idSkladKarty; 
    if(_pocetSkladKarty = 0) then 
      insert into tmp_SkladoveKarty (idskladkarty) values (i_idSkladKarty); 
      for _polSklad in (select * from dpolsklad where datVyst >= i_datum and idkarty = i_idSkladKarty) loop 
        execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
      end loop; 
    else 
      -- do something stupid - kdyz je skladkarta v seznamu 
    end if; 
  else 
    -- pokud se jedna o celkovy prepocet skladu tak do tmp tabulky skladovych karet dam vsechny pro dane obdobi 
    -- TODO omezit na obdobi 
    for _skladKarta in (select * from skarty) loop 
      insert into tmp_SkladoveKarty(idskladkarty) values (_skladKarta.idKarty); 
    end loop; 
 
    -- TODO omezit na obdobi 
    for _polSklad in (select * from dpolsklad where datVyst >= i_datum) loop 
      execute skladInsertRozsirenouPolozku(_polSklad.idPolSklad); 
    end loop; 
  end if; 

  return _result;
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladgenerujrozsirenepolozky(date, integer, integer) OWNER TO %firmaRole%;




-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying;
  _mazatTmpTable boolean;
begin 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;   
  --pokud výdej, tak fifuju vazby   
  if (_typPohybuk = 'typPohybu.vydej') then   
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idSkladu, NEW.idKarty, NEW.mnozmj);   
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad);   
  end if; 
 
  -- generuji rozsirene polozky 
  select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

  execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 

  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
      execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
    end if; 
  end loop; 
   
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
  end loop; 

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
  end if;
 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;



-- Function: dpolskladdelete()
-- DROP FUNCTION dpolskladdelete();
CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _mazatTmpTable boolean; 
begin 
  if(not OLD.storno) then 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(OLD.datVyst, OLD.idPolSklad, OLD.idKarty) into _mazatTmpTable; 

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if;
    end loop; 
 
    -- musim jeste odpocist mazanou polozku 
    --execute skladOdpoctiRozsirenouPolozku(OLD.idPolSklad); 
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idSkladu, -1); 
   
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      else 
        --raise exception 'v rozsirenych polozkach je mazana polozka s id %', _rozsirenaPolozka; 
      end if; 
    end loop; 
     
    execute sfifostorno(OLD.idPolSklad, OLD.idDoklSklad); 

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if; 
  
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;



-- Function: dpolskladupdate()
-- DROP FUNCTION dpolskladupdate();
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$ 
declare 
  tmp_rozsirenepolozky_exists boolean; 
  _updatuj boolean; 
  _pocetPolozek integer; 
  _rozsirenaPolozka record; 
  _sklFifo boolean; 
  _mazatTmpTable boolean;
begin 
  /* 
    prepocet skladu budeme provadet jen v okamziku kdy neexistuje tabulka tmp_rozsirenePolozky 
    nebo kdyz tato tabulka existuje ale neni v ni obsazeno polozka kteoru chceme updatovat 
  */ 
  _updatuj = true; 
  tmp_rozsirenepolozky_exists := (select istableexist('tmp_RozsirenePolozky')); 
  if(tmp_rozsirenepolozky_exists = true) then 
    select count(*) into _pocetPolozek from tmp_rozsirenePolozky where idPolSklad = NEW.idPolSklad; 
    if(_pocetPolozek > 0) then 
      _updatuj = false; 
    end if; 
  end if; 
 
  _sklfifo := (select isfifosklad(NEW.datvyst));   
  if (_sklfifo) then   
    --fifo   
    if (OLD.storno=false and NEW.storno=true) then   
      execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);   
    end if;     
    if (OLD.cenamj <> NEW.cenamj) then   
      execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);   
    end if;     
    --fifo konec   
  end if;   
 
  if(_updatuj) then 
 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
    
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> OLD.idPolSklad) then 
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if; 
    end loop; 
 
    execute sprepoctiskladkartu(OLD.mnozMj, OLD.cenaMj, OLD.datVyst, OLD.idKarty, OLD.idDoklSklad, OLD.idSkladu, -1); 
   
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
     
  end if; 
   
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

create or replace function skladInsertRozsirenouPolozku(i_idPolSklad integer) returns void as
$BODY$
declare
  _polSklad record;
  _navazanaPolSklad record;
  _pocetRozsirenePolSklad integer;
  _typPohybuK character varying;
  _pocetProSkupinu integer;
  _skupina integer;
  _idDoklSkladMaster integer;
  _idDoklSkladMasterPom integer;
  _mazatTmpTable boolean;
begin
  select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad;
  select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = _polSklad.idPolSklad;
  if(_pocetRozsirenePolSklad = 0) then
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    -- urceni skupiny do ktere dana polozka patri
    _skupina = 2;
    select count(*) into _pocetProSkupinu from dvazebtab 
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'));
    if(_pocetProSkupinu = 0) then
      if(_typPohybuK = 'typPohybu.prijem') then
        _skupina = 1;
      else
        _skupina = 3;
      end if;
    end if;

    -- urceni id skladoveho doklad ktery je master
    _idDoklSkladMaster = _polSklad.idDoklSklad;
    if(_skupina = 2) then
      -- _idDoklSkladMasterPom
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and 
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus');
      if(_idDoklSkladMasterPom is not null) then
        _idDoklSkladMaster = _idDoklSkladMasterPom;
      end if;
    end if;

    -- rekurzi spoustim pro prevodku a kusovnik
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then
      select * into _navazanaPolSklad from dPolSklad 
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');

      -- pokud neni soucasti prevodky tak se jedna o kusovnik
      if(_navazanaPolSklad is null) then
        select * into _navazanaPolSklad from dPolSklad
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      end if;
      
      if(_navazanaPolSklad is null) then
        --raise notice 'navazana je null';
      else
        --raise notice 'volam rekurzi';
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datVyst, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable;
      end if;
    end if;

    -- vlozeni zaznamu o polozce do tmp tabulky
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, skupina, typPohybuK, idskladkarty, /*mnozMj, cenaMj, sumZkl,*/ iddoklskladpolozky, storno)
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datVyst, _skupina, _typPohybuK, _polSklad.idkarty, /*_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno);
  else
    -- do something stupid - kdyz je polozka v seznamu
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;


-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
RETURNS void AS
$BODY$
declare
  _rozsirenaPolozka record;
  _zaznam record;
  _vyrobniCislo record;
  _pocatek_ucetobd date;
  _konec_ucetobd date;
  _evidVyrCis boolean;
  _mazatTmpTable boolean;
begin
  
  execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
  
  -- nacteni datumu zacatku ucetniho obdobi
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;

  -- smazani tabulky fifo vazeb
  delete from sfifovazby where idpolskladvydej in 
    (select idpolsklad from dpolsklad where 
            datVyst >= _pocatek_ucetobd and datVyst <= _konec_ucetobd);

  delete from sfifovazby f
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p);

  -- nagenerovani pomocnych tabulek
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable;

  -- vynulovani skladovych karet
  execute skladVynulujSkladoveKarty();
  
  -- napocteni rozsirenych polozek
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej') then
      select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;  
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik; 
      if (not _evidVyrCis) then 
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idSkladu, _zaznam.idKarty, _zaznam.mnozmj); 
      else 
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop 
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo; 
        end loop; 
      end if; 
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);  
    end if; 

    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
  end loop;

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 292, 't');
