-----------------------------------------------------------------------------
-- Bug 19333 – [WinStrom] Problém s generací výdejek při změně typu dokladu
-----------------------------------------------------------------------------

create or replace function deletenavazanepolsklad(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$
declare
  _generujSklDoklad boolean;
begin
  _generujSklDoklad = false;
  if(_modul = 'FAV' or _modul = 'FAP') then
    select generovatSkl into _generujSklDoklad from dDoklFak where idDoklFak = (select idDoklFak from dPolFak where idPolFak = _idPolDokl);
  elsif(_modul = 'POK') then
    select generovatSkl into _generujSklDoklad from dDoklInt where idDoklInt = (select idDoklInt from dPolInt where idPolInt = _idPolDokl);
  end if;
  execute deletenavazanepolsklad(_idPolDokl, _modul, _generujSklDoklad);
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying) OWNER TO %firmaRole%;


-- Function: deletenavazanepolsklad(integer, character varying)
-- DROP FUNCTION deletenavazanepolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION deletenavazanepolsklad(_idpoldokl integer, _modul character varying, _generujSklDoklad boolean)
  RETURNS void AS
$BODY$ 
declare 
  _idPolSklad integer; 
  _idVazbyPolSklad integer; 
  _idPolSkladRozpad integer; 
  _zdrojProSklPolDokl boolean; 
begin 
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
    if (_modul like 'FAV' or _modul like 'FAP') then 
      select zdrojProSkl into _zdrojProSklPolDokl from dPolFak where idPolFak = _idPolDokl; 
    elsif (_modul like 'POK') then 
      select zdrojProSkl into _zdrojProSklPolDokl from dPolInt where idPolInt = _idPolDokl; 
    end if; 
 
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
      end loop;  
    end if; 
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      delete from dPolSklad where idPolSklad = _idPolSklad;     
    end if; 
  end loop; 
 
  for _idPolSklad in select idTabA from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSkl'  
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL' 
    loop 
    if (_modul like 'FAV' or _modul like 'FAP') then 
      select zdrojProSkl into _zdrojProSklPolDokl from dPolFak where idPolFak = _idPolDokl; 
    elsif (_modul like 'POK') then 
      select zdrojProSkl into _zdrojProSklPolDokl from dPolInt where idPolInt = _idPolDokl; 
    end if; 
 
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
        select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
        delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
        delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
      end loop;  
    end if; 
     
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSkl';  
    if(_generujSklDoklad = true and _zdrojProSklPolDokl = true) then
      delete from dPolSklad where idPolSklad = _idPolSklad;      
    end if; 
  end loop;   
 
  -- mazani polozek prevodky 
  -- polozky prevodky by meli jit mazat z obou stran 
  for _idPolSklad in select idTabB from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'   
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';   
    delete from dPolSklad where idPolSklad = _idPolSklad;     
  end loop;  
  
  for _idPolSklad in select idTabA from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklPrevod'   
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklPrevod';   
    delete from dPolSklad where idPolSklad = _idPolSklad;      
  end loop;   
  
  -- mazani polozek sady 
  for _idPolSklad in select idTabB from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklSada'   
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dPolSklad where idPolSklad = _idPolSklad;     
  end loop;  
 
  for _idPolSklad in select idTabA from dvazebtab where  
    typVazbyK like 'typVazbyDokl.polozkaSklSada'   
    and idTabB = _idPolDokl and modulB = _modul and modulA = 'SKL'  
    loop  
  
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop   
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;   
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;   
    end loop;  
  
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad    
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad    
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklSada';   
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
 
  -- pokud mazu polozku vydejky, ktera byla vytvorena k polozce prijemky podle kusovniku 
  -- vyhodim vyjimku, polozek vydejky se muselo vytvorit vice a musel bych je smazat vsechny 
  -- navic mi prijemka ridi existenci vydejky a tak bych celou vazbu mel ovladat z ni 
  if (exists (select 1 from dvazebtab where idTabB = _idPolDokl and modulB = _modul 
    and typVazbyK = 'typVazbyDokl.polozkaSklKus')) then 
        raise exception 'polozku dokladu vydejky nelze smazat, smazte zavislou polozku na prijemce'; 
  end if; 
 
  for _idPolSklad in select idTabB from dvazebtab where 
    typVazbyK like 'typVazbyDokl.polozkaSklKus'  
    and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL' 
    loop 
 
    for _idVazbyPolSklad in select idVazbyPolSklad from sVazbyPolSklad where idPolSkladZdroj = _idPolSklad loop  
      select idPolSkladCil into _idPolSkladRozpad from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from sVazbyPolSklad where idVazbyPolSklad = _idVazbyPolSklad;  
      delete from dPolSklad where idPolSklad = _idPolSkladRozpad;  
    end loop; 
 
    delete from dVazebTab where idTabA = _idPolDokl and idTabB = _idPolSklad   
      and modulA like _modul and modulB like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dVazebTab where idTabB = _idPolDokl and idTabA = _idPolSklad   
      and modulB like _modul and modulA like 'SKL' and typVazbyK like 'typVazbyDokl.polozkaSklKus'; 
    delete from dPolSklad where idPolSklad = _idPolSklad;    
  end loop; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION deletenavazanepolsklad(integer, character varying, boolean) OWNER TO %firmaRole%;


create or replace function ddokladupdatesklad() returns trigger as
$BODY$
declare
  _polFak record;
  _idPolSklad integer;
  _idDoklSklad integer;
  _idDoklad integer;
  _doklSklad record;
  _pocetPolozek integer;
  _typZasobyK character varying;
  _sadaItemCount integer;
begin
  if(OLD.generovatSkl <> NEW.generovatSkl) then
    if(NEW.generovatSkl = false and NEW.zdrojProSkl = true) then
      -- pokud se nema podle noveho nastaveni z typu dokladu generovat skladove doklady
      -- a tento doklad je zdrojovy pro generovani skladovych dokladu tak tyto automaticky
      -- vygenerovane doklady musim smazat

      -- nejdriv smazeme polozky navazanych dokladu
      _idDoklad = null;
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        _idDoklad = NEW.idDoklFak;
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          execute deleteNavazanePolSklad(_polFak.idPolFak, _polFak.modul, OLD.generovatSkl);
        end loop;
      elsif(NEW.modul = 'POK') then
        _idDoklad = NEW.idDoklInt;
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          execute deleteNavazanePolSklad(_polFak.idPolInt, _polFak.modul, OLD.generovatSkl);
        end loop;
      end if;

      if(_idDoklad is not null) then
        for _idDoklSklad in select idTabB from dVazebTab where idTabA = _idDoklad and modulA = NEW.modul and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.hlavaSkl') loop
          select * into _doklSklad from dDoklSklad where idDoklSklad = _idDoklSklad;
          select count(idPolSklad) into _pocetPolozek from dPolSklad where idDoklSklad = _idDoklSklad;
          -- smazeme pouze takove doklady, ktere maji pocet polozek = 0 nejsou zdrojove pro generovani faktur
          if(_doklSklad.zdrojProFak = false and _pocetPolozek = 0) then
            delete from dvazebtab where idTabA = _idDoklad and modulA = NEW.modul and idTabB = _idDoklSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.hlavaSkl';
            delete from dDoklSklad where idDoklSklad = _idDoklSklad;
          end if;
        end loop;
      end if;
    elsif (NEW.generovatSkl = true and NEW.zdrojProSkl = true) then
      -- bylo false a nastavi se true tak musime zajistit vygenerovani skladoveho dokladu k polozkam, ktere nejste nejsou vyskladneny
      if(NEW.modul = 'FAV' or NEW.modul = 'FAP') then
        for _polFak in select * from dPolFak where idDoklFak = NEW.idDoklFak loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select typZasobyK into _typZasobyK from cCenik where idCenik = _polFak.idCenik; 
            if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
              select findParovanyPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then 
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then 
                  execute createPolSkladSada(_polFak.idPolFak, NEW.modul); 
                else 
                  select createPolSklad(_polFak.idPolFak, NEW.modul) into _idPolSklad;  
                end if; 
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      elsif (NEW.modul = 'POK') then
        for _polFak in select * from dPolInt where idDoklInt = NEW.idDoklInt loop
          if(_polFak.typPolozkyK like 'typPolozky.katalog' and _polFak.zdrojProSkl) then
            select typZasobyK into _typZasobyK from cCenik where idCenik = _polFak.idCenik; 
            if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
              select findParovanyPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
              if(_idPolSklad is null) then 
                select count(*) into _sadaItemCount from csady where idceniksada = _polFak.idCenik;
                if(_sadaItemCount > 0) then 
                  execute createPolSkladSada(_polFak.idPolInt, NEW.modul);
                else 
                  select createPolSklad(_polFak.idPolInt, NEW.modul) into _idPolSklad;
                end if; 
              else
                -- nejspis nebudeme delat nic
              end if;
            end if;
          end if;
        end loop;
      end if;  
    else
    end if;
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION ddokladupdatesklad() OWNER TO %firmaRole%;

CREATE TRIGGER ddoklfakupdatesklad
  AFTER UPDATE
  ON ddoklfak
  FOR EACH ROW
  EXECUTE PROCEDURE ddokladupdatesklad();

CREATE TRIGGER ddoklintupdatesklad
  AFTER UPDATE
  ON ddoklint
  FOR EACH ROW
  EXECUTE PROCEDURE ddokladupdatesklad();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 310, 't');