--------------------------------------------------------------------------------
-- Bug 19235 – [winstrom] - Automatické párování bankovních výpisů
--------------------------------------------------------------------------------

ALTER TABLE ddoklint ADD COLUMN jakuhrk character varying(50);

-- -----------------------------------------------------------------------------
-- aktualizace jakuhr k jiz existujicich dokladech

alter table ddoklint disable trigger all;

update ddoklint
set jakuhrk = iq2.jakuhrk
from (

select di_iddoklint, di_kod, di_sumcelkem, di_sumcelkemmen, di_sparovano,
  sum(v_castka) as v_sumcastka,
  count(df_kod) as pocetdf, count(df_sumcelkem) as pocetdfazb,
  sum(df_sumcelkem) as df_sumcelkem, sum(df_sumcelkemmen) as df_sumcelkemmen,

  (case when (
      (di_sumcelkem <> 0 and di_sumcelkem = sum(v_castka) and sum(v_castka) = sum(df_sumcelkem)) or
      (di_sumcelkemmen <> 0 and di_sumcelkemmen = sum(v_castka) and sum(v_castka) = sum(df_sumcelkemmen)))
   then
      (case when (count(df_kod) = 1) then 'jakUhrazeno.rucne1' else 'jakUhrazeno.rucneN' end)
   else
      (case when (
        (di_sumcelkem <> 0 and di_sumcelkem = sum(v_castka)
           and ((sum(df_sumcelkem) > 0 and sum(v_castka) < sum(df_sumcelkem)) or
                (sum(df_sumcelkem) < 0 and sum(v_castka) > sum(df_sumcelkem))))
        or
        (di_sumcelkemmen <> 0 and di_sumcelkemmen = sum(v_castka)
           and ((sum(df_sumcelkemmen) > 0 and sum(v_castka) < sum(df_sumcelkemmen)) or
                (sum(df_sumcelkemmen) < 0 and sum(v_castka) > sum(df_sumcelkemmen))))
      ) then 'jakUhrazeno.rucneCast' else null end)
   end) as jakuhrk

 from (
    select di.iddoklint as di_iddoklint, di.kod as di_kod, di.sumcelkem as di_sumcelkem, di.sumcelkemmen as di_sumcelkemmen,
      di.sparovano as di_sparovano, di.jakuhrk as di_jakuhrk,
      v.typvazbyk as v_typvazbyk, v.castka as v_castka,
      df.kod as df_kod,
      df.sumcelkem as df_sumcelkem, df.sumcelkemmen as df_sumcelkemmen
    from ddoklint di inner join (dvazebtab v inner join ddoklfak df on v.idtaba = df.iddoklfak) on di.iddoklint = v.idtabb
    where (v.typvazbyk in ('typVazbyDokl.uhrada', 'typVazbyDokl.uhradaZALOHY'))
    union
    select di.iddoklint as di_iddoklint, di.kod as di_kod, di.sumcelkem as di_sumcelkem, di.sumcelkemmen as di_sumcelkemmen,
      di.sparovano as di_sparovano, di.jakuhrk as di_jakuhrk,
      v.typvazbyk as v_typvazbyk, v.castka as v_castka,
      null as df_kod,
      (case when (v.castka  > 0) then zb.sumcelkem else -zb.sumcelkem end) as df_sumcelkem,
      (case when (v.castka  > 0) then zb.sumcelkemmen else -zb.sumcelkemmen end) as df_sumcelkemmen
    from ddoklint di inner join (dvazebtab v inner join ddoklint zb on v.idtabb = zb.iddoklint) on di.iddoklint = v.idtaba
    where (v.typvazbyk in ('typVazbyDokl.ZB'))
    ) as iq
group by di_iddoklint, di_kod, di_sumcelkem, di_sumcelkemmen, di_sparovano, di_jakuhrk
order by di_iddoklint

) as iq2
where iddoklint = iq2.di_iddoklint;

alter table ddoklint enable trigger all;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 315, 't');
