--------------------------------------------------------------------------------
-- Bug 19538 – [WinStrom] Na ceník přidat novou položku "Běžná cena"
--------------------------------------------------------------------------------

ALTER TABLE ccenik ADD COLUMN cenabezna numeric(19,6) NOT NULL DEFAULT 0.0;
UPDATE ccenik SET cenabezna = 0.0;

--------------------------------------------------------------------------------
-- Bug 19561 – [WinStrom] Na doklad doplnit položku "Činnost"
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_ucinnost
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_ucinnost OWNER TO %firmaRole%;

CREATE TABLE ucinnost
(
  idcinnost integer DEFAULT nextval('seq_ucinnost'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  show boolean NOT NULL DEFAULT true,
  platido integer NOT NULL DEFAULT 9999,
  platiod integer NOT NULL DEFAULT 0,
  CONSTRAINT ucinnost_pkey PRIMARY KEY (idcinnost)
);
ALTER TABLE ucinnost OWNER TO %firmaRole%;

-- navazani na doklady
ALTER TABLE ddoklfak ADD COLUMN idcinnost integer;
ALTER TABLE ddoklfak ADD CONSTRAINT fk649d2f4094e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE ddoklint ADD COLUMN idcinnost integer;
ALTER TABLE ddoklint ADD CONSTRAINT fk649d3c1f94e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE ddoklobch ADD COLUMN idcinnost integer;
ALTER TABLE ddoklobch ADD CONSTRAINT fk2f0cd34894e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE ddoklsklad ADD COLUMN idcinnost integer;
ALTER TABLE ddoklsklad ADD CONSTRAINT fkb2ca2c6794e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

-- navazani na polozky
ALTER TABLE dpolfak ADD COLUMN kopcinnost boolean NOT NULL DEFAULT true;
ALTER TABLE dpolfak ADD COLUMN idcinnost integer;
ALTER TABLE dpolfak ADD CONSTRAINT fk38c1330794e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE dpolint ADD COLUMN kopcinnost boolean NOT NULL DEFAULT true;
ALTER TABLE dpolint ADD COLUMN idcinnost integer;
ALTER TABLE dpolint ADD CONSTRAINT fk38c13fe694e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE dpolobch ADD COLUMN kopcinnost boolean NOT NULL DEFAULT true;
ALTER TABLE dpolobch ADD COLUMN idcinnost integer;
ALTER TABLE dpolobch ADD CONSTRAINT fkdf69486194e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE dpolsklad ADD COLUMN kopcinnost boolean NOT NULL DEFAULT true;
ALTER TABLE dpolsklad ADD COLUMN idcinnost integer;
ALTER TABLE dpolsklad ADD CONSTRAINT fkdfc5a6e94e84085 FOREIGN KEY (idcinnost)
  REFERENCES ucinnost (idcinnost) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

-- indexy
CREATE INDEX dDoklFak_IdCinnost_index ON dDoklFak USING btree (IdCinnost);
CREATE INDEX dDoklInt_IdCinnost_index ON dDoklInt USING btree (IdCinnost);
CREATE INDEX dDoklObch_IdCinnost_index ON dDoklObch USING btree (IdCinnost);
CREATE INDEX dDoklSklad_IdCinnost_index ON dDoklSklad USING btree (IdCinnost);
CREATE INDEX dPolFak_IdCinnost_index ON dPolFak USING btree (IdCinnost);
CREATE INDEX dPolInt_IdCinnost_index ON dPolInt USING btree (IdCinnost);
CREATE INDEX dPolObch_IdCinnost_index ON dPolObch USING btree (IdCinnost);
CREATE INDEX dPolSklad_IdCinnost_index ON dPolSklad USING btree (IdCinnost);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 320, 't');