--------------------------------------------------------------------------------
-- Bug 19750 – [winstrom] - faktury V+P - Změna skladu u položky s výrobním číslem jde do chyby
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dzpoldoklcheckvyrcisl()
  RETURNS trigger AS
$BODY$  
declare
  _vyrCisl record;
begin
  /*
   Tento trigger zjistuje zda je sklad na vyrobnim cisle stejny jako na navazane polozce dokladu
   a pokud ne tak ho odvaze z teto polozky
  */
  if(NEW.modul = 'FAV') then
    for _vyrCisl in (select * from svyrobnicislo where idPolFakVydej = NEW.idPolFak) loop
      if(_vyrCisl.idtypdokl = NEW.idSkladu) then
        -- vsechno je v pohode
      else
        update svyrobnicislo set idpolfakvydej = null, idpolskladvydej = null where idvyrobnicislo = _vyrCisl.idvyrobnicislo; 
      end if;
    end loop;
  elsif(NEW.modul = 'POK') then
    for _vyrCisl in (select * from svyrobnicislo where idPolIntVydej = NEW.idPolInt) loop
      if(_vyrCisl.idtypdokl = NEW.idSkladu) then
        -- vsechno je v pohode
      else
        update svyrobnicislo set idpolintvydej = null, idpolskladvydej = null where idvyrobnicislo = _vyrCisl.idvyrobnicislo; 
      end if;
    end loop;
  end if;
  return NEW;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dzpoldoklcheckvyrcisl() OWNER TO %firmaRole%;

CREATE TRIGGER dzpolfakcheckvyrcisl
  AFTER UPDATE
  ON dpolfak
  FOR EACH ROW
  EXECUTE PROCEDURE dzpoldoklcheckvyrcisl();

CREATE TRIGGER dzpolintcheckvyrcisl
  AFTER UPDATE
  ON dpolint
  FOR EACH ROW
  EXECUTE PROCEDURE dzpoldoklcheckvyrcisl();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 335, 't');