--------------------------------------------------------------------------------
-- Bug 20566 – [winstrom] - 51 - Výběr tiskového formuláře pro konkrétní typ dokladu. (Axes)
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_dautotisk
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
ALTER TABLE seq_dautotisk OWNER TO %firmaRole%;

CREATE TABLE dautotisk
(
    idautotisk integer DEFAULT nextval('seq_dautotisk'::regclass) NOT NULL,
    lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
    pocet integer DEFAULT 0 NOT NULL,
    typTiskDoklK character varying(50) NOT NULL,
    report character varying(255) NOT NULL,
    idtypdokl integer NOT NULL,
    CONSTRAINT dautotisk_pkey PRIMARY KEY (idautotisk),
    CONSTRAINT dautotisk_idtypdokl_fk FOREIGN KEY (idtypdokl)
        REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE dautotisk OWNER TO %firmaRole%;

CREATE INDEX dAutoTisk_IdTypDokl_index ON dAutoTisk USING btree (IdTypDokl);

CREATE OR REPLACE FUNCTION runupgrade() RETURNS void AS $$
declare
    _td record;
begin
    for _td in select * from dtypdokl where modul = 'FAV' loop
        if (_td.tiskfakturapocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskfakturapocet, 'typTiskDokladu.doklad', 'favAkt:fakturaKB', _td.idtypdokl);
        end if;

        if (_td.tiskzjeddandoklpocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskzjeddandoklpocet, 'typTiskDokladu.doklad', '_globalreports/prodejka:prodejka60mm', _td.idtypdokl);
        end if;

        if (_td.tiskdodakpocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskdodakpocet, 'typTiskDokladu.doklad', '_globalreports/dodaciList:dodaciList', _td.idtypdokl);
        end if;

        if (_td.tiskpokldoklpocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskpokldoklpocet, 'typTiskDokladu.dokladPokladny', 'pokAkt:pokDoklad', _td.idtypdokl);
        end if;

        if (_td.tiskvydejkapocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskvydejkapocet, 'typTiskDokladu.dokladSkladu', 'sklAkt:prijemkaVydejka', _td.idtypdokl);
        end if;

        if (_td.tiskdodakvydejkapocet != 0) then
            insert into dautotisk(pocet, typTiskDoklK, report, idtypdokl)
                values (_td.tiskdodakvydejkapocet, 'typTiskDokladu.dokladSkladu', '_globalreports/dodaciList:dodaciList', _td.idtypdokl);
        end if;
    end loop;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();
drop function runupgrade();

ALTER TABLE dtypdokl 
            DROP COLUMN tiskfakturapocet,
            DROP COLUMN tiskzjeddandoklpocet,
            DROP COLUMN tiskdodakpocet,
            DROP COLUMN tiskpokldoklpocet,
            DROP COLUMN tiskdodakvydejkapocet,
            DROP COLUMN tiskvydejkapocet;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 379, 't');
