--------------------------------------------------------------------------------
-- Bug 20647 – [WinStrom] Pokročilá filtrace - Datový model pro filtry
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wfiltry
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wfiltry OWNER TO %firmaRole%;

CREATE TABLE wfiltry (
    idfiltru integer DEFAULT nextval('seq_wfiltry'::regclass) NOT NULL,
    lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,

    kod character varying(20),
    nazev character varying(255) NOT NULL,
    beankey character varying(50) NOT NULL,
    obsahfiltru text,

    privatni boolean DEFAULT false NOT NULL,
    navrhar boolean DEFAULT false NOT NULL,
    iduzivatel integer NOT NULL,

    CONSTRAINT wfiltry_pkey PRIMARY KEY (idfiltru),
    CONSTRAINT wfiltry_iduzivatel FOREIGN KEY (iduzivatel)
      REFERENCES wuzivatel (iduzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE wfiltry OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 380, 't');
