-- uprava funkce na generovani unikatniho kodu
CREATE OR REPLACE FUNCTION generateuniquekod(i_kod character varying, i_tablename character varying, infix character varying)
  RETURNS character varying AS $$
declare 
  _result varchar(20); 
  _resultExt varchar(20); 
  _pocet integer;
  _cislo integer;
begin
  -- pokud neexistuje vratime ho beze zmen
  execute 'select count(*) from '||i_tableName|| ' where kod = '''||i_kod||'''' into _pocet;
  if (_pocet = 0) then
    return i_kod;
  end if;

  _result = substring(i_kod, 0, 14);
  _resultExt = _result;
  _cislo = 2;
  execute 'select count(*) from '||i_tableName|| ' where kod = '''||_result||'''' into _pocet;
  while (_pocet > 0) loop
    _resultExt = _result||infix||_cislo;
    _cislo = _cislo + 1;
    execute 'select count(*) from '||i_tableName|| ' where kod = '''||_resultExt||'''' into _pocet;
  end loop;
  
  return _resultExt;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.generateUniqueKod(varchar, varchar, varchar) OWNER TO %firmaRole%;


-- zneplatneni stavajicich typu dokladu
update dtypdokl set platido = 2008 where idtypdokl in (12, 15, 16, 25, 26, 34, 35);


-- nastaveni uuid jiz existujicim dokladum
-- cz podnikatele
update dtypdokl set uuid = 'CZ_POD_08_FAV_STD' where idtypdokl = 12;
update dtypdokl set uuid = 'CZ_POD_08_BAN_STD' where idtypdokl = 13;
update dtypdokl set uuid = 'CZ_POD_08_FAV_ZAL' where idtypdokl = 14;
update dtypdokl set uuid = 'CZ_POD_08_FAP_SLU' where idtypdokl = 15;
update dtypdokl set uuid = 'CZ_POD_08_FAP_MAT' where idtypdokl = 16;
update dtypdokl set uuid = 'CZ_POD_08_POK_KC' where idtypdokl = 17;
update dtypdokl set uuid = 'CZ_POD_08_SKL_STD' where idtypdokl = 18;
update dtypdokl set uuid = 'CZ_POD_08_FAP_ZAL' where idtypdokl = 19;
update dtypdokl set uuid = 'CZ_POD_08_INT_KURROZ_ZISK' where idtypdokl = 20;
update dtypdokl set uuid = 'CZ_POD_08_INT_KURROZ_ZTRATA' where idtypdokl = 21;
update dtypdokl set uuid = 'CZ_POD_08_INT_ZBYTEK_VYNOS' where idtypdokl = 22;
update dtypdokl set uuid = 'CZ_POD_08_INT_ZBYTEK_NAKLAD' where idtypdokl = 23;
update dtypdokl set uuid = 'CZ_POD_08_FAP_ZDD' where idtypdokl = 24;
update dtypdokl set uuid = 'CZ_POD_08_FAP_ZBO' where idtypdokl = 25;
update dtypdokl set uuid = 'CZ_POD_08_FAP_SPOTMAT' where idtypdokl = 26;
update dtypdokl set uuid = 'CZ_POD_08_POK_EUR' where idtypdokl = 27;
update dtypdokl set uuid = 'CZ_POD_08_PPP_STD' where idtypdokl = 28;
update dtypdokl set uuid = 'CZ_POD_08_NAV_STD' where idtypdokl = 29;
update dtypdokl set uuid = 'CZ_POD_08_OBP_STD' where idtypdokl = 30;
update dtypdokl set uuid = 'CZ_POD_08_PPV_STD' where idtypdokl = 31;
update dtypdokl set uuid = 'CZ_POD_08_NAP_STD' where idtypdokl = 32;
update dtypdokl set uuid = 'CZ_POD_08_OBV_STD' where idtypdokl = 33;
update dtypdokl set uuid = 'CZ_POD_08_ZAV_STD' where idtypdokl = 34;
update dtypdokl set uuid = 'CZ_POD_08_PHL_STD' where idtypdokl = 35;
-- cz rozpoctovky
update dtypdokl set uuid = 'CZ_ROZ_08_INT_KURROZ_ZISK' where idtypdokl = 37;
update dtypdokl set uuid = 'CZ_ROZ_08_INT_KURROZ_ZTRATA' where idtypdokl = 38;
update dtypdokl set uuid = 'CZ_ROZ_08_INT_ZBYTEK_VYNOS' where idtypdokl = 39;
update dtypdokl set uuid = 'CZ_ROZ_08_INT_ZBYTEK_NAKLAD' where idtypdokl = 40;
-- sk podnikatele
update dtypdokl set uuid = 'SK_POD_08_INT_KURROZ_ZISK' where idtypdokl = 41;
update dtypdokl set uuid = 'SK_POD_08_INT_KURROZ_ZTRATA' where idtypdokl = 42;
update dtypdokl set uuid = 'SK_POD_08_INT_ZBYTEK_VYNOS' where idtypdokl = 43;
update dtypdokl set uuid = 'SK_POD_08_INT_ZBYTEK_NAKLAD' where idtypdokl = 44;


-- vytvoreni novych typu dokladu pro rok 2009 - zmena cleneni dph
INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-06-26 17:01:17.078', generateuniquekod('FAKTURA 09', 'dtypdokl', ' '), 'Faktura - daňový doklad', NULL, NULL, NULL, 'Typ dokladu pro standardní fakturu', NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, 'formaUhr.prevod', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'FAV', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 14, NULL, 'typDokladu.faktura', true, NULL, NULL, 'zaokrJak.nahoru', 'zaokrJak.matem', 'zaokrNa.desetiny', 'zaokrNa.desetiny', NULL, 
 (select idrady from drady where idrady = 1), 
 NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 38, 123, 80, NULL, NULL, NULL, 1, NULL, NULL, 117, NULL, 1, 149, NULL, 13, NULL, 124, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_FAV_STD');

INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-06-26 16:22:57.953', generateuniquekod('SLUŽBY 09', 'dtypdokl', ' '), 'Přijatá faktura za služby', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'FAP', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 5), 
 NULL, NULL, 38, 123, NULL, NULL, 135, NULL, NULL, NULL, NULL, 119, NULL, 1, NULL, NULL, 13, NULL, 124, 108, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_FAP_SLU');
INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-09-08 11:18:48.25', generateuniquekod('MATERIÁL 09', 'dtypdokl', ' '), 'Přijatá faktura za pořízení materiálu (způsob A)', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'FAP', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 5), 
 NULL, NULL, 38, 123, NULL, NULL, 159, NULL, NULL, NULL, NULL, 119, NULL, 1, NULL, NULL, 13, NULL, 124, 108, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_FAP_MAT');

INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-11-05 21:57:42.387', generateuniquekod('ZBOŽÍ 09', 'dtypdokl', ' '), 'Přijatá faktura za pořízení zboží (způsob A)', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'FAP', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 5), 
 NULL, NULL, 38, 123, NULL, NULL, 113, NULL, NULL, NULL, NULL, 119, NULL, 1, NULL, NULL, 13, NULL, 124, 108, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_FAP_ZBO');
INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-09-08 11:19:53.718', generateuniquekod('SPOTŘMAT 09', 'dtypdokl', ' '), 'Přijatá faktura za spotřební materiál', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'FAP', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 5), 
 NULL, NULL, 38, 123, NULL, NULL, 131, NULL, NULL, NULL, NULL, 119, NULL, 1, NULL, NULL, 13, NULL, 124, 108, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_FAP_SPOTMAT');

INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-11-05 17:04:44.652', generateuniquekod('OST. ZÁVAZKY 09', 'dtypdokl', ' '), 'Ostatní závazky', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'ZAV', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 18 and modul = 'ZAV'),
 NULL, NULL, 38, 123, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 13, NULL, 124, 108, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_ZAV_STD');
INSERT INTO dtypdokl (lastupdate, kod, nazev, nazeva, nazevb, nazevc, popis, poznam, show, bic, buc, buckonverze, bucprimarni, danevidk, doprava, email, fax, formauhrk, iban, jazyk1k, jazyk2k, jazyk3k, jazyk4k, jazyk5k, jazyk6k, mesto, mobil, modul, nazbanky, priprikaz, privypis, psc, slevadokl, sloprikaz, slovypis, specsym, splatdny, tel, typdoklk, ucetni, ulice, www, zaokrjakdphk, zaokrjaksumk, zaokrnadphk, zaokrnasumk, zkrklienta, idradyprijem, idtiskses6, idtiskses2, idstatpuvod, idstatodesl, idtiskses5, idobchtrans, idradyvydej, idtiskses4, iducetobdobiod, idstatdph, iddphsnizucet, idclendphp, idsmerkod, idprotiucetv, idelbanformat, idkonsym, iddruhdopr, idtiskses3, idprimucet, idzvlpoh, idstred, idprotiucetp, idstatu, idtypdoklban, idmeny, iddphzaklucet, idclendphv, idmenabanky, idkrajurc, idtiskses1, iducetobdobido, iddodpodm, idstaturc, platiod, uuid) 
VALUES ('2008-11-05 17:06:05.831', generateuniquekod('OST. POHLEDÁVKY 09', 'dtypdokl', ' '), 'Ostatní pohledávky', NULL, NULL, NULL, NULL, NULL, true, NULL, NULL, false, false, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'PHL', NULL, NULL, NULL, NULL, 0.00, NULL, NULL, NULL, 0, NULL, 'typDokladu.faktura', true, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
 (select idrady from drady where idrady = 19 and modul = 'PHL'),
 NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 38, 123, 80, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, 124, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 2009,
 'CZ_POD_09_PHL_STD');


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 39, 't');
