---------------------------------------------------------------------------------------
-- Bug 21104 – [WinStrom] Oprava nákupu s v.č. (změna množství) "maže" v.č. z příjemky
---------------------------------------------------------------------------------------

-- Function: dpoldoklupdatesklad()
-- DROP FUNCTION dpoldoklupdatesklad();
CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer; 
  _vypnutySklad character varying;  
begin 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    --raise exception 'sem sem se nemel dostat'; 
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
      return NEW; 
    end if; 
 
    if(NEW.modul like 'POK') then 
      _idPolDokl = NEW.idPolInt; 
      _idDoklad = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
      _idPolDokl = NEW.idPolFak; 
      _idDoklad = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    else  
      return NEW;   
    end if; 
 
    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
    if((NEW.idSkladu <> OLD.idSkladu or NEW.idCenik <> OLD.idCenik  
       or NEW.typPolozkyK <> OLD.typPolozkyK or NEW.mnozMj <> OLD.mnozMj 
       or NEW.sarze <> OLD.sarze or NEW.expirace <> OLD.expirace) 
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then   
      --raise exception 'mazu polSklad'; 
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
    end if; 
 
    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then   
      select typZasobyK into _typZasobyK from cCenik where idCenik = NEW.idCenik; 
     
      if (_typZasobyK like 'typZasoby.skladem' or _typZasobyK like 'typZasoby.vyrobek') then 
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
        if(_idPolSklad is null) then 
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          if(_sadaItemCount > 0) then 
            execute createPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        else 
          if(_sadaItemCount > 0) then 
            execute fillPolSkladSada(_idPolDokl, NEW.modul);
          else 
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        end if; 
        -- provedeni upgradu vyrobnich cisel 
        if(NEW.modul like 'FAV') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'FAP') then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'POK') then 
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
          if(_typPohybuK like 'typPohybu.prijem') then 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          else 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          end if; 
        end if; 
 
      end if; 
      -- prepocteni sum na dokladu 
      select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
      execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst); 
    end if; 
  end if; 
 
  return NEW; 
end 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad() OWNER TO %firmaRole%;


---------------------------------------------------
-- Bug 21128 – [WinStrom] Prodej na fakturu - sada
---------------------------------------------------

-- Function: skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer)
-- DROP FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer);
CREATE OR REPLACE FUNCTION skladfindcenamjnakup(i_mnozmj numeric, i_idcenik integer, i_idskladu integer, i_datum date, i_sarze character varying, i_expirace date, i_idvyrobnihocisla integer)
  RETURNS numeric AS
$BODY$ 
declare 
  _sklfifo boolean; 
  _mazatTmpTable boolean; 
  _idkarty integer; 
  _rozsirenaPolozka record; 
  _iducetobdobi integer; 
  _result numeric(19,6); 
  _pomocDPolSkladF record; 
  _mnozstvi numeric(19,6); 
  _potrebnyPocet numeric(19,6); 
  _sadaItemCount integer; 
  _polozkaSady record; 
  _pomoc numeric(19,6); 
 
  _sumSumZkl numeric(19,6); 
  _sumMnozMj numeric(19,6); 
  _sumTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _typPohybuK character varying; 
  _karta record; 
begin 
  _result = 0.0; 
  _mnozstvi = 0.0; 
 
  if(i_mnozMj > 0) then 
    select count(*) into _sadaItemCount from csady where idceniksada = i_idcenik; 
    if(_sadaItemCount > 0) then 
      FOR _polozkaSady IN (select * from cSady where idCenikSada = i_idcenik) LOOP 
        -- TODO doresit sarze expirace a vyrobni cisla 
        select skladfindcenamjnakup(i_mnozmj * _polozkaSady.mnozMj, _polozkaSady.idcenik, i_idskladu, i_datum, null, null, null) into _pomoc; 
        _result = _result + (_pomoc * i_mnozmj * _polozkaSady.mnozMj); 
      end loop; 
    else 
      select findiducetniobdobikdatu(i_datum) into _iducetobdobi; 
      _sklfifo := (select isfifosklad(i_datum)); 
      if (_sklfifo) then 
        if(i_idvyrobnihocisla is not null and i_idvyrobnihocisla > 0) then 
          -- pokud je zadano vyrobni cislo ma nejvetsi prioritu 
          select cenaMj into _result from dpolskladf where idcenik = i_idcenik and idskladu = i_idskladu and idvyrobnicislo = i_idvyrobnihocisla; 
        elsif(i_sarze is not null and i_expirace is not null) then 
          -- pokud je zadana sarze i expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze and expirace = i_expirace order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is not null and i_expirace is null) then 
          -- pokud je zadana jen sarze 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and sarze = i_sarze order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        elsif(i_sarze is null and i_expirace is not null) then 
          -- pokud je zadana jen expirace 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu and expirace = i_expirace order by datVyst,idpolsklad) loop 
            if(i_mnozMj > _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        else 
          -- pokud neni zadana ani sarze ani expirace ani vyrobni cislo 
          for _pomocDPolSkladF in (select * from dpolskladf where idcenik = i_idcenik and idSkladu = i_idSkladu order by datVyst,idpolsklad) loop 
            if(i_mnozMj >= _mnozstvi) then 
              _potrebnyPocet = _pomocDPolSkladF.pocet; 
              if((_mnozstvi + _potrebnyPocet) > i_mnozMj) then 
                _potrebnyPocet = i_mnozMj - _mnozstvi; 
              end if; 
              _mnozstvi = _mnozstvi + _potrebnyPocet; 
              _result = _result + _potrebnyPocet * _pomocDPolSkladF.cenaMj; 
            end if; 
          end loop; 
          if(_mnozstvi != 0.0) then 
            _result = _result / _mnozstvi; 
          else 
            _result = 0.0; 
          end if; 
        end if; 
      else 
        -- generuji rozsirene polozky 
        select * into _karta from skarty where idcenik = i_idcenik and idtypdokl = i_idskladu and iducetobdobi = _iducetobdobi; 
	if(_karta is null) then 
	  raise exception 'Nenalezena sklad karta'; 
	end if; 
        _sumTuz = 0.0; 
        _mnozMj = 0.0; 
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d 
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.prijem' and p.datVyst > i_datum; 
        if(_sumSumZkl is null) then 
          _sumSumZkl = 0.0; 
        end if; 
        if(_sumMnozMj is null) then 
          _sumMnozMj = 0.0; 
        end if; 
        _sumTuz = _sumTuz + _sumSumZkl; 
        _mnozMj = _mnozMj + _sumMnozMj; 
 
        select sum(p.sumZkl), sum(p.mnozMj) into _sumSumZkl, _sumMnozMj from dPolSklad p, dDoklSklad d 
          where p.idDoklSklad = d.idDoklSklad and p.idKarty = _karta.idKarty and d.typPohybuK = 'typPohybu.vydej'and p.datVyst > i_datum; 
        if(_sumSumZkl is null) then 
          _sumSumZkl = 0.0; 
        end if; 
        if(_sumMnozMj is null) then 
          _sumMnozMj = 0.0; 
        end if; 
        _sumTuz = _sumTuz - _sumSumZkl; 
        _mnozMj = _mnozMj - _sumMnozMj; 
 
        _sumTuz = _karta.stavTuz - _sumTuz; 
        _mnozMj = _karta.stavMj - _mnozMj; 
        if(_mnozMj = 0.0) then 
          _result = 0.0; 
        else 
          _result = _sumTuz / _mnozMj; 
        end if; 
      end if; 
    end if; 
  end if; 
  return _result; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladfindcenamjnakup(numeric, integer, integer, date, character varying, date, integer) OWNER TO %firmaRole%;

insert into dbversion(iddbversion, dbversion, needreimport)
    values (nextval('seq_dbversion'), 396, 't');