--------------------------------------------------------------------------------
-- Bug 22167 – [WinStrom] Zaktualizovat ciselniky
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
    pocet integer;
begin
  select a.uuid into stat from nnastav n  left join utyporg u on u.idtyporg = n.idtyporg left join astaty a on a.idstatu = u.idstatu
    where ((select max(platioddata) from nnastav) is null or (select max(platioddata) from nnastav) = platioddata);

  -- zmeny v ciselniku ceskych smerovych kodu
  if (stat = 'CZ_CZ') then
    UPDATE asmerkod
    SET platido = 2010
    WHERE uuid in ('CZ_5000', 'CZ_5400', 'CZ_2010', 'CZ_2240');

    INSERT INTO asmerkod (Kod, Nazev, PlatiOd, PlatiDo, LastUpdate, Show, Uuid)
    -- nove
    VALUES ('2250', 'Záložna CREDITAS, spořitelní družstvo', 2011, 9999, '2011-01-27', true, 'CZ_2250'),
      ('2220', 'Artesa, spořitelní družstvo ', 2011, 9999, '2011-01-27', true, 'CZ_2220'),
    
    -- povetsinou pozmeneny nazev
      ('5000', 'Crédit Agricole Corporate and Investment Bank S.A. Prague, organizační složka', 2011, 9999, '2011-01-27', true, 'CZ_5000'),
      ('5400', 'The Royal Bank of Scotland N.V.', 2011, 9999, '2011-01-27', true, 'CZ_5400'),
      ('2010', 'Fio banka, a.s.', 2011, 9999, '2011-01-27', true, 'CZ_2010'),
      ('2240', 'Poštová banka, a.s., pobočka Česká republika', 2011, 9999, '2011-01-27', true, 'CZ_2240');

    -- konec ceskeho bloku
  end if;

  -- zmeny v ciselniku slovenskych smerovych kodu
  if (stat = 'SK_SK') then
    UPDATE asmerkod
    SET platido = 2010
    WHERE uuid in ('SK_0720', 'SK_3000', 'SK_8020', 'SK_8100', 'SK_8330', 'SK_8350');

    -- oprava chybnych uuid
    UPDATE asmerkod
    SET uuid = 'SK_8370'
    WHERE uuid = 'SK_8400'
    and kod = '8370';

    UPDATE asmerkod
    SET uuid = 'SK_1030'
    WHERE uuid = 'SK_8400' and kod = '1030';

    INSERT INTO asmerkod (lastupdate, kod, nazev, show, platiod, platido, uuid)
    -- nove hodnoty
    VALUES ('2011-01-27', '8380', 'AXA Bank Europe, pobočka zahraničnej banky', true, 2011, 9999, 'SK_8380'),
        ('2011-01-27', '8410', 'ZUNO BANK AG, pobočka zahraničnej banky', true, 2011, 9999, 'SK_8410'),
        -- opravy nazvu
        ('2011-01-27', '0720', 'Národná banka Slovenska', true, 2011, 9999, 'SK_0720'),
        ('2011-01-27', '3000', 'Slovenská záručná a rozvojová banka, a.s.', true, 2011, 9999, 'SK_3000'),
        ('2011-01-27', '8020', 'Crédit Agricole Corporate and Investment Bank S.A., pobočka zahraničnej banky', true, 2011, 9999, 'SK_8020'),
        ('2011-01-27', '8100', '+Komerční banka, a.s., pobočka zahraničnej banky',  true, 2011, 9999, 'SK_8100'),
        ('2011-01-27', '8330', 'Fio banka, a.s., pobočka zahraničnej banky',  true, 2011, 9999, 'SK_8330'),
        ('2011-01-27', '8350', 'The Royal Bank of Scotland N.V., pobočka zahraničnej banky',  true, 2011, 9999, 'SK_8350');

    -- konec slovenskeho bloku
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 435, 't', %appVersion%, clock_timestamp());
