--------------------------------------------------------------------------------
-- Bug 23209 – [winstrom] - Skladové karty - doplnit umístění ve skladu - místnost, regál, police
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_sumisteni
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_sumisteni OWNER TO %firmaRole%;

CREATE TABLE sumisteni
(
  idumisteni integer DEFAULT nextval('seq_sumisteni'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido integer NOT NULL DEFAULT 9999,
  platiod integer NOT NULL DEFAULT 0,
  typumistenik character varying(50) NOT NULL,
  CONSTRAINT sumisteni_pkey PRIMARY KEY (idumisteni)
);
ALTER TABLE public.sumisteni OWNER TO %firmaRole%;


ALTER TABLE skarty ADD COLUMN idmistnost integer;
ALTER TABLE skarty ADD COLUMN idregal integer;
ALTER TABLE skarty ADD COLUMN idpolice integer;

ALTER TABLE skarty ADD CONSTRAINT skarty_idmistnost FOREIGN KEY (idmistnost)
  REFERENCES sumisteni (idumisteni) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE skarty ADD CONSTRAINT skarty_idregal FOREIGN KEY (idregal)
  REFERENCES sumisteni (idumisteni) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;
ALTER TABLE skarty ADD CONSTRAINT skarty_idpolice FOREIGN KEY (idpolice)
  REFERENCES sumisteni (idumisteni) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX sKarty_IdMistnost_index ON sKarty USING btree (IdMistnost);
CREATE INDEX sKarty_IdRegal_index ON sKarty USING btree (IdRegal);
CREATE INDEX sKarty_IdPolice_index ON sKarty USING btree (IdPolice);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 465, 't', %appVersion%, clock_timestamp());
