-------------------------------------------------------------------------------------------
-- Bug 22366 – [WinStrom] FIFO - při prodeji zboží se nezohledňuje vydané zboží dobropisem
-------------------------------------------------------------------------------------------

-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$
declare
  _rozsirenaPolozka record;
  _typPohybuk character varying;
  _mazatTmpTable boolean;
  _idPolSklad integer;
  _probihaPrepocetSkladu character varying;
begin
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu;
  if(_probihaPrepocetSkladu = 'true') then
  else
    -- v pripade ze neprobiha prepocet skladu
    -- generuji rozsirene polozky
    select skladGenerujRozsirenePolozky(NEW.datVyst, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable;

    execute putglotxvariable('zurnalTxName', 'prepocetSkladu');

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then
        execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
      end if;
    end loop;

    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
      execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
    end loop;

    if(_mazatTmpTable) then
      drop table tmp_RozsirenePolozky;
      drop table tmp_SkladoveKarty;
      execute removeglotxvariable('zurnalTxName');
    end if;
  end if;

  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
  --pokud výdej, tak fifuju vazby
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj);
    execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
  end if;

  if(_probihaPrepocetSkladu = 'true') then
    if(NEW.idPolSklad < 0) then
      _idPolSklad = -NEW.idPolSklad;
    else
      _idPolSklad = NEW.idPolSklad;
    end if;

    execute skladinsertrozsirenoupolozku(_idPolSklad);
  end if;

  return NEW;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;


-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$
declare
  _zaznam Record;
  _vybrano numeric(19,6);
  _i integer;
  _novevydcelkem numeric(19,6);
  _pocet numeric(19,6);
  _cenamjP numeric(19,6);
  _cenaMjPMen numeric(19,6);
  _kurzDokladuP numeric(19,6);
  _kurzDokladuV numeric(19,6);
  _idDoklSkladP integer;
  _idDoklSkladV integer;
  _datVystV date;
  _idrozlozeni integer;
  _vydexpir boolean;
  _vyrcis character varying(255);
  _sklfifo boolean;
  _sarze character varying(255);
  _expirace date;
  _evidVyrCis boolean;
begin
  _vybrano := 0;
  _i := 1;
  _novevydcelkem := vyd;
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;
  if (not _evidVyrCis) then
    if (idvydej>0) then
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;
      if (not _vydexpir) then
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
              if (_vybrano<_novevydcelkem) then
                _pocet := _zaznam.pocet;
                if( _vybrano+_pocet) > _novevydcelkem then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                _vyrcis := '';
                if (_zaznam.idvyrobnicislo>0) then
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;
                --
                if (_i = 1) then
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
	                end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace
                          where idpolsklad = idvydej;
                  else
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;
                  end if;
                else
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select nextval('seq_dpolsklad') into _idrozlozeni;
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
                         (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP*_kurzDokladuV,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej);
                    --
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
                  else
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);
                  end if;
                end if;
                --
                _i:=_i+1;
              else
                if (_vybrano>_novevydcelkem) then
                  _pocet := -_zaznam.pocet;
                  if(( _vybrano+_pocet) < _novevydcelkem) then
                    _pocet := _novevydcelkem-_vybrano;
                  end if;
                  _vybrano := _vybrano+_pocet;
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;
                end if;
              end if;
            end if;
          end if;
        end loop;
      else
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop
          if(not _zaznam is null) then
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
              if (_vybrano<_novevydcelkem) then
                _pocet := _zaznam.pocet;
                if( _vybrano+_pocet) > _novevydcelkem then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                _vyrcis := '';
                if (_zaznam.idvyrobnicislo>0) then
                    select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                end if;
                --
                if (_i = 1) then
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace
                          where idpolsklad = idvydej;
                  else
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;
                  end if;
                else
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));
                  if (_sklfifo) then
                    select nextval('seq_dpolsklad') into _idrozlozeni;
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);
                    if (_kurzDokladuP <> 0.0) then
                      _cenamjP := _cenamjP * _kurzDokladuP;
                    end if;
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));
                    _cenamjP := _cenamjP / _kurzDokladuV;
                    _cenaMjPMen := 0.0;
                    if(_kurzDokladuV <> 1.0) then
                      _cenaMjPMen := _cenaMjP;
                    end if;
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy)
	                             (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej);
                    --
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
                  else
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);
                  end if;
                end if;
                --
                _i:=_i+1;
              else
                if (_vybrano>_novevydcelkem) then
                  _pocet := -_zaznam.pocet;
                  if(( _vybrano+_pocet) < _novevydcelkem) then
                    _pocet := _novevydcelkem-_vybrano;
                  end if;
                  _vybrano := _vybrano+_pocet;
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;
                end if;
              end if;
            end if;
          end if;
        end loop;
      end if;
    else
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;
    end if;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;


-- Function: sprepoctisklad(integer)
-- DROP FUNCTION sprepoctisklad(integer);
CREATE OR REPLACE FUNCTION sprepoctisklad(i_ucetobd integer)
  RETURNS void AS
$BODY$
declare
  _rozsirenaPolozka record;
  _zaznam record;
  _vyrobniCislo record;
  _pocatek_ucetobd date;
  _konec_ucetobd date;
  _evidVyrCis boolean;
  _mazatTmpTable boolean;
  _citac integer;
  _pocetPred integer;
  _pocetPo integer;
begin

  execute putglotxvariable('zurnalTxName', 'prepocetSkladu');
  execute putglotxvariable('probihaPrepocetSkladu', 'true');

  -- nacteni datumu zacatku ucetniho obdobi
  select platioddata, platidodata into _pocatek_ucetobd, _konec_ucetobd from nucetobdobi where iducetobdobi = i_ucetobd;

  -- smazani tabulky fifo vazeb
  delete from sfifovazby where idpolskladvydej in
    (select idpolsklad from dpolsklad where
            datVyst >= _pocatek_ucetobd);

  delete from sfifovazby f
    where f.idpolskladvydej not in (select p.idpolsklad from dpolsklad p);

  -- nagenerovani pomocnych tabulek
  select skladGenerujRozsirenePolozky(_pocatek_ucetobd, -1, -1) into _mazatTmpTable;

  select count(*) into _pocetPred from tmp_RozsirenePolozky;

  -- provedu fifovani rozsirenych polozek
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    select * into _zaznam from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    if (_rozsirenaPolozka.typPohybuk = 'typPohybu.vydej'  or (_rozsirenaPolozka.typPohybuk = 'typPohybu.prijem' and _zaznam.mnozMj < 0.0)) then
      select evidVyrCis into _evidVyrCis from ccenik where idcenik = _zaznam.idCenik;
      if (not _evidVyrCis) then
        execute sfifoVydej(_zaznam.idPolSklad, _zaznam.idCenik, _zaznam.idBspSkl, _zaznam.idKarty, _zaznam.mnozmj);
      else
        for _vyrobniCislo in select * from svyrobnicislo where idpolskladvydej = _zaznam.idPolSklad loop
          update svyrobnicislo set idpolskladvydej = null where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
          update svyrobnicislo set idpolskladvydej = _zaznam.idPolSklad where idvyrobnicislo = _vyrobniCislo.idvyrobnicislo;
        end loop;
      end if;
      execute sPrepoctiSumyDokladu(_zaznam.idDoklSklad);
    end if;
  end loop;

  --select count(*) into _pocetPo from tmp_RozsirenePolozky;

  -- vynulovani skladovych karet
  execute skladVynulujSkladoveKarty();

  -- zafifovane veci zapoctu na skladove karty
  for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop
    execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad);
  end loop;

  if(_mazatTmpTable) then
    drop table tmp_RozsirenePolozky;
    drop table tmp_SkladoveKarty;
    execute removeglotxvariable('zurnalTxName');
    execute removeglotxvariable('probihaPrepocetSkladu');
  end if;

end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisklad(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 468, 't', %appVersion%, clock_timestamp());
