----------------------------------------------------------------------------------------------------
-- Bug 23994 – [WinStrom] Znasobovani ceny na prevodkach ve FIFO skladu
----------------------------------------------------------------------------------------------------

-- Function: skladprepoctirozsirenoupolozku(integer, integer)
-- DROP FUNCTION skladprepoctirozsirenoupolozku(integer, integer);
create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_rozsirenaPolozka.datum));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if(_navazanaPolSklad.mnozMj <> 0.0) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
          else
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _sumZkl = _navazanaPolSklad.sumZkl;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            raise exception '_mnozMjProCenaMj je 0.0'; -- TODO vyresit co se bude dit
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _rozsirenaPolozka.datum) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        update dPolSklad set
          cenaMjPoriz = _cenaMjPoriz,
          cenaMj = _cenaMj,
          cenaMjSkl = _cenaMjSkl,
          sumZkl = _sumZkl,
          sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
      end if;

      execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0) then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _rozsirenaPolozka.datum));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;





-- Function: sfifovydej(integer, integer, integer, integer, numeric)
-- DROP FUNCTION sfifovydej(integer, integer, integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$      
declare       
  _zaznam Record;       
  _vybrano numeric(19,6);     
  _i integer;     
  _novevydcelkem numeric(19,6);     
  _pocet numeric(19,6);     
  _cenamjP numeric(19,6);  
  _cenaMjPMen numeric(19,6);  
  _kurzDokladuP numeric(19,6);   
  _kurzDokladuV numeric(19,6);   
  _idDoklSkladP integer;    
  _idDoklSkladV integer;   
  _datVystV date;   
  _idrozlozeni integer;     
  _vydexpir boolean;     
  _vyrcis character varying(255);     
  _sklfifo boolean;  
  _sarze character varying(255);  
  _expirace date;       
  _evidVyrCis boolean;    
begin       
  _vybrano := 0;     
  _i := 1;     
  _novevydcelkem := vyd;     
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;  
  if (not _evidVyrCis) then  
    if (idvydej>0) then  
      select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;  
      select sarze, expirace into _sarze, _expirace from dpolsklad where idpolsklad = idvydej;     
      if (not _vydexpir) then     
        --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                  select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                end if;     
                --     
                if (_i = 1) then  
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;  
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then  
                      _cenamjP := _cenamjP * _kurzDokladuP;     
	                end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));  
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace  
                          where idpolsklad = idvydej;  
                  else  
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if; 
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
                         (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP*_kurzDokladuV,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej); 
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);     
                  end if;     
                end if;     
                --     
                _i:=_i+1;     
              else 
                if (_vybrano>_novevydcelkem) then 
                  _pocet := -_zaznam.pocet; 
                  if(( _vybrano+_pocet) < _novevydcelkem) then 
                    _pocet := _novevydcelkem-_vybrano; 
                  end if; 
                  _vybrano := _vybrano+_pocet; 
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ; 
                end if; 
              end if;  
            end if; 
          end if; 
        end loop;    
      else     
        --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)     
        for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop       
          if(not _zaznam is null) then 
            if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then  
              if (_vybrano<_novevydcelkem) then     
                _pocet := _zaznam.pocet;     
                if( _vybrano+_pocet) > _novevydcelkem then     
                  _pocet := _novevydcelkem-_vybrano;     
                end if;     
                _vybrano := _vybrano+_pocet;     
                --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo     
                _vyrcis := '';     
                if (_zaznam.idvyrobnicislo>0) then     
                    select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo; 
                end if;     
                --     
                if (_i = 1) then     
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);     
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;   
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, cenaMjPoriz = _cenaMjP, sumzkl = _pocet*_cenamjP*_kurzDokladuV, sumZklMen = _pocet*_cenaMjPMen, sarze = _zaznam.sarze, expirace = _zaznam.expirace  
                          where idpolsklad = idvydej;  
                  else  
                    update dpolsklad set sarze = _zaznam.sarze, expirace = _zaznam.expirace where idpolsklad = idvydej;  
                  end if;     
                else     
                  _sklfifo := (select isfifosklad(_zaznam.datvyst));     
                  if (_sklfifo) then     
                    select nextval('seq_dpolsklad') into _idrozlozeni;     
                    select cenamj, idDoklSklad into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);    
                    select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
                    if (_kurzDokladuP <> 0.0) then    
                      _cenamjP := _cenamjP * _kurzDokladuP;     
                    end if;    
                    select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = idvydej;   
                    _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
                    _cenamjP := _cenamjP / _kurzDokladuV;  
                    _cenaMjPMen := 0.0;  
                    if(_kurzDokladuV <> 1.0) then  
                      _cenaMjPMen := _cenaMjP;  
                    end if;  
                    insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
	                             (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,_zaznam.expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,_zaznam.sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,_pocet*_cenaMjPMen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad=idVydej); 
                    --     
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);     
                    insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);     
                  else      
                    insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);      
                  end if;      
                end if;      
                --      
                _i:=_i+1;      
              else 
                if (_vybrano>_novevydcelkem) then 
                  _pocet := -_zaznam.pocet; 
                  if(( _vybrano+_pocet) < _novevydcelkem) then 
                    _pocet := _novevydcelkem-_vybrano; 
                  end if; 
                  _vybrano := _vybrano+_pocet; 
                  insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ; 
                end if; 
              end if;   
            end if; 
          end if;     
        end loop;      
      end if;      
    else      
      --nepoustím fifo do rekurze, příznak záporného id udělám opět kladný      
      update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;               
    end if;  
  end if;     
end;       
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;



-- Function: svyrobnicisloupdate()
-- DROP FUNCTION svyrobnicisloupdate();
CREATE OR REPLACE FUNCTION svyrobnicisloupdate()
  RETURNS trigger AS
$BODY$    
declare 
  _sklFifo boolean; 
  _mnozMj numeric(19,6); 
  _datVyst date; 
  _idRozlozeni integer; 
  _cenaMjP numeric(19,6); 
  _kurzDokladuP numeric(19,6); 
  _kurzDokladuV numeric(19,6); 
  _idDoklSkladP integer; 
  _idDoklSkladV integer; 
  _datVystV date; 
  _cenaMjPMen numeric(19,6); 
  _mnozVyrobnichCisel numeric(19,6);  
  _mnozMjPoZmene numeric(19,6); 
begin 
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then 
    select datVyst, mnozMj into _datVyst, _mnozMj from dPolSklad where idPolSklad = NEW.idPolSkladVydej; 
    _mnozVyrobnichCisel = 1; 
    _mnozMjPoZmene = _mnozMj; 
    if(_mnozMj < 0.0) then 
      _mnozMjPoZmene = 0.0 - _mnozMj; 
      _mnozVyrobnichCisel = -1; 
    end if; 
  
    _sklfifo := (select isfifosklad(_datVyst)); 
    if(_sklFifo) then 
 
      select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = NEW.idPolSkladPrijem);     
      select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
      if (_kurzDokladuP <> 0.0) then    
	_cenamjP := _cenamjP * _kurzDokladuP;     
      end if;   
      select iddoklsklad, datVyst into _idDoklSkladV, _datVystV from dpolsklad where idpolsklad = NEW.idPolSkladVydej;   
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   
      _cenamjP := _cenamjP / _kurzDokladuV; 
      _cenaMjPMen := 0.0; 
	  if(_kurzDokladuV <> 1.0) then 
        _cenaMjPMen := _cenaMjP; 
      end if; 
      if(_mnozMjPoZmene > 1) then 
        -- odecteni 1 z mnoz mj a vytvoreni nove polozky a mnozstvim 1 a 1 vyrobnim cislem 
        select nextval('seq_dpolsklad') into _idrozlozeni;                        
	update dpolsklad set mnozMJ = _mnozMj - _mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej; 
 
        insert into dpolsklad(idpolsklad,           mnozmj,             autozaokr,autogen,baleniid,cenjednotka,cenamj,  cenaMjPoriz,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,                                       sumzklmen,                       szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy) 
                             (select (_idrozlozeni),_mnozVyrobnichCisel,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,_cenaMjP,   cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_cenamjP*_kurzDokladuV * _mnozVyrobnichCisel,_cenaMjPMen * _mnozVyrobnichCisel,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idbspskl,idfirmy from dpolsklad where idpolsklad = NEW.idpolskladvydej); 
	insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,_idrozlozeni,1,NEW.idvyrobnicislo); 
	insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (NEW.idPolSkladVydej, _idrozlozeni); 
	NEW.idPolSkladVydej = _idRozlozeni; 
      else 
        -- nastaveni vyrobniho cisla na a vytvoreni vazby 
        --update sfifovazby set idvyrobnicislo = NEW.idvyrobnicislo, kusu = 1, idpolskladprijem = NEW.idpolskladprijem where idpolskladvydej = NEW.idpolskladvydej and idvyrobnicislo = -1; 
        insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo); 
        --select cenaMj into _cenaMjP from dpolsklad where idPolSklad = NEW.idPolSkladPrijem; 
        update dpolsklad set cenaMJ = _cenaMjP, cenaMjPoriz = _cenaMjP, sumZkl = _cenamjP*_kurzDokladuV*_mnozVyrobnichCisel, sumZklMen = _cenaMjPMen*_mnozVyrobnichCisel where idPolSklad = NEW.idPolSkladVydej; 
      end if; 
      -- 
    else 
      insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,NEW.idvyrobnicislo); 
    end if; 
  elsif (NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then 
    -- pokud se idPolSkladVydej nastavi na null z nejake hodnoty musi se smazat i fifo vazba s timto vyrobnim cislem 
    delete from sfifovazby where idvyrobnicislo = NEW.idVyrobniCislo; 
  end if; 
  execute sprepoctisumydokladu(_idDoklSkladV); 
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;



-- Function: sfifocenamj(integer, integer, numeric)
-- DROP FUNCTION sfifocenamj(integer, integer, numeric);
CREATE OR REPLACE FUNCTION sfifocenamj(idpohyb integer, iddokl integer, cenamjprijem numeric)
  RETURNS void AS
$BODY$   
declare   
	_typPohybuk character varying(255); 
         _pouzitaPrijemka integer; 
        _idPolSklad integer; 
        _polSklad record; 
        _cenaMj numeric(19,6); 
        _kurzPrijem numeric(19,6); 
        _kurzVydej numeric(19,6); 
        _sumZkl numeric(19,6); 
        _sumZklMen numeric(19,6); 
        _vydejCiziMena boolean; 
        _prijemCiziMena boolean; 
        _datVystPrijem date; 
begin   
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = iddokl;	 
	if (_typPohybuk = 'typPohybu.prijem') then 
	        select datVyst into _datVystPrijem from ddoklsklad where iddoklsklad = iddokl; 
                select getkurzfromdoklad(iddokl, _datVystPrijem) into _kurzPrijem; 
                _cenaMj = cenamjprijem * _kurzPrijem; 
                --pokud změna ceny na příjemce, tak změním dle vazeb na výdejkách  
         	for _idpolsklad in select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb loop 
                  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
 
                  select getkurzfromdoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzVydej; 
                  select isdoklskladmenacizi(_polSklad.idDoklSklad, _polSklad.datVyst) into _vydejCiziMena; 
                  _sumZkl = _cenaMj * _polSklad.mnozMj; 
                  if(_vydejCiziMena = true) then 
                    _sumZklMen = (_cenaMj * polSklad.mnozMj) / _kurzVydej ; 
                  else 
                    _sumZklMen = 0.0; 
                  end if; 
                   
         	  update dpolsklad set  
         	    cenamj = (_cenaMj / _kurzVydej),
                    cenaMjPoriz = (_cenaMj / _kurzVydej), 
         	    sumZkl = _sumZkl, 
         	    sumZklMen = _sumZklMen  
         	    where idpolsklad = _idPolSklad; 
         	  execute sprepoctisumydokladu(_polSklad.idDoklSklad); 
         	end loop; 
		--update dpolsklad set cenamj = cenamjprijem where idpolsklad = (select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb);  
         end if; 
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifocenamj(integer, integer, numeric) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 487, 't', %appVersion%, clock_timestamp());

