--------------------------------------------------------------------------------
-- Bug 23686 – [winstrom] - Cenotvorba - Analýza
--------------------------------------------------------------------------------

-- tabulka skupin cen
CREATE SEQUENCE seq_cskupcen
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_cskupcen OWNER TO %firmaRole%;

CREATE TABLE cskupcen
(
  idskupcen integer DEFAULT nextval('seq_cskupcen'::regclass) NOT NULL,
  lastupdate timestamp without time zone NOT NULL DEFAULT '2008-01-01 00:00:00'::timestamp without time zone,
  kod character varying(20) NOT NULL,
  nazev character varying(255) NOT NULL,
  nazeva character varying(255),
  nazevb character varying(255),
  nazevc character varying(255),
  popis text,
  poznam text,
  "show" boolean NOT NULL DEFAULT true,
  platido integer NOT NULL DEFAULT 9999,
  platiod integer NOT NULL DEFAULT 0,
  CONSTRAINT cskupcen_pkey PRIMARY KEY (idskupcen)
);
ALTER TABLE cskupcen OWNER TO %firmaRole%;

--vazebni tabulka skupina cen - cenova hladina
CREATE TABLE cskc_chl
(
  idskupcen integer NOT NULL,
  idcenhlad integer NOT NULL,
  CONSTRAINT cskc_chl_pkey PRIMARY KEY (idskupcen, idcenhlad),
  CONSTRAINT cskc_chl_idcenhlad FOREIGN KEY (idcenhlad)
      REFERENCES ccenhlad (idcenhlad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT cskc_chl_idskupcen FOREIGN KEY (idskupcen)
      REFERENCES cskupcen (idskupcen) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE cskc_chl OWNER TO %firmaRole%;

CREATE INDEX cskc_chl_idskupcen_index ON cskc_chl USING btree (idskupcen);
CREATE INDEX cskc_chl_idcenhlad_index ON cskc_chl USING btree (idcenhlad);

-- vazebni tabulka cenova hladina - firma
CREATE TABLE cchl_adr
(
  idcenhlad integer NOT NULL,
  idfirmy integer NOT NULL,
  CONSTRAINT cchl_adr_pkey PRIMARY KEY (idfirmy, idcenhlad),
  CONSTRAINT cchl_adr_idcenhlad FOREIGN KEY (idcenhlad)
      REFERENCES ccenhlad (idcenhlad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT cchl_adr_idfirmy FOREIGN KEY (idfirmy)
      REFERENCES aadresar (idfirmy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE cchl_adr OWNER TO %firmaRole%;

CREATE INDEX cchl_adr_idcenhlad_index ON cchl_adr USING btree (idcenhlad);
CREATE INDEX cchl_adr_idfirmy_index ON cchl_adr USING btree (idfirmy);

-- pridani skupin cen na adresar
ALTER TABLE aadresar ADD COLUMN idskupcen integer;

ALTER TABLE aadresar ADD CONSTRAINT aadresar_idskupcen FOREIGN KEY (idskupcen)
  REFERENCES cskupcen (idskupcen) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX aAdresar_IdSkupCen_index ON aAdresar USING btree (IdSkupCen);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 489, 't', %appVersion%, clock_timestamp());
