----------------------------------------------------------------------------------------------------------
-- Bug 23876 – [winstrom] !!! Prodej - hromadná fakturace z objednávek, skladu - umožnit přidávat položky
----------------------------------------------------------------------------------------------------------

-- Function: dpoldoklinsertsklad()
-- DROP FUNCTION dpoldoklinsertsklad();
CREATE OR REPLACE FUNCTION dpoldoklinsertsklad()
  RETURNS trigger AS
$BODY$ 
declare 
  pocetNavazanychDokladu integer; 
  _idPolFak integer; 
  _idDoklFak integer; 
  _idPolSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _skladove boolean; 
  _sadaItemCount integer;  
  _cenaMjNakup numeric(19,6);   
  _typDoklK character varying; 
begin 
 
  if(NEW.typPolozkyK like 'typPolozky.katalog') then 
    if(NEW.modul like 'POK') then 
      _idPolFak = NEW.idPolInt; 
      _idDoklFak = NEW.idDoklInt; 
      select generovatSkl into _dokladGenerovatSkl from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolint where idpolint = NEW.idPolInt); 
    else 
      _idPolFak = NEW.idPolFak; 
      _idDoklFak = NEW.idDoklFak; 
      select generovatSkl into _dokladGenerovatSkl from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    end if; 
 
    select skladove into _skladove from cCenik where idCenik = NEW.idCenik; 

    if (_skladove and NEW.idBspSkl is not null 
      and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then 

      select count(*) into pocetNavazanychDokladu from dvazebtab where 
        typVazbyK like 'typVazbyDokl.hlavaSkl' 
        and ( 
        (idTabA = _idDoklFak and modulA like NEW.modul) 
        or 
        (idTabB = _idDoklFak and modulB like NEW.modul)); 
 
      --if(pocetNavazanychDokladu > 1) then 
        --neco jeste nevim co 
      --else 
        if(_sadaItemCount > 0) then 
          execute createPolSkladSada(_idPolFak, NEW.modul); 
        else 
          select createPolSklad(_idPolFak, NEW.modul) into _idPolSklad;  
        end if; 
      --end if; 
   
      execute putglotxvariable('vypniSklad', 'true'); 
      if(NEW.modul = 'FAV' and _typDoklK != 'typDokladu.dobropis') then 
        select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup; 
        update dpolfak set cenaMjNakup = _cenaMjNakup where idpolfak = _idPolFak; 
      elsif(NEW.modul = 'POK') then 
        select skladGetCenaMjNakup(_idPolFak, NEW.modul, NEW.mnozMj) into _cenaMjNakup; 
        update dpolint set cenaMjNakup = _cenaMjNakup where idpolint = _idPolFak; 
      end if; 
      execute removeglotxvariable('vypniSklad'); 
    end if;  
  end if; 
  
  return NEW; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklinsertsklad() OWNER TO %firmaRole%;

-- Function: dpoldokldeletesklad()
-- DROP FUNCTION dpoldokldeletesklad();
CREATE OR REPLACE FUNCTION dpoldokldeletesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idDoklSklad integer;
  _idPolSklad integer; 
  _pocetPozadavku integer; 
  _stavSkladK character varying;  
  _zdrojProFak boolean;
  _pocetPolozek integer;
begin 
  if(OLD.modul like 'POK') then 
    _idPolDokl = OLD.idPolInt; 
    _idDoklad = OLD.idDoklInt;
  elsif(OLD.modul like 'FAP' or OLD.modul like 'FAV') then 
    _idPolDokl = OLD.idPolFak; 
    _idDoklad = OLD.idDoklFak; 
  else 
    _idPolDokl = null; 
    _idDoklad = null; 
  end if; 

  _idPolSklad = null;
  _idDoklSklad = null;
  if(_idPolDokl is not null) then
    select findParovanyPolSklad(_idPolDokl, OLD.modul) into _idPolSklad;
    --raise exception 'iddoklsklad neni null ale je %', _idPolSklad; 

    if(_idPolSklad is not null) then
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSklad;
    end if;
  end if;
 
  if(_idPolDokl is not null) then 
    execute deleteNavazanePolSklad(_idPolDokl, OLD.modul); 
  end if; 
 
  if(_idDoklSklad is not null) then
    execute sprepoctiSumyDokladu(_idDoklSklad); 

    select stavSkladK, zdrojProFak into _stavSkladK, _zdrojProFak from ddoklsklad where idDoklSklad = _idDoklSklad;  
    select count(*) into _pocetPozadavku from dpolSklad where idDoklSklad = _idDoklSklad and mnozMj = 0.0 and mnozMjPlan != 0.0; 
   
    if(_pocetPozadavku = 0) then 
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then 
        update ddoklsklad set stavSkladK = 'stavSklad.vygenFakt' where idDoklSklad = _idDoklSklad; 
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then 
        update ddoklsklad set stavSkladK = 'stavSklad.vygenPokl' where idDoklSklad = _idDoklSklad; 
      end if; 
    end if;  

    if(_zdrojProFak) then
      --select count(*) into _pocetPolozek from dpolsklad where iddoklsklad = _idDoklSklad;
      select count(*) into _pocetPolozek from dpolsklad ps join dvazebtab vt 
        on ps.idpolsklad = vt.idtabb and vt.modulb = 'SKL' and typvazbyk = 'typVazbyDokl.polozkaSkl'
        where ps.iddoklsklad = _idDoklSklad;
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfakt')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.vyfaktHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.vyfaktHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazen')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHromCast')) then
        if(_pocetPolozek > 0) then 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
      if(compareVarchar(_stavSkladK, 'stavSklad.uhrazenHrom')) then 
        if(_pocetPolozek > 0) then 
          update ddoklsklad set stavSkladK = 'stavSklad.uhrazenHromCast' where idDoklSklad = _idDoklSklad; 
        else
          update ddoklsklad set stavSkladK = null where idDoklSklad = _idDoklSklad; 
        end if;
      end if; 
    end if;
  end if; 
   
  return OLD; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpoldokldeletesklad() OWNER TO %firmaRole%;


-- Function: createpolsklad(integer, character varying)
-- DROP FUNCTION createpolsklad(integer, character varying);
CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
  _skupZboz record; 
  _idTypUcOp integer; 
  _datSklad date; 
begin 
  _kopZklMdUcet =false; 
  _kopZklDalUcet = false; 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 
 
  select datSklad into _datSklad from ddoklSklad where idDoklSklad = _idDoklSklad; 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
  select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklMdUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklMdUcet = true; 
    end if; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      --_cenaMjTuz = _prumCenaTuz; 
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
      if(_skupZboz.idProtiUcetSklV is not null) then 
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
        _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
      else 
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
        _kopZklDalUcet = true; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
      _idZklDalUcet = _polDokl.idZklMdUcet; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
  end if; 
   
  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,  
        idStred, idZakazky, idMeny, zdrojProFak, idCinnost, idTypUcOp) 
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj, 
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.cisRad, true,  
        _polDokl.idStred, _polDokl.idZakazky, _idMeny, false, _polDokl.idCinnost, _idTypUcOp); 
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying) OWNER TO %firmaRole%;

-- Function: createpolskladsada(integer, character varying)
-- DROP FUNCTION createpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _doklad record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean; 
  _nasobic integer; 
  _idSkladu integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idTypUcOp integer; 
  _datSklad date; 
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak; 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt; 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
    if(_idDoklSklad is null) then 
      return; 
    end if; 
  end if; 
 
  select datSklad into _datSklad from ddoklSklad where idDoklSklad = _idDoklSklad; 
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad; 
 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.skladove) then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
 
      _idSkladu = _polDokl.idBspSkl; 
 
      select * into _skladKarta from skarty  
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi; 
 
      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
      if(_skladKarta is null) then 
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu; 
        select * into _skladKarta from skarty 
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi; 
        if(_skladKarta is null) then 
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
        end if; 
      else 
        _idSkladu = _skladKarta.idSkladu; 
      end if; 
      _nasobic = 1; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        _nasobic = -1; 
      end if; 
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      _kopZklMdUcet = false; 
      _kopZklDalUcet = false; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven 
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz; 
        if(_idZklDalUcet is null) then 
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklDalUcet = true; 
        end if; 
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu; 
      else 
        -- md ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven 
        select idProtiUcetSklV into _idZklMdUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz; 
        if(_idZklMdUcet is null) then 
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklMdUcet = true; 
        end if; 
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu; 
      end if; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
          nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni,   
          idStred, idZakazky, idMeny, zdrojProFak, idCinnost, idTypUcOp) 
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, _datSklad, _polDokl.datVyst, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _cisRad, true,   
          _polDokl.idStred, _polDokl.idZakazky, _idMeny, false, _polDokl.idCinnost, _idTypUcOp); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)   
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');   
    end if;  
  END LOOP;  
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying) OWNER TO %firmaRole%;

-- Function: fillpolsklad(integer, integer, character varying)
-- DROP FUNCTION fillpolsklad(integer, integer, character varying);
CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjPoriz numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _cenaMjPoriz = _polSklad.cenaMjPoriz; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _polDokl.cenaMjNakup;  
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMjPoriz = _cenaMjTuz / _kurz; 
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz; 
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz)); 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMjPoriz = _sumZkl / _mnozMj; 
      else 
        _cenaMjPoriz = _sumZkl; 
      end if; 
      _cenaMjPoriz = _cenaMjPoriz / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj; 
        else 
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl); 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj); 
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
 
  if(_polSklad.cenaMj <> _cenaMj 
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz 
    or _polSklad.sumZkl <> _sumZkl 
    or _polSklad.sumZklMen <> _sumZklMen 
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev) 
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA) 
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB) 
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC) 
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst) 
    or not compareDate(_polSklad.datUcto, _polDokl.datVyst) 
    or not compareId(_polSklad.baleniId, _polDokl.baleniId) 
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni) 
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze) 
    or not compareDate(_polSklad.expirace, _polDokl.expirace) 
    or not compareId(_polSklad.cisRad, _polDokl.cisRad) 
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod) 
    or not compareId(_polSklad.idmj, _polDokl.idmj) 
    or not compareId(_polSklad.idStred, _polDokl.idStred) 
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky) 
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet) 
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) ) 
  then 
    update dPolSklad set 
      lastUpdate = LOCALTIMESTAMP, 
      cenaMj = _cenaMj, 
      cenaMjPoriz = _cenaMjPoriz, 
      --mnozMj = _mnozMj, 
      sumZkl = _sumZkl, 
      sumZklMen = _sumZklMen, 
      nazev = _polDokl.nazev, 
      nazevA = _polDokl.nazevA, 
      nazevB = _polDokl.nazevB, 
      nazevC = _polDokl.nazevC, 
      datVyst = _polDokl.datVyst, 
      datUcto = _polDokl.datVyst, 
      baleniId = _polDokl.baleniId, 
      mnozBaleni = _polDokl.mnozBaleni, 
      sarze = _polDokl.sarze, 
      expirace = _polDokl.expirace, 
      cisRad = _polDokl.cisRad, 
      eankod = _polDokl.eanKod, 
      idmj = _polDokl.idmj, 
      idStred = _polDokl.idStred, 
      idMeny = _polSklad.idMeny, 
      idZakazky = _polDokl.idZakazky, 
      --idZklMdUcet = _idZklMdUcet, 
      --idZklDalUcet = _idZklDalUcet, 
      ucetni = true 
      where idPolSklad = _idPolSklad; 
  end if; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying) OWNER TO %firmaRole%;


-- Function: fillpolskladsada(integer, character varying)
-- DROP FUNCTION fillpolskladsada(integer, character varying);
CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare  
  _polDokl record;  
  _polSklad record;  
  _idDoklad integer;  
  _typPohybuK character varying;  
  _typPohybuSklad character varying;  
  _cenaMj numeric(19,6);  
  _cenaMjTuz numeric(19,6);  
  _mnozMj numeric(19,6);  
  _sumZkl numeric(19,6);  
  _sumZklMen numeric(19,6);  
  _idDoklSklad integer;  
  _idUcetObdobi integer;  
  _idKarty integer;  
  _sklad record;  
  _kurz numeric(19,6);  
  _prumCenaTuz numeric(19,6);  
  _isCiziMena boolean;  
  _typDoklK character varying;  
  _idZklMdUcet integer;  
  _idZklDalUcet integer;  
begin 
  if(_modul like 'POK') then  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  else  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  end if;  
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad; 
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if;  
 
  for _polSklad in   
    select * from dPolSklad where idPolSklad in (  
      select idTabB from dvazebtab where  
        typVazbyK like 'typVazbyDokl.polozkaSklSada'   
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    )  
  loop  
    select typPohybuK into _typPohybuSklad from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;   
  
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;  
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;  
    
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;  
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena  
    _cenaMj = _polSklad.cenaMj;  
    _mnozMj = _polSklad.mnozMj;  
    _sumZkl = _polSklad.sumZkl;  
    _sumZklMen = _polSklad.sumZklMen;  
    -- nastaveni uctu pro polSklad vydej  
    --TODO doresit zklMdUcet; 
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
    _idZklDalUcet = _sklad.idPrimUcet;  
    
    update dPolSklad set   
      lastUpdate = LOCALTIMESTAMP,   
      cenaMj = _cenaMj,   
      mnozMj = _mnozMj,   
      sumZkl = _sumZkl,   
      sumZklMen = _sumZklMen,   
      --nazev = _polDokl.nazev,   
      --nazevA = _polDokl.nazevA,   
      --nazevB = _polDokl.nazevB,   
      --nazevC = _polDokl.nazevC,   
      datVyst = _polDokl.datVyst,   
      datUcto = _polDokl.datVyst, 
      baleniId = _polDokl.baleniId,   
      mnozBaleni = _polDokl.mnozBaleni,   
      --sarze = _polDokl.sarze,   
      --expirace = _polDokl.expirace,   
      --cisRad = _polDokl.cisRad,   
      --eankod = _polDokl.eanKod,   
      --idmj = _polDokl.idmj,   
      idStred = _polDokl.idStred,   
      idMeny = _polSklad.idMeny,   
      idZakazky = _polDokl.idZakazky,   
      --idZklMdUcet = _idZklMdUcet,   
      --idZklDalUcet = _idZklDalUcet, 
      ucetni = true  
      where idPolSklad = _polSklad.idPolSklad;  
  end loop; 
  --return _idPolSklad;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying) OWNER TO %firmaRole%;


-- Function: findparovanydoklsklad(integer, character varying, character varying)
-- DROP FUNCTION findparovanydoklsklad(integer, character varying, character varying);
CREATE OR REPLACE FUNCTION findparovanydoklsklad(_iddoklad integer, _modul character varying, _typvazby character varying, _jenSlave boolean)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
begin 
  if(_jenSlave) then
    select idTabB into _idDoklSklad from dvazebtab vt left join ddoklsklad ds on ds.iddoklsklad = vt.idtabb
      where vt.typVazbyK = _typVazby 
      and vt.idTabA = _idDoklad and vt.modulA = _modul and zdrojProFak = false; 
  else
    select idTabB into _idDoklSklad from dvazebtab
      where typVazbyK = _typVazby 
      and idTabA = _idDoklad and modulA = _modul; 
  end if;
  if(_idDoklSklad is null) then 
    if(_jenSlave) then
      select idTabA into _idDoklSklad from dvazebtab vt left join ddoklsklad ds on ds.iddoklsklad = vt.idtabA
        where vt.typVazbyK = _typVazby 
        and vt.idTabB = _idDoklad and vt.modulB = _modul and zdrojProFak = false; 
    else
      select idTabA into _idDoklSklad from dvazebtab
        where typVazbyK = _typVazby 
        and idTabB = _idDoklad and modulB = _modul; 
    end if;
  end if; 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION findparovanydoklsklad(integer, character varying, character varying, boolean) OWNER TO %firmaRole%;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 500, 't', %appVersion%, clock_timestamp());
