--J.Svik
--FIFO
---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE TABLE svyrobnicislo
(
  idvyrobnicislo integer NOT NULL,
  idpolsklad integer,
  kod character varying(255),
  CONSTRAINT svyrobnicislo_pkey PRIMARY KEY (idvyrobnicislo)
)
WITH (OIDS=FALSE);
ALTER TABLE svyrobnicislo OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

CREATE SEQUENCE seq_sfifovazby
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_sfifovazby OWNER TO %firmaRole%;

CREATE TABLE sfifovazby
(
  idfifovazby integer NOT NULL DEFAULT nextval('seq_sfifovazby'::regclass),
  idpolskladprijem integer,
  idpolskladvydej integer,
  idvyrobnicislo integer,
  kusu numeric(19,6),
  CONSTRAINT sfifovazby_pkey PRIMARY KEY (idfifovazby)
)
WITH (OIDS=FALSE);
ALTER TABLE sfifovazby OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

CREATE SEQUENCE seq_svazbypolsklad
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_svazbypolsklad OWNER TO %firmaRole%;

CREATE TABLE svazbypolsklad
(
  idvazbypolsklad integer NOT NULL DEFAULT nextval('seq_svazbypolsklad'),
  idpolskladzdroj integer NOT NULL,
  idpolskladcil integer NOT NULL,
  CONSTRAINT svazbypolsklad_pkey PRIMARY KEY (idvazbypolsklad)
)
WITH (OIDS=FALSE);
ALTER TABLE svazbypolsklad OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION jevydano(idPrijemka integer)
  RETURNS numeric(19,6) AS
$BODY$ 
--J.Svik - zjisti, kolik je z dane prijemky jiz vydano 
declare
	jeVydano numeric(19,6);
begin  
  select Sum(kusu) into jeVydano from sfifovazby where idpolskladprijem = idPrijemka limit 1;
  if (jeVydano is null) then
    jeVydano:=0;
  end if; 
  return jeVydano;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION "jevydano"(integer) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE VIEW dpolskladdoklad AS 
 SELECT p.idpolsklad, p.lastupdate, p.autozaokr, p.autogen, p.baleniid, p.cenjednotka, p.cenamj, p.cenamjnakup, p.cenamjprodej, p.cisrad, p.datucto, p.datvyst, p.eankod, p.expirace, p.kod, p.kopclendph, p.kopdphdalucet, p.kopdphmducet, p.kopklice, p.kopstred, p.kopzakazku, p.kopzkldalucet, p.kopzklmducet, p.mnozbaleni, p.mnozmj, p.mnozmjplan, p.mnozmjreal, p.modul, p.nazev, p.objednatk, p.objem, p.poznam, p.proczakl, p.rezervovat, p.sarze, p.slevadokl, p.slevamnoz, p.slevapol, p.stavuzivk, p.storno, p.stornopol, p.sumdph, p.sumdphmen, p.sumzkl, p.sumzklmen, p.szbdph, p.typcenydphk, p.typpolozkyk, p.typszbdphk, p.typvypcenyk, p.ucetni, p.uplslevadokl, p.vyrcis, p.zaokrjakk, p.zaokrnak, p.idzkldalucet, p.iddphdalucet, p.idmjobjem, p.idmeny, p.idstred, p.idkarty, p.idcenik, p.idzklmducet, p.iddphmducet, p.idsazbydph, p.idclendph, p.idzakazky, p.idmj, p.iddoklsklad, p.idskladu, p.idfirmy, d.typpohybuk
   FROM dpolsklad p
   LEFT JOIN ddoklsklad d ON p.iddoklsklad = d.iddoklsklad;

ALTER TABLE dpolskladdoklad OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE VIEW dpolskladf AS 
 --J.Svik - pohled, který nabízí příjemky k vyskladnění
 SELECT p.idpolsklad, p.mnozmj - jevydano(p.idpolsklad) AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, -1 AS idvyrobnicislo, ( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik) AS evidvyrcis
   FROM dpolskladdoklad p
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric AND (( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik)) = false AND p.storno <> true
UNION ALL 
 SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo AS idvyrobnicislo, ( SELECT c.evidvyrcis
           FROM ccenik c
          WHERE c.idcenik = p.idcenik) AS evidvyrcis
   FROM svyrobnicislo v
   LEFT JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolsklad
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND (( SELECT c.evidvyrcis
      FROM ccenik c
     WHERE c.idcenik = p.idcenik)) = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
      FROM sfifovazby
     WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;
ALTER TABLE dpolskladf OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$  
--J.Svik - zavedeni fifo vazby pri vydeji
declare  
	_typPohybuk character varying(255);
        _sklfifo boolean;
begin  
  --_sklfifo := (select isfifosklad(NEW.datvyst));
  --if (_sklfifo) then
        --pokud výdej, tak fifuju vazby
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad;
	--pokud výdej, tak fifuju vazby
	if (_typPohybuk = 'typPohybu.vydej') then
		execute sfifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idSkladu, NEW.idKarty, NEW.mnozmj);
        execute sPrepoctiSumyDokladu(NEW.idDoklSklad);
	end if;         
  --end if;
  
  -- prumerne ceny
  execute sZapoctiDoMinulosti(NEW.MnozMJ,NEW.CenaMJ,NEW.DatVyst,NEW.idKarty,NEW.idDoklSklad,NEW.idSkladu,1, NEW.idPolSklad);      
  --prumerne ceny konec  

  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert() OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------  
CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric)
  RETURNS void AS
$BODY$  
--J.Svik - zavedeni fifo vazby pri vydeji
declare  
	_zaznam Record;  
         _vybrano numeric(19,6);
         _i integer;
         _novevydcelkem numeric(19,6);
         _pocet numeric(19,6);
         _cenamjP numeric(19,6);
         _idrozlozeni integer;
         _vydexpir boolean;
         _vyrcis character varying(255);
         _sklfifo boolean;  
begin  
  _vybrano := 0;
  _i := 1;
  _novevydcelkem := vyd;
  if (idvydej>0) then
           select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;
           if (not _vydexpir) then
                    --pořadí výdeje dle datvyst (dále se bude řeit upřednostněný výdej mimo FIFO)
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datVyst,idpolsklad loop  
	                  if (_vybrano<_novevydcelkem) then
	                   _pocet := _zaznam.pocet;
	                   if( _vybrano+_pocet) > _novevydcelkem then
	                     _pocet := _novevydcelkem-_vybrano;
	                   end if;
	                   _vybrano := _vybrano+_pocet;
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                            _vyrcis := '';
                            if (_zaznam.idvyrobnicislo>0) then
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                            end if;
                            --
	                   if (_i = 1) then
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));
                             if (_sklfifo) then
	                       select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
	                       update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP, vyrcis=_vyrcis  where idpolsklad = idvydej;
                             end if;
	                   else
                             _sklfifo := (select isfifosklad(_zaznam.datvyst));
                             if (_sklfifo) then
	                       select nextval('seq_dpolsklad') into _idrozlozeni;
	                       select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);                                                   
	                       insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis) 
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,_cenamjP,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);
	                       --
	                       insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                               insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
                             else
                               insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,idvydej,_pocet,_zaznam.idvyrobnicislo);
                             end if;
	                   end if;
	                   --
	                   _i:=_i+1;
	                  end if;
	           end loop;
           else
                    --pořadí výdeje dle expirace (dále se bude řeit upřednostněný výdej mimo FIFO)
	           for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop  
	                  if (_vybrano<_novevydcelkem) then
	                   _pocet := _zaznam.pocet;
	                   if( _vybrano+_pocet) > _novevydcelkem then
	                     _pocet := _novevydcelkem-_vybrano;
	                   end if;
	                   _vybrano := _vybrano+_pocet;
                            --pokud je výrobní číslo, tak jeho kód zaznamenám na výdejku (otázka je, zda tam nedat rovnou idvyrobnicislo
                            _vyrcis := '';
                            if (_zaznam.idvyrobnicislo>0) then
                            	select kod into _vyrcis from svyrobnicislo where idvyrobnicislo = _zaznam.idvyrobnicislo;
                            end if;
                            --
	                   if (_i = 1) then
	                     insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo) ;
	                     select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
	                     update dpolsklad set mnozmj = _pocet,cenamj = _cenamjP, sumzkl = _pocet*_cenamjP, vyrcis=_vyrcis where idpolsklad = idvydej;
	                   else
	                     select nextval('seq_dpolsklad') into _idrozlozeni;
	                     select cenamj  into _cenamjP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);
	                     insert into dpolsklad(idpolsklad,mnozmj,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,sumzkl,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,vyrcis) 
	                                          (select (-1*_idrozlozeni),_pocet,autozaokr,autogen,baleniid,cenjednotka,cenamj,cenamjnakup,cenamjprodej,cisrad,datucto,datvyst,eankod,expirace,kod,kopclendph,kopdphdalucet,iddphmducet,kopklice,kopstred,kopzakazku,kopzkldalucet,kopzklmducet,mnozbaleni,modul,nazev,objednatk,objem,poznam,proczakl,rezervovat,sarze,slevadokl,slevamnoz,slevapol,stavuzivk,storno,stornopol,sumdph,sumdphmen,_pocet*_cenamjP,sumzklmen,szbdph,typcenydphk,typpolozkyk,typszbdphk, typvypcenyk,ucetni,uplslevadokl,zaokrjakk,zaokrnak,idzkldalucet,iddphdalucet,idmjobjem,idmeny,idstred,idkarty,idcenik,idzklmducet,idsazbydph,idclendph,idzakazky,idmj,iddoklsklad,idskladu,idfirmy,_vyrcis from dpolsklad where idpolsklad=idVydej);
	                     --
	                     insert into sfifovazby(idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values(_zaznam.idpolsklad,_idrozlozeni,_pocet,_zaznam.idvyrobnicislo);
                             insert into svazbypolsklad(idpolskladzdroj,idpolskladcil) values (idvydej, _idrozlozeni);
	                   end if;
	                   --
	                   _i:=_i+1;
	                  end if;
	           end loop;
           end if;
  else
  	--nepoutím fifo do rekurze, příznak záporného id udělám opět kladný
         update dpolsklad set idPolSklad = -1*idVydej where idpolsklad=idVydej;         
  end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION sfifostorno(idpohyb integer, iddokl integer)
  RETURNS void AS
$BODY$  
--J.Svik - pokud stornuju nebo mau pohled, tak ruím fifo vazby
declare  
	_typPohybuk character varying(255);
         _pouzitaPrijemka integer;
begin  
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = iddokl;	
	if (_typPohybuk = 'typPohybu.vydej') then
         	--pokud výdej, tak vymau fifo vazby
		delete from sfifovazby where idpolskladvydej = idpohyb;
         else
	    	--pokud se stornuje prijemka, tak jen pokud neni ve fifo vazbách		         	 
                 select Count(*) into _pouzitaPrijemka from sfifovazby where idpolskladprijem = idpohyb; 
                 if (_pouzitaPrijemka > 0) then
                 	raise exception 'Nelze STORNOVAT příjemku ze které ji čerpá výdejka !!!!';
                 end if;         
         end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifostorno(integer, integer) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION sfifocenamj(idpohyb integer, iddokl integer, cenamjprijem numeric(19,6))
  RETURNS void AS
$BODY$  
--J.Svik - pokud stornuju nebo mau pohled, tak ruím fifo vazby
declare  
	_typPohybuk character varying(255);
         _pouzitaPrijemka integer;
begin  
	select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = iddokl;	
	if (_typPohybuk = 'typPohybu.prijem') then
         	--pokud změna ceny na příjemce, tak změním dle vazeb na výdejkách
		update dpolsklad set cenamj = cenamjprijem where idpolsklad = (select idpolskladvydej from sfifovazby where idpolskladprijem = idpohyb);
         end if;
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sfifocenamj(integer, integer, numeric(19,6)) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dpolskladupdate()
  RETURNS trigger AS
$BODY$  
declare 
  _sklfifo boolean; 
begin  
  _sklfifo := (select isfifosklad(NEW.datvyst));
  if (_sklfifo) then
    --fifo
    if (OLD.storno=false and NEW.storno=true) then
	execute sfifoStorno(OLD.idpolsklad, OLD.iddoklsklad);
    end if;  
    if (OLD.cenamj <> NEW.cenamj) then
	execute sfifocenamj(OLD.idpolsklad, OLD.iddoklsklad, NEW.cenamj);
    end if;  
    --fifo konec
  end if;

  -- prum ceny
  if OLD.storno = false then 
    execute sZapoctiDoMinulosti(OLD.MnozMJ,OLD.CenaMJ,OLD.DatVyst,OLD.idKarty,OLD.idDoklSklad,OLD.idSkladu,-1, OLD.idPolSklad);  
  end if; 
  if NEW.storno = false then 
    execute sZapoctiDoMinulosti(NEW.MnozMJ,NEW.CenaMJ,NEW.DatVyst,NEW.idKarty,NEW.idDoklSklad,NEW.idSkladu,1, NEW.idPolSklad);  
  end if; 
  -- prum ceny konec

  return NEW;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladupdate() OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION dpolskladdelete()
  RETURNS trigger AS
$BODY$  
--J.Svik - pokud stornuju nebo mau pohled, tak ruím fifo vazby  
declare  
begin  
  if OLD.storno = false then 
    execute sZapoctiDoMinulosti(OLD.MnozMJ,OLD.CenaMJ,OLD.DatVyst,OLD.idKarty,OLD.idDoklSklad,OLD.idSkladu,-1, OLD.idPolSklad);  
    execute sfifoStorno(OLD.idPolSklad, OLD.iddoklsklad);
  end if; 
    
  return OLD;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION dpolskladdelete() OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
DROP TRIGGER dpolskladinsert ON dpolsklad;

CREATE TRIGGER dpolskladinsert
  AFTER INSERT
  ON dpolsklad
  FOR EACH ROW
  EXECUTE PROCEDURE dpolskladinsert();

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION isfifosklad(i_datum date)
  RETURNS boolean AS
$BODY$
declare
  _sklfifo boolean;
begin
 select sklfifo into _sklfifo from nNastav where i_datum >= PlatiOdData order by PlatiOdData desc limit 1;
 if (_sklfifo is null) then
        select sklfifo into _sklfifo from nNastav where PlatiOdData is null limit 1; 
 end if;
 return _sklfifo;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION isfifosklad(date) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

-- Function: szapoctipolozkyoddata(integer, date, integer)

-- DROP FUNCTION szapoctipolozkyoddata(integer, date, integer);

CREATE OR REPLACE FUNCTION szapoctipolozkyoddata(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS void AS
$BODY$  
declare  
  zaznam Record;  
  _sklfifo boolean;
begin  
  for zaznam in select * from dPolSklad where ((DatVyst > i_Datum) or (DatVyst = i_Datum and idPolSklad > i_polSkladId)) 
  and idKarty = i_SkladKartaId order by DatVYst asc LOOP 
    _sklfifo := (select isfifosklad(zaznam.datvyst));
    if (_sklfifo <> true) then
      execute sZmenCenyNaPolSklad(zaznam.idPolSklad, i_SkladKartaId, zaznam.iddoklsklad);  
    end if;
    execute sPrepoctiSkladKartu(zaznam.MnozMJ,zaznam.CenaMj,zaznam.DatVyst,zaznam.idKarty,zaznam.idDoklSklad,zaznam.idSkladu,1);  
  end loop;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION szapoctipolozkyoddata(integer, date, integer) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$  
/* Prepocte stavy na skladove karte s id = iSkladKartaId */  
declare  
  /* Deklarace promennych */  
  _PomMnozMJ numeric(19,2);  
  _StavMJ numeric(19,2);  
  _StavTuz numeric(19,2);  
  _StavMen numeric(19,2);  
  _PrumCenaTuz numeric(19,2);  
  _PrumCenaMen numeric(19,2);  
  _PoslCenaTuz numeric(19,2);  
  _PoslCenaMen numeric(19,2);  
  _TypPohybuK varchar(50);  
  _DatPosl date;  
  _kurzSkladKarty numeric(19,6); 
  _kurzDokladu numeric(19,6); 
  loc_MnozMJ numeric(19,6); 
  _sklzapor boolean;
  _sklfifo boolean;  
  
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */  
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;  
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;    
begin  
  loc_MnozMJ:= i_MnozMJ;  
  
  /* Nacteni dat ze skladove karty */  
  open ThisSkladKarta;  
  fetch ThisSkladKarta into _StavMJ,  
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;  
  close ThisSkladKarta;  
    
  /* Zjisteni typPohybuK */  
  open ThisDoklSklad;  
  fetch ThisDoklSklad into _TypPohybuK;  
  close ThisDoklSklad;  
 
  /* zjisteni meny skladove karty */ 
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst)); 
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst)); 
   
  /* pokud jde o vydej musim odecitat */  
  if _TypPohybuK = 'typPohybu.vydej' then  
    loc_MnozMJ:= 0-loc_MnozMJ;  
  end if;  
    
  /* Vypocet StavMJ */  
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;  
 
  if _StavMJ < 0 then 
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
	if (_sklzapor is null) then 
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;  
	end if; 
    if _sklzapor is null or _sklzapor = false then 
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/ 
    end if; 
  end if; 
	 
    
  /* Vypocet StavTuz */  
  if loc_MnozMJ = 0 then  
    _PomMnozMJ:=1;  
  else  
    _PomMnozMJ:=loc_MnozMJ;  
  end if;  
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu);  
  /* Vypocet StavMen */  
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;  
 
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/ 
  if _TypPohybuK = 'typPohybu.prijem' then 
    /* Vypocet PrumCenaTuz */  
    if _StavMJ > 0 then  
      _PrumCenaTuz:=_StavTuz/_StavMJ;  
    end if;  
    /* Vypocet PrumCenaMen */  
    if _StavMJ > 0 then  
      _PrumCenaMen:=_StavMen/_StavMJ;  
    end if;  
  end if;  
  
  /* Prepocteni stavu skladu pro FIFO */
  _sklfifo := (select isfifosklad(i_DatVyst));
  if (_sklfifo) then
    _StavTuz := _PrumCenaTuz * _StavMJ;
    _StavMen := _PrumCenaMen * _StavMJ;
  end if;
  
  /* Nastaveni posledni ceny */  
  _PoslCenaTuz:= i_CenaMJ;  
  _PoslCenaMen:= i_CenaMJ;  
 
  /* Nastaveni data posledniho pohybu na karte */  
  if _DatPosl is null then  
    _DatPosl:= i_DatVyst;  
  end if;  
  if _DatPosl < i_DatVyst then  
    _DatPosl:=i_DatVyst;  
  end if;  
 
  /* Update v databazi */  
  update sKarty set StavMJ = _StavMJ,  
    StavTuz = _StavTuz,  
    StavMen = _StavMen,  
    PrumCenaTuz = _PrumCenaTuz,  
    PrumCenaMen = _PrumCenaMen,  
    PoslCenaTuz = _PoslCenaTuz,  
    PoslCenaMen = _PoslcenaMen,  
    DatPosl = _DatPosl where  
    idKarty = i_SkladKartaId;  
end;  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;

---------------------------------------------------------------------------
---------------------------------------------------------------------------
---------------------------------------------------------------------------
CREATE OR REPLACE FUNCTION sPrepoctiSumyDokladu(i_idDoklSklad integer)
  RETURNS void AS
$BODY$
declare
 _sumZkl numeric(15,2); 
 _sumZklMen numeric(15,2);  
begin
 select sum(sumZkl), sum(sumZklMen) into _sumZkl, _sumZklMen from dPolSklad where idDoklSklad = i_idDoklSklad;
 update dDoklSklad set sumCelkem = _sumZkl, sumCelkemMen = _sumZklMen where idDoklSklad = i_idDoklSklad;
end
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sPrepoctiSumyDokladu(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 51, 't');
