--------------------------------------------------------------------------------
-- Bug 24754 – [WinStrom] Přidat nové certifikační autority
--------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
  _idautcert integer;
begin
  select idautcert into _idautcert from wautcert where certnazev = 'PostSignum Public CA';
  if (_idautcert is null) then
    INSERT INTO wautcert (idautcert, lastupdate, uzivnazev, certnazev, certorgan, platido, platiod) VALUES (nextval('seq_wautcert'), now(), NULL, 'PostSignum Public CA',  'Česká pošta s.p. [IČ 47114983]', '2020-11-08 12:06:16', '2005-11-08 12:07:27');
    INSERT INTO wautcertcipher (idautcertcipher, idautcert, certifikat) VALUES (nextval('seq_wautcertcipher'), currval('seq_wautcert'), '-----BEGIN CERTIFICATE-----\\012MIIGKzCCBROgAwIBAgIBJzANBgkqhkiG9w0BAQUFADBZMQswCQYDVQQGEwJDWjEs\\012MCoGA1UECgwjxIxlc2vDoSBwb8WhdGEsIHMucC4gW0nEjCA0NzExNDk4M10xHDAa\\012BgNVBAMTE1Bvc3RTaWdudW0gUm9vdCBRQ0EwHhcNMDUxMTA4MTEwNzI3WhcNMjAx\\012MTA4MTEwNjE2WjBaMQswCQYDVQQGEwJDWjEsMCoGA1UECgwjxIxlc2vDoSBwb8Wh\\012dGEsIHMucC4gW0nEjCA0NzExNDk4M10xHTAbBgNVBAMTFFBvc3RTaWdudW0gUHVi\\012bGljIENBMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAtDh3+A6UCnnS\\012MtwgjDTRwRfO1kvTFTUgPzrnfLZ4oqZbHtE1XJlM8l/1QuAThIN3D6Q46z1dJ43k\\0129Pn5kqY2oGN1qESdYf7RncZmuDNJpQ1n9N/8uQGw3Cb53FrrTIh7OtVpHbGOVJWu\\012Hw4nrK+NmUkHJZ9HxgUEuGWuMtVvPnHCS0Er2Yj61t9tIhs5POXb72X7KByZ0Oes\\012mkfLqMS/hwkuXUNVICT+L/cpglglanm5rW2pypuNfLSS0zXaCGcINCsp/0SgDZjI\\012Fef6Mikuce8oXy7efLP268U59yvyyCedBSdM1H9AkKJK4OinVJUObZx+1lqnvktS\\012mhmHvGA1xQIDAQABo4IC+zCCAvcwgaEGA1UdIASBmTCBljCBkwYEVR0gADCBijCB\\012hwYIKwYBBQUHAgIwexp5VGVudG8gY2VydGlmaWthdCBieWwgdnlkYW4gamFrbyBr\\012dmFsaWZpa292YW55IHN5c3RlbW92eSBjZXJ0aWZpa2F0IHZlIHNteXNsdSB6YWtv\\012bmEgMjI3LzIwMDAgU2IuIGEgbmF2YXp1amljaWNoIHByZWRwaXN1LjAPBgNVHRME\\012CDAGAQH/AgEAMA4GA1UdDwEB/wQEAwIBBjCBgQYDVR0jBHoweIAUKx3RnXn11Xge\\012AjyCSujd7kOvKUShXaRbMFkxCzAJBgNVBAYTAkNaMSwwKgYDVQQKDCPEjGVza8Oh\\012IHBvxaF0YSwgcy5wLiBbScSMIDQ3MTE0OTgzXTEcMBoGA1UEAxMTUG9zdFNpZ251\\012bSBSb290IFFDQYIBATCCAYsGA1UdHwSCAYIwggF+MDCgLqAshipodHRwOi8vd3d3\\012LnBvc3RzaWdudW0uY3ovY3JsL3Bzcm9vdHFjYS5jcmwwMKAuoCyGKmh0dHA6Ly9w\\012b3N0c2lnbnVtLnR0Yy5jei9jcmwvcHNyb290cWNhLmNybDCBiqCBh6CBhIaBgWxk\\012YXA6Ly9xY2EucG9zdHNpZ251bS5jei9jbiUzZFBvc3RTaWdudW0lMjBSb290JTIw\\012UUNBLG8lM2RDZXNrYSUyMHBvc3RhJTIwcy5wLiUyMFtJQyUyMDQ3MTE0OTgzXSxj\\012JTNkQ1o/Y2VydGlmaWNhdGVSZXZvY2F0aW9uTGlzdDCBiqCBh6CBhIaBgWxkYXA6\\012Ly9wb3N0c2lnbnVtLnR0Yy5jei9jbiUzZFBvc3RTaWdudW0lMjBSb290JTIwUUNB\\012LG8lM2RDZXNrYSUyMHBvc3RhJTIwcy5wLiUyMFtJQyUyMDQ3MTE0OTgzXSxjJTNk\\012Q1o/Y2VydGlmaWNhdGVSZXZvY2F0aW9uTGlzdDAdBgNVHQ4EFgQUBfCgAxQlYilb\\012c89xCC8Mr4y3dpAwDQYJKoZIhvcNAQEFBQADggEBACCZClobqyFiJMNTjrPQLo9h\\012JuJbOrH5FU9KonByYpoJ2X0RpAi/KOMk0v3RqO0uDkmmv66U6aXaerjf/q+/Lfin\\0121lekWdJ8IrqnCDkAEzlp2Ebh8MUnDzPwyXhVE+IZ9f1JQjMn3RSAk9alNeeohL42\\012/cg2h/7zpfCnUMQe3oTKh/JbJRXbyt7MD9yHX8NEVy4pfXn77mjHok+2cfM7DsQg\\012yOOG9zXWKV0XB6PvdTGo4gMOsGR7/I1wAtX/qtlfaCvVmaxUnukkCU/PenJIol/9\\012Ztnl1VwS+k+0zRBVHcmMfRUwt6gFbvkp9OHjT7mmt0KhwFaAf8RIRSLoeOqvdV4=\\012-----END CERTIFICATE-----\\012\\012');
  end if;

  select idautcert into _idautcert from wautcert where certnazev = 'PostSignum Root QCA 2';
  if (_idautcert is null) then
    INSERT INTO wautcert (idautcert, lastupdate, uzivnazev, certnazev, certorgan, platido, platiod) VALUES (nextval('seq_wautcert'), now(), NULL, 'PostSignum Root QCA 2','Česká pošta, s.p. [IČ 47114983]','2025-01-19 09:04:31','2010-01-19 09:04:31');
    INSERT INTO wautcertcipher (idautcertcipher, idautcert, certifikat) VALUES (nextval('seq_wautcertcipher'), currval('seq_wautcert'), '-----BEGIN CERTIFICATE-----\\012MIIFnDCCBISgAwIBAgIBZDANBgkqhkiG9w0BAQsFADBbMQswCQYDVQQGEwJDWjEs\\012MCoGA1UECgwjxIxlc2vDoSBwb8WhdGEsIHMucC4gW0nEjCA0NzExNDk4M10xHjAc\\012BgNVBAMTFVBvc3RTaWdudW0gUm9vdCBRQ0EgMjAeFw0xMDAxMTkwODA0MzFaFw0y\\012NTAxMTkwODA0MzFaMFsxCzAJBgNVBAYTAkNaMSwwKgYDVQQKDCPEjGVza8OhIHBv\\012xaF0YSwgcy5wLiBbScSMIDQ3MTE0OTgzXTEeMBwGA1UEAxMVUG9zdFNpZ251bSBS\\012b290IFFDQSAyMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAoFz8yBxf\\0122gf1uN0GGXknvGHwurpp4Lw3ZPWZB6nEBDGjSGIXK0Or6Xa3ZT+tVDTeUUjT133G\\0127Vs51D6z/ShWy+9T7a1f6XInakewyFj8PT0EdZ4tAybNYdEUO/dShg2WvUyfZfXH\\0120jmmZm6qUDy0VfKQfiyWchQRi/Ax6zXaU2+X3hXBfvRMr5l6zgxYVATEyxCfOLM9\\012a5U6lhpyCDf2Gg6dPc5Cy6QwYGGpYER1fzLGsN9stdutkwlP13DHU1Sp6W5ywtfL\\012owYaV1bqOOdARbAoJ7q8LO6EBjyIVr03mFusPaMCOzcEn3zL5XafknM36Vqtdmqz\\012iWR+3URAUgqE0wIDAQABo4ICaTCCAmUwgaUGA1UdHwSBnTCBmjAxoC+gLYYraHR0\\012cDovL3d3dy5wb3N0c2lnbnVtLmN6L2NybC9wc3Jvb3RxY2EyLmNybDAyoDCgLoYs\\012aHR0cDovL3d3dzIucG9zdHNpZ251bS5jei9jcmwvcHNyb290cWNhMi5jcmwwMaAv\\012oC2GK2h0dHA6Ly9wb3N0c2lnbnVtLnR0Yy5jei9jcmwvcHNyb290cWNhMi5jcmww\\012gfEGA1UdIASB6TCB5jCB4wYEVR0gADCB2jCB1wYIKwYBBQUHAgIwgcoagcdUZW50\\012byBrdmFsaWZpa292YW55IHN5c3RlbW92eSBjZXJ0aWZpa2F0IGJ5bCB2eWRhbiBw\\012b2RsZSB6YWtvbmEgMjI3LzIwMDBTYi4gYSBuYXZhem55Y2ggcHJlZHBpc3UvVGhp\\012cyBxdWFsaWZpZWQgc3lzdGVtIGNlcnRpZmljYXRlIHdhcyBpc3N1ZWQgYWNjb3Jk\\012aW5nIHRvIExhdyBObyAyMjcvMjAwMENvbGwuIGFuZCByZWxhdGVkIHJlZ3VsYXRp\\012b25zMBIGA1UdEwEB/wQIMAYBAf8CAQEwDgYDVR0PAQH/BAQDAgEGMB0GA1UdDgQW\\012BBQVKYzFRWmruLPD6v5LuDHY3PDndjCBgwYDVR0jBHwweoAUFSmMxUVpq7izw+r+\\012S7gx2Nzw53ahX6RdMFsxCzAJBgNVBAYTAkNaMSwwKgYDVQQKDCPEjGVza8OhIHBv\\012xaF0YSwgcy5wLiBbScSMIDQ3MTE0OTgzXTEeMBwGA1UEAxMVUG9zdFNpZ251bSBS\\012b290IFFDQSAyggFkMA0GCSqGSIb3DQEBCwUAA4IBAQBeKtoLQKFqWJEgLNxPbQNN\\0125OTjbpOTEEkq2jFI0tUhtRx//6zwuqJCzfO/KqggUrHBca+GV/qXcNzNAlytyM71\\012fMv/VwgL9gBHTN/IFIw100JbciI23yFQTdF/UoEfK/m+IFfirxSRi8LRERdXHTEb\\012vwxMXIzZVXloWvX64UwWtf4Tvw5bAoPj0O1Z2ly4aMTAT2a+y+z184UhuZ/oGyMw\\012eIakmFM7M7RrNki507jiSLTzuaFMCpyWOX7ULIhzY6xKdm5iQLjTvExn2JTvVChF\\012Y+jUu/G0zAdLyeU4vaXdQm1A8AEiJPTd0Z9LAxL6Sq2iraLNN36+NyEK/ts3mPLL\\012-----END CERTIFICATE-----\\012\\012');
  end if;

  select idautcert into _idautcert from wautcert where certnazev = 'PostSignum Qualified CA 2';
  if (_idautcert is null) then
    INSERT INTO wautcert (idautcert, lastupdate, uzivnazev, certnazev, certorgan, platido, platiod) VALUES (nextval('seq_wautcert'), now(), NULL, 'PostSignum Qualified CA 2','Česká pošta, s.p. [IČ 47114983]','2020-01-19 12:30:20','2010-01-19 12:31:20');
    INSERT INTO wautcertcipher (idautcertcipher, idautcert, certifikat) VALUES (nextval('seq_wautcertcipher'), currval('seq_wautcert'), '-----BEGIN CERTIFICATE-----\\012MIIGXzCCBUegAwIBAgIBcTANBgkqhkiG9w0BAQsFADBbMQswCQYDVQQGEwJDWjEs\\012MCoGA1UECgwjxIxlc2vDoSBwb8WhdGEsIHMucC4gW0nEjCA0NzExNDk4M10xHjAc\\012BgNVBAMTFVBvc3RTaWdudW0gUm9vdCBRQ0EgMjAeFw0xMDAxMTkxMTMxMjBaFw0y\\012MDAxMTkxMTMwMjBaMF8xCzAJBgNVBAYTAkNaMSwwKgYDVQQKDCPEjGVza8OhIHBv\\012xaF0YSwgcy5wLiBbScSMIDQ3MTE0OTgzXTEiMCAGA1UEAxMZUG9zdFNpZ251bSBR\\012dWFsaWZpZWQgQ0EgMjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAKbR\\012ReVFlmMooQD/ZzJA9M793LcZivHRvWEG8jsEpp2xTayR17ovs8OMeoYKjvGo6PDf\\012kCJs+sBYS0q5WQFApdWkyl/tUOw1oZ2SPSq6uYLJUyOYSKPMOgKz4u3XuB4Ki1Z+\\012i8Fb7zeRye6eqahK+tql3ZAJnrJKgC4X2Ta1RKkxK+Hu1bdhWJA3gwL+WkIZbL/P\\012YIzjet++T8ssWK1PWdBXsSfKOTikNzZt2VPETAQDBpOYxqAgLfCRbcb9KU2WIMT3\\012NNxILu3sNl+OM9gV/GWO943JHsOMAVyJSQREaZksG5KDzzNzQS/LsbYkFtnJAmmh\\0127g9p9Ci6cEJ+pfBTtMECAwEAAaOCAygwggMkMIHxBgNVHSAEgekwgeYwgeMGBFUd\\012IAAwgdowgdcGCCsGAQUFBwICMIHKGoHHVGVudG8ga3ZhbGlmaWtvdmFueSBzeXN0\\012ZW1vdnkgY2VydGlmaWthdCBieWwgdnlkYW4gcG9kbGUgemFrb25hIDIyNy8yMDAw\\012U2IuIGEgbmF2YXpueWNoIHByZWRwaXN1L1RoaXMgcXVhbGlmaWVkIHN5c3RlbSBj\\012ZXJ0aWZpY2F0ZSB3YXMgaXNzdWVkIGFjY29yZGluZyB0byBMYXcgTm8gMjI3LzIw\\012MDBDb2xsLiBhbmQgcmVsYXRlZCByZWd1bGF0aW9uczASBgNVHRMBAf8ECDAGAQH/\\012AgEAMIG8BggrBgEFBQcBAQSBrzCBrDA3BggrBgEFBQcwAoYraHR0cDovL3d3dy5w\\012b3N0c2lnbnVtLmN6L2NydC9wc3Jvb3RxY2EyLmNydDA4BggrBgEFBQcwAoYsaHR0\\012cDovL3d3dzIucG9zdHNpZ251bS5jei9jcnQvcHNyb290cWNhMi5jcnQwNwYIKwYB\\012BQUHMAKGK2h0dHA6Ly9wb3N0c2lnbnVtLnR0Yy5jei9jcnQvcHNyb290cWNhMi5j\\012cnQwDgYDVR0PAQH/BAQDAgEGMIGDBgNVHSMEfDB6gBQVKYzFRWmruLPD6v5LuDHY\\0123PDndqFfpF0wWzELMAkGA1UEBhMCQ1oxLDAqBgNVBAoMI8SMZXNrw6EgcG/FoXRh\\012LCBzLnAuIFtJxIwgNDcxMTQ5ODNdMR4wHAYDVQQDExVQb3N0U2lnbnVtIFJvb3Qg\\012UUNBIDKCAWQwgaUGA1UdHwSBnTCBmjAxoC+gLYYraHR0cDovL3d3dy5wb3N0c2ln\\012bnVtLmN6L2NybC9wc3Jvb3RxY2EyLmNybDAyoDCgLoYsaHR0cDovL3d3dzIucG9z\\012dHNpZ251bS5jei9jcmwvcHNyb290cWNhMi5jcmwwMaAvoC2GK2h0dHA6Ly9wb3N0\\012c2lnbnVtLnR0Yy5jei9jcmwvcHNyb290cWNhMi5jcmwwHQYDVR0OBBYEFInoTN+L\\012Jjk+1yQuEg565+Yn5daXMA0GCSqGSIb3DQEBCwUAA4IBAQB17M2VB48AXCVfVeeO\\012Lo0LIJZcg5EyHUKurbnff6tQOmyT7gzpkJNY3I3ijW2ErBfUM/6HefMxYKKWSs4j\\012XqGSK5QfxG0B0O3uGfHPS4WFftaPSAnWk1tiJZ4c43+zSJCcH33n9pDmvt8n0j+6\\012cQAZIWh4PPpmkvUg3uN4E0bzZHnH2uKzMvpVnE6wKml6oV+PUfPASPIYQw9gFEAN\\012cMzp10hXJHrnOo0alPklymZdTVssBXwdzhSBsFel1eVBSvVOx6+y8zdbrkRLOvTV\\012nSMb6zH+fsygU40mimdo30rY/6N+tdQhbM/sTCxgdWAy2g0elAN1zi9Jx6aQ76wo\\012Dcn+\\012-----END CERTIFICATE-----\\012\\012');
  end if;

  select idautcert into _idautcert from wautcert where certnazev = 'PostSignum Public CA 2';
  if (_idautcert is null) then
    INSERT INTO wautcert (idautcert, lastupdate, uzivnazev, certnazev, certorgan, platido, platiod) VALUES (nextval('seq_wautcert'), now(), NULL, 'PostSignum Public CA 2','Česká pošta, s.p. [IČ 47114983]','2020-01-19 14:35:42','2010-01-19 14:36:11');
    INSERT INTO wautcertcipher (idautcertcipher, idautcert, certifikat) VALUES (nextval('seq_wautcertcipher'), currval('seq_wautcert'), '-----BEGIN CERTIFICATE-----\\012MIIGKzCCBROgAwIBAgIBJzANBgkqhkiG9w0BAQUFADBZMQswCQYDVQQGEwJDWjEs\\012MCoGA1UECgwjxIxlc2vDoSBwb8WhdGEsIHMucC4gW0nEjCA0NzExNDk4M10xHDAa\\012BgNVBAMTE1Bvc3RTaWdudW0gUm9vdCBRQ0EwHhcNMDUxMTA4MTEwNzI3WhcNMjAx\\012MTA4MTEwNjE2WjBaMQswCQYDVQQGEwJDWjEsMCoGA1UECgwjxIxlc2vDoSBwb8Wh\\012dGEsIHMucC4gW0nEjCA0NzExNDk4M10xHTAbBgNVBAMTFFBvc3RTaWdudW0gUHVi\\012bGljIENBMIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAtDh3+A6UCnnS\\012MtwgjDTRwRfO1kvTFTUgPzrnfLZ4oqZbHtE1XJlM8l/1QuAThIN3D6Q46z1dJ43k\\0129Pn5kqY2oGN1qESdYf7RncZmuDNJpQ1n9N/8uQGw3Cb53FrrTIh7OtVpHbGOVJWu\\012Hw4nrK+NmUkHJZ9HxgUEuGWuMtVvPnHCS0Er2Yj61t9tIhs5POXb72X7KByZ0Oes\\012mkfLqMS/hwkuXUNVICT+L/cpglglanm5rW2pypuNfLSS0zXaCGcINCsp/0SgDZjI\\012Fef6Mikuce8oXy7efLP268U59yvyyCedBSdM1H9AkKJK4OinVJUObZx+1lqnvktS\\012mhmHvGA1xQIDAQABo4IC+zCCAvcwgaEGA1UdIASBmTCBljCBkwYEVR0gADCBijCB\\012hwYIKwYBBQUHAgIwexp5VGVudG8gY2VydGlmaWthdCBieWwgdnlkYW4gamFrbyBr\\012dmFsaWZpa292YW55IHN5c3RlbW92eSBjZXJ0aWZpa2F0IHZlIHNteXNsdSB6YWtv\\012bmEgMjI3LzIwMDAgU2IuIGEgbmF2YXp1amljaWNoIHByZWRwaXN1LjAPBgNVHRME\\012CDAGAQH/AgEAMA4GA1UdDwEB/wQEAwIBBjCBgQYDVR0jBHoweIAUKx3RnXn11Xge\\012AjyCSujd7kOvKUShXaRbMFkxCzAJBgNVBAYTAkNaMSwwKgYDVQQKDCPEjGVza8Oh\\012IHBvxaF0YSwgcy5wLiBbScSMIDQ3MTE0OTgzXTEcMBoGA1UEAxMTUG9zdFNpZ251\\012bSBSb290IFFDQYIBATCCAYsGA1UdHwSCAYIwggF+MDCgLqAshipodHRwOi8vd3d3\\012LnBvc3RzaWdudW0uY3ovY3JsL3Bzcm9vdHFjYS5jcmwwMKAuoCyGKmh0dHA6Ly9w\\012b3N0c2lnbnVtLnR0Yy5jei9jcmwvcHNyb290cWNhLmNybDCBiqCBh6CBhIaBgWxk\\012YXA6Ly9xY2EucG9zdHNpZ251bS5jei9jbiUzZFBvc3RTaWdudW0lMjBSb290JTIw\\012UUNBLG8lM2RDZXNrYSUyMHBvc3RhJTIwcy5wLiUyMFtJQyUyMDQ3MTE0OTgzXSxj\\012JTNkQ1o/Y2VydGlmaWNhdGVSZXZvY2F0aW9uTGlzdDCBiqCBh6CBhIaBgWxkYXA6\\012Ly9wb3N0c2lnbnVtLnR0Yy5jei9jbiUzZFBvc3RTaWdudW0lMjBSb290JTIwUUNB\\012LG8lM2RDZXNrYSUyMHBvc3RhJTIwcy5wLiUyMFtJQyUyMDQ3MTE0OTgzXSxjJTNk\\012Q1o/Y2VydGlmaWNhdGVSZXZvY2F0aW9uTGlzdDAdBgNVHQ4EFgQUBfCgAxQlYilb\\012c89xCC8Mr4y3dpAwDQYJKoZIhvcNAQEFBQADggEBACCZClobqyFiJMNTjrPQLo9h\\012JuJbOrH5FU9KonByYpoJ2X0RpAi/KOMk0v3RqO0uDkmmv66U6aXaerjf/q+/Lfin\\0121lekWdJ8IrqnCDkAEzlp2Ebh8MUnDzPwyXhVE+IZ9f1JQjMn3RSAk9alNeeohL42\\012/cg2h/7zpfCnUMQe3oTKh/JbJRXbyt7MD9yHX8NEVy4pfXn77mjHok+2cfM7DsQg\\012yOOG9zXWKV0XB6PvdTGo4gMOsGR7/I1wAtX/qtlfaCvVmaxUnukkCU/PenJIol/9\\012Ztnl1VwS+k+0zRBVHcmMfRUwt6gFbvkp9OHjT7mmt0KhwFaAf8RIRSLoeOqvdV4=\\012-----END CERTIFICATE-----\\012\\012');
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 512, 't', %appVersion%, clock_timestamp());