--------------------------------------------------------------------------------
-- Bug 24682 – [WinStrom] Přijaté objednávky - chybné % realizovatelnosti při neskladové zboží
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION obchodrealizovatelnost(iddokl integer) RETURNS numeric
    AS $$  
declare 
  zbyvaNakl numeric(15,2); 
  moznoSklad numeric(15,2); 
  moznoNesklad numeric(15,2); 
  vysledek numeric(6,2); 
  _idUcetniObdobi integer; 
  _idadresar integer;
  _typPohybuK character varying;
begin  
  select idUcetObdobi into _idUcetniObdobi from nUcetObdobi where (DATE(NOW()) >= PlatiOdData and DATE(NOW()) <= PlatiDoData) limit 1; 
   
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into zbyvaNakl from dPolObch where idDoklObch = idDokl; 
  
  select idfirmy, typPohybuK into _idadresar, _typPohybuK from ddoklobch where iddoklobch = iddokl;
  
  if(_typPohybuK = 'typPohybu.prijem') then
    _typPohybuK = 'typPohybu.vydej';
  else
    _typPohybuK = 'typPohybu.prijem';
  end if;

  select coalesce(sum(a.procpol), 0) into moznoSklad from 
   (select minValue( 
        maxValue(dgetstavnasklade((select idKarty from sKarty where idCenik = P.idCenik AND idSkladu = P.idBspSkl AND idUcetObdobi = _idUcetniObdobi), DATE(NOW()), -1, _idadresar, null, null, _typPohybuK), 0),
        sum(mnozMj-mnozMjReal)) 
    * (sum(cenamj * (mnozMj-mnozMjReal)) / sum(mnozMj-mnozMjReal)) as procpol
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik 
      where idDoklObch = idDokl and C.skladove = true and mnozMj-mnozMjReal > 0
    group by P.idcenik, idbspskl) as a;
 
  select coalesce(sum((mnozMj-mnozMjReal) * cenaMj), 0) into moznoNesklad 
    from dPolObch as P left outer join ccenik as C on P.idcenik = C.idcenik  where idDoklObch = idDokl and (C.skladove is null or C.skladove = false); 
 
  if (zbyvaNakl = 0) then 
    vysledek := 100 ; 
  else 
    vysledek := ((moznoSklad + moznoNesklad) / zbyvaNakl) * 100; 
  end if; 
   
  return vysledek; 
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.obchodrealizovatelnost(iddokl integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 523, 't', %appVersion%, clock_timestamp());