--------------------------------------------------------------------------------
-- Bug 25898 – [winstrom] Dodatečné přiznání k DPH vytvořit
--------------------------------------------------------------------------------

CREATE SEQUENCE SEQ_URADEKPRIZNANIDPH
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.SEQ_URADEKPRIZNANIDPH OWNER TO %firmaRole%;

CREATE TABLE uRadekPriznaniDph (
    idradekpriznanidph integer DEFAULT nextval('SEQ_URADEKPRIZNANIDPH'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    rok integer not null default 0,
    mesic integer default 0,
    ctvrtleti integer default 0,
    datum date,
    stavk  character varying(50) not null,
    zaklad numeric (19,6) not null default 0.0,
    dph numeric (19,6) not null default 0.0,
    typszbdphk character varying(50),
    iduzivatel integer,
    idclendph integer
);

ALTER TABLE public.uRadekPriznaniDph OWNER TO %firmaRole%;

ALTER TABLE uRadekPriznaniDph
  ADD CONSTRAINT uradekpriznanidph_pkey PRIMARY KEY (idradekpriznanidph);

ALTER TABLE uRadekPriznaniDph
  ADD CONSTRAINT uRadekPriznaniDph_idclendph_fk FOREIGN KEY (idclendph)
      REFERENCES uclendph (idclendph) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

ALTER TABLE uRadekPriznaniDph
  ADD CONSTRAINT uRadekPriznaniDph_iduzivatel_fk FOREIGN KEY (iduzivatel)
      REFERENCES wuzivatel (iduzivatel) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX uRadekPriznaniDph_IdUzivatel_index ON uRadekPriznaniDph USING btree (IdUzivatel);
CREATE INDEX uRadekPriznaniDph_IdClenDph_index ON uRadekPriznaniDph USING btree (IdClenDph);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 580, 't', %appVersion%, clock_timestamp());
