--------------------------------------------------------------------------------
-- Bug 29178 – [WinStrom] Náhodné změny účtu na dokladech
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION ddoklfakupdateucty() RETURNS trigger AS $$  
declare nelzeZmena int;  
        idDokl int;  
        dokl record;
        ucPrij int;
        ucVyd int;
        _zdrojprofak boolean;
        _hromfakt boolean;
begin  
  nelzeZmena := 0;  
    
  --pokud dojde ke zmene primarniho uctu  
  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then  
    -- uprava banka/pokladna vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni  
    for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))  
    loop  
        execute dNastavUcetDokladu(1, idDokl, 1, NEW.idPrimUcet);  
    end loop;  
  
    -- uhradaKR, preceneni - u kurzoveho rozdilu a preceneni nevim na ktere strane je hledany ucet, testuji oba  
    for dokl in (select * from dDoklInt where compareId(idProtiUcet, NEW.idPrimUcet) = false and compareId(idProtiUcet, OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  
    for dokl in (select * from dDoklInt where compareId(idPrimUcet,  NEW.idPrimUcet) = false and compareId(idPrimUcet,  OLD.idPrimUcet) = true and idDoklInt in  
        (select idTabB from dVazebTab where idTabA = NEW.idDoklFak and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))  
    loop  
      if (not compareid(dokl.idProtiUcet, dokl.idPrimUcet)) then
        execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
      else
        select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = dokl.iddoklint;
        if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
          execute dNastavUcetDokladu(1, dokl.idDoklInt, 1, NEW.idPrimUcet);
        end if;
      end if;
    end loop;  
  end if;  
  
  --pokud dojde ke zmene protiuctu (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklDalUcet, NEW.idProtiUcet) = false and kopZklDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idProtiUcet where compareId(idZklDalUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idZklMdUcet, NEW.idProtiUcet) = false and kopZklMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idZklMdUcet = NEW.idProtiUcet where compareId(idZklMdUcet, NEW.idProtiUcet) = false and idPolFak in  
            (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
  
      -- vazba na sklad  
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklFak and modulA = NEW.modul and   
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)  
      loop  
        select zdrojprofak, hromfakt into _zdrojprofak, _hromfakt from ddoklsklad where iddoklsklad = iddokl;
        if _zdrojprofak = false or _hromfakt = false then     -- pokud byl skladovy doklad pridany hromadnou fakturaci tak na nej neprenasime
          execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);
        end if;  
      end loop;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu zakladni sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphZaklUcet, OLD.idDphZaklUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphZaklUcet where compareId(idDphDalUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphZaklUcet where compareId(idDphMdUcet, NEW.idDphZaklUcet) = false and typSzbDphK = 'typSzbDph.dphZakl' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  --pokud dojde ke zmene protiuctu snizene sazby dph (doklad je zdd menime ucty odpoctu)  
  if (compareId(NEW.idDphSnizUcet, OLD.idDphSnizUcet) = false and nelzeZmena = 0) then  
    if (NEW.typPohybuK = 'typPohybu.prijem') then             -- kdyz je to faktura vydana  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphDalUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphDalUcet = NEW.idDphSnizUcet where compareId(idDphDalUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  
    if (NEW.typPohybuK = 'typPohybu.vydej') then             -- kdyz je to faktura prijata  
      -- zjistime zda neexistujou nake co nesmime zmenit  
      select count(*) into nelzeZmena from dPolFak where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and kopDphMdUcet = true and  
          idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      -- pokud smime zmenit vsechny polozky co potrebujeme menime  
      if (nelzeZmena = 0) then  
        update dPolFak set lastupdate = now(), idDphMdUcet = NEW.idDphSnizUcet where compareId(idDphMdUcet, NEW.idDphSnizUcet) = false and typSzbDphK = 'typSzbDph.dphSniz' and   
            idPolFak in (select idTabA from dVazebTab where idTabB = NEW.idDoklFak and typVazbyK = 'typVazbyDokl.odpocetZDD');  
      end if;  
    end if;  
  end if;  
  
  if (nelzeZmena > 0) then  
    raise exception '0008:dDoklFakUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
  end if;  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklfakupdateucty() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION ddoklintupdateucty() RETURNS trigger
    AS $$
declare idPoloz int;
        idDokl int;
        kopirovat boolean;
        ucPrij int;
        ucVyd int;
        _zdrojprofak boolean;
        _hromfakt boolean;
begin
  --pokud dojde ke zmene protiuctu
  if (compareId(NEW.idProtiUcet, OLD.idProtiUcet) = false) then
    if (NEW.modul = 'POK' and NEW.typPohybuK = 'typPohybu.vydej') then             -- pokladni vydej
      -- vazba na sklad   
      for idDokl in (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.hlavaSkl' and idTabA = NEW.idDoklInt and modulA = NEW.modul and 
            compareId((select idProtiUcet from dDoklSklad where idDoklSklad = idTabB), NEW.idProtiUcet) = false)   
      loop   
        select zdrojprofak, hromfakt into _zdrojprofak, _hromfakt from ddoklsklad where iddoklsklad = iddokl;
        if _zdrojprofak = false or _hromfakt = false then     -- pokud byl skladovy doklad pridany hromadnou fakturaci tak na nej neprenasime
          execute dNastavUcetDokladu(2, idDokl, 1, NEW.idProtiUcet);   
        end if;  
      end loop;   
    end if;   

    -- uprava faktur vazbami uhrada a vazbaZDD, pouze pokud ucet nesouhlasi aby nedochazelo k zacykleni
    for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and idDoklFak in
        (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhrada','typVazbyDokl.vazbaZDD')))
    loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
    end loop;

    -- odpocet zalohy - polozka dokladu
    for idPoloz in (select idTabA from dVazebTab where typVazbyK = 'typVazbyDokl.odpocetZALOHY' and idTabB in
            (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK = 'typVazbyDokl.uhradaZALOHY')) loop
      if (NEW.typPohybuK = 'typPohybu.prijem') then
        update dPolFak set lastupdate = now(), idZklDalUcet = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklDalUcet, NEW.idProtiUcet) = false and compareId(idZklDalUcet, OLD.idProtiUcet) = true;
      else
        update dPolFak set lastupdate = now(), idZklMdUcet  = NEW.idProtiUcet where idPolFak = idPoloz and compareId(idZklMdUcet,  NEW.idProtiUcet) = false and compareId(idZklMdUcet,  OLD.idProtiUcet) = true;
      end if;
    end loop;

    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is null and ucVyd is not null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idProtiUcet) = false and compareId(idPrimUcet, OLD.idProtiUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idProtiUcet);
      end loop;
    end if;
  end if;

  if (compareId(NEW.idPrimUcet, OLD.idPrimUcet) = false) then
    -- uhradaKR, preceneni
    kopirovat = false;
    if not compareId(OLD.idPrimUcet, OLD.idProtiUcet) then                    -- ucty na internim dokladu nebyli stejne
      kopirovat = true;
    else
      select P.idprotiucetp, P.idprotiucetv into ucPrij, ucVyd from ddoklint as D inner join utypucop as P on D.idtypucop = P.idtypucop where iddoklint = NEW.iddoklint;
      if (ucPrij is not null and ucVyd is null) then      -- pokud je z predpisu zauctovani zrejme ktery ucet se prenasi
        kopirovat = true;
      end if;
    end if;
    
    if kopirovat then
      for idDokl in (select idDoklFak from dDoklFak where compareId(idPrimUcet, NEW.idPrimUcet) = false and compareId(idPrimUcet, OLD.idPrimUcet) = true and idDoklFak in
          (select idTabA from dVazebTab where idTabB = NEW.idDoklInt and typVazbyK in ('typVazbyDokl.uhradaKR','typVazbyDokl.preceneni','typVazbyDokl.uhradaZB')))
      loop
        execute dNastavUcetDokladu(0, idDokl, 0, NEW.idPrimUcet);
      end loop;
    end if;
  end if;

  return NEW;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.ddoklintupdateucty() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolfakupdateucty() RETURNS trigger AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
        pol record;
        df record;
        ds record;
        ucetFak varchar;
        ucetSkl varchar;
begin  
  if (NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          select * into pol from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.polozkaSkl') limit 1;
          select * into df from ddoklfak where iddoklfak = NEW.iddoklfak;
          select * into ds from ddoklsklad where iddoklsklad = pol.iddoklsklad;
          
          select kod into ucetFak from uucty where iducet = NEW.idZklMdUcet;
          select kod into ucetSkl from uucty where iducet = pol.idZklDalUcet;
        
          raise exception '0008:dPolFakUpdateUcty(): Nelze zmenit ucet u navazane polozky. FAK: zdroj-% hrom-% pol: kop-% % zdroj-% SKL: zdroj-% hrom-% pol: kop-% % zdroj-%', 
            df.zdrojProSkl, df.hromFakt, NEW.kopZklMdUcet, ucetFak, NEW.zdrojProSkl, ds.zdrojProFak, ds.hromFakt, true, ucetSkl, pol.ZdrojProFak;  
        end if;  
      end if;  
  end if;  
  
  if (NEW.typPolozkyK in ('typPolozky.odpocetZdd','typPolozky.odpocetZalohy')) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklFak where idDoklFak = NEW.idDoklFak;  
  
      -- vydana faktura  
      if (typPohyb = 'typPohybu.prijem') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklDalUcet, OLD.idZklDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklDalUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklDalUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklDalUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphDalUcet, OLD.idDphDalUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphDalUcet);  
              end loop;  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphDalUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphDalUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o vydanou fakturu  
  
      --------------------------------------------------------------------------  
      -- prijata faktura  
      if (typPohyb = 'typPohybu.vydej') then  
        -- meni se ucet zakladu  
        if (compareId(NEW.idZklMdUcet, OLD.idZklMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idProtiUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idZklMdUcet) = false)  
            loop  
                execute dNastavUcetDokladu(0, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
  
          -- polozka odpocitava zalohu  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZalohy') then  
            for idDokl in (select idDoklInt from dDoklInt where compareId(idProtiUcet, NEW.idZklMdUcet) = false and idDoklInt in  
                (select idTabB from dVazebTab where typVazbyK = 'typVazbyDokl.uhradaZALOHY' and idTabA in  
                  (select idTabB from dVazebTab where idTabA = NEW.idPolFak and typVazbyK = 'typVazbyDokl.odpocetZALOHY')))  
            loop  
                execute dNastavUcetDokladu(1, idDokl, 1, NEW.idZklMdUcet);  
            end loop;  
          end if;  
        end if;    -- konec zmena uctu zakladu  
  
        -- meni se ucet dane  
        if (compareId(NEW.idDphMdUcet, OLD.idDphMdUcet) = false) then  
          -- polozka odpocitava zdd  
          if (NEW.typPolozkyK = 'typPolozky.odpocetZdd') then  
            -- dph je zakladni  
            if (NEW.typSzbDphK = 'typSzbDph.dphZakl') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                compareId((select idDphZaklUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 2, NEW.idDphMdUcet);  
              end loop;  
  
            end if;   -- konec dph zakladni  
  
            -- dph je snizena  
            if (NEW.typSzbDphK = 'typSzbDph.dphSniz') then  
              for idDokl in (select idTabB from dVazebTab as V where typVazbyK = 'typVazbyDokl.odpocetZDD' and idTabA = NEW.idPolFak and   
                    compareId((select idDphSnizUcet from dDoklFak where idDoklFak = V.idTabB), NEW.idDphMdUcet) = false)  
              loop  
                  execute dNastavUcetDokladu(0, idDokl, 3, NEW.idDphMdUcet);  
              end loop;  
            end if;-- konec dph snizena  
          end if;  -- konec odpocet zdd  
        end if;    -- konec zmena uctu dane  
  
      end if;      -- konec jedna se o prijatou fakturu  
  
  end if;       -- konec podminky na typ dokladu  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolfakupdateucty() OWNER TO %firmaRole%;


CREATE OR REPLACE FUNCTION dpolintupdateucty() RETURNS trigger AS $$  
declare typPohyb character varying(50);  
        nelzeZmena int;  
        idDokl int;  
begin  
  if (NEW.modul = 'POK' and NEW.typPolozkyK = 'typPolozky.katalog' and compareid(NEW.idzklmducet, OLD.idzklmducet) = false) then  
      -- nacteni typu pohybu  
      select typPohybuK into typPohyb from dDoklInt where idDoklInt = NEW.idDoklInt;  
  
      -- vydej penez
      if (typPohyb = 'typPohybu.vydej') then  
        -- zjistime zda neexistujou nake co nesmime zmenit  
        select count(*) into nelzeZmena from dPolSklad where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and kopZklDalUcet = true and  
            idPolSklad in (select idTabB from dVazebTab where idTabA = NEW.idPolInt and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        -- pokud smime zmenit vsechny polozky co potrebujeme menime  
        if (nelzeZmena = 0) then  
          update dPolSklad set lastupdate = now(), idZklDalUcet = NEW.idZklMdUcet where compareId(idZklDalUcet, NEW.idZklMdUcet) = false and idPolSklad in  
            (select idTabB from dVazebTab where idTabA = NEW.idPolInt and modulA = NEW.modul and typVazbyK = 'typVazbyDokl.polozkaSkl');  
        else  
          raise exception '0008:dPolIntUpdateUcty(): Nelze zmenit ucet u navazane polozky.';  
        end if;  
      end if;  
  end if;  
  
  return NEW;  
end;  
$$ LANGUAGE plpgsql;
ALTER FUNCTION public.dpolintupdateucty() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 606, 't', %appVersion%, clock_timestamp());
