----------------------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
----------------------------------------------------------------------------------------------

DROP VIEW dpolskladfbezvc;

CREATE OR REPLACE VIEW dpolskladfbezvc AS 
 SELECT p.idpolsklad, 
   (case when p.typpohybuk = 'typPohybu.prijem' then p.mnozmj - jevydano(p.idpolsklad) else -p.mnozmj - jevydano(p.idpolsklad) end) AS pocet, 
   p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, false AS evidvyrcis,
   p.typPohybuK
 FROM dpolskladdoklad p
 WHERE ((p.typpohybuk::text = 'typPohybu.prijem' ::text and p.mnozMj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric ) 
      OR (p.typpohybuk::text = 'typPohybu.vydej' ::text and p.mnozMj < 0.0AND (-p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric )) 
      AND p.storno <> true;

ALTER TABLE dpolskladfbezvc OWNER TO %firmaRole%;



-- View: dpolskladf

DROP VIEW dpolskladf;

CREATE OR REPLACE VIEW dpolskladf AS 
         SELECT p.idpolsklad, 
           (case when p.typpohybuk = 'typPohybu.prijem' then p.mnozmj - jevydano(p.idpolsklad) else -p.mnozmj - jevydano(p.idpolsklad) end) AS pocet, 
           p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, NULL::integer AS idvyrobnicislo, c.evidvyrcis,
           p.typPohybuK
           FROM dpolskladdoklad p
      JOIN ccenik c ON c.idcenik = p.idcenik
     WHERE ((p.typpohybuk::text = 'typPohybu.prijem' ::text and p.mnozMj >= 0.0 AND (p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric ) 
      OR (p.typpohybuk::text = 'typPohybu.vydej' ::text and p.mnozMj < 0.0AND (-p.mnozmj - jevydano(p.idpolsklad)) > 0::numeric )) 
      AND c.evidvyrcis = false AND p.storno <> true
UNION ALL 
         SELECT p.idpolsklad, 1 AS pocet, p.cenamj, p.datvyst, p.datsklad, p.expirace, p.idzakazky, p.idskladu, p.idcenik, p.sarze, v.idvyrobnicislo, c.evidvyrcis,
           p.typPohybuK
           FROM svyrobnicislo v
      JOIN dpolskladdoklad p ON p.idpolsklad = v.idpolskladprijem
   JOIN ccenik c ON c.idcenik = p.idcenik
  WHERE p.typpohybuk::text = 'typPohybu.prijem'::text AND c.evidvyrcis = true AND NOT (v.idvyrobnicislo IN ( SELECT sfifovazby.idvyrobnicislo
         FROM sfifovazby
        WHERE sfifovazby.idpolskladprijem = p.idpolsklad)) AND p.storno <> true;

ALTER TABLE dpolskladf OWNER TO %firmaRole%;



CREATE OR REPLACE FUNCTION sfifovydej(idvydej integer, idcenikvydej integer, idskladvydej integer, idkartyvydej integer, vyd numeric, _cenyrucne boolean)
  RETURNS void AS
$BODY$       
declare        
  _zaznam Record;        
  _vybrano numeric(19,6);      
  _i integer;      
  _novevydcelkem numeric(19,6);      
  _pocet numeric(19,6);      
  _cenamjP numeric(19,6);   
  _sumZklP numeric(19,2);  
  _cenaMjPMen numeric(19,6);   
  _kurzDokladuP numeric(19,6);    
  _kurzDokladuV numeric(19,6);    
  _idDoklSkladP integer;     
  _idDoklSkladV integer;    
  _datVystV date;    
  _idrozlozeni integer;      
  _vydexpir boolean;      
  _vyrcis character varying(255);      
  _sklfifo boolean;   
  _sarze character varying(255);   
  _expirace date;        
  _evidVyrCis boolean;     
  _typPohybuK character varying(255);
  _sumZklVysl numeric(19,6);
begin
  -- pokud ma byt vydane mnozstvi 0.0 tak i cena byt tomu mela odpovidat -> 0.0  
  -- a tim samozrejme skoncime
  if(vyd = 0.0) then 
    update dpolsklad set
      lastUpdate = LOCALTIMESTAMP, 
      cenaMj = 0.0, 
      sumZkl = 0.0, 
      sumZklMen = 0.0 
      where idPolSklad = idvydej; 
    return; 
  end if; 

  -- pokud se sem dostane zaporna vydejka tak to je jako prijemka a nefifuje se
  select ds.typpohybuk, ps.datVyst, sarze,  expirace,  ps.iddoklsklad 
      into _typPohybuK, _datVystV,  _sarze, _expirace, _idDoklSkladV 
      from ddoklsklad ds join dpolsklad ps on ds.iddoklsklad = ps.iddoklsklad and ps.idpolsklad = idvydej;
  if(_typPohybuK = 'typPohybu.vydej' and vyd < 0.0) then
    return;
  end if;

  _vybrano := 0;
  _i := 1;
  _novevydcelkem := vyd;
  _sumZklVysl = 0.0;
  _sklfifo := (select isfifosklad(_datVystV));      
  _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVystV));   

  -- pro polozky na kterych se eviduji vyrobni cisla je samostatny trigger na vyrobnich cislech
  select evidVyrCis into _evidVyrCis from ccenik where idcenik = idcenikvydej;
  if (not _evidVyrCis) then
    select vydexpir into _vydexpir from skarty where idkarty=idkartyvydej limit 1;

    if (not _vydexpir) then
      --pořadí výdeje dle datvyst (dále se bude řesit upřednostněný výdej mimo FIFO)
      for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by datSklad,idpolsklad loop
        if(not _zaznam is null) then
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi
          if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano
            if(_vybrano<_novevydcelkem) then
              _pocet := _zaznam.pocet;
              if( _vybrano+_pocet) > _novevydcelkem then
                _pocet := _novevydcelkem-_vybrano;
              end if;
              _vybrano := _vybrano+_pocet;
              
              if (_sklfifo and not _cenyRucne) then
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);      
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);     
                if (_kurzDokladuP <> 0.0) then   
                  _cenamjP := _cenamjP * _kurzDokladuP;      
	        end if;    
                _cenamjP := _cenamjP / _kurzDokladuV;   
                _cenaMjPMen := 0.0;   
                if(_kurzDokladuV <> 1.0) then   
                  _cenaMjPMen := _cenaMjP;   
                end if;   
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV;

                if(_zaznam.pocet = _pocet) then
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end)
                     - coalesce(((select sum(round(kusu * _cenaMjP, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0)
                    into _sumZklP
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad;
                else  
                end if;                


                _sumZklVysl = _sumZklVysl + _sumZklP;
              end if;  
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo);
            else
              if (_vybrano>_novevydcelkem) then
                _pocet := -_zaznam.pocet;
                if(( _vybrano+_pocet) < _novevydcelkem) then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;  
              end if;
            end if;
          end if;
        end if;
      end loop;
    else      
      --pořadí výdeje dle expirace (dále se bude řesit upřednostněný výdej mimo FIFO)      
      for _zaznam in select * from dPolSkladF where idCenik=idCenikVydej and idSkladu=idSkladVydej order by expirace, idpolsklad loop        
        if(not _zaznam is null) then 
          -- pokud je nejaka sarze nebo expirace musime vyfiltrovat danou sarzi nebo expiraci pokud ne tak nas to netrapi
          if((_sarze is null or _sarze = _zaznam.sarze) and (_expirace is null or _expirace = _zaznam.expirace)) then
            -- pokud je doted rozfifovane mnozstvi mensi nez celkove ktere ma byt vydano
            if(_vybrano<_novevydcelkem) then
              _pocet := _zaznam.pocet;
              if( _vybrano+_pocet) > _novevydcelkem then
                _pocet := _novevydcelkem-_vybrano;
              end if;
              _vybrano := _vybrano+_pocet;
              
              if (_sklfifo and not _cenyRucne) then
                -- pokud se jedna o fifo sklad musime spravne fifalne urcit cenu
                select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where(idpolsklad = _zaznam.idPolSklad);      
                select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);     
                if (_kurzDokladuP <> 0.0) then   
                  _cenamjP := _cenamjP * _kurzDokladuP;      
	        end if;    
                _cenamjP := _cenamjP / _kurzDokladuV;   
                _cenaMjPMen := 0.0;   
                if(_kurzDokladuV <> 1.0) then   
                  _cenaMjPMen := _cenaMjP;   
                end if;   
                _sumZklP = _pocet*_cenamjP*_kurzDokladuV;

                if(_zaznam.pocet = _pocet) then
                  select (case when _zaznam.typPohybuK = 'typPohybu.vydej' then -pp.sumZkl else pp.sumZkl end)
                     - coalesce(((select sum(round(kusu * _cenaMjP, 2)) from sfifoVazby where idpolskladprijem = _zaznam.idpolsklad)), 0.0)
                    into _sumZklP
                  from dpolsklad pp where idpolsklad = _zaznam.idpolsklad;
                else  
                end if;                


                _sumZklVysl = _sumZklVysl + _sumZklP;
              end if;  
              insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, _pocet,_zaznam.idvyrobnicislo);
            else
              if (_vybrano>_novevydcelkem) then
                _pocet := -_zaznam.pocet;
                if(( _vybrano+_pocet) < _novevydcelkem) then
                  _pocet := _novevydcelkem-_vybrano;
                end if;
                _vybrano := _vybrano+_pocet;
                insert into sfifovazby( idpolskladprijem,idpolskladvydej,kusu,idvyrobnicislo) values( _zaznam.idpolsklad, idVydej, 0-_pocet,_zaznam.idvyrobnicislo) ;  
              end if;
            end if;
          end if; 
        end if;
      end loop;
    end if;
  end if;
  
  -- nakonec nastavime spravne ceny na vydejce
  if(_sklfifo and not _cenyRucne) then
    update dpolsklad set
      lastUpdate = LOCALTIMESTAMP, 
      sumZkl = _sumZklVysl,
      cenaMj = _sumZklVysl / vyd
      where idpolsklad = idvydej;
  end if;
end;        
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sfifovydej(integer, integer, integer, integer, numeric, boolean) OWNER TO %firmaRole%;




-- Function: svyrobnicisloupdate()

-- DROP FUNCTION svyrobnicisloupdate();

CREATE OR REPLACE FUNCTION svyrobnicisloupdate()
  RETURNS trigger AS
$BODY$    
declare 
  _mnozMj numeric(19,6); 
  _datVyst date; 
  _idDoklSkladV integer; 
  _idDoklSkladP integer; 
  _kurzDokladuP numeric(19,6); 
  _kurzDokladuV numeric(19,6); 
  _sumZklVysl numeric(19,6);
  _sumZklMenVysl numeric(19,6);
  _sklFifo boolean;
  _cenaMjP numeric(19,6);
  _cenaMjVysl numeric(19,6);
  _koeficient integer;
begin 
  if(NEW.idPolSkladVydej is not null and OLD.idPolSkladVydej is null) then
    select datVyst, mnozMj, idDoklSklad, sumZkl, sumZklMen into _datVyst, _mnozMj, _idDoklSkladV, _sumZklVysl, _sumZklMenVysl
      from dpolsklad where idpolsklad = NEW.idPolSkladVydej;
    _koeficient = 1;
    if(_mnozMj < 0.0) then
      _koeficient = -1;
    end if;
    _sklfifo := (select isfifosklad(_datVyst)); 
    if(_sklFifo and _mnozMj <> 0.0) then
      select cenamj, idDoklSklad  into _cenamjP, _idDoklSkladP from dpolsklad where idpolsklad = NEW.idPolSkladPrijem;
      
      select kurz into _kurzDokladuP from ddoklsklad where (iddoklsklad = _idDoklSkladP);    
      if (_kurzDokladuP <> 0.0) then    
	_cenamjP := _cenamjP * _kurzDokladuP;     
      end if;   
      _KurzDokladuV := (select getKurzFromDoklad(_idDoklSkladV, _datVyst));   

      _sumZklVysl = _sumZklVysl + (_koeficient * _cenaMjP);
      if(_kurzDokladuV <> 1.0) then 
        _cenamjP := _cenamjP / _kurzDokladuV;
        _sumZklMenVysl = _sumZklMenVysl + (_koeficient * _cenaMjP);
        _cenaMjVysl = _sumZklMenVysl / _mnozMj;
      else
        _sumZklMenVysl = 0.0;
        _cenaMjVysl = _sumZklVysl / _mnozMj;
      end if;

      update dpolsklad set
        lastUpdate = LOCALTIMESTAMP, 
        sumZkl = _sumZklVysl,
        sumZklMen = _sumZklMenVysl,
        cenaMj = _cenaMjVysl,
	cenaMjPoriz = _cenaMjVysl
        where idpolsklad = NEW.idPolSkladVydej;
    end if;

    insert into sfifovazby(idpolskladprijem,    idpolskladvydej,    kusu,idvyrobnicislo) 
                   values (NEW.idPolSkladPrijem,NEW.idPolSkladVydej,1,   NEW.idvyrobnicislo); 

  elsif (NEW.idPolSkladVydej is null and OLD.idPolSkladVydej is not null) then 
    -- pokud se idPolSkladVydej nastavi na null z nejake hodnoty musi se smazat i fifo vazba s timto vyrobnim cislem 
    delete from sfifovazby where idvyrobnicislo = NEW.idVyrobniCislo; 
  end if;

  execute sprepoctisumydokladu(_idDoklSkladV); 
  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION svyrobnicisloupdate() OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 616, 't', %appVersion%, clock_timestamp());

