-- Function: szmencenynapolsklad(integer, integer, integer)
-- DROP FUNCTION szmencenynapolsklad(integer, integer, integer);
CREATE OR REPLACE FUNCTION szmencenynapolsklad(i_polskladid integer, i_skladkartaid integer, i_doklskladid integer)
  RETURNS void AS
$BODY$    
declare    
  /* Deklarace promennych */    
  _MnozMJ numeric(19,2);   
  _CenaMJOld numeric(19,2);    
  _SumZkl numeric(19,2);    
  _SumZklMen numeric(19,2);    
  _PrumCenaTuz numeric(19,2);    
  _PrumCenaMen numeric(19,2);   
  _PrumCena numeric(19,2);    
  _TypPohybuK varchar(50);    
  _DatVyst date;   
  _CiziMena boolean;     
  zaznam record;   
  _KurzSkladKarty numeric(19,6);   
  _KurzDokladu numeric(19,6);
     
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */    
  declare ThisDoklSklad cursor for select TypPohybuK, DatVyst from dDoklSklad where idDoklSklad = i_DoklSkladId;   
  declare ThisPolSklad cursor for select MnozMJ, CenaMJ from dPolSklad  where idPolSklad = i_PolSkladId;   
  declare ThisSkladKarta cursor for select PrumCenaTuz,PrumCenaMen from sKarty where idKarty = i_SkladKartaId;   
  declare ThisPolSkladSum cursor for select SumZkl, SumZklMen from dPolSklad where idDoklSklad = i_DoklSkladId;      
begin   
  /* Ahoj */   
     
  /* Zjisteni typPohybuK */   
  open ThisDoklSklad;    
  fetch ThisDoklSklad into _TypPohybuK, _DatVyst;    
  close ThisDoklSklad;    
   
  /* Zjisteni mnozstvi jednotek */   
  open ThisPolSklad;    
  fetch ThisPolSklad into _MnozMJ, _CenaMJOld;    
  close ThisPolSklad;    
   
  /* Nacteni dat ze skladove karty */   
  open ThisSkladKarta;    
  fetch ThisSkladKarta into _PrumCenaTuz,_PrumCenaMen;    
  close ThisSkladKarta;   
     
  if _TypPohybuK = 'typPohybu.vydej' then  
    --_KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));   
    _KurzDokladu := (select getKurzFromDoklad(i_DoklSkladId, _DatVyst));   
    _PrumCena := _PrumCenaTuz / _KurzDokladu;
    --_CiziMena := (select isDoklSkladMenaCizi(i_DoklSkladId, _DatVyst));   
    --if _CiziMena then   
    --  _PrumCena := _PrumCenaMen;   
    --else   
    --  _PrumCena := _PrumCenaTuz;   
    --end if;   

    _SumZkl := _PrumCenaTuz * _MnozMJ;
    _SumZklMen := 0;
    if(_KurzDokladu <> 1.0) then
      _sumZklMen := _PrumCena * _MnozMJ;
    end if;
    update dPolSklad set    
      cenaMJ = _PrumCena,   
      sumZkl = _SumZkl,
      sumZklMen = _SumZklMen
      where    
      idPolSklad = i_PolSkladId;   
   
    /* Nacteni novych souctu na skladovem dokladu */   
    _SumZkl := 0;   
    _SumZklMen := 0;    
    for zaznam in select * from dPolSklad where idDoklSklad = i_DoklSkladId loop    
      _SumZkl := _SumZkl + zaznam.sumZkl;   
      _SumZklMen := _SumZklMen + zaznam.sumZklMen;   
    end loop;     
   
    update dDoklSklad set   
      sumCelkem = _SumZkl,   
      sumCelkemMen = _SumZklMen   
      where   
      idDoklSklad = i_DoklSkladId;   
   
  end if;   
end;   
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION szmencenynapolsklad(integer, integer, integer) OWNER TO %firmaRole%;

-- Function: sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer)
-- DROP FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer);
CREATE OR REPLACE FUNCTION sprepoctiskladkartu(i_mnozmj numeric, i_cenamj numeric, i_datvyst date, i_skladkartaid integer, i_doklskladid integer, i_skladid integer, i_nasobic integer)
  RETURNS void AS
$BODY$    
/* Prepocte stavy na skladove karte s id = iSkladKartaId */    
declare    
  /* Deklarace promennych */    
  _PomMnozMJ numeric(19,2);    
  _StavMJ numeric(19,2);    
  _StavTuz numeric(19,2);    
  _StavMen numeric(19,2);    
  _PrumCenaTuz numeric(19,2);    
  _PrumCenaMen numeric(19,2);    
  _PoslCenaTuz numeric(19,2);    
  _PoslCenaMen numeric(19,2);    
  _TypPohybuK varchar(50);    
  _DatPosl date;    
  _kurzSkladKarty numeric(19,6);   
  _kurzDokladu numeric(19,6);   
  loc_MnozMJ numeric(19,6);   
  _sklzapor boolean;  
  _sklfifo boolean;    
    
  /* Deklarace kurzoru pro nacteni potrebnych dat ze skladove karty a dokladu */    
  declare ThisDoklSklad cursor for select TypPohybuK from dDoklSklad where idDoklSklad = i_DoklSkladId;    
  declare ThisSkladKarta cursor for select StavMJ,StavTuz,StavMen,PrumCenaTuz,PrumCenaMen,DatPosl from sKarty where idKarty = i_SkladKartaId;      
begin    
  loc_MnozMJ:= i_MnozMJ;    
    
  /* Nacteni dat ze skladove karty */    
  open ThisSkladKarta;    
  fetch ThisSkladKarta into _StavMJ,    
    _StavTuz,_StavMen,_PrumCenaTuz,_PrumCenaMen,_DatPosl;    
  close ThisSkladKarta;    
      
  /* Zjisteni typPohybuK */    
  open ThisDoklSklad;    
  fetch ThisDoklSklad into _TypPohybuK;    
  close ThisDoklSklad;    
   
  /* zjisteni meny skladove karty */   
  _KurzSkladKarty := (select getKurzFromSklad(i_skladId, i_DatVyst));   
  _KurzDokladu := (select getKurzFromDoklad(i_doklSkladId, i_DatVyst));   
     
  /* pokud jde o vydej musim odecitat */    
  if _TypPohybuK = 'typPohybu.vydej' then    
    loc_MnozMJ:= 0-loc_MnozMJ;    
  end if;    
      
  /* Vypocet StavMJ */    
  _StavMJ:=_StavMJ+loc_MnozMJ*i_Nasobic;    
   
  if _StavMJ < 0 then   
    select sklzapor into _sklzapor from nNastav where i_DatVyst >= PlatiOdData order by PlatiOdData desc limit 1;   
	if (_sklzapor is null) then   
		select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1;    
	end if;   
    if _sklzapor is null or _sklzapor = false then   
        /*raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu';*/   
    end if;   
  end if;   
	   
      
  /* Vypocet StavTuz */    
  if loc_MnozMJ = 0 then    
    _PomMnozMJ:=1;    
  else    
    _PomMnozMJ:=loc_MnozMJ;    
  end if;    
  _StavTuz:=_StavTuz+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu); 
  /* Vypocet StavMen */    
  _StavMen:=_StavMen+(_PomMnozMJ*i_CenaMJ*i_Nasobic*_KurzDokladu)/_KurzSkladKarty;    
   
  /* Vypocet prumernych cen ma byt proveden jen pri prijmu*/   
  if _TypPohybuK = 'typPohybu.prijem' then 
    /* Vypocet PrumCenaTuz */    
    if _StavMJ > 0 then    
      _PrumCenaTuz:=_StavTuz/_StavMJ;    
    end if;    
    /* Vypocet PrumCenaMen */    
    if _StavMJ > 0 then    
      _PrumCenaMen:=_StavMen/_StavMJ;    
    end if;    
  end if;    
    
  /* Prepocteni stavu skladu pro FIFO */
  -- drobna uprava prumerne ceny pokud by doslo k chybe vlivem zaokrouhleni a pro fifo nutnost  
  --_sklfifo := (select isfifosklad(i_DatVyst));  
  --if (_sklfifo) then  
    if(_StavMJ <> 0.0) then 
      _PrumCenaTuz := _StavTuz / _StavMJ;  
      _PrumCenaMen := _StavMen / _StavMJ; 
    end if; 
  --end if;  
    
  /* Nastaveni posledni ceny */    
  _PoslCenaTuz:= i_CenaMJ * _KurzDokladu;   
  _PoslCenaMen:= i_CenaMJ;    
   
  /* Nastaveni data posledniho pohybu na karte */    
  if _DatPosl is null then    
    _DatPosl:= i_DatVyst;    
  end if;    
  if _DatPosl < i_DatVyst then    
    _DatPosl:=i_DatVyst;    
  end if;    
   
  /* Update v databazi */ 
  update sKarty set StavMJ = _StavMJ,    
    StavTuz = _StavTuz,    
    StavMen = _StavMen,    
    PrumCenaTuz = _PrumCenaTuz,    
    PrumCenaMen = _PrumCenaMen,    
    PoslCenaTuz = _PoslCenaTuz,    
    PoslCenaMen = _PoslcenaMen,    
    DatPosl = _DatPosl where    
    idKarty = i_SkladKartaId;    
end;    
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION sprepoctiskladkartu(numeric, numeric, date, integer, integer, integer, integer) OWNER TO %firmaRole%;

-- Function: dgetstavnasklade(integer, date, integer)
-- DROP FUNCTION dgetstavnasklade(integer, date, integer);
CREATE OR REPLACE FUNCTION dgetstavnasklade(i_skladkartaid integer, i_datum date, i_polskladid integer)
  RETURNS numeric AS
$BODY$  
declare  
  _pocMj numeric(19,6);  
  _obratMj numeric(19,6);  
  _stavMj numeric(19,6);  
begin  
  SELECT pocatMj INTO _pocMj  
  FROM sKarty  
  WHERE idKarty = i_skladkartaid;  
    
  if (i_datum is null) then  
    raise exception '0005:dGetStavNaSklade : Vstupni parametr datum je null.';   
  end if;  
  
  if (i_polSkladId < 0) then  
    SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj  
    FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad  
    WHERE idkarty = i_skladkartaid AND ps.datUcto <= i_datum;  
  else  
    SELECT sum(CASE ds.typPohybuK WHEN 'typPohybu.prijem' THEN ps.mnozMj ELSE -ps.mnozMj END) INTO _obratMj  
    FROM dPolSklad ps LEFT OUTER JOIN dDoklSklad ds ON ps.idDoklSklad = ds.idDoklSklad  
    WHERE idkarty = i_skladkartaid AND (ps.datUcto < i_datum OR (ps.datUcto = i_datum AND ps.idPolSklad < i_polskladid));  
  end if;  
  if(_obratMj is null) then _obratMj = 0.0; end if;  
  if(_pocMj is null) then _pocMj = 0.0; end if;   
  _stavMj = _pocMj + _obratMj;  
  
  RETURN _stavMj;  
end  
$BODY$
  LANGUAGE 'plpgsql' VOLATILE;
ALTER FUNCTION dgetstavnasklade(integer, date, integer) OWNER TO %firmaRole%;

-- Zvyseni verze aplikace
insert into dbversion(iddbversion, dbversion, needreimport) values (nextval('seq_dbversion'), 62, 't')