--------------------------------------------------------------------------------
-- Bug 28907 – [WinStrom] Přidat podporu pro webhook a pro sledování změn
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_hook
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_hook OWNER TO %firmaRole%;

create table hook (
    idhook integer DEFAULT nextval('seq_hook'::regclass) NOT NULL,

    url character varying(255) not null,
    data_format character varying(255) not null,
    last_version integer not null default 0,

    penalty integer not null default 0,
    last_penalty timestamp,

    CONSTRAINT idhook_pkey PRIMARY KEY (idhook)
);
alter table hook owner to %firmaRole%;

CREATE INDEX hook_penalty_index ON hook USING btree (penalty);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 641, 't', %appVersion%, clock_timestamp());
