--------------------------------------------------------------------------------------
-- Bug 28947 – [winstrom] - sklad - zrychlení skladu a zrušení rozpadů fifa
--------------------------------------------------------------------------------------

-- Function: sprepoctisumydokladu(integer, date)
-- DROP FUNCTION sprepoctisumydokladu(integer, date);
CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datvyst date)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2); 
 _sumZklMen numeric(15,2); 
 _sumZklDoklad numeric(15,2); 
 _sumZklMenDoklad numeric(15,2); 
 _datVyst date; 
 _datUcto date; 
 _stavSkladK character varying; 
 _stavSkladKNew character varying; 
 _typPohybuK character varying; 
 _sumMnozMj numeric(19,6); 
 _sumMnozMjPlan numeric(19,6); 
begin 
 select sum(sumZkl), sum(sumZklMen), sum(mnozMj), sum(mnozMjPlan) into _sumZkl, _sumZklMen, _sumMnozMj, _sumMnozMjPlan from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false; 
 
 select sumCelkem, sumCelkemMen, datVyst, datUcto, stavSkladK, typPohybuK  
   into _sumZklDoklad, _sumZklMenDoklad, _datVyst, _datUcto, _stavSkladK, _typPohybuK 
   from dDoklSklad where idDoklSklad = i_idDoklSklad; 
 
 if(_sumZkl is null) then _sumZkl = 0.0; end if; 
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if; 
 
 _stavSkladKNew = _stavSkladK; 
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj != _sumMnozMjPlan) then  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFakt')) then  
     _stavSkladKNew = 'stavSklad.vygenFaktNeuplny';  
   end if;  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPokl')) then  
     _stavSkladKNew = 'stavSklad.vygenPoklNeuplny';  
   end if;  
 end if;  
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj = _sumMnozMjPlan) then  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then  
     _stavSkladKNew = 'stavSklad.vygenFakt';  
   end if;  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then  
     _stavSkladKNew = 'stavSklad.vygenPokl';  
   end if;  
 end if; 

 if(_sumZkl <> _sumZklDoklad  
    or _sumZklMen <> _sumZklMenDoklad 
    or not compareDate(i_datVyst, _datVyst) 
    or not compareDate(i_datVyst, _datUcto)  
    or not compareVarchar(_stavSkladK, _stavSkladKNew) 
    ) then  
   /*
    * pozor !!!
    * radka lastUpdate = LOCALTIMESTAMP,
    * se nesmi nikdy odkomentovat, protoze se pak rozbije ukladani obycejne polozky dokladu
    * pri insertu polozky se hlavicce nastavi jiny lastUpdate a diky tomu pak neprojde update
    * hlavicky dokladu s tim, ze doklad jiz zmenil jiny uzivatel
    */ 
   update dDoklSklad set  
       --lastUpdate = LOCALTIMESTAMP,  
       sumCelkem = _sumZkl,  
       sumCelkemMen = _sumZklMen,  
       sumOsv = _sumZkl,  
       sumOsvMen = _sumZklMen,  
       datVyst = i_datVyst,  
       datUcto = i_datVyst, 
       stavSkladK = _stavSkladKNew 
     where idDoklSklad = i_idDoklSklad;  
 end if; 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date)
  OWNER TO %firmaRole%;




-- Function: dpolskladinsert()
-- DROP FUNCTION dpolskladinsert();
CREATE OR REPLACE FUNCTION dpolskladinsert()
  RETURNS trigger AS
$BODY$ 
declare 
  _rozsirenaPolozka record; 
  _typPohybuk character varying; 
  _mazatTmpTable boolean; 
  _idPolSklad integer; 
  _probihaPrepocetSkladu character varying; 
  _polSklad record;  
  _pocetMenenychVydejek integer; 
begin 
  if(NEW.storno = true) then 
    return NEW; 
  end if;  
   
  select getglotxvariable('probihaPrepocetSkladu') into _probihaPrepocetSkladu; 
  if(_probihaPrepocetSkladu = 'true') then 
  else 
    -- tento select zjisti kolik je vydejek, ktere by se meli prepocitavat 
    select count(idpolsklad) into _pocetMenenychVydejek from dpolsklad ps join ddoklsklad ds  
      on ps.datsklad >= NEW.datSklad and ps.cenyRucne = false and ps.iddoklsklad = ds.iddoklsklad and ds.typpohybuk = 'typPohybu.vydej'; 
    if(_pocetMenenychVydejek = 0 and NEW.cenyRucne = true) then 
      execute sprepoctiskladkartu(NEW.mnozMj, NEW.cenaMj, NEW.sumZkl, NEW.datVyst, NEW.idKarty, NEW.idDoklSklad, NEW.idBspSkl, 1);  
      return NEW; 
    end if; 
 
    -- v pripade ze neprobiha prepocet skladu 
    -- generuji rozsirene polozky 
    select skladGenerujRozsirenePolozky(NEW.datSklad, NEW.idPolSklad, NEW.idKarty) into _mazatTmpTable; 
 
    execute putglotxvariable('zurnalTxName', 'prepocetSkladu'); 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.idPolSklad <> NEW.idPolSklad) then 
        if(_rozsirenaPolozka.cenyRucne = true) then 
          -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
          if(_rozsirenaPolozka.storno = false) then  
            select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
            execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, -1);  
          end if; 
        else 
          execute skladOdpoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
        end if; 
      end if; 
    end loop; 
 
    for _rozsirenaPolozka in (select * from tmp_RozsirenePolozky order by datum, skupina, iddoklskladMaster, typpohybuk desc, idpolsklad) loop 
      if(_rozsirenaPolozka.cenyRucne = true) then 
        -- pokud maji byt ceny zadany rucne a nemaji se nikterak menit tak jen zmenime skladovou kartu a jedeme dal 
        if(_rozsirenaPolozka.storno = false) then  
          select * into _polSklad from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad; 
          execute sprepoctiskladkartu(_polSklad.mnozMj, _polSklad.cenaMj, _polSklad.sumZkl, _polSklad.datVyst, _polSklad.idKarty, _polSklad.idDoklSklad, _polSklad.idBspSkl, 1);  
        end if; 
      else 
        execute skladZapoctiRozsirenouPolozku(_rozsirenaPolozka.idPolSklad); 
      end if; 
    end loop; 
 
    if(_mazatTmpTable) then 
      drop table tmp_RozsirenePolozky; 
      drop table tmp_SkladoveKarty; 
      execute removeglotxvariable('zurnalTxName'); 
    end if; 
  end if; 
 
  select typpohybuk into _typPohybuk from ddoklsklad where iddoklsklad = NEW.iddoklsklad; 
  --pokud výdej, tak fifuju vazby 
  if (_typPohybuk = 'typPohybu.vydej' or (_typPohybuK = 'typPohybu.prijem' and NEW.mnozMj < 0.0)) then 
    execute sFifoVydej(NEW.idPolSklad, NEW.idCenik, NEW.idBspSkl, NEW.idKarty, NEW.mnozmj, NEW.cenyRucne); 
    --execute sPrepoctiSumyDokladu(NEW.idDoklSklad); 
  end if; 
 
  if(_probihaPrepocetSkladu = 'true') then 
    if(NEW.idPolSklad < 0) then 
      _idPolSklad = -NEW.idPolSklad; 
    else 
      _idPolSklad = NEW.idPolSklad; 
    end if; 
 
    execute skladinsertrozsirenoupolozku(_idPolSklad); 
  end if; 
 
  execute sprepoctisumydokladu(NEW.idDoklSklad);

  return NEW; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsert()
  OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 650, 't', %appVersion%, clock_timestamp());
