--------------------------------------------------------------------------------
-- Bug 31689 – [WinStrom] Inventura skladu
--------------------------------------------------------------------------------

-- INVENTURA
create sequence seq_sinventura
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_sinventura owner to %firmaRole%;

create table sinventura (
    idinventura integer DEFAULT nextval('seq_sinventura'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    popisInventury text,
    typInventury character varying(255),
    datZahaj date not null,
    datKonec date,
    vedouci character varying(255),
    osoby text,
    poznam text,
    popis text,
    stavK character varying(50), 

    CONSTRAINT sInventura_pkey PRIMARY KEY (idInventura)
);
alter table sInventura owner to %firmaRole%;

-- POLOZKA INVENTURY
create sequence seq_spolinventura
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
alter table public.seq_spolinventura owner to %firmaRole%;

create table spolinventura (
    idpolinventura integer DEFAULT nextval('seq_spolinventura'::regclass) not null,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    idKarty integer,
    idInventury integer,
    mnozMjReal numeric(19,6),
    mnozMjKarta numeric(19,6),
    mnozMjReal2 numeric(19,6),
    mnozMjReal3 numeric(19,6),
    idMj integer,
    idMj2 integer,
    idMj3 integer,

    CONSTRAINT spolinventura_pkey PRIMARY KEY (idpolinventura),
    CONSTRAINT sPolInventura_idInventura FOREIGN KEY (idInventury)
        REFERENCES sInventura (idInventura)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT sPolInventura_idKarty FOREIGN KEY (idkarty)
        REFERENCES skarty (idkarty)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT sPolInventura_idMj FOREIGN KEY (idMj)
        REFERENCES cmerjed (idmj)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT sPolInventura_idMj2 FOREIGN KEY (idMj2)
        REFERENCES cmerjed (idmj)
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT sPolInventura_idMj3 FOREIGN KEY (idMj3)
        REFERENCES cmerjed (idmj)
        ON UPDATE NO ACTION ON DELETE NO ACTION

);
alter table spolinventura owner to %firmaRole%;

CREATE INDEX sPolInventura_IdKarty_index ON sPolInventura USING btree (IdKarty);
CREATE INDEX sPolInventura_IdInventury_index ON sPolInventura USING btree (IdInventury);
CREATE INDEX sPolInventura_IdMj_index ON sPolInventura USING btree (IdMj);
CREATE INDEX sPolInventura_IdMj2_index ON sPolInventura USING btree (IdMj2);
CREATE INDEX sPolInventura_IdMj3_index ON sPolInventura USING btree (IdMj3);


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 670, 't', %appVersion%, clock_timestamp());
