--------------------------------------------------------------------------------
-- Bug 33003 – [FlexiBee] Není možné importem zaktualizovat reporty
--------------------------------------------------------------------------------

-- při nahrazení BLOBu v datech přílohy chceme také vymazat původní BLOB (jako při DELETE)
CREATE OR REPLACE FUNCTION update_priloha_data_LO() RETURNS trigger AS $BODY$
BEGIN
  IF (OLD.blobdata NOTNULL AND OLD.blobdata IS DISTINCT FROM NEW.blobdata) THEN
    PERFORM lo_unlink(OLD.blobdata);
  END IF;
  RETURN OLD;
END;
$BODY$
  LANGUAGE plpgsql
  SECURITY DEFINER;

ALTER FUNCTION update_priloha_data_LO() OWNER TO %admin%;

CREATE TRIGGER update_priloha_data AFTER UPDATE ON wprilohadata
  FOR EACH ROW EXECUTE PROCEDURE update_priloha_data_LO();
  
-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 706, 't', %appVersion%, clock_timestamp());
