--------------------------------------------------------------------------------
-- Bug 34166 – [FlexiBee] Rozšířit datový model kvůli workflow
--------------------------------------------------------------------------------

ALTER TABLE askupfir
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE cskupzboz
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE dtypdokl
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE dtypsml
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE utypzakazky
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;


ALTER TABLE mtypmaj
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE mtypleas
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;


ALTER TABLE pskuposob
  ADD COLUMN workflow boolean NOT NULL DEFAULT false;

ALTER TABLE posoba
  ADD COLUMN idnadzizeny integer,
  ADD CONSTRAINT posoba_idnadzizeny FOREIGN KEY (idnadzizeny)
      REFERENCES posobahlav (idosobahlav) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX pOsoba_IdNadzizeny_index ON pOsoba USING btree (IdNadzizeny);



CREATE SEQUENCE seq_wactdefinice
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wactdefinice OWNER TO %firmaRole%;


CREATE TABLE wactdefinice (
    idactdefinice integer DEFAULT nextval('seq_wactdefinice'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    uuid character varying(50),
    beankeys text,
    autorun boolean NOT NULL DEFAULT false,
    iduzivatel integer,

    CONSTRAINT wactdefinice_pkey PRIMARY KEY (idactdefinice),
    CONSTRAINT wactdefinice_iduzivatel FOREIGN KEY (iduzivatel)
        REFERENCES wuzivatel(iduzivatel) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wactdefinice OWNER TO %firmaRole%;

CREATE INDEX wactdefinice_iduzivatel_index ON wactdefinice USING btree (iduzivatel);


CREATE SEQUENCE seq_wactskupina
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wactskupina OWNER TO %firmaRole%;


CREATE TABLE wactskupina (
    idactskupina integer DEFAULT nextval('seq_wactskupina'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    typrolek character varying(50),
    uuid character varying(50),

    CONSTRAINT wactskupina_pkey PRIMARY KEY (idactskupina)
);
ALTER TABLE public.wactskupina OWNER TO %firmaRole%;


CREATE SEQUENCE seq_wactclenstvi
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wactclenstvi OWNER TO %firmaRole%;


CREATE TABLE wactclenstvi (
    idactclenstvi integer DEFAULT nextval('seq_wactclenstvi'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    typrolek character varying(50),
    idactskupina integer,
    iduzivatel integer,
    idzakazky integer,
    idfirmy integer,
    idstred integer,

    CONSTRAINT wactclenstvi_pkey PRIMARY KEY (idactclenstvi),
    CONSTRAINT wactclenstvi_idactskupina FOREIGN KEY (idactskupina)
      REFERENCES wactskupina (idactskupina) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wactclenstvi_iduzivatel FOREIGN KEY (iduzivatel)
        REFERENCES wuzivatel(iduzivatel) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wactclenstvi_idzakazky FOREIGN KEY (idzakazky)
        REFERENCES uzakazky(idzakazky) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wactclenstvi_idfirmy FOREIGN KEY (idfirmy)
        REFERENCES aadresar(idfirmy) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION,
    CONSTRAINT wactclenstvi_idstred FOREIGN KEY (idstred)
        REFERENCES ustrediska(idstred) MATCH SIMPLE
        ON UPDATE NO ACTION ON DELETE NO ACTION
);
ALTER TABLE public.wactclenstvi OWNER TO %firmaRole%;

CREATE INDEX wactclenstvi_idskupina_index ON wactclenstvi USING btree (idactskupina);
CREATE INDEX wactclenstvi_iduzivatel_index ON wactclenstvi USING btree (iduzivatel);
CREATE INDEX wactclenstvi_idzakazky_index ON wactclenstvi USING btree (idzakazky);
CREATE INDEX wactclenstvi_idfirmy_index ON wactclenstvi USING btree (idfirmy);
CREATE INDEX wactclenstvi_idstred_index ON wactclenstvi USING btree (idstred);



ALTER TABLE audalosti
  ADD COLUMN iddoklfak integer,
  ADD COLUMN iddoklint integer,
  ADD COLUMN iddoklobch integer,
  ADD COLUMN iddoklsklad integer,
  ADD COLUMN idcenik integer,
  ADD COLUMN idkontakt integer,
  ADD COLUMN idkonektor integer,
  ADD COLUMN idreport integer,
  ADD COLUMN idsmlouvy integer,
  ADD COLUMN idpolsml integer,

  ADD CONSTRAINT audalosti_iddoklfak FOREIGN KEY (iddoklfak) 
      REFERENCES ddoklfak(iddoklfak) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_iddoklint FOREIGN KEY (iddoklint)
      REFERENCES ddoklint(iddoklint) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_iddoklobch FOREIGN KEY (iddoklobch)
      REFERENCES ddoklobch(iddoklobch) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_iddoklsklad FOREIGN KEY (iddoklsklad)
      REFERENCES ddoklsklad(iddoklsklad) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idcenik FOREIGN KEY (idcenik)
      REFERENCES ccenik(idcenik) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idkontakt FOREIGN KEY (idkontakt)
      REFERENCES akontakty(idkontakt) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idkonektor FOREIGN KEY (idkonektor)
      REFERENCES wkonektor(idkonektor) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idreport FOREIGN KEY (idreport)
      REFERENCES wreport(idreport) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idsmlouvy FOREIGN KEY (idsmlouvy)
      REFERENCES dsmlouvy (idsmlouvy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT audalosti_idpolsml FOREIGN KEY (idpolsml)
      REFERENCES dpolsml (idpolsml) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX audalosti_iddoklfak_index ON audalosti USING btree (iddoklfak);
CREATE INDEX audalosti_iddoklint_index ON audalosti USING btree (iddoklint);
CREATE INDEX audalosti_iddoklobch_index ON audalosti USING btree (iddoklobch);
CREATE INDEX audalosti_iddoklsklad_index ON audalosti USING btree (iddoklsklad);
CREATE INDEX audalosti_idcenik_index ON audalosti USING btree (idcenik);
CREATE INDEX audalosti_idkontakt_index ON audalosti USING btree (idkontakt);
CREATE INDEX audalosti_idkonektor_index ON audalosti USING btree (idkonektor);
CREATE INDEX audalosti_idreport_index ON audalosti USING btree (idreport);
CREATE INDEX audalosti_idsmlouvy_index ON audalosti USING btree (idsmlouvy);
CREATE INDEX audalosti_idpolsml_index ON audalosti USING btree (idpolsml);

insert into atypakt (druhudalk, kod, nazev)
     values ('druhUdal.workflow', 'ÚKOL WORKFLOW', 'Úkol workflow');

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 733, 't', %appVersion%, clock_timestamp());
