--------------------------------------------------------------------------------
-- Bug 34802 – [FlexiBee] Přidat podporu pro skupiny štítků
--------------------------------------------------------------------------------

CREATE SEQUENCE seq_wskupvybklic
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
ALTER TABLE public.seq_wskupvybklic OWNER TO %firmaRole%;

CREATE TABLE wskupvybklic (
    idskupvybklic integer DEFAULT nextval('seq_wskupvybklic'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    kod character varying(20) NOT NULL,
    nazev character varying(255) NOT NULL,
    nazeva character varying(255),
    nazevb character varying(255),
    nazevc character varying(255),
    popis text,
    poznam text,
    show boolean DEFAULT true NOT NULL,
    platido integer DEFAULT 9999 NOT NULL,
    platiod integer DEFAULT 0 NOT NULL,
    pouzeJeden boolean DEFAULT false,
    CONSTRAINT wskupvybklic_pkey PRIMARY KEY (idskupvybklic)
);
ALTER TABLE public.wskupvybklic OWNER TO %firmaRole%;

-- pridani ext id
ALTER TABLE wextid ADD COLUMN idskupvybklic integer;
ALTER TABLE wextid ADD CONSTRAINT wextid_idskupvybklic FOREIGN KEY (idskupvybklic)
  REFERENCES wskupvybklic (idskupvybklic) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE CASCADE;
CREATE INDEX wExtId_IdSkupVybKlic_index ON wExtId USING btree (IdSkupVybKlic);

-- pridani na vyberovy klic/stitek
ALTER TABLE wvybklice ADD COLUMN idskupvybklic integer;
ALTER TABLE wvybklice ADD CONSTRAINT wvybklice_idskupvybklic FOREIGN KEY (idskupvybklic)
  REFERENCES wskupvybklic (idskupvybklic) MATCH SIMPLE ON UPDATE NO ACTION ON DELETE CASCADE;
CREATE INDEX wVybKlice_IdSkupVybKlic_index ON wVybKlice USING btree (IdSkupVybKlic);

-- zvyseni verze databaze
INSERT INTO dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  VALUES (nextval('seq_dbversion'), 744, 't', %appVersion%, clock_timestamp());
