--------------------------------------------------------------------------------
-- Bug 35628 – [WinStrom] Upravit smlouvy
--------------------------------------------------------------------------------

ALTER TABLE dsmlouvy
  ADD COLUMN ignorovattypsml boolean NOT NULL DEFAULT false,
  ADD COLUMN autoprodl boolean NOT NULL DEFAULT false,
  ADD COLUMN autozakazka boolean NOT NULL DEFAULT false,
  ADD COLUMN autogen boolean NOT NULL DEFAULT false,
  ADD COLUMN preplatky boolean NOT NULL DEFAULT false,
  ADD COLUMN automail boolean NOT NULL DEFAULT false,
  ADD COLUMN varsymfakt boolean NOT NULL DEFAULT false,
  ADD COLUMN datvystzduzp boolean NOT NULL DEFAULT false,
  ADD COLUMN generovatnulovefaktury boolean NOT NULL DEFAULT true,
  ADD COLUMN zpusfaktk character varying(50),
  ADD COLUMN dnyfakt integer,
  ADD COLUMN valorizovat boolean NOT NULL DEFAULT false,
  ADD COLUMN valorizovatmesic integer;

ALTER TABLE dpolsml
  ADD COLUMN zpusfaktk character varying(50),
  ADD COLUMN dnyfakt integer,
  ADD COLUMN den integer,
  ADD COLUMN mesic integer,
  ADD COLUMN varsym character varying(30),
  ADD COLUMN vypovednilhuta integer,
  ADD COLUMN autogen boolean NOT NULL DEFAULT true,
  ADD COLUMN idtypdokl integer,
  ADD COLUMN idfirmyfakt integer,
  ADD CONSTRAINT dpolsml_idfirmyfakt FOREIGN KEY (idfirmyfakt)
      REFERENCES aadresar (idfirmy) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  ADD CONSTRAINT dpolsml_idtypdokl FOREIGN KEY (idtypdokl)
      REFERENCES dtypdokl (idtypdokl) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

CREATE INDEX dPolSml_IdFirmyFakt_index ON dPolSml USING btree (IdFirmyFakt);
CREATE INDEX dPolSml_IdTypDokl_index ON dPolSml USING btree (IdTypDokl);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 773, 't', %appVersion%, clock_timestamp());
