----------------------------------------------------------------------------------
-- Bug 38211 – [WinStrom] Změna data vystavení faktury rozbije sklad a účetnictvi
----------------------------------------------------------------------------------

-- Function: createpolsklad(integer, character varying)

-- DROP FUNCTION createpolsklad(integer, character varying);

CREATE OR REPLACE FUNCTION createpolsklad(_idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _polDokl record; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _idPolSklad integer; 
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _typPohybuK character varying; 
  _prumCenaTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _kurz numeric(19,6); 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _sklad record; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _isCiziMena boolean; 
  _idMeny integer;   
  _skupZboz record; 
  _idTypUcOp integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
  _typPohybuSkladKVydej character varying;
  _datUcto date; 
begin 
  _kopZklMdUcet =false; 
  _kopZklDalUcet = false; 
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  else 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _idDoklad = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  end if; 

  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _polDokl.idbspskl) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 
 
  if(_polDokl.idPolDobropis is not null and _polDokl.idPolDobropis > 0) then 
    return null; 
  end if; 
 
  select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
  select typPohybuK, idstred, idcinnost, idZakazky 
    into _typPohybuK, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad 
    from dDoklSklad where idDoklSklad = _idDoklSklad;  
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
  select idMeny, idTypUcOp into _idMeny, _idTypUcOp from dDoklSklad where idDoklSklad = _idDoklSklad; 
       
  if(_typPohybuK like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _prumCenaTuz / _kurz; 
    _sumZkl = _prumCenaTuz * _mnozMj; 
    if(_isCiziMena) then 
      _sumZklMen = _mnozMj * _cenaMj; 
    else 
      _sumZklMen = 0.0; 
    end if; 
    -- nastaveni uctu pro polSklad vydej 
    select typPohybuSkladK into _typPohybuSkladKVydej from ddoklsklad where iddoklsklad = _idDoklSklad; 
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
    if(_skupzboz.idskupzboz is not null) then 
      -- Úpravy dle Bug 32848 – [WinStrom] - nerespektování upřesnění typu pohybu při tvorbě výdejky 
      if(_typPohybuSkladKVydej is null) then 
        _idZklMdUcet = _skupZboz.idprotiucetsklv; 
      -- typPohybuSklad.vydejHoly -  Holý" výdej  - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejHoly') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
      -- typPohybuSklad.vydejPoFak - Výdej po faktuře  - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoFak') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklv; 
      -- typPohybuSklad.vydejPolot - Výdej polotovaru - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPolot') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
      -- typPohybuSklad.vydejPoObch - Výdej po objednávce  -  idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoObch') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklv; 
      -- typPohybuSklad.vydejPrevod -  Výdej pro převodku  - idprotiucetsklprevv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPrevod') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklprevv; 
      -- typPohybuSklad.vydejProFakCenik - Výdej pro fakturaci (ceny z ceníku) - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakCenik') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklv; 
      -- typPohybuSklad.vydejProFakRucne - Výdej pro fakturaci (ceny ručně) - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakRucne') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklv;  
      --typPohybuSklad.vydejVyrob - Výdej výrobku  - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejVyrob') then 
        _idZklMdUcet = _skupZboz.idprotiucetsklholyv;  
      end if; 
    end if;  
     
    if(_idZklMdUcet is null) then  
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklMdUcet = true; 
    end if; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      --_cenaMjTuz = _prumCenaTuz; 
      _cenaMjTuz = _polDokl.cenaMjNakup; 
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMj = _cenaMjTuz / _kurz; 
      _sumZkl = _mnozMj * _cenaMjTuz; 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
      select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik); 
      if(_skupZboz.idProtiUcetSklV is not null) then 
        -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
        _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
      else 
        -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
        select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
        _kopZklDalUcet = true; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMj = _sumZkl / _mnozMj; 
      else 
        _cenaMj = _sumZkl; 
      end if; 
      _cenaMj = _cenaMj / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = _cenaMj * _mnozMj;   
        else 
          _sumZklMen = _cenaMj; 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
      _idZklDalUcet = _polDokl.idZklMdUcet; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
  end if;  
 
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if; 

  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,  
        idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp) 
      values (_idPolSklad, LOCALTIMESTAMP, _polDokl.idcenik, _polDokl.idbspskl, _idkarty, _polDokl.datVyst, LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto,'SKL', 'typPolozky.katalog', _idDoklSklad, 
        _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _polDokl.idmj, 
        _polDokl.nazev, _polDokl.nazevA, _polDokl.nazevB, _polDokl.nazevC, _polDokl.sarze, _polDokl.expirace, _polDokl.datTrvan, _polDokl.datVyroby, _polDokl.cisRad, true,  
        _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp); 
  
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSkl'); 
 
  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolsklad(integer, character varying)
  OWNER TO %firmaRole%;



-- Function: createdoklsklad(integer, integer, character varying)

-- DROP FUNCTION createdoklsklad(integer, integer, character varying);

CREATE OR REPLACE FUNCTION createdoklsklad(_idpoldokl integer, _iddoklad integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _doklad record; 
  _polDokl record; 
  _doklSklad record; 
  _idDoklSklad integer; 
  _cisDoklad character varying; 
  _idrada integer; 
  _rada record; 
  _sklad record; 
  _idUcetObd integer; 
  _radaRok record; 
  _typPohybuSklad character varying; 
  _idTypUcOp integer; 
  _cisloDokladuCursor refCursor; 
  _typDoklFak record; 
  _typDoklSkl record; 
  _idUcetSklad integer; 
  _idProtiUcet integer; 
  _typUcOp record; 
  _kurz numeric(19,6); 
  _idMenyTuzemsko integer; 
  _idMenySklad integer; 
  _kurzMnozstvi numeric(19,6); 
  _typVazby character varying; 
  _stavSklad character varying; 
  _typPohybuSkladK character varying; 
  _isDobropis boolean; 
  _ucetObdPlatiOd date; 
  _ucetObdPlatiDo date;
  _datUcto date;
begin 
  if(_modul like 'POK') then 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenPokl'; 
  elsif (_modul like 'FAV' or _modul like 'FAP') then 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    _stavSklad = 'stavSklad.vygenFakt'; 
  else 
    select * into _doklad from dDoklSklad where idDoklSklad = _idDoklad; 
    select * into _polDokl from dPolSklad where idPolSklad = _idPolDokl; 
    _stavSklad = 'stavSklad.vyroba'; 
  end if; 
 
  if(_doklad.datVyst >= '2014-01-01') then
    _datUcto = _doklad.datUcto;
    if(_datUcto is null) then
      _datUcto = _doklad.datVyst;
    end if;
  else
    _datUcto = _doklad.datVyst;
  end if;

  --select * into _sklad from dTypDokl where idTypDokl = _polDokl.idskladu; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
  select * into _typDoklFak from dTypDokl where idTypDokl = _doklad.idTypDokl; 
 
  if(_typDoklFak.typDoklK like 'typDokladu.dobropis') then 
    _isDobropis = true; 
  else 
    _isDobropis = false; 
  end if; 
  
  if(_doklad.idTypDoklSkl is null) then  
    if((_modul like 'FAV' and _isDobropis) or (_modul like 'FAP')) then 
      --pro dobropisy vydanych faktur a prijate faktury budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif((_modul like 'FAV' and not _isDobropis)) then 
      --pro dobropisy prijatych faktur a vydane faktury budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.prijem') then 
      --pro prijmovy pokladni doklad budeme mit vydejku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    elsif(_modul like 'POK' and _doklad.typPohybuK like 'typPohybu.vydej') then 
      --pro vydajovy pokladni doklad budeme mit prijemku 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuprijem; 
    elsif(_modul like 'SKL') then 
      -- vyroba 
      select * into _typDoklSkl from dTypDokl where idTypDokl = _typDoklFak.idtypprotidokladuvydej; 
    else 
      raise exception 'createdoklsklad:Nespravny modul %', _modul; 
    end if; 
    if(_typDoklSkl is null) then 
      return null; 
    end if; 
  else 
    select * into _typDoklSkl from dTypDokl where idTypDokl = _doklad.idTypDoklSkl; 
  end if; 
 
  -- urceni spravneho typu pohybu 
  if((_typDoklFak.modul like 'FAV') and (_typDoklFak.typDoklK like 'typDokladu.dobropis')) then 
    _typPohybuSklad = _doklad.typPohybuK; 
  else 
    if(_doklad.typPohybuK like 'typPohybu.prijem') then 
      _typPohybuSklad = 'typPohybu.vydej'; 
    else 
      _typPohybuSklad = 'typPohybu.prijem'; 
    end if; 
  end if;  
  
  -- urceni spravneho typy pohybu sklad 
  _typPohybuSkladK = _typDoklSkl.typPohybuSkladK; 
  if(_typPohybuSklad like 'typPohybu.prijem' and _typPohybuSkladK like 'typPohybuSklad.vydej%') then 
     _typPohybuSkladK = null; 
  end if; 
  if(_typPohybuSklad like 'typPohybu.vydej' and _typPohybuSkladK like 'typPohybuSklad.prijem%') then 
     _typPohybuSkladK = null; 
  end if; 
 
  -- doplneni zbyvajicich veci zavislich na typu pohybu 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idrada = _typDoklSkl.idRadyPrijem; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyPrijem; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpP; 
    if(_typPohybuSkladK is null) then 
      if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
        _typPohybuSkladK = 'typPohybuSklad.prijemPoFak'; 
      else 
        _typPohybuSkladK = 'typPohybuSklad.prijemVyrob'; 
      end if; 
    end if; 
  else 
    _idrada = _typDoklSkl.idRadyVydej; 
    if(_idrada is null) then 
      _idRada = _sklad.idRadyVydej; 
    end if; 
    if(_idRada is null) then 
      raise exception 'Neni odkud natahnout dokladovou radu.'; 
    end if; 
    _idTypUcOp = _typDoklSkl.idTypUcOpV; 
    if(_typPohybuSkladK is null) then 
      if(_modul = 'FAV' or _modul = 'FAP' or _modul = 'POK') then 
        _typPohybuSkladK = 'typPohybuSklad.vydejPoFak'; 
      else 
        _typPohybuSkladK = 'typPohybuSklad.vydejVyrob'; 
      end if; 
    end if; 
  end if; 
 
  _idUcetSklad = _sklad.idPrimUcet; 
  select * into _typUcOp from utypucop where idtypucop = _idTypUcOp; 
  if(_typPohybuSklad like 'typPohybu.prijem') then 
    _idProtiUcet = _typUcOp.idProtiucetP; 
  else 
    _idProtiUcet = _typUcOp.idProtiucetV; 
  end if; 
  if(_modul = 'FAP') then 
    _idProtiUcet = _doklad.idProtiUcet; 
  end if; 
 
  select * into _rada from drady where idRady = _idrada; 
  select findIdUcetniObdobiKDatu(_datUcto) into _idUcetObd; 
  select * into _radaRok from dRadyRok where iducetobdobi = _idUcetObd and idrady = _idrada; 
 
  select nextval('seq_ddoklsklad') into _idDoklSklad; 
  select dgetcisdokl(null, _idrada, _idUcetObd, 'SKL', _typPohybuSklad) into _cisloDokladuCursor; 
  fetch _cisloDokladuCursor into _cisDoklad; 
 
  -- ziskani kurzu pro menu skladu 
  -- select getKurzFromSklad(_polDokl.idSkladu, _polDokl.datVyst) into _kurz; 
  -- nejde pouzit protoze potrebuju jak kurz tak kurzove mnozstvi a ne prepocteny nna kurzove mnozstvi 1 
  select idMeny into _idMenyTuzemsko from nNastav where _polDokl.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
  if (_idMenyTuzemsko is null) then 
    select idMeny into _idMenyTuzemsko from nNastav where PlatiOdData is null limit 1; 
  end if; 
  --select idMeny into _idMenySklad from dTypDokl where idTypDokl = _polDokl.idSkladu; 
 
  if(_sklad.idMeny is null or _sklad.idMeny = _idMenyTuzemsko) then 
    _kurz = 0.0; 
    _kurzMnozstvi = 1; 
  else 
    select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
      where idMeny = _sklad.idMeny and _polDokl.datVyst >= PlatiOdData and typkurzuk = 'typKurzu.obecny' 
      order by PlatiOdData desc limit 1; 
    if(_kurz is null) then 
      select nbStred, kurzMnozstvi into _kurz, _kurzMnozstvi from uKurzy 
        where idMeny = _sklad.idMeny and PlatiOdData is null and typkurzuk = 'typKurzu.obecny' 
        limit 1; 
    end if; 
    if(_kurz is null) then 
      raise exception '0001:getKurzFromSklad : neexistuje kurz!'; 
    end if; 
  end if; 
  
  if(_isDobropis) then 
    if(_modul like 'FAV') then 
      _typPohybuSkladK = 'typPohybuSklad.prijemVratka'; 
    else 
      _typPohybuSkladK = 'typPohybuSklad.prijemVydejVratka'; 
    end if; 
  end if; 
 
  -- vytvoreni noveho skladoveho dokladu 
  insert into dDoklSklad (idDoklSklad, lastUpdate, datVyst, datUcto, kod, modul, typPohybuK, idTypDokl, idBsp,ucetni, varSym, 
         idFirmy, nazFirmy, ulice, mesto, psc, idStatu, ic, dic, vatId, 
         idMur, idKrajUrc, idStatUrc, idTypUcOp, cisObj, cisDodak, doprava, idDruhDopr, popis, poznam, 
         idStred, idZakazky, idMeny, kurz, kurzMnozstvi, 
         eanKod, idstatpuvod, idstatodesl, idobchtrans, iddodpodm, idzvlpoh, 
         idPrimUcet, idProtiUcet, idRady, idPolRady, zdrojProFak, stavSkladK , typPohybuSkladK, 
         idCinnost, idKontaktOsoba, idZodpOsoba 
         ) 
       values (_idDoklSklad, LOCALTIMESTAMP, _doklad.datVyst, _datUcto, _cisDoklad, 'SKL', _typPohybuSklad, _typDoklSkl.idTypDokl, _sklad.idBsp, _typDoklSkl.ucetni, _doklad.varSym, 
         _doklad.idFirmy, _doklad.nazFirmy, _doklad.ulice, _doklad.mesto, _doklad.psc, _doklad.idStatu, _doklad.ic, _doklad.dic, _doklad.vatId, 
         _doklad.idMur, _doklad.idKrajUrc, _doklad.idStatUrc, _idTypUcOp, _doklad.cisObj, null, _doklad.doprava, _doklad.idDruhDopr, _doklad.popis, _doklad.poznam, 
         _doklad.idStred, _doklad.idZakazky, _sklad.idMeny, _kurz, _kurzMnozstvi, 
         _doklad.eanKod, _doklad.idstatpuvod, _doklad.idstatodesl, _doklad.idobchtrans, _doklad.iddodpodm, _doklad.idzvlpoh, 
         _idUcetSklad, _idProtiUcet, _idRada, _radaRok.idRadyRok, false, _stavSklad, _typPohybuSkladK, 
         _doklad.idCinnost, _doklad.idKontaktOsoba, _doklad.idZodpOsoba 
         ); 
 
 
  if (_modul = 'SKL') then 
    _typVazby = 'typVazbyDokl.hlavaSklKus'; 
  else 
    _typVazby = 'typVazbyDokl.hlavaSkl'; 
  end if; 
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _idDoklad, _idDoklSklad, _doklad.modul, 'SKL', false, _typVazby); 
 
  return _idDoklSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createdoklsklad(integer, integer, character varying)
  OWNER TO %firmaRole%;




-- Function: sprepoctisumydokladu(integer, date)

DROP FUNCTION if exists sprepoctisumydokladu(integer, date);

CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer, i_datvyst date, i_datucto date)
  RETURNS void AS
$BODY$ 
declare 
 _sumZkl numeric(15,2); 
 _sumZklMen numeric(15,2); 
 _sumZklDoklad numeric(15,2); 
 _sumZklMenDoklad numeric(15,2); 
 _datVyst date; 
 _datUcto date; 
 _stavSkladK character varying; 
 _stavSkladKNew character varying; 
 _typPohybuK character varying; 
 _sumMnozMj numeric(19,6); 
 _sumMnozMjPlan numeric(19,6); 
 _inDatUcto date;
begin 
 if(i_datVyst >= '2014-01-01') then
   _inDatUcto = i_datUcto;
   if(_inDatUcto is null) then
     _inDatUcto = i_datVyst;
   end if;
 else
   _inDatUcto = i_datVyst;
 end if;
 
 select sum(sumZkl), sum(sumZklMen), sum(mnozMj), sum(mnozMjPlan) into _sumZkl, _sumZklMen, _sumMnozMj, _sumMnozMjPlan from dPolSklad where idDoklSklad = i_idDoklSklad and stornoPol = false; 
 
 select sumCelkem, sumCelkemMen, datVyst, datUcto, stavSkladK, typPohybuK  
   into _sumZklDoklad, _sumZklMenDoklad, _datVyst, _datUcto, _stavSkladK, _typPohybuK 
   from dDoklSklad where idDoklSklad = i_idDoklSklad; 
 
 if(_sumZkl is null) then _sumZkl = 0.0; end if; 
 if(_sumZklMen is null) then _sumZklMen = 0.0; end if; 
 
 _stavSkladKNew = _stavSkladK; 
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj != _sumMnozMjPlan) then  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFakt')) then  
     _stavSkladKNew = 'stavSklad.vygenFaktNeuplny';  
   end if;  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPokl')) then  
     _stavSkladKNew = 'stavSklad.vygenPoklNeuplny';  
   end if;  
 end if;  
 if(_typPohybuK = 'typPohybu.vydej' and _sumMnozMj = _sumMnozMjPlan) then  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenFaktNeuplny')) then  
     _stavSkladKNew = 'stavSklad.vygenFakt';  
   end if;  
   if(compareVarchar(_stavSkladK, 'stavSklad.vygenPoklNeuplny')) then  
     _stavSkladKNew = 'stavSklad.vygenPokl';  
   end if;  
 end if; 
  
 if(_sumZkl <> _sumZklDoklad  
    or _sumZklMen <> _sumZklMenDoklad 
    or not compareDate(i_datVyst, _datVyst) 
    or not compareDate(_inDatUcto, _datUcto)  
    or not compareVarchar(_stavSkladK, _stavSkladKNew) 
    ) then  
   /* 
    * pozor !!! 
    * radka lastUpdate = LOCALTIMESTAMP, 
    * se nesmi nikdy odkomentovat, protoze se pak rozbije ukladani obycejne polozky dokladu 
    * pri insertu polozky se hlavicce nastavi jiny lastUpdate a diky tomu pak neprojde update 
    * hlavicky dokladu s tim, ze doklad jiz zmenil jiny uzivatel 
    */  
   update dDoklSklad set  
       --lastUpdate = LOCALTIMESTAMP,  
       sumCelkem = _sumZkl,  
       sumCelkemMen = _sumZklMen,  
       sumOsv = _sumZkl,  
       sumOsvMen = _sumZklMen,  
       datVyst = i_datVyst,  
       datUcto = _inDatUcto, 
       stavSkladK = _stavSkladKNew 
     where idDoklSklad = i_idDoklSklad;  
 end if; 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer, date, date)
  OWNER TO %firmaRole%;


-- Function: sprepoctisumydokladu(integer)

-- DROP FUNCTION sprepoctisumydokladu(integer);

CREATE OR REPLACE FUNCTION sprepoctisumydokladu(i_iddoklsklad integer)
  RETURNS void AS
$BODY$  
declare  
 _sumZkl numeric(15,2);   
 _sumZklMen numeric(15,2);    
 _datVyst date;
 _datUcto date; 
begin  
 select datVyst, datUcto into _datVyst, _datUcto from dDoklSklad where idDoklSklad = i_idDoklSklad; 
 execute sprepoctisumydokladu(i_idDoklSklad, _datVyst, _datUcto); 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION sprepoctisumydokladu(integer)
  OWNER TO %firmaRole%;


-- Function: dpoldoklupdatesklad()

-- DROP FUNCTION dpoldoklupdatesklad();

CREATE OR REPLACE FUNCTION dpoldoklupdatesklad()
  RETURNS trigger AS
$BODY$ 
declare 
  _idPolDokl integer; 
  _idDoklad integer; 
  _idPolSklad integer; 
  _idDoklSklad integer; 
  _dokladGenerovatSkl boolean; 
  _typDoklGenerovatSkl boolean; 
  _typZasobyK character varying; 
  _skladove boolean; 
  _vyrobniCislo record; 
  _typPohybuK character varying; 
  _sadaItemCount integer; 
  _vypnutySklad character varying;  
  _typDoklK character varying; 
  _idPolSkladProPrepocetDokladu integer; 
  _idPolSkladPuvodni integer; 
  _idDoklSkladPuvodni integer; 
  _pocetPolozekSklDokl integer; 
  _datUcto date;
begin 
  select getglotxvariable('vypniSklad') into _vypnutySklad; 
  if(_vypnutySklad is null or _vypnutySklad <> 'true') then 
    --raise exception 'sem sem se nemel dostat'; 
    if(NEW.storno <> OLD.storno or NEW.stornoPol <> OLD.stornoPol) then 
      return NEW; 
    end if; 
 
    _typDoklK = ''; 
 
    if(NEW.modul like 'POK') then 
      _idPolDokl = NEW.idPolInt; 
      _idDoklad = NEW.idDoklInt; 
      select generovatSkl, datUcto into _dokladGenerovatSkl, _datUcto from dDoklInt where idDoklInt = NEW.idDoklInt; 
      select generovatSkl into _typDoklGenerovatSkl from dTypDokl where idTypDokl = (select idTypDokl from dDoklInt where idDoklInt = NEW.idDoklInt); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolInt where idpolint = NEW.idPolInt); 
    elsif (NEW.modul like 'FAV' or NEW.modul like 'FAP') then 
      _idPolDokl = NEW.idPolFak; 
      _idDoklad = NEW.idDoklFak; 
      select generovatSkl, datUcto into _dokladGenerovatSkl, _datUcto from dDoklFak where idDoklFak = NEW.idDoklFak; 
      select generovatSkl, typDoklK into _typDoklGenerovatSkl, _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = NEW.idDoklFak); 
 
      select count(*) into _sadaItemCount from csady where idceniksada = (select idcenik from dpolfak where idpolfak = NEW.idPolFak); 
    else  
      return NEW;   
    end if; 
 
    -- pokud se lisi sklad, cenik, typPolozky, mnozMj, sarze, expirace 
    -- tak skladovou polozku musim smazat a vytvorit znovu kvuli fifu 
    if((not compareId(NEW.idBspSkl, OLD.idBspSkl) 
       or not compareId(NEW.idCenik, OLD.idCenik) 
       or not compareVarchar(NEW.typPolozkyK, OLD.typPolozkyK) 
       or NEW.mnozMj <> OLD.mnozMj 
       or not compareVarchar(NEW.sarze, OLD.sarze) 
       or not compareDate(NEW.expirace, OLD.expirace) 
       ) 
       and _dokladGenerovatSkl and NEW.zdrojProSkl) then   
            
      -- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2) 
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then 
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladPuvodni; 
        select idDoklSklad into _idDoklSkladPuvodni from dPolSklad where idPolSklad = _idPolSkladPuvodni; 
      end if; 
       
      --raise exception 'mazu polSklad'; 
      execute deleteNavazanePolSklad(_idPolDokl, NEW.modul); 
       
      -- Bug 38144 – [FlexiBee] Při změně skladu zůstane doklad bez hlavičky (emeldi) (P2) 
      if (not compareId(NEW.idBspSkl, OLD.idBspSkl)) then 
        -- Vymaž skladový doklad pokud zůstal po změně skladu na položce prázdný. 
        -- ( změna skladu = přehození položky na nový skladový doklad, resp. na již existující doklad pro nový sklad ) 
        -- Očekáváme, že se vzniklá díra použije pro nově vytvářený doklad, případně zůstane volná pro příští použití. 
        SELECT count(*) into _pocetPolozekSklDokl from dPolSklad where idDoklSklad = _idDoklSkladPuvodni; 
         
        if _pocetPolozekSklDokl = 0 then 
          DELETE from dVazebTab where modulA = NEW.modul and idTabA = _idDoklad and modulB = 'SKL' and idTabB = _idDoklSkladPuvodni and typVazbyK = 'typVazbyDokl.hlavaSkl';    
          DELETE from dDoklSklad where idDoklSklad = _idDoklSkladPuvodni; 
        elseif _pocetPolozekSklDokl > 0 then 
          -- Po výmazu položky při změně skladu je třeba přepočítat původní (neprázdný) doklad. 
          EXECUTE sprepoctiSumyDokladu(_idDoklSkladPuvodni); 
        end if; 
      end if; 
    end if; 
 
    if(NEW.typPolozkyK like 'typPolozky.katalog' and _dokladGenerovatSkl and _typDoklGenerovatSkl and NEW.zdrojProSkl) then   
      select skladove into _skladove from cCenik where idCenik = NEW.idCenik; 
     
      if (_skladove and NEW.idBspSkl is not null) then 
        select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSklad; 
        if(_idPolSklad is null) then 
          --select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          if(_sadaItemCount > 0) then 
            execute createPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select createPolSklad(_idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        else 
          if(_sadaItemCount > 0) then 
            execute fillPolSkladSada(_idPolDokl, NEW.modul); 
          else 
            select fillPolSklad(_idPolSklad, _idPolDokl, NEW.modul) into _idPolSklad;  
          end if; 
        end if; 
        -- provedeni upgradu vyrobnich cisel 
        if((NEW.modul like 'FAV' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAP' and _typDoklK like 'typDokladu.dobropis')) then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakVydej = NEW.idPolFak and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if((NEW.modul like 'FAP' and _typDoklK not like 'typDokladu.dobropis') or (NEW.modul like 'FAV' and _typDoklK like 'typDokladu.dobropis')) then 
          for _vyrobniCislo in select * from sVyrobniCislo where idPolFakPrijem = NEW.idPolFak and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
            update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
          end loop; 
        end if; 
        if(NEW.modul like 'POK') then 
          select typPohybuK into _typPohybuK from dDoklInt where idDoklInt = _idDoklad; 
          if(_typPohybuK like 'typPohybu.prijem') then 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntVydej = NEW.idPolInt and (idPolSkladVydej is null or idPolSkladVydej <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladVydej = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          else 
            for _vyrobniCislo in select * from sVyrobniCislo where idPolIntPrijem = NEW.idPolInt and (idPolSkladPrijem is null or idPolSkladPrijem <> _idPolSklad) loop 
              update sVyrobniCislo set idPolSkladPrijem = _idPolSklad where idVyrobniCislo = _vyrobniCislo.idVyrobniCislo; 
            end loop; 
          end if; 
        end if; 
 
      end if; 
      -- prepocteni sum na dokladu 
      --select findParovanyDoklSklad(_idDoklad, NEW.modul) into _idDoklSklad; 
      select findParovanyPolSklad(_idPolDokl, NEW.modul) into _idPolSkladProPrepocetDokladu; 
      select idDoklSklad into _idDoklSklad from dPolSklad where idPolSklad = _idPolSkladProPrepocetDokladu; 
      if(NEW.datVyst >= '2014-01-01') then
        execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst, _datUcto);
      else
        execute sprepoctiSumyDokladu(_idDoklSklad, NEW.datVyst, NEW.datVyst);
      end if;
    end if; 
  end if; 
 
  return NEW; 
end 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpoldoklupdatesklad()
  OWNER TO %firmaRole%;








-- Function: createpolskladsada(integer, character varying)

-- DROP FUNCTION createpolskladsada(integer, character varying);

CREATE OR REPLACE FUNCTION createpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare 
  _polDokl record; 
  _doklad record; 
  _polozkaSady record; 
  _skladKarta record; 
  _cenik record; 
  _sklad record; 
  _idDoklSklad integer; 
  _idDoklad integer; 
  _idMeny integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _idPolSklad integer; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _i integer; 
  _cisRad integer; 
  _typDoklK character varying; 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _cenaMj numeric(19,6); 
  _kurz numeric(19,6); 
  _isCiziMena boolean; 
  _nasobic integer; 
  _idSkladu integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idTypUcOp integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
  _typPohybuSkladKVydej character varying; 
  _skupZboz record;
  _datUcto date; 
begin 
 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    _idDoklad = _polDokl.idDoklFak; 
    select * into _doklad from dDoklFak where idDoklFak = _idDoklad; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  else  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    _idDoklad = _polDokl.idDoklInt; 
    select * into _doklad from dDoklInt where idDoklInt = _idDoklad; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  end if; 
 
  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;


  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
 
  _i = 0; 
 
  FOR _polozkaSady IN 
    select * from cSady where idCenikSada = _polDokl.idCenik 
  LOOP 
    select * into _cenik from cCenik where idCenik = _polozkaSady.idCenik; 
 
    if(_cenik.skladove) then 
      _i = _i + 1; 
      _cisRad = 100 * _polDokl.cisRad + _i; 
   
      select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi;  
 
      _idSkladu = _polDokl.idBspSkl; 
 
      select * into _skladKarta from skarty  
        where idSkladu = _idSkladu and idCenik = _polozkaSady.idCenik and idUcetObdobi = _idUcetObdobi; 
 
      -- pokud neexistuje skladova karta pokusim se ji najit pomoci mapovani skladu 
      if(_skladKarta is null) then 
        select getPrefIdSkladu(_polDokl.idStred, _cenik.idSkupZboz, _cenik.idCenik) into _idSkladu; 
        select * into _skladKarta from skarty 
          where idSkladu = _idSkladu and idCenik = _cenik.idCenik and idUcetObdobi = _idUcetObdobi; 
        if(_skladKarta is null) then 
          -- pokud ani podle mapovani skladu se skladova karta nenajde tak vyhazuju vyjimku 
          raise exception '0007:Skladová karta neexistuje pro ceník % a sklad % a nebo je špatně nastaveno mapovaní skladu.', _cenik.nazev, _sklad.nazev; 
        end if; 
      else 
        _idSkladu = _skladKarta.idSkladu; 
      end if; 
 
      select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _idSkladu) into _idDoklSklad;   
    
      if(_idDoklSklad is null) then   
        select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;   
        if(_idDoklSklad is null) then  
          return;  
        end if;  
      end if;  
  
      select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
      select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;   
  
      select idMeny, idTypUcOp, idstred, idcinnost, idZakazky  
        into _idMeny, _idTypUcOp, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad   
        from dDoklSklad where idDoklSklad = _idDoklSklad;   
  
      _nasobic = 1; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        _nasobic = -1; 
      end if; 
      _mnozMj = _polozkaSady.mnozMj * _polDokl.mnozMj * _nasobic; 
      _cenaMj = _skladKarta.prumCenaTuz / _kurz; 
      _sumZkl = _mnozMj * _skladKarta.prumCenaTuz; 
      if(_isCiziMena) then  
        _sumZklMen = _mnozMj * _cenaMj;  
      else  
        _sumZklMen = 0.0;  
      end if; 
     
      -- nastaveni uctu pro polSklad vydej  
      _kopZklMdUcet = false; 
      _kopZklDalUcet = false; 
      if(_typDoklK like 'typDokladu.dobropis') then 
        -- dal ucet je ze skupiny zbozi nebo z hlavicky pokud neni ve skupine zbozi nastaven 
        select idProtiUcetSklV into _idZklDalUcet from cSkupZboz where idSkupZboz = _cenik.idSkupZboz; 
        if(_idZklDalUcet is null) then 
          select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklDalUcet = true; 
        end if; 
        -- md ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklMdUcet from dBsp where idBsp = _idSkladu; 
      else 
        -- nastaveni uctu pro polSklad vydej  
        select typPohybuSkladK into _typPohybuSkladKVydej from ddoklsklad where iddoklsklad = _idDoklSklad; 
        select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _polDokl.idCenik);  
     
        if(_skupzboz.idskupzboz is not null) then 
          -- Úpravy dle Bug 32848 – [WinStrom] - nerespektování upřesnění typu pohybu při tvorbě výdejky 
          if(_typPohybuSkladKVydej is null) then 
            _idZklMdUcet = _skupZboz.idprotiucetsklv; 
          -- typPohybuSklad.vydejHoly -  Holý" výdej  - idprotiucetsklholyv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejHoly') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
          -- typPohybuSklad.vydejPoFak - Výdej po faktuře  - idprotiucetsklv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoFak') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklv; 
          -- typPohybuSklad.vydejPolot - Výdej polotovaru - idprotiucetsklholyv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPolot') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv; 
          -- typPohybuSklad.vydejPoObch - Výdej po objednávce  -  idprotiucetsklv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoObch') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklv; 
          -- typPohybuSklad.vydejPrevod -  Výdej pro převodku  - idprotiucetsklprevv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPrevod') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklprevv; 
          -- typPohybuSklad.vydejProFakCenik - Výdej pro fakturaci (ceny z ceníku) - idprotiucetsklv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakCenik') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklv; 
          -- typPohybuSklad.vydejProFakRucne - Výdej pro fakturaci (ceny ručně) - idprotiucetsklv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakRucne') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklv;  
          --typPohybuSklad.vydejVyrob - Výdej výrobku  - idprotiucetsklholyv 
          elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejVyrob') then 
            _idZklMdUcet = _skupZboz.idprotiucetsklholyv;  
          end if; 
        end if;  
     
        if(_idZklMdUcet is null) then 
          -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true  
          select idProtiUcet into _idZklMdUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
          --pokud je z hlavicky tak se bude kopirovat 
          _kopZklMdUcet = true; 
        end if; 
        -- dal ucet musi byt primarni ucet skladu ze ktereho se kousky sady vydavaji 
        select idPrimUcet into _idZklDalUcet from dBsp where idBsp = _idSkladu; 
      end if;  
  
      _kopStred = true; 
      if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
        _kopStred = false; 
      end if; 
      _kopCinnost = true; 
      if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
        _kopCinnost = false; 
      end if; 
      _kopZakazku = true; 
      if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
        _kopZakazku = false; 
      end if; 
 
      select nextval('seq_dpolsklad') into _idPolSklad; 
      insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad, 
          mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
          nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,   
          idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp) 
        values (_idPolSklad, LOCALTIMESTAMP, _polozkaSady.idcenik, _idSkladu, _skladKarta.idKarty, _polDokl.datVyst, LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,     
          _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, 0.0, _cenik.idmj1, 
          _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, null, null, _polDokl.datTrvan, _polDokl.datVyroby, _cisRad, true,   
          _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp); 
 
      insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)   
        values (0.0, _idPolDokl, _idPolSklad, _modul, 'SKL', false, 'typVazbyDokl.polozkaSklSada');   
    end if;  
  END LOOP;  
 
  execute sprepoctiSumyDokladu(_idDoklSklad);  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladsada(integer, character varying)
  OWNER TO %firmaRole%;



-- Function: createpolskladdobropis(integer, integer, character varying, character varying)

-- DROP FUNCTION createpolskladdobropis(integer, integer, character varying, character varying);

CREATE OR REPLACE FUNCTION createpolskladdobropis(_iddobropisovanepolsklad integer, _iddobropisujicipoldokl integer, _modul character varying, _typvazbyk character varying)
  RETURNS integer AS
$BODY$  
declare 
  _idPolSklad integer; 
  _idDoklad integer; 
  _idDoklSklad integer;  
  _dobropisovanaPolSklad record; 
  _kopZakazku boolean; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _polDokl record; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
  _iducetobdobi integer; 
  _idkarty integer; 
  _mnozMj numeric(19,6);  
  _pomer numeric(19,12); 
  _cenaMj numeric(19,6);  
  _cenaMjTuz numeric(19,6);  
  _sumZkl numeric(19,6);  
  _sumZklMen numeric(19,6);  
  _mnozMjDobropisovane numeric(19,6); 
  _idZklMdUcet integer;  
  _idZklDalUcet integer;  
  _kopZklMdUcet boolean;  
  _kopZklDalUcet boolean;  
  _idMeny integer; 
  _idTypUcOp integer;  
  _kurz numeric(19,6);  
  _ciziMena boolean; 
  _typPohybuK character varying; 
  _nasobic numeric(19,6); 
  _skupZboz record; 
  _datUcto date;
begin 
  if(_modul like 'FAV' or _modul like 'FAP') then  
    select * into _polDokl from dPolFak where idPolFak = _iddobropisujicipoldokl; 
    _idDoklad = _polDokl.idDoklFak; 
    select mnozMj into _mnozMjDobropisovane from dPolFak where idPolFak = _polDokl.idPolDobropis; 
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad; 
  else  
    select * into _polDokl from dPolInt where idPolInt = _iddobropisujicipoldokl; 
    _idDoklad = _polDokl.idDoklInt; 
    select mnozMj into _mnozMjDobropisovane from dPolInt where idPolInt = _polDokl.idPolDobropis; 
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad; 
  end if;  
 
  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _polDokl.idBspSkl) into _idDoklSklad;   
    
  if(_idDoklSklad is null) then  
    select createDoklSklad(_iddobropisujicipoldokl, _idDoklad, _modul) into _idDoklSklad;  
    if(_idDoklSklad is null) then  
      return null;  
    end if;  
  end if;  
 
  select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _iddobropisovanepolsklad; 
  select idstred, idcinnost, idZakazky, idMeny 
      into _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad, _idMeny  
      from dDoklSklad where idDoklSklad = _idDoklSklad;   
 
  select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi;  
  select idkarty into _idkarty from skarty where idcenik = _dobropisovanaPolSklad.idcenik and idskladu = _dobropisovanaPolSklad.idbspskl and iducetobdobi = _iducetobdobi; 
  if(_idkarty is null) then 
    raise exception 'idkarty je null protoze neexistuje skladova karta pro ucetni obdobi'; 
  end if; 
   
  _nasobic = 1; 
  if(_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej')then 
    _nasobic = -1; 
  end if; 
  _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMj; 
  _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl; 
   
  if((-1 * _polDokl.mnozMj) <> _mnozMjDobropisovane) then 
    _pomer = -1 * _polDokl.mnozMj / _mnozMjDobropisovane; 
    _mnozMj = _mnozMj * _pomer; 
    _sumZkl = _sumZkl * _pomer; 
  end if; 
  --raise exception '% % %', _polDokl.mnozMj, _mnozMjDobropisovane, _mnozMj; 
  -- zohledneni meny 
  select ismenacizi(_idMeny, _polDokl.datvyst) into _ciziMena; 
  if(_ciziMena) then 
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
    _sumZklMen = _sumZkl / _kurz; 
    _cenaMj = _sumZklMen / _mnozMj; 
  else 
    _sumZklMen = 0.0; 
    _cenaMj = _sumZkl / _mnozMj; 
  end if; 
     
  _kopStred = true;  
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then  
    _kopStred = false;  
  end if;  
  _kopCinnost = true;  
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then  
    _kopCinnost = false;  
  end if;  
  _kopZakazku = true;  
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then  
    _kopZakazku = false;  
  end if;   
 
  select idprimucet into _idZklMdUcet from dbsp where idbsp = _dobropisovanaPolSklad.idbspskl; 
  _kopZklMdUcet = false; 
 
  _kopZklDalUcet = false; 
  if(_modul like 'FAV') then 
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _dobropisovanaPolSklad.idCenik);  
    if(_skupZboz.idProtiUcetSklV is not null) then  
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false;  
      _idZklDalUcet = _skupZboz.idProtiUcetSklV;  
    else  
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true  
      select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad;  
      _kopZklDalUcet = true; 
    end if;  
  else 
    _idZklDalUcet = _polDokl.idZklMdUcet;  
  end if; 
 
  select nextval('seq_dpolsklad') into _idPolSklad;    
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad,  
      mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj,  
      nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni,   
      idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp, 
      idPolDobropis)  
    values (_idPolSklad, LOCALTIMESTAMP, _dobropisovanaPolSklad.idcenik, _dobropisovanaPolSklad.idbspskl, _idkarty, _polDokl.datVyst, /*_dobropisovanaPolSklad.datSklad + interval '0.000001'*/ LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad,  
      _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _dobropisovanaPolSklad.idmj,  
      _dobropisovanaPolSklad.nazev, _dobropisovanaPolSklad.nazevA, _dobropisovanaPolSklad.nazevB, _dobropisovanaPolSklad.nazevC, _dobropisovanaPolSklad.sarze, _dobropisovanaPolSklad.expirace, _dobropisovanaPolSklad.datTrvan, _dobropisovanaPolSklad.datVyroby, _dobropisovanaPolSklad.cisRad, true,   
      _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp, 
      _iddobropisovanepolsklad);  
 
  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK)  
       values (0.0, _iddobropisujicipoldokl, _idPolSklad, _modul, 'SKL', false, _typVazbyK);  
 
  -- prepocteni sum na dokladu  
  execute sprepoctiSumyDokladu(_idDoklSklad);  
 
  return _idPolSklad;  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying)
  OWNER TO %firmaRole%;




-- Function: dpolskladinsertkusovnik(integer)

-- DROP FUNCTION dpolskladinsertkusovnik(integer);

CREATE OR REPLACE FUNCTION dpolskladinsertkusovnik(i_idpolsklad integer)
  RETURNS integer AS
$BODY$ 
declare 
    _polSklad record; 
    _typPohybuK varchar; 
    _typZasobyK varchar; 
    _skladove boolean; 
    _idKusovnik integer; 
    _iducetobdobi integer; 
    _stavNaSklade numeric; 
    _sklKarta record; 
    _cenik record; 
    --_sklzapor boolean; 
    _idVydejPolSklad integer; 
    _idParovanyDoklad integer; 
    potKus record; 
    _parKusMnoz numeric; 
    _i integer; 
    _kurz numeric; 
    _isCiziMena boolean; 
    _idMeny integer; 
    _mnozMj numeric; 
    _cenaMj numeric; 
    _sumZkl numeric; 
    _newSumZkl numeric; 
    _sumZklMen numeric; 
    _idSkladPotKus integer; 
    _idProtiUcetDoklad integer; 
    _idStred integer; 
    _kopStred boolean; 
    _sklad record; 
    _typPohybuSkladK character varying; 
    _typPohybuSkladKVydej character varying;  
    _cenaMjSkl numeric(19,6); 
    _cenaMjNeskl numeric(19,6); 
    _navazanaPolSklad record; 
    _rozpadlaPolSklad record; 
    _kurzDokladu numeric; 
begin 
  select * into _polSklad from dpolsklad where idpolsklad = i_idpolSklad; 
 
  -- napriklad pokud se jedna o prevodku mezi sklady nechceme z prijemky vytvaret prevodku 
  if (_polSklad.prevodka = true) then 
    return null; 
  end if; 
 
  -- typem pohybu musi byt prijem 
  select typpohybuk into _typPohybuK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if (_typPohybuK <> 'typPohybu.prijem') then 
    return null; 
  end if; 
 
  -- pokud neni nastaven typ pohybu sklad prijem z vyroby tak koncime 
  select typpohybuskladk into _typPohybuSkladK from ddoklsklad d where d.iddoklsklad = _polSklad.iddoklsklad; 
  if(_typPohybuSkladK is null or _typPohybuSkladK <> 'typPohybuSklad.prijemVyrob') then 
    return null; 
  end if; 
 
  -- idcenik odkazuje na neco co je soucasti kusovniku. 
  select ckus.idkusovnik into _idKusovnik from ckusovnik ckus where ckus.idcenik = _polSklad.idcenik 
    and exists (select 1 from ckusovnik cPot where cPot.idotec = ckus.idkusovnik); 
  if (_idKusovnik is null) then 
    return null; 
  end if; 
 
  -- vytvorime nebo nalezneme zparovany doklad skl vydej 
  select findparovanydoklsklad(_polSklad.iddoklsklad, _polSklad.modul, 'typVazbyDokl.hlavaSklKus') into _idParovanyDoklad; 
  if (_idParovanyDoklad is null) then 
    select createdoklsklad(_polSklad.idpolsklad, _polSklad.iddoklsklad, _polSklad.modul) into _idParovanyDoklad; 
  end if; 
 
  if(_idParovanyDoklad is null) then 
    return null; 
  end if; 
 
  select typPohybuSkladK into _typPohybuSkladKVydej from ddoklsklad where iddoklsklad = _idParovanyDoklad; 
  
  select isDoklSkladMenaCizi(_idParovanyDoklad, _polSklad.datVyst) into _isCiziMena; 
  select getkurzfromdoklad(_idParovanyDoklad, _polSklad.datVyst) into _kurz; 
  select idMeny into _idMeny from dDoklSklad where idDoklSklad = _idParovanyDoklad; 
 
  _i = 0; 
  _newSumZkl = 0.0; 
  _cenaMjSkl = 0.0; 
  _cenaMjNeskl = 0.0; 
 
  perform putglotxvariable('zurnalTxName', 'rozpadKusovniku'); 
 
  -- pro vsechny kusovniky, ktere jsou pod nasim kusovnikem a jsou skladove nebo vyroba a nemaji nulove mnozstvi 
  for potKus in (select * from ckusovnik cPot where cPot.idotec = _idKusovnik and cPot.mnoz > 0.0) loop 
    select * into _cenik from cCenik where idCenik = potKus.idCenik; 
 
    select mnoz into _parKusMnoz from ckusovnik where idkusovnik = _idKusovnik; 
 
    select skladove into _skladove from cCenik cen where cen.idCenik = potKus.idCenik; 
    if (not _skladove) then 
        _newSumZkl = _newSumZkl + ((_cenik.nakupcena * potKus.mnoz * _polSklad.mnozMj) / _parKusMnoz); 
        _cenaMjNeskl = _cenaMjNeskl + ((_cenik.nakupcena * potKus.mnoz) / _parKusMnoz); 
        continue; 
    end if; 
    _i = _i + 1; 
 
    select findIdUcetniObdobiKDatu(_polSklad.datVyst) into _iducetobdobi; 
    -- vybereme skladovou kartu podle preferovaneho skladu 
    select null into _sklKarta; 
    _idSkladPotKus = null; 
 
    select getPrefIdSkladu( 
	(select idstred from ddoklsklad where iddoklsklad = _polSklad.iddoklsklad), 
	_cenik.idskupzboz, potKus.idcenik) into _idSkladPotKus; 
 
    if (_idSkladPotKus is not null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _idSkladPotKus and iducetobdobi = _iducetobdobi; 
    end if; 
 
    -- sklad karta nebyla nalezena podle preferovaneho skladu, vezmeme sklad stejny jako z vytvarene polozky 
    if (_sklKarta is null) then 
	select * into _sklKarta from skarty where idcenik = potKus.idcenik and idSkladu = _polSklad.idBspSkl and iducetobdobi = _iducetobdobi; 
	select _polSklad.idStred into _idStred; 
	select _polSklad.kopstred into _kopStred; 
    else 
        select idstred into _idStred from dbsp d where _sklKarta.idskladu = d.idbsp; 
	select false into _kopStred; 
    end if; 
 
    -- skladovou 
    if (_sklKarta is null) then 
	raise exception 'Nebyla nalezena skladova karta k polozce ceniku %. Definujte mapovani skladu pro tuto polozku nebo ji pridejte na sklad %', 
		_cenik.kod, (select kod from dtypdokl where idtypdokl = _polSklad.idskladu); 
    end if; 
 
   _mnozMj = (potKus.mnoz / _parKusMnoz) * _polSklad.mnozMj; 
   _cenaMj = _sklKarta.prumCenaTuz / _kurz; 
   _sumZkl = _mnozMj * _sklKarta.prumCenaTuz; 
   _cenaMjSkl = _cenaMjSkl + (_cenaMj * (potKus.mnoz / _parKusMnoz)); 
   _newSumZkl = _newSumZkl + _sumZkl; 
 
   if(_isCiziMena) then 
     _sumZklMen = _mnozMj * _cenaMj; 
   else 
     _sumZklMen = 0.0; 
   end if; 
 
    -- TODO doplnit sarze a expirace 
    select dgetstavnaskladeaktualni(_sklKarta.idKarty) into _stavNaSklade;  
    --select dgetstavnasklade(_sklKarta.idkarty, _polSklad.datVyst, -1, _polSklad.idfirmy, NULL, NULL, _typPohybuK) into _stavNaSklade;  
 
    -- osetreni zda je povoleny zaporny stav na sklade 
    if (_stavNaSklade - _mnozMj < 0) then 
        /*select sklzapor into _sklzapor from nNastav where _polSklad.datVyst >= PlatiOdData order by PlatiOdData desc limit 1; 
        if (_sklzapor is null) then 
            select sklzapor into _sklzapor from nNastav where PlatiOdData is null limit 1; 
        end if; 
        if _sklzapor is null or _sklzapor = false then */ 
            raise exception '0002:sPreporctiSkladKartu: neni povolen zaporny stav skladu'; 
        /*end if; */ 
    end if; 
 
    select nextval('seq_dpolsklad'::regclass) into _idVydejPolSklad; 
 
    if(_cenik.idskupzboz is not null) then 
      -- Úpravy dle Bug 32848 – [WinStrom] - nerespektování upřesnění typu pohybu při tvorbě výdejky 
      if(_typPohybuSkladKVydej is null) then 
        select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejHoly -  Holý" výdej  - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejHoly') then 
        select idprotiucetsklholyv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejPoFak - Výdej po faktuře  - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoFak') then 
        select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejPolot - Výdej polotovaru - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPolot') then 
        select idprotiucetsklholyv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejPoObch - Výdej po objednávce  -  idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPoObch') then 
        select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejPrevod -  Výdej pro převodku  - idprotiucetsklprevv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejPrevod') then 
        select idprotiucetsklprevv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      -- typPohybuSklad.vydejProFakCenik - Výdej pro fakturaci (ceny z ceníku) - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakCenik') then 
        select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz; 
      -- typPohybuSklad.vydejProFakRucne - Výdej pro fakturaci (ceny ručně) - idprotiucetsklv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejProFakRucne') then 
        select idprotiucetsklv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      --typPohybuSklad.vydejVyrob - Výdej výrobku  - idprotiucetsklholyv 
      elsif(_typPohybuSkladKVydej like 'typPohybuSklad.vydejVyrob') then 
        select idprotiucetsklholyv into _idProtiUcetDoklad from cskupzboz where idskupzboz = _cenik.idskupzboz;  
      end if; 
    end if; 
    if(_idProtiUcetDoklad is null) then 
      select idprotiucet into _idProtiUcetDoklad from ddoklsklad where iddoklsklad = _idParovanyDoklad; 
    end if; 
 
    select * into _sklad from dBsp where _sklKarta.idSkladu = idBsp; 
 
    insert into dpolsklad(idPolSklad, idcenik, idBspSkl, idkarty, datVyst, datSklad, datUcto, modul, typPolozkyK, idDoklSklad, 
        mnozMj, cenaMj, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, 
        nazev, nazevA, nazevB, nazevC, sarze, expirace, cisRad, ucetni, idStred, idZakazky, idMeny, kopstred) 
    values (_idVydejPolSklad, potKus.idcenik, _sklKarta.idSkladu, _sklKarta.idkarty, _polSklad.datVyst, _polSklad.datSklad - interval '0.000001', _polSklad.datUcto, _polSklad.modul, _polSklad.typpolozkyk, _idParovanyDoklad, 
        _mnozMj, _cenaMj, _sumZkl, _sumZklMen, _idProtiUcetDoklad, _sklad.idprimucet, false, false, _polSklad.baleniid, _polSklad.mnozbaleni, 
        _cenik.nazev, _cenik.nazevA, _cenik.nazevB, _cenik.nazevC, NULL, NULL, _polSklad.cisRad * 100 + _i, true, 
        _idStred, _polSklad.idZakazky, _idMeny, _kopStred); 
 
    insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
      values (0.0, _polSklad.idpolsklad, _idVydejPolSklad, 'SKL', 'SKL', false, 'typVazbyDokl.polozkaSklKus'); 
 
  end loop; 
 
  perform removeglotxvariable('zurnalTxName'); 
 
  select getkurzfromdoklad(_polSklad.iddoklsklad, _polSklad.datvyst) into _kurz; 
  _cenaMj = _newSumZkl / _polSklad.mnozMj / _kurz; 
 
  select isDoklSkladMenaCizi(_polSklad.iddoklsklad, _polSklad.datVyst) into _isCiziMena; 
  if (_isCiziMena) then 
    _sumZklMen = _polSklad.cenaMj * _polSklad.mnozMj; 
  else 
    _sumZklMen = 0.0; 
  end if; 
 
 
  select getKurzFromDoklad(_polSklad.idDoklSklad, _polSklad.datVyst) into _kurzDokladu; 
  _cenaMjSkl = 0.0; 
  _cenaMj = _cenaMjNeskl; 
  _sumZkl = _cenaMjNeskl * _polSklad.mnozMj; 
  for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
    (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') ) 
    loop 
      if(_navazanaPolSklad.mnozMj <> 0.0) then 
        _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
        _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
      else 
        raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
      end if; 
      _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl; 
 
      -- musime zohlednit i pripadne rozpady skladovych polozek 
      for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in 
        (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad)) 
        loop 
          if(_rozpadlaPolSklad.mnozMj <> 0.0) then 
            _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
            _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu; 
          else 
            raise exception 'mnozMj je 0.0'; -- TODO vyresit co se bude dit 
          end if; 
          _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl; 
      end loop; 
  end loop; 
 
  update dpolsklad set 
       lastUpdate = LOCALTIMESTAMP, 
       sumzkl = _sumZkl, 
       cenaMj = _cenaMj, 
       --sumZklMen = _sumZklMen, 
       cenaMjSkl = _cenaMjSkl, 
       cenaMjNeskl = _cenaMjNeskl 
     where idpolsklad = _polSklad.idpolsklad; 
 
  -- prepocteni pripadnych cen prijmovem skladoveho dokladu zajisti update trigger na ddoklsklad 
 
  -- ale sumy na vydejce se musi prepocitat protoze na hlavicce dokladu nedochazi k zadne zmene 
  execute sprepoctisumydokladu(_idParovanyDoklad);  
 
  return _polSklad.idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION dpolskladinsertkusovnik(integer)
  OWNER TO %firmaRole%;






-- Function: fillpolsklad(integer, integer, character varying)

-- DROP FUNCTION fillpolsklad(integer, integer, character varying);

CREATE OR REPLACE FUNCTION fillpolsklad(_idpolsklad integer, _idpoldokl integer, _modul character varying)
  RETURNS integer AS
$BODY$ 
declare 
  _polDokl record; 
  _polSklad record; 
  _idDoklad integer; 
  _typPohybuK character varying; 
  _typPohybuSklad character varying; 
  _cenaMj numeric(19,6); 
  _cenaMjPoriz numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _mnozMj numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _idDoklSklad integer; 
  _idUcetObdobi integer; 
  _idKarty integer; 
  _sklad record; 
  _kurz numeric(19,6); 
  _prumCenaTuz numeric(19,6); 
  _isCiziMena boolean; 
  _typDoklK character varying; 
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _zdrojProFak boolean; 
  _datUcto date;
begin 
  if(_modul like 'POK') then 
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl; 
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt; 
    _typDoklK = null; -- pro pokladnu dobropisy nejsou 
  else 
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl; 
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak; 
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak); 
  end if; 

  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;
 
  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', false) into _idDoklSklad; 
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad; 
  end if; 
 
  select * into _polSklad from dPolSklad where idPolSklad = _idPolSklad; 
  select typPohybuK, idStred, idCinnost, idZakazky  
    into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad 
    from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;  
 
  select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi; 
  select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl; 
   
  select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
  select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty; 
  select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena; 
 
  if(_typPohybuSklad like 'typPohybu.vydej') then 
    -- vsechny dobropisy generuji prijemky 
    --if(_typDoklK like 'typDokladu.dobropis') then 
    --  _mnozMj = -_polDokl.mnozMj; 
    --else 
      _mnozMj = _polDokl.mnozMj; 
    --end if; 
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena 
    _cenaMj = _polSklad.cenaMj; 
    _cenaMjPoriz = _polSklad.cenaMjPoriz; 
    _sumZkl = _polSklad.sumZkl; 
    _sumZklMen = _polSklad.sumZklMen; 
    -- nastaveni uctu pro polSklad vydej 
    select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet; 
    _idZklDalUcet = _sklad.idPrimUcet; 
  else 
    if(_typDoklK like 'typDokladu.dobropis' and _modul like 'FAV') then 
      -- pokud se jedna o dobropis tak doplnuji nakupni ceny; 
      _mnozMj = -_polDokl.mnozMj; 
      _cenaMjTuz = _polDokl.cenaMjNakup;  
      if(_cenaMjTuz = 0.0) then 
        _cenaMjTuz = (select nakupCena from ccenik where idCenik = _polDokl.idCenik); 
        if(_cenaMj = 0.0) then 
          _cenaMj = _polDokl.cenaMj * _kurz; 
        end if; 
      end if; 
      _cenaMjPoriz = _cenaMjTuz / _kurz; 
      _cenaMj = _polSklad.cenaMjNakl + _cenaMjPoriz; 
      _sumZkl = _mnozMj * (_cenaMjTuz + (_polSklad.cenaMjNakl * _kurz)); 
      if(_isCiziMena) then 
        _sumZklMen = _mnozMj * _cenaMj; 
      else 
        _sumZklMen = 0.0; 
      end if; 
    else 
      -- pokud na sklad prijmam zkopiruji se ceny z faktury 
      _mnozMj = _polDokl.mnozMj; 
      _sumZkl = _polDokl.sumZkl; 
      if(_mnozMj <> 0.0) then 
        _cenaMjPoriz = _sumZkl / _mnozMj; 
      else 
        _cenaMjPoriz = _sumZkl; 
      end if; 
      _cenaMjPoriz = _cenaMjPoriz / _kurz; 
      if(_isCiziMena) then 
        if(_mnozMj <> 0.0) then 
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl) * _mnozMj; 
        else 
          _sumZklMen = (_cenaMjPoriz + _polSklad.cenaMjNakl); 
        end if; 
      else 
        _sumZklMen = 0.0;   
      end if; 
      _sumZkl = _sumZkl + (_polSklad.cenaMjNakl * _kurz * _mnozMj); 
      _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl; 
    end if; 
    -- nastaveni uctu pro polSklad prijem 
    _idZklMdUcet = _sklad.idPrimUcet; 
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if; 
 
  _zdrojProFak = not _polDokl.zdrojProSkl; 
 
  if(_polSklad.cenaMj <> _cenaMj 
    or _polSklad.cenaMjPoriz <> _cenaMjPoriz 
    or _polSklad.sumZkl <> _sumZkl 
    or _polSklad.sumZklMen <> _sumZklMen 
    or not compareVarchar(_polSklad.nazev, _polDokl.nazev) 
    or not compareVarchar(_polSklad.nazevA, _polDokl.nazevA) 
    or not compareVarchar(_polSklad.nazevB, _polDokl.nazevB) 
    or not compareVarchar(_polSklad.nazevC, _polDokl.nazevC) 
    or not compareDate(_polSklad.datVyst, _polDokl.datVyst) 
    or not compareDate(_polSklad.datUcto, _datUcto) 
    or _polSklad.kopDatUcto <> _polDokl.kopDatUcto
    or not compareId(_polSklad.baleniId, _polDokl.baleniId) 
    or not compareNumeric(_polSklad.mnozBaleni, _polDokl.mnozBaleni) 
    or not compareVarchar(_polSklad.sarze, _polDokl.sarze) 
    or not compareDate(_polSklad.expirace, _polDokl.expirace) 
    or not compareDate(_polSklad.datTrvan, _polDokl.datTrvan) 
    or not compareDate(_polSklad.datVyroby, _polDokl.datVyroby) 
    or not compareId(_polSklad.cisRad, _polDokl.cisRad) 
    or not compareVarchar(_polSklad.eankod, _polDokl.eanKod) 
    or not compareId(_polSklad.idmj, _polDokl.idmj) 
    or not compareId(_polSklad.idStred, _polDokl.idStred) 
    or not compareId(_polSklad.idCinnost, _polDokl.idCinnost) 
    or not compareId(_polSklad.idZakazky, _polDokl.idZakazky) 
    or not compareId(_polSklad.idZklMdUcet, _idZklMdUcet) 
    or not compareId(_polSklad.idZklDalUcet, _idZklDalUcet) 
    or _zdrojProFak <> _polSklad.zdrojProFak 
    ) 
  then 
    _kopStred = _polSklad.kopStred; 
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
      _kopStred = false; 
    end if; 
    _kopCinnost = _polSklad.kopCinnost; 
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
      _kopCinnost = false; 
    end if; 
    _kopZakazku = _polSklad.kopZakazku; 
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
      _kopZakazku = false; 
    end if; 
 
    update dPolSklad set 
      lastUpdate = LOCALTIMESTAMP, 
      cenaMj = _cenaMj, 
      cenaMjPoriz = _cenaMjPoriz, 
      --mnozMj = _mnozMj, 
      sumZkl = _sumZkl, 
      sumZklMen = _sumZklMen, 
      nazev = _polDokl.nazev, 
      nazevA = _polDokl.nazevA, 
      nazevB = _polDokl.nazevB, 
      nazevC = _polDokl.nazevC, 
      datVyst = _polDokl.datVyst, 
      datUcto = _datUcto, 
      kopDatUcto = _polDokl.kopDatUcto,  
      baleniId = _polDokl.baleniId, 
      mnozBaleni = _polDokl.mnozBaleni, 
      sarze = _polDokl.sarze, 
      expirace = _polDokl.expirace, 
      datTrvan = _polDokl.datTrvan, 
      datVyroby = _polDokl.datVyroby, 
      cisRad = _polDokl.cisRad, 
      eankod = _polDokl.eanKod, 
      idmj = _polDokl.idmj, 
      idStred = _polDokl.idStred, 
      kopStred = _kopStred, 
      idCinnost = _polDokl.idCinnost, 
      kopCinnost = _kopCinnost, 
      idMeny = _polSklad.idMeny, 
      idZakazky = _polDokl.idZakazky, 
      kopZakazku = _kopZakazku,  
      --idZklMdUcet = _idZklMdUcet, 
      --idZklDalUcet = _idZklDalUcet, 
      zdrojProFak = _zdrojProFak, 
      ucetni = true 
      where idPolSklad = _idPolSklad; 
  end if; 
 
  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION fillpolsklad(integer, integer, character varying)
  OWNER TO %firmaRole%;


-- Function: fillpolskladsada(integer, character varying)

-- DROP FUNCTION fillpolskladsada(integer, character varying);

CREATE OR REPLACE FUNCTION fillpolskladsada(_idpoldokl integer, _modul character varying)
  RETURNS void AS
$BODY$  
declare  
  _polDokl record;  
  _polSklad record;  
  _idDoklad integer;  
  _typPohybuK character varying;  
  _typPohybuSklad character varying;  
  _cenaMj numeric(19,6);  
  _cenaMjTuz numeric(19,6);  
  _mnozMj numeric(19,6);  
  _sumZkl numeric(19,6);  
  _sumZklMen numeric(19,6);  
  _idDoklSklad integer;  
  _idUcetObdobi integer;  
  _idKarty integer;  
  _sklad record;  
  _kurz numeric(19,6);  
  _prumCenaTuz numeric(19,6);  
  _isCiziMena boolean;  
  _typDoklK character varying;  
  _idZklMdUcet integer;  
  _idZklDalUcet integer;  
  _idStredDoklSklad integer; 
  _idCinnostDoklSklad integer; 
  _idZakazkyDoklSklad integer; 
  _kopStred boolean; 
  _kopCinnost boolean; 
  _kopZakazku boolean; 
  _datUcto date;
begin 
  if(_modul like 'POK') then  
    select * into _polDokl from dPolInt where idPolInt = _idPolDokl;  
    select idDoklInt, typPohybuK into _idDoklad, _typPohybuK from dDoklInt where idDoklInt = _polDokl.idDoklInt;  
    _typDoklK = null; -- pro pokladnu dobropisy nejsou  
  else  
    select * into _polDokl from dPolFak where idPolFak = _idPolDokl;  
    select idDoklFak, typPohybuK into _idDoklad, _typPohybuK from dDoklFak where idDoklFak = _polDokl.idDoklFak;  
    select typDoklK into _typDoklK from dTypDokl where idTypDokl = (select idTypDokl from dDoklFak where idDoklFak = _polDokl.idDoklFak);  
  end if;  
 
  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true) into _idDoklSklad;  
  if(_idDoklSklad is null) then  
    select createDoklSklad(_idPolDokl, _idDoklad, _modul) into _idDoklSklad;  
  end if;  
 
  for _polSklad in   
    select * from dPolSklad where idPolSklad in (  
      select idTabB from dvazebtab where  
        typVazbyK like 'typVazbyDokl.polozkaSklSada'   
        and idTabA = _idPolDokl and modulA = _modul and modulB = 'SKL'  
    )  
  loop  
    select typPohybuK, idStred, idCinnost, idZakazky 
      into _typPohybuSklad, _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad 
      from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad; 
  
    select findIdUcetniObdobiKDatu(_polDokl.datVyst) into _iducetobdobi;  
    select idkarty into _idkarty from skarty where idcenik = _polDokl.idcenik and idskladu = _polDokl.idbspskl and iducetobdobi = _iducetobdobi;  
    select * into _sklad from dBsp where idBsp = _polDokl.idBspSkl;  
    
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz;  
    select prumCenaTuz into _prumCenaTuz from sKarty where idKarty = _idKarty;  
    select isDoklSkladMenaCizi(_idDoklSklad, _polDokl.datVyst) into _isCiziMena;  
  
    -- pokud vydavam ze skladu tak ma byt pouzita prumerna cena  
    _cenaMj = _polSklad.cenaMj;  
    _mnozMj = _polSklad.mnozMj;  
    _sumZkl = _polSklad.sumZkl;  
    _sumZklMen = _polSklad.sumZklMen;  
    -- nastaveni uctu pro polSklad vydej  
    --TODO doresit zklMdUcet; 
    --select findZklMdUcetIfVydej(_idPolDokl, _modul) into _idZklMdUcet;  
    _idZklDalUcet = _sklad.idPrimUcet;  
    
    _kopStred = _polSklad.kopStred; 
    if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
      _kopStred = false; 
    end if; 
    _kopCinnost = _polSklad.kopCinnost; 
    if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
      _kopCinnost = false; 
    end if; 
    _kopZakazku = _polSklad.kopZakazku; 
    if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
      _kopZakazku = false; 
    end if; 
 
    update dPolSklad set   
      lastUpdate = LOCALTIMESTAMP,   
      cenaMj = _cenaMj,   
      mnozMj = _mnozMj,   
      sumZkl = _sumZkl,   
      sumZklMen = _sumZklMen,   
      --nazev = _polDokl.nazev,   
      --nazevA = _polDokl.nazevA,   
      --nazevB = _polDokl.nazevB,   
      --nazevC = _polDokl.nazevC,   
      datVyst = _polDokl.datVyst,   
      datUcto = _datUcto, 
      kopDatUcto = _polDokl.kopDatUcto,
      baleniId = _polDokl.baleniId,   
      mnozBaleni = _polDokl.mnozBaleni,   
      --sarze = _polDokl.sarze,   
      --expirace = _polDokl.expirace,   
      --cisRad = _polDokl.cisRad,   
      --eankod = _polDokl.eanKod,   
      --idmj = _polDokl.idmj, 
      datTrvan = _polDokl.datTrvan, 
      datVyroby = _polDokl.datVyroby, 
      idStred = _polDokl.idStred,   
      kopStred = _kopStred, 
      idCinnost = _polDokl.idCinnost, 
      kopCinnost = _kopCinnost,    
      idMeny = _polSklad.idMeny,   
      idZakazky = _polDokl.idZakazky,   
      kopZakazku = _kopZakazku,    
      --idZklMdUcet = _idZklMdUcet,   
      --idZklDalUcet = _idZklDalUcet, 
      ucetni = true  
      where idPolSklad = _polSklad.idPolSklad;  
  end loop; 
  --return _idPolSklad;  
end;  
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION fillpolskladsada(integer, character varying)
  OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 832, 't', %appVersion%, clock_timestamp());
