--------------------------------------------------------------------------------
-- Bug 38677 – [Bug] Upřednostnit záporný výdej před normálním výdejem
--------------------------------------------------------------------------------

create or replace function skladInsertRozsirenouPolozku(i_idPolSklad integer) returns void as
$BODY$
declare
  _polSklad record;
  _navazanaPolSklad record;
  _pocetRozsirenePolSklad integer;
  _typPohybuK character varying;
  _pocetProSkupinu integer;
  _skupina integer;
  _idDoklSkladMaster integer;
  _idDoklSkladMasterPom integer;
  _mazatTmpTable boolean;
  _evidVyrCis boolean;
begin
  --select count(*) into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad;
  --if(_pocetRozsirenePolSklad = 0) then
  select 1 into _pocetRozsirenePolSklad from tmp_RozsirenePolozky where idPolSklad = i_idPolSklad limit 1;
  if(_pocetRozsirenePolSklad is null) then
    select * into _polSklad from dPolSklad where idPolSklad = i_idPolSklad;
    select typPohybuK into _typPohybuK from dDoklSklad where idDoklSklad = _polSklad.idDoklSklad;

    -- urceni skupiny do ktere dana polozka patri
    _skupina = 2;
    select 1 into _pocetProSkupinu from dvazebtab
         where (idtabA = _polSklad.idPolSklad and modulA = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
             or (idtabB = _polSklad.idPolSklad and modulB = 'SKL' and (typVazbyK = 'typVazbyDokl.polozkaSklPrevod' or typVazbyK = 'typVazbyDokl.polozkaSklKus'))
         limit 1;
    if(_pocetProSkupinu is null and _polSklad.idPolDobropis is null) then
      if(_typPohybuK = 'typPohybu.prijem' or (_typPohybuK = 'typPohybu.vydej' and _polSklad.mnozMj < 0.0)) then 
        _skupina = 1;
      else
        _skupina = 3;
      end if;
    end if;

    -- urceni id skladoveho doklad ktery je master
    _idDoklSkladMaster = _polSklad.idDoklSklad;
    if(_skupina = 2) then
      -- _idDoklSkladMasterPom
      select idtabA into _idDoklSkladMasterPom from dvazebtab where idtabB = _polSklad.idDoklSklad and modulB = 'SKL' and modulA = 'SKL' and 
          (typVazbyK = 'typVazbyDokl.hlavaSklPrevod' or typVazbyK = 'typVazbyDokl.hlavaSklKus');
      if(_idDoklSkladMasterPom is not null) then
        _idDoklSkladMaster = _idDoklSkladMasterPom;
      end if;
    end if;

    -- rekurzi spoustim pro prevodku a kusovnik
    if(_skupina = 2 and _typPohybuK = 'typPohybu.vydej') then
      select * into _navazanaPolSklad from dPolSklad 
        where idPolSklad = (select idTabB from dvazebtab where idTabA = _polSklad.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');

      -- pokud neni soucasti prevodky tak se jedna o kusovnik
      if(_navazanaPolSklad is null) then
        select * into _navazanaPolSklad from dPolSklad
          where idPolSklad = (select idTabA from dVazebTab where idTabB = _polSklad.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus');
      end if;
      
      if(_navazanaPolSklad is null) then
        --raise notice 'navazana je null';
      else
        --raise notice 'volam rekurzi';
        select skladGenerujRozsirenePolozky(_navazanaPolSklad.datSklad, _navazanaPolSklad.idPolSklad, _navazanaPolSklad.idKarty ) into _mazatTmpTable;
      end if;
    end if;

    select evidVyrCis into _evidVyrCis from ccenik where idcenik = _polSklad.idcenik;
    -- vlozeni zaznamu o polozce do tmp tabulky
    insert into tmp_RozsirenePolozky (idpolsklad, iddoklskladMaster, datum, datVyst, skupina, typPohybuK, idskladkarty, mnozMj, /*cenaMj, sumZkl,*/ iddoklskladpolozky, storno, cenyRucne, evidVyrCis, idcenik, idbspskl)
            values (_polSklad.idPolSklad, _idDoklSkladMaster, _polSklad.datSklad, _polSklad.datVyst, _skupina, _typPohybuK, _polSklad.idkarty, _polSklad.mnozMj, /*_polSklad.cenaMj, _polSklad.sumZkl,*/ _polSklad.idDoklSklad, _polSklad.storno, _polSklad.cenyRucne, _evidVyrCis, _polSklad.idcenik, _polSklad.idbspskl);
  else
    -- do something stupid - kdyz je polozka v seznamu
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladInsertRozsirenouPolozku(integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 844, 't', %appVersion%, clock_timestamp());
