--------------------------------------------------------------------------------
-- Bug 38957 – [Bug] Nejde vygenerovat dobropis FAV
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION createpolskladdobropis(_iddobropisovanepolsklad integer, _iddobropisujicipoldokl integer, _modul character varying, _typVazbyK character varying)
  RETURNS integer AS
$BODY$ 
declare
  _idPolSklad integer;
  _idDoklad integer;
  _idDoklSklad integer; 
  _dobropisovanaPolSklad record;
  _kopZakazku boolean;
  _kopStred boolean;
  _kopCinnost boolean;
  _polDokl record;
  _idStredDoklSklad integer;
  _idCinnostDoklSklad integer;
  _idZakazkyDoklSklad integer;
  _iducetobdobi integer;
  _idkarty integer;
  _mnozMj numeric(19,6); 
  _pomer numeric(19,12);
  _cenaMj numeric(19,6); 
  _cenaMjTuz numeric(19,6); 
  _sumZkl numeric(19,6); 
  _sumZklMen numeric(19,6); 
  _mnozMjDobropisovane numeric(19,6);
  _idZklMdUcet integer; 
  _idZklDalUcet integer; 
  _kopZklMdUcet boolean; 
  _kopZklDalUcet boolean; 
  _idMeny integer;
  _idTypUcOp integer; 
  _kurz numeric(19,6); 
  _ciziMena boolean;
  _typPohybuK character varying;
  _nasobic numeric(19,6);
  _skupZboz record;
  _datUcto date;
begin
  if(_modul like 'FAV' or _modul like 'FAP') then 
    select * into _polDokl from dPolFak where idPolFak = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklFak;
    select mnozMj into _mnozMjDobropisovane from dPolFak where idPolFak = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  else 
    select * into _polDokl from dPolInt where idPolInt = _iddobropisujicipoldokl;
    _idDoklad = _polDokl.idDoklInt;
    select mnozMj into _mnozMjDobropisovane from dPolInt where idPolInt = _polDokl.idPolDobropis;
    select typPohybuK into _typPohybuK from ddoklfak where iddoklfak = _idDoklad;
  end if; 

  if(_polDokl.datVyst >= '2014-01-01') then
    _datUcto = _polDokl.datUcto;
    if(_datUcto is null) then
      _datUcto = _polDokl.datVyst;
    end if;
  else
    _datUcto = _polDokl.datVyst;
  end if;

  select findparovanydoklsklad(_iddoklad, _modul, 'typVazbyDokl.hlavaSkl', true, _polDokl.idBspSkl) into _idDoklSklad;  
   
  if(_idDoklSklad is null) then 
    select createDoklSklad(_iddobropisujicipoldokl, _idDoklad, _modul) into _idDoklSklad; 
    if(_idDoklSklad is null) then 
      return null; 
    end if; 
  end if; 

  select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _iddobropisovanepolsklad;
  select idstred, idcinnost, idZakazky, idMeny
      into _idStredDoklSklad, _idCinnostDoklSklad, _idZakazkyDoklSklad, _idMeny 
      from dDoklSklad where idDoklSklad = _idDoklSklad;  

  select findIdUcetniObdobiKDatu(_datUcto) into _iducetobdobi; 
  select idkarty into _idkarty from skarty where idcenik = _dobropisovanaPolSklad.idcenik and idskladu = _dobropisovanaPolSklad.idbspskl and iducetobdobi = _iducetobdobi;
  if(_idkarty is null) then
    raise exception 'idkarty je null protoze neexistuje skladova karta pro ucetni obdobi';
  end if;
  
  _nasobic = 1;
  if(_typPohybuK is not null and _typPohybuK = 'typPohybu.vydej')then
    _nasobic = -1;
  end if;
  if(_dobropisovanaPolSklad.mnozMj = 0) then
    _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMjPlan; 
  else
    _mnozMj = _nasobic * _dobropisovanaPolSklad.mnozMj; 
  end if;
  _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl;
  
  if((-1 * _polDokl.mnozMj) <> _mnozMjDobropisovane) then
    _pomer = -1 * _polDokl.mnozMj / _mnozMjDobropisovane;
    _mnozMj = _mnozMj * _pomer;
    _sumZkl = _sumZkl * _pomer;
  end if;
  --raise exception '% % %', _polDokl.mnozMj, _mnozMjDobropisovane, _mnozMj;
  -- zohledneni meny
  select ismenacizi(_idMeny, _polDokl.datvyst) into _ciziMena;
  if(_ciziMena) then
    select getkurzfromdoklad(_idDoklSklad, _polDokl.datVyst) into _kurz; 
    _sumZklMen = _sumZkl / _kurz;
    _cenaMj = _sumZklMen / _mnozMj;
  else
    _sumZklMen = 0.0;
    _cenaMj = _sumZkl / _mnozMj;
  end if;
    
  _kopStred = true; 
  if(not compareId(_idStredDoklSklad, _polDokl.idStred)) then 
    _kopStred = false; 
  end if; 
  _kopCinnost = true; 
  if(not compareId(_idCinnostDoklSklad, _polDokl.idCinnost)) then 
    _kopCinnost = false; 
  end if; 
  _kopZakazku = true; 
  if(not compareId(_idZakazkyDoklSklad, _polDokl.idZakazky)) then 
    _kopZakazku = false; 
  end if;  

  select idprimucet into _idZklMdUcet from dbsp where idbsp = _dobropisovanaPolSklad.idbspskl;
  _kopZklMdUcet = false;

  _kopZklDalUcet = false;
  if(_modul like 'FAV') then
    select * into _skupZboz from cskupzboz where idskupzboz = (select idskupzboz from ccenik where idcenik = _dobropisovanaPolSklad.idCenik); 
    if(_skupZboz.idProtiUcetSklV is not null) then 
      -- pokud je ve skupine zbozi nastaven protiucet pro vydej ze skladu pouzije se ten a kopirovani se necha na false; 
      _idZklDalUcet = _skupZboz.idProtiUcetSklV; 
    else 
      -- pokud neni ve skupine zbozi nastaven protiucet tak vemu protiucet z hlavicky a dam kopirovat na true 
      select idProtiUcet into _idZklDalUcet from dDoklSklad where idDoklSklad = _idDoklSklad; 
      _kopZklDalUcet = true;
    end if; 
  else
    _idZklDalUcet = _polDokl.idZklMdUcet; 
  end if;

  select nextval('seq_dpolsklad') into _idPolSklad;   
  insert into dpolsklad(idPolSklad, lastUpdate, idcenik, idbspskl, idkarty, datVyst, datSklad, datUcto, kopDatUcto, modul, typPolozkyK, idDoklSklad, 
      mnozMj, cenaMj, cenaMjPoriz, sumZkl, sumZklMen, idZklMdUcet, idZklDalUcet, kopZklMdUcet, kopZklDalUcet, baleniid, mnozBaleni, idmj, 
      nazev, nazevA, nazevB, nazevC, sarze, expirace, datTrvan, datVyroby, cisRad, ucetni, eanKod,  
      idStred, kopStred, idZakazky, kopZakazku, idMeny, zdrojProFak, idCinnost, kopCinnost, idTypUcOp,
      idPolDobropis) 
    values (_idPolSklad, LOCALTIMESTAMP, _dobropisovanaPolSklad.idcenik, _dobropisovanaPolSklad.idbspskl, _idkarty, _polDokl.datVyst, /*_dobropisovanaPolSklad.datSklad + interval '0.000001'*/ LOCALTIMESTAMP, _datUcto, _polDokl.kopDatUcto, 'SKL', 'typPolozky.katalog', _idDoklSklad, 
      _mnozMj, _cenaMj, _cenaMj, _sumZkl, _sumZklMen, _idZklMdUcet, _idZklDalUcet, _kopZklMdUcet, _kopZklDalUcet, _polDokl.baleniid, _polDokl.mnozBaleni, _dobropisovanaPolSklad.idmj, 
      _dobropisovanaPolSklad.nazev, _dobropisovanaPolSklad.nazevA, _dobropisovanaPolSklad.nazevB, _dobropisovanaPolSklad.nazevC, _dobropisovanaPolSklad.sarze, _dobropisovanaPolSklad.expirace, _dobropisovanaPolSklad.datTrvan, _dobropisovanaPolSklad.datVyroby, _dobropisovanaPolSklad.cisRad, true, _dobropisovanaPolSklad.eanKod, 
      _polDokl.idStred, _kopStred, _polDokl.idZakazky, _kopZakazku, _idMeny, false, _polDokl.idCinnost, _kopCinnost, _idTypUcOp,
      _iddobropisovanepolsklad); 

  insert into dvazebtab (castka, idtabA, idtabB, modulA, modulB, storno, typVazbyK) 
       values (0.0, _iddobropisujicipoldokl, _idPolSklad, _modul, 'SKL', false, _typVazbyK); 

  -- prepocteni sum na dokladu 
  execute sprepoctiSumyDokladu(_idDoklSklad); 

  return _idPolSklad; 
end; 
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
ALTER FUNCTION createpolskladdobropis(integer, integer, character varying, character varying) OWNER TO %firmaRole%;

create or replace function skladPrepoctiRozsirenouPolozku(i_idrozsirenepolozky integer, sign integer) returns void as
$BODY$
declare
  _skladKarta record;
  _rozsirenaPolozka record;
  _polSklad record;
  _navazanaPolSklad record;
  _stavMj numeric(19,6);
  _stavTuz numeric(19,6);
  _stavMen numeric(19,6);
  _prumCenaTuz numeric(19,6);
  _prumCenaMen numeric(19,6);
  _pocetNavazanych integer;
  _cenaMj numeric(19,6);
  _sumZkl numeric(19,6);
  _sumZklMen numeric(19,6);
  _kurzDokladu numeric(19,6);
  _kurzSkladKarty numeric(19,6);
  _isCiziMena boolean;
  _sklfifo boolean;
  _datPosl date; 
  _PoslCenaTuz numeric(19,6);     
  _PoslCenaMen numeric(19,6);     
  _cenaMjSkl numeric(19,6);
  _updateCena boolean;
  _rozpadlaPolSklad record;
  _sumZklProCenaMj numeric(19,6);
  _mnozMjProCenaMj numeric(19,6);
  _cenaMjPoriz numeric(19,6);
  _dobropisovanaPolSklad record;
  _nasobic integer;
  _typPohybuDobropisovanePolozky character varying;
  _mnozMjDobropisovanePolozky numeric(19,6);
  --_cenaMjNakl numeric(19,6);
begin
  select * into _rozsirenaPolozka from tmp_RozsirenePolozky where idpolsklad = i_idrozsirenepolozky;
  select * into _polSklad from dPolSklad where idPolSklad = i_idrozsirenepolozky;
  if(_polSklad is null) then
    -- muze se stat ze v rozsirenych polozkach je uz polozka ktera byla v ramci transakce smazana
    return;
  end if;
  
  select * into _skladKarta from sKarty where idKarty = _rozsirenaPolozka.idskladkarty;
  select getKurzFromDoklad(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _kurzDokladu;

  if(sign = 1) then
    if(_rozsirenaPolozka.skupina = 1) then
      if(_polSklad.mnozMj = 0.0) then
        _stavTuz = _polSklad.cenaMj * _kurzDokladu;
      else
        --select sumZkl into _stavTuz from dpolsklad where idPolSklad = _rozsirenaPolozka.idPolSklad;
        _stavTuz = _polSklad.sumZkl;
      end if;
    else
      -- pokud se jedna o prijemku z prevodky nebo vyroby tak se musi cena nastavit podle navazane vydejky
      _cenaMjSkl = 0.0;
      _sklfifo := (select isfifosklad(_polSklad.datVyst));
      -- menit cenu budeme jen pokud to neni fifo
      _updateCena = not _sklFifo;
      if(_rozsirenaPolozka.skupina = 2 and _polSklad.idPolDobropis is not null) then
        if(_polSklad.mnozMj < 0) then
          -- budeme se k takoveto prijemce chovat jako k vydejce a ocenime ji prumernou cenou
          _cenaMj = _skladKarta.prumCenaTuz; 
          _cenaMjPoriz = _skladKarta.prumCenaTuz; 
          if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then 
            _cenaMj = _cenaMj / _kurzDokladu; 
          end if; 
          _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz; 
          _sumZklMen = 0.0; 
          select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena; 
          if(_isCiziMena) then 
            _sumZklMen = _polSklad.mnozMj * _cenaMj;  
          end if;
        else
          select * into _dobropisovanaPolSklad from dpolsklad where idpolsklad = _polSklad.idPolDobropis;
          select typPohybuK into _typPohybuDobropisovanePolozky from dDoklSklad where idDoklSklad = _dobropisovanaPolSklad.idDoklSklad;
          _nasobic = 1; 
          if(_typPohybuDobropisovanePolozky = 'typPohybu.prijem') then 
            _nasobic = -1; 
          end if; 
          if(_dobropisovanaPolSklad.mnozMj = 0) then
            _mnozMjDobropisovanePolozky = _dobropisovanaPolSklad.mnozMjPlan;
          else
            _mnozMjDobropisovanePolozky = _dobropisovanaPolSklad.mnozMj;
          end if;
          _sumZkl = _nasobic * _dobropisovanaPolSklad.sumZkl;  
          _sumZkl = _sumZkl * _nasobic * _polSklad.mnozMj / _mnozMjDobropisovanePolozky;  

          select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena; 
          if(_isciziMena) then 
            _sumZklMen = _sumZkl / _kurzDokladu; 
            _cenaMj = _sumZklMen / _polSklad.mnozMj; 
          else 
            _sumZklMen = 0.0; 
            _cenaMj = _sumZkl / _polSklad.mnozMj; 
          end if; 
          _cenaMjPoriz = _cenaMj;
          _cenaMjSkl = _cenaMj;
        end if;
      elsif(_rozsirenaPolozka.skupina = 2 and _rozsirenaPolozka.typPohybuK = 'typPohybu.prijem') then
        select * into _navazanaPolSklad from dPolSklad 
            where idPolSklad = (select idTabA from dvazebtab where idTabB = _rozsirenaPolozka.idPolSklad and modulB = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklPrevod');
        if(_navazanaPolSklad is null) then
          _cenaMj = _polSklad.cenaMjNeskl;
          _cenaMjSkl = 0.0;
          _cenaMjPoriz = _cenaMj;
          _sumZkl = _polSklad.cenaMjNeskl * _polSklad.mnozMj;
          for _navazanaPolSklad in (select * from dPolSklad where idPolSklad in 
            (select idTabB from dvazebtab where idTabA = _rozsirenaPolozka.idPolSklad and modulA = 'SKL' and typVazbyK = 'typVazbyDokl.polozkaSklKus') )
            loop
            if(_navazanaPolSklad.mnozMj <> 0.0) then
              _cenaMj = _cenaMj + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              _cenaMjSkl = _cenaMjSkl + (_navazanaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
            else
              raise exception 'mnozMj je 0.0 - 1'; -- TODO vyresit co se bude dit
            end if;
            _sumZkl = _sumZkl + _navazanaPolSklad.sumZkl;

            -- musime zohlednit i pripadne rozpady skladovych polozek
            for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
              (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad))
            loop
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _cenaMj = _cenaMj + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
                _cenaMjSkl = _cenaMjSkl + (_rozpadlaPolSklad.sumZkl / _polSklad.mnozMj) / _kurzDokladu;
              else
                raise exception 'mnozMj je 0.0 - 2'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end loop;

            _cenaMjPoriz = _cenaMj;

            -- ovsem pokud se jedna o vyrobu musime zmenit cenu prijmky z vyroby
            _updateCena = true;
          end loop;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
        else
          _sumZklProCenaMj = 0.0;
          _mnozMjProCenaMj = 0.0;
          if((_navazanaPolSklad.mnozMj <> 0.0) and (_polSklad.mnozMj <> 0.0)) then
            _sumZklProCenaMj = _sumZklProCenaMj + _navazanaPolSklad.sumZkl / _kurzDokladu;
            _mnozMjProCenaMj = _mnozMjProCenaMj + _navazanaPolSklad.mnozMj;
            _sumZkl = _navazanaPolSklad.sumZkl; 
          else
            _sumZklProCenaMj = 0.0;
            _mnozMjProCenaMj = 0.0;
            _sumZkl = 0.0; 
          end if;
          -- musime zohlednit i pripadne rozpady skladovych polozek
          for _rozpadlaPolSklad in (select * from dPolSklad where idPolSklad in
            (select idpolskladcil from svazbypolsklad where idpolskladzdroj = _navazanaPolSklad.idPolSklad order by idpolskladcil desc)
            order by idpolsklad desc) 
          loop
            if(_polSklad.mnozMj > _mnozMjProCenaMj) then
              if(_rozpadlaPolSklad.mnozMj <> 0.0) then
                _sumZklProCenaMj = _sumZklProCenaMj + _rozpadlaPolSklad.sumZkl / _kurzDokladu;
                _mnozMjProCenaMj = _mnozMjProCenaMj + _rozpadlaPolSklad.mnozMj;
              else
                raise exception 'mnozMj je 0.0 - 4'; -- TODO vyresit co se bude dit
              end if;
              _sumZkl = _sumZkl + _rozpadlaPolSklad.sumZkl;
            end if;
          end loop;

          if(_mnozMjProCenaMj <> 0.0) then
            _cenaMjPoriz = _sumZklProCenaMj / _mnozMjProCenaMj;
          else
            _cenaMjPoriz = _sumZklProCenaMj;
          end if;
          _cenaMj = _cenaMjPoriz + _polSklad.cenaMjNakl;
          _sumZkl = _sumZkl + (_polSklad.mnozMj * _polSklad.cenaMjNakl);
          --_sumZkl = _polSklad.mnozMj * _cenaMj;
          -- ovsem pokud se jedna o prevodku musime zmenit cenu prijmky z prevodky
          _updateCena = true;
        end if;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj;
        end if;
      else
        _cenaMj = _skladKarta.prumCenaTuz;
        _cenaMjPoriz = _skladKarta.prumCenaTuz;
        if(_kurzDokladu is not null and _kurzDokladu <> 0.0) then
          _cenaMj = _cenaMj / _kurzDokladu;
        end if;
        _sumZkl = _polSklad.mnozMj * _skladKarta.prumCenaTuz;
        _sumZklMen = 0.0;
        select isdoklskladmenacizi(_rozsirenaPolozka.idDoklSkladPolozky, _polSklad.datVyst) into _isCiziMena;
        if(_isCiziMena) then
          _sumZklMen = _polSklad.mnozMj * _cenaMj; 
        end if;
      end if;

      if (_updateCena) then
        if(_polSklad.cenaMjPoriz <> _cenaMjPoriz or
          _polSklad.cenaMj <> _cenaMj or
          _polSklad.cenaMjSkl <> _cenaMjSkl or
          _polSklad.sumZkl <> _sumZkl or
          _polSklad.sumZklMen <> _sumZklMen
        ) then
          update dPolSklad set
            cenaMjPoriz = _cenaMjPoriz,
            cenaMj = _cenaMj,
            cenaMjSkl = _cenaMjSkl,
            sumZkl = _sumZkl,
            sumZklMen = _sumZklMen
          where idPolSklad = _rozsirenaPolozka.idPolSklad;
        end if;
      end if;

      --execute sprepoctisumydokladu(_rozsirenaPolozka.idDoklSkladPolozky);

      select sumZkl into _stavTuz from dpolsklad where idpolsklad = _rozsirenaPolozka.idPolSklad;
    end if;
  else
    if(_polSklad.mnozMj = 0.0 and _rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
      _stavTuz = _polSklad.cenaMj * _kurzDokladu;
    else
      select sumZkl into _stavTuz from dpolsklad where idPolSklad = i_idrozsirenepolozky;
    end if;
  end if;

  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.vydej') then
    _stavMj = _skladKarta.stavMj - (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz - (sign*_stavTuz);
  else
    _stavMj = _skladKarta.stavMj + (sign*_polSklad.mnozMj);
    _stavTuz = _skladKarta.stavTuz + (sign*_stavTuz);
  end if;

  if(_stavMj is null) then
    raise exception 'stav mj je null a idpolsklad je % a _skladkarta je % a _polSklad je %',i_idrozsirenepolozky, _skladkarta, _polSklad;
  end if;

  _prumCenaTuz = _skladKarta.prumCenaTuz;
  if(_stavMj <> 0.0) then
    _prumCenaTuz = _stavTuz / _stavMj;
  end if;
  if(_prumCenaTuz is null) then
    raise exception 'prumCenaTuz je null, _stavTuz je %, _stavMj je %', _stavTuz, _stavMj;
  end if; 
 
  _datPosl = _skladKarta.datPosl;
  if(_datPosl is null or _datPosl < _polSklad.datVyst) then
    _datPosl = _polSklad.datVyst;
  end if;

  _poslCenaTuz = _skladKarta.poslCenaTuz;
  _poslCenaMen = _skladKarta.poslCenaMen;
  if(_rozsirenaPolozka.typpohybuk = 'typPohybu.prijem') then
    _PoslCenaTuz := _polSklad.cenaMj * _KurzDokladu;   
    _PoslCenaMen := _polSklad.cenaMj; 
  end if;
 
  _KurzSkladKarty := (select getKurzFromSklad(_skladKarta.idSkladu, _polSklad.datVyst));
  if (not _rozsirenaPolozka.storno) then
    update skarty set 
      stavmj = _stavMj,
      stavMjSPozadavky = _stavMj - _skladKarta.pozadavkyMj,
      stavTuz = _stavTuz,
      stavMen = round(_stavTuz / _kurzSkladKarty, 2),
      prumCenaTuz = _prumCenaTuz,
      prumCenaMen = _prumCenaTuz / _kurzSkladKarty,
      datPosl = _datPosl,
      poslCenaTuz = _poslCenaTuz,
      poslCenaMen = _poslCenaMen,
      lastUpdate = LOCALTIMESTAMP
      where idkarty = _rozsirenaPolozka.idSkladKarty;
  end if;
end;
$BODY$
  LANGUAGE 'plpgsql' VOLATILE
  COST 100;
ALTER FUNCTION skladPrepoctiRozsirenouPolozku(integer, integer) OWNER TO %firmaRole%;

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 845, 't', %appVersion%, clock_timestamp());
