--Bug 13565 – [WinStrom] Sprava osobních certifikátu
-- certifikat firem v adresari

CREATE SEQUENCE seq_wadrcert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wadrcert OWNER TO %firmaRole%;

CREATE TABLE wadrcert (
    idadrcert integer DEFAULT nextval('seq_wadrcert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    duveryhodnostk character varying(50) NOT NULL,
    idadresar integer DEFAULT NULL
);

ALTER TABLE public.wadrcert OWNER TO %firmaRole%;

ALTER TABLE ONLY wadrcert
    ADD CONSTRAINT wadrcert_pkey PRIMARY KEY (idadrcert);

ALTER TABLE wadrcert ADD CONSTRAINT wadrcert_adresar_id FOREIGN KEY (idadresar) REFERENCES aadresar (idfirmy) ON UPDATE NO ACTION ON DELETE NO ACTION;

-- uloziste pro certifikat

CREATE SEQUENCE seq_wadrcertcipher
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
    
ALTER TABLE public.seq_wadrcertcipher OWNER TO %firmaRole%;

CREATE TABLE wadrcertcipher (
    idadrcertcipher integer DEFAULT nextval('seq_wadrcertcipher'::regclass) NOT NULL,
    certifikat oid,
    idadrcert integer NOT NULL DEFAULT 0
);

ALTER TABLE public.wadrcertcipher OWNER TO %firmaRole%;

ALTER TABLE ONLY wadrcertcipher
    ADD CONSTRAINT wadrcertcipher_pkey PRIMARY KEY (idadrcertcipher);

ALTER TABLE wadrcertcipher ADD CONSTRAINT wadrcertcipher_certifikat_id FOREIGN KEY (idadrcert) REFERENCES wadrcert (idadrcert) ON UPDATE NO ACTION ON DELETE NO ACTION;


CREATE INDEX woscertcipher_idcert_index ON woscertcipher USING btree (idoscert);
CREATE INDEX wadrcert_idadresar_index ON wadrcert USING btree (idadresar);
CREATE INDEX wadrcertcipher_idadrcert_index ON wadrcertcipher USING btree (idadrcert);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 88, 't');
