-- Bug 13567 – [WinStrom] Zmena hesla u certifikatu a pridani cert. autorit
-- pridani tabulky pro certifikacni autority a pro ulozeni keystore,
-- ktery je bude obsahovat

CREATE SEQUENCE seq_wautcert
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_wautcert OWNER TO %firmaRole%;

CREATE TABLE wautcert (
    idAutCert integer DEFAULT nextval('seq_wautcert'::regclass) NOT NULL,
    lastupdate timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL,
    uzivNazev character varying(255),
    certNazev character varying(255) NOT NULL,
    certOrgan character varying(255) NOT NULL,
    platido timestamp without time zone DEFAULT '2009-01-01 00:00:00'::timestamp without time zone NOT NULL,
    platiod timestamp without time zone DEFAULT '2008-01-01 00:00:00'::timestamp without time zone NOT NULL
);

ALTER TABLE public.wautcert OWNER TO %firmaRole%;

ALTER TABLE ONLY wautcert
    ADD CONSTRAINT wautcert_pkey PRIMARY KEY (idAutCert);

-- uloziste pro certifikacni autority

CREATE SEQUENCE seq_wautcertcipher
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;

ALTER TABLE public.seq_wautcertcipher OWNER TO %firmaRole%;

CREATE TABLE wautcertcipher (
    idautcertcipher integer DEFAULT nextval('seq_wautcertcipher'::regclass) NOT NULL,
    keyStore oid
);

ALTER TABLE public.wautcertcipher OWNER TO %firmaRole%;

ALTER TABLE ONLY wautcertcipher
    ADD CONSTRAINT wautcertcipher_pkey PRIMARY KEY (idautcertcipher);

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 89, 't');
