---------------------------------------------------------------------------------------
-- Bug 41543 - Dopočet ZP do minimálního vyměřovacího základu v případě skončení PP
---------------------------------------------------------------------------------------

create or replace function runupgrade()
    returns void as $$
declare
    stat character varying(10);
begin
  select a.uuid into stat from nnastav n 
    left join utyporg u on u.idtyporg = n.idtyporg
    left join astaty a on a.idstatu = u.idstatu
  order by coalesce(n.platioddata, '1900-01-01') desc limit 1;

  if (stat = 'CZ_CZ') then

-- zacatek ceskeho bloku
UPDATE pmzdcalc SET nazev = 'Fond pracovní doby',  polein = 'procMzd', idmzdslozin = 188 WHERE idmzdcalc = 6339;
UPDATE pmzdcalc SET koeficient2 = 1.0, koeficient3 = 0.0, polein2 = '' WHERE idmzdcalc = 6340;
UPDATE pmzdcalc SET dohodnoty = 0.0, vysldohodnoty = 9.9999999999E10 WHERE idmzdcalc = 6341;
-- konec ceskeho bloku
    
  end if;
end;
$$ LANGUAGE plpgsql;
ALTER FUNCTION runupgrade() OWNER TO %firmaRole%;

select runupgrade();

drop function runupgrade();

-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport, appversion, upgradetime)
  values (nextval('seq_dbversion'), 923, 't', %appVersion%, clock_timestamp());
