--------------------------------------------------------------------------------
-- Bug 13763 – [WINSTROM]-Odpocet zalohy ve fakture je roven hodnote faktury = uhrazena
--------------------------------------------------------------------------------

CREATE OR REPLACE FUNCTION dpolfakdeletevazba() RETURNS trigger
    AS $$
declare _dokl record;
        uhrad integer;
        _stavUhrK varchar;
begin  
  if (OLD.typPolozkyK in ('typPolozky.odpocetZalohy', 'typPolozky.odpocetZdd')) then  
    delete from dVazebTab where idtaba = OLD.idPolFak and (typVazbyK = 'typVazbyDokl.odpocetZALOHY' or typVazbyK = 'typVazbyDokl.odpocetZDD');
    
    select * into _dokl from dDoklFak where idDoklFak = OLD.idDoklFak;
    
    if (_dokl.stavUhrK = 'stavUhr.uhrazeno' and OLD.sumZkl < 0) then
      select count(*) into uhrad from dVazebTab where idTabA = _dokl.idDoklFak and modulA = _dokl.modul and typVazbyK = 'typVazbyDokl.uhrada';
      
      _stavUhrK = null;
      if (uhrad > 0) then
        _stavUhrK = 'stavUhr.castUhr';
      end if;
      
      update dDoklFak set stavUhrK = _stavUhrK where idDoklFak = _dokl.idDoklFak;
    end if;
  end if;  
  
  return OLD;  
end;  
$$
    LANGUAGE plpgsql;


update dDoklFak as D set stavUhrK = 'stavUhr.uhrazeno' where sumCelkem - juhSum = 0 and 
  (select count(*) from dPolFak as P where P.idDoklFak = D.idDoklFak and typPolozkyK in ('typPolozky.odpocetZdd', 'typPolozky.odpocetZalohy')) > 0;


-- zvyseni verze databaze
insert into dbversion(iddbversion, dbversion, needreimport)
  values (nextval('seq_dbversion'), 99, 't');