<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
	<xsl:output method="xml" encoding="utf-8" />
	
	<!-- 
	
	
    flexibee2xml-cli.exe -x ukazka-in.xml -t faktura-prijata-in.xslt -o ukazka-out.xml
   -->
	
	<xsl:template match="winstrom">
	  <winstrom version="1.0">
			 <xsl:apply-templates select="doklad"/>
		</winstrom>
	</xsl:template>
  
  
	<xsl:template match="doklad">
    <xsl:variable name="cil" select="java:flexibee.Tool.split(typPohybu, ':', 0)"/>
    <xsl:variable name="jak" select="java:flexibee.Tool.split(typPohybu, ':', 1)"/>
    <xsl:variable name="td" select="java:flexibee.Tool.split(typPohybu, ':', 2)"/>
    
    <xsl:choose>
      <xsl:when test="$jak = 'realizace-objednavky'">
        <xsl:choose>
          <xsl:when test="$cil = 'faktura-vydana' or $cil = 'vydejka'">
            <objednavka-prijata>
              <xsl:call-template name="spolecneRealizace"/>
            </objednavka-prijata>
          </xsl:when>
          <xsl:when test="$cil = 'faktura-prijata' or $cil = 'prijemka'">
            <objednavka-vydana>
              <xsl:call-template name="spolecneRealizace"/>
            </objednavka-vydana>
          </xsl:when>
        </xsl:choose>
      </xsl:when>
      
      
      <xsl:when test="$jak = 'tvorba'">
        <xsl:choose>
          <xsl:when test="$cil = 'faktura-vydana' or $cil = 'vydana-faktura'">
            <faktura-vydana>
              <xsl:call-template name="spolecneTvorba">
                <xsl:with-param name="polTag" select="'polozkyFaktury'"/>
              </xsl:call-template>
            </faktura-vydana>
          </xsl:when>
          <xsl:when test="$cil = 'faktura-prijata' or $cil = 'prijata-faktura'">
            <faktura-prijata>
              <xsl:call-template name="spolecneTvorba">
                <xsl:with-param name="polTag" select="'polozkyFaktury'"/>
              </xsl:call-template>
            </faktura-prijata>
          </xsl:when>
          <xsl:when test="$cil = 'prijemka' or $cil = 'vydejka'">
            <skladovy-pohyb>
              <xsl:choose>
                <xsl:when test="$cil = 'prijemka'">
                  <typPohybuK>typPohybu.prijem</typPohybuK>
                </xsl:when>
                <xsl:when test="$cil = 'vydejka'">
                  <typPohybuK>typPohybu.vydej</typPohybuK>
                </xsl:when>
              </xsl:choose>
              
              <xsl:call-template name="spolecneTvorba">
                <xsl:with-param name="polTag" select="'skladovePolozky'"/>  <!-- TODO nemame sklad na polozce-->
              </xsl:call-template>
            </skladovy-pohyb>
          </xsl:when>
        </xsl:choose>
      
      
      </xsl:when>
      <xsl:otherwise>
      </xsl:otherwise>
    </xsl:choose>
	</xsl:template>
  
  
  <xsl:template name="spolecneRealizace">
    <xsl:if test="cisloDokladu != ''">
        <id>code:<xsl:value-of select="cisloDokladu"/></id>
    </xsl:if>
    <id>ext:K-COLLECT:<xsl:value-of select="idOperace"/></id>
    
    <realizaceObj>
        
      <xsl:variable name="cil" select="java:flexibee.Tool.split(typPohybu, ':', 0)"/>
      <xsl:choose>
        <xsl:when test="$cil = 'prijemka' or $cil = 'vydejka'">
          <xsl:attribute name="type">skladovy-pohyb</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="type"><xsl:value-of select="$cil"/></xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>

      <generovatPozadavky>true</generovatPozadavky>
       
      <xsl:if test="java:flexibee.Tool.split(typPohybu, ':', 2) != ''">
        <typDokl>code:<xsl:value-of select="java:flexibee.Tool.split(typPohybu, ':', 2)"/></typDokl>
      </xsl:if>
      <polozkyObchDokladu>
        <xsl:for-each select="polozky/polozka">
          <polozka>
            <cenikNeboVyrobniCislo><xsl:value-of select="ean"/></cenikNeboVyrobniCislo>
            <mj><xsl:value-of select="mnozstvi"/></mj>
          </polozka>
	      </xsl:for-each>
      </polozkyObchDokladu>
    </realizaceObj>
    
  </xsl:template>
  
  
  <xsl:template name="spolecneTvorba">
    <xsl:param name="polTag" />
    
    <id>ext:K-COLLECT:<xsl:value-of select="idOperace"/></id>
    
    <xsl:if test="cisloDokladu != ''">
        <cisDosle><xsl:value-of select="cisloDokladu"/></cisDosle>
    </xsl:if>
  
    <typDokl>code:<xsl:value-of select="java:flexibee.Tool.split(typPohybu, ':', 2)"/></typDokl>
    
    <xsl:element name="{$polTag}">
      <xsl:for-each select="polozky/polozka">
        <polozka>
          <cenik>ean:<xsl:value-of select="ean"/></cenik>
          <mnozMj><xsl:value-of select="mnozstvi"/></mnozMj>
        </polozka>
	    </xsl:for-each>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
