<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java" xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" >

  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="Cenik">
    <winstrom version="1.0">
	<!-- Zalozime autorsky poplatek a poplatek za recyklaci -->
	<cenik update="ignore">
		<id>ext:ATC:Aut_Pop</id>
		<id>code:AUT_POP</id>
		<kod>AUT_POP</kod>
		<nazev>Autorský poplatek</nazev>
		<typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
		<typZasobyK>typZasoby.poplatek</typZasobyK>
		<nakupCena>1</nakupCena>
	</cenik>

	<cenik update="ignore">
		<id>ext:ATC:Rema</id>
		<id>code:RE_MA</id>
		<kod>RE_MA</kod>
		<nazev>Recyklace materiálu</nazev>
		<typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
		<typZasobyK>typZasoby.poplatek</typZasobyK>
		<nakupCena>1</nakupCena>
	</cenik>
    <xsl:apply-templates select="Zbozi"/>
    </winstrom>
  </xsl:template>

<!--
kategorie
  kod_kategorie
  nazev_kategorie
  podkategorie
    kod_podkategorie
    nazev_podkategorie
-->

  <xsl:template match="Zbozi">
	<xsl:if test="@jednotka != ''">
	<merna-jednotka update="ignore">
		<id>ext:ATC-MJ:<xsl:value-of select="@jednotka"/></id>
		<id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@jednotka)"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@jednotka)"/></kod>
		<nazev><xsl:value-of select="@jednotka"/></nazev>
	</merna-jednotka>
	</xsl:if>

	<xsl:if test="@kod_vyrobce != ''">
	<adresar update="ignore">
		<id>ext:ATC-ADR:<xsl:value-of select="@kod_vyrobce"/></id>
		<id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_vyrobce)"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@kod_vyrobce)"/></kod>
		<nazev><xsl:value-of select="@vyrobce"/></nazev>
	</adresar>
	</xsl:if>
	
	<xsl:if test="@kod_kategorie != ''">
	<strom update="ignore">
		<id>ext:ATC-UZEL:<xsl:value-of select="@kod_kategorie"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@kod_kategorie)"/></kod>
		<nazev><xsl:value-of select="@kategorie"/></nazev>
	</strom>
	</xsl:if>

	<xsl:if test="@kod_podkategorie != ''">
	<strom update="ignore">
		<id>ext:ATC-UZEL:<xsl:value-of select="@kod_podkategorie"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@kod_podkategorie)"/></kod>
		<nazev><xsl:value-of select="@podkategorie"/></nazev>
		<otec>ext:ATC-UZEL:<xsl:value-of select="@kod_kategorie"/></otec>
	</strom>
	</xsl:if>

	<cenik>
		<id>ext:ATC-CENIK:<xsl:value-of select="@kod_zbozi"/></id>
		<id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_zbozi)"/></id>
		<kod><xsl:value-of select="java:flexibee.Tool.toUpper(@kod_zbozi)"/></kod>
		<nazev><xsl:value-of select="@popis"/></nazev>
		<xsl:if test="@jednotka != ''">
		<mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@jednotka)"/></mj1>
		</xsl:if>
		<zaruka><xsl:value-of select="@zaruka"/></zaruka>
		<typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(@dph)"/></typSzbDphK>
		<typZasobyK>typZasoby.zbozi</typZasobyK>
		<skladove>true</skladove>
		<nakupCena><xsl:value-of select="@cena"/></nakupCena>

		<vyrobce>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_vyrobce)"/></vyrobce>

		<eanKod><xsl:value-of select="@ean"/></eanKod>
		<xsl:choose>
			<xsl:when test="@pevna_cena = true">
			<cenaZakl><xsl:value-of select="@pevna_cena"/></cenaZakl>
			</xsl:when>
			<xsl:otherwise>
			<cenaZakl><xsl:value-of select="@cenaEU"/></cenaZakl>
			</xsl:otherwise>
		</xsl:choose>
		<typCenyDphK>typCeny.bezDph</typCenyDphK>

		<popis><xsl:value-of select="rozsireny_text"/></popis>

		<xsl:if test="(@rema != '' or @aut_poplatek != '') and (@rema != '0' or @rema != '0.000' or @aut_poplatek != '0')">
		<poplatky>
			<xsl:if test="@rema != '' and @rema != '0.000' and @rema != '0'">
			<poplatek update="ignore">
				<id>ext:ATC-REMA:<xsl:value-of select="@kod_zbozi"/></id>
				<cenikOtec>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_zbozi)"/></cenikOtec>
				<cenik>[code:REMA][ext:ATC:Rema]</cenik>
				<mnozMj><xsl:value-of select="@rema"/></mnozMj>
			</poplatek>
			</xsl:if>

			<xsl:if test="@aut_poplatek != '' and @aut_poplatek != '0'">
			<poplatek update="ignore">
				<id>ext:ATC-AUTPOP:<xsl:value-of select="@kod_zbozi"/></id>
				<cenikOtec>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@kod_zbozi)"/></cenikOtec>
				<cenik>[code:AUT_POP][ext:ATC:Aut_Pop]</cenik>
				<mnozMj><xsl:value-of select="@aut_poplatek"/></mnozMj>
			</poplatek>
			</xsl:if>
		</poplatky>
		</xsl:if>

		<xsl:if test="@snimek != ''">
		<prilohy>
			<priloha update="ignore">
				<xsl:choose>
				    <xsl:when test="contains(@snimek, '/')">
					<id>ext:ATC-ATT:<xsl:value-of select="substring(@kod_zbozi, 1, 51)"/></id>
					<nazSoub><xsl:value-of select="substring-after(@snimek, '/')"/>.html</nazSoub>
				    </xsl:when>
				    <xsl:otherwise>
					<id>ext:ATC-ATT:<xsl:value-of select="substring(@kod_zbozi, 1, 51)"/></id>
					<nazSoub><xsl:value-of select="@snimek"/>.html</nazSoub>
				    </xsl:otherwise>
				</xsl:choose>
				<contentType>image/jpeg</contentType>
				<link>http://www.atcomp.cz/katalog/<xsl:value-of select="@snimek"/></link>
				<linkPicture>true</linkPicture>
			</priloha>
		</prilohy>
		</xsl:if>

		<xsl:if test="@kod_podkategorie != ''">
		<ceniky-ve-stromu>
			<strom-cenik>
				<id>ext:ATC-VAZUZEL:<xsl:value-of select="@kod_podkategorie"/>+<xsl:value-of select="@kod_zbozi"/></id>
				<uzel>ext:ATC-UZEL:<xsl:value-of select="@kod_podkategorie"/></uzel>
			</strom-cenik>
		</ceniky-ve-stromu>
		</xsl:if>
    	</cenik>
  </xsl:template>
</xsl:stylesheet>
