<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes"  encoding="utf-8"/>

    <xsl:template match="//stock">
	<winstrom version="1.0">
	<xsl:apply-templates select="stock"/>
	</winstrom>
    </xsl:template>

    <xsl:template match="//stock/stock">
	<xsl:if test="@groupId != ''">
    	    <skupina-zbozi update="ignore">
		    <id>ext:AWIS-GROUP:<xsl:value-of select="@groupId"/></id>
		    <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@groupName)"/></id>
		    <kod><xsl:value-of select="java:flexibee.Tool.toUpper(@groupName)"/></kod>
		    <nazev><xsl:value-of select="@groupName"/></nazev>
	    </skupina-zbozi>
	</xsl:if>

	<xsl:if test="@measure != ''">
    	    <merna-jednotka update="ignore">
		    <id>ext:AWIS-MJ:<xsl:value-of select="@measure"/></id>
		    <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@measure)"/></id>
		    <kod><xsl:value-of select="java:flexibee.Tool.toUpper(@measure)"/></kod>
		    <nazev><xsl:value-of select="@measure"/></nazev>
	    </merna-jednotka>
	</xsl:if>


	<cenik>
	    <!--
            	id="2"  		ok
		external_id="0"        	ign
		plu="001"               ok
		name="Coca Cola 0,2"    ok
		measure="ks" 		ok
		ean="" 			ok
		vat="20.000000" 	ok
		currency="CZK" 
		price="26.000000" 	ok
		type="Goods"		ok
	    -->
	    <id>ext:AWIS-STOCK-<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/>:<xsl:value-of select="@id"/></id>
	    <xsl:if test="@plu != ''"><id>plu:SKL<xsl:value-of select="@plu"/></id></xsl:if>
	    <!-- <xsl:if test="@ean != ''"><id>ean:<xsl:value-of select="@ean"/></id></xsl:if> -->

	    <xsl:if test="@groupId != ''">
		<skupZboz>[ext:AWIS-GROUP:<xsl:value-of select="@groupId"/>][code:<xsl:value-of select="java:flexibee.Tool.toUpper(@groupName)"/>]</skupZboz>
	    </xsl:if>

	    <nazev><xsl:value-of select="@name"/></nazev>
	    <mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@measure)"/></mj1>
	    <typZasobyK><xsl:choose>
		    <xsl:when test="@type = 'Service'">typZasoby.sluzba</xsl:when>
		    <xsl:otherwise>typZasoby.skladem</xsl:otherwise>
		</xsl:choose></typZasobyK>
	    <kodPlu>SKL<xsl:value-of select="@plu"/></kodPlu>
	    <!-- <eanKod><xsl:value-of select="@ean"/></eanKod> -->
	    <cenaZakl><xsl:value-of select="@price"/></cenaZakl>
	    <typCenyDphK>typCeny.sDph</typCenyDphK>
	    <typSzbDphK><xsl:choose>
		<xsl:when test="@vat = 0.0">typSzbDph.dphOsv</xsl:when>
		<xsl:when test="@vat &lt; 18.0">typSzbDph.dphSniz</xsl:when>
		<xsl:otherwise>typSzbDph.dphZakl</xsl:otherwise>
	    </xsl:choose></typSzbDphK>

	    <skladKarty>
		<SkladKarta>
			<cenik></cenik>
			<typDokl>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.params('terminal-store'))"/></typDokl>
			<ucetObdobi>code:<xsl:value-of select="java:flexibee.Tool.formatDate(java:flexibee.Tool.currentDate(), 'yyyy')"/></ucetObdobi>
		</SkladKarta>
	    </skladKarty>
	</cenik>

    </xsl:template>

</xsl:stylesheet>