<?xml version="1.0" encoding="utf-8"?>

<!-- soubor pro transformaci výpisů z formátu camt.053.001.02 do XML, které umí FlexiBee naimportovat -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:java="http://xml.apache.org/xalan/java" 
exclude-result-prefixes="java">

  <xsl:template match="/">
    <xsl:apply-templates select="report"/>
  </xsl:template>

  <xsl:template match="report">
    <winstrom version="1.0" source="importVypisu">  
      <xsl:apply-templates select="merchants"/>
    </winstrom>
  </xsl:template>
  
  <xsl:template match="merchants">
    <xsl:apply-templates select="merchant"/>    
  </xsl:template>
  
  <xsl:template match="merchant">
    <xsl:param name="cisloUctu" select="merchant_header/bank_account"></xsl:param> 
    <xsl:variable name="mena" select="merchant_header/transaction_currency"></xsl:variable>
    <xsl:apply-templates select="terminals/terminal/transaction"/>    
  </xsl:template>
  
  <xsl:template match="terminals/terminal/transaction">
    <banka>
      <banka>bankovniUcet.urlParam</banka>
      <typDokl>typDokl.zNastaveni</typDokl>
      <!--banka>iban:CZ71<xsl:value-of select="../../../merchant_header/bank_code" />0000000<xsl:value-of select="../../../merchant_header/bank_account" /></banka-->
      <mena>code:<xsl:value-of select="../../../merchant_header/transaction_currency" /></mena>
      <!--mena>code:<xsl:value-of select="$mena" /></mena-->
      <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(date, 'yyyyMMdd')" /></datVyst>
      <varSym><xsl:value-of select="variable_symbol" /></varSym>
      <poznam><xsl:value-of select="invoice_number" /></poznam>
      <sumCelkem><xsl:value-of select="brutto_account_currency" /></sumCelkem>
      <sumOsv><xsl:value-of select="brutto_account_currency" /></sumOsv>
      <bezPolozek>true</bezPolozek>
      <xsl:choose>
        <xsl:when test="brutto_CRDB = 'CR'">
          <typPohybuK>typPohybu.prijem</typPohybuK>
        </xsl:when>
        <xsl:when test="brutto_CRDB = 'DB'">
          <typPohybuK>typPohybu.vydej</typPohybuK>
        </xsl:when>
      </xsl:choose>
    </banka>
    <xsl:if test="fee != 0.00">
      <banka>
        <banka>bankovniUcet.urlParam</banka>
        <typDokl>typDokl.zNastaveni</typDokl>
        <!--banka>code:CSOB-PLATEBNI-BRANA</banka-->
        <!--iban><xsl:value-of select="../../merchant_header/bank_account" /></iban-->
        <mena>code:<xsl:value-of select="../../../merchant_header/transaction_currency" /></mena>
        <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(date, 'yyyyMMdd')" /></datVyst>
        <varSym><xsl:value-of select="variable_symbol" /></varSym>
        <poznam><xsl:value-of select="invoice_number" /></poznam>
        <sumCelkem><xsl:value-of select="fee" /></sumCelkem>
        <sumOsv><xsl:value-of select="fee" /></sumOsv>
        <bezPolozek>true</bezPolozek>
        <typPohybuK>typPohybu.vydej</typPohybuK>
      </banka>
    </xsl:if>    
    
  </xsl:template>
  
  
  
</xsl:stylesheet>
