﻿<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="winstrom">
	<winstrom>
	    <xsl:apply-templates select="*"/>
	</winstrom>
    </xsl:template>

    <!--
    PLU_ID
    BARCODE
    NAME
    DESC
    PRINT_STOCK
    UNIT_ID
    DPT_ID
    SALE
    HALO
    TAX_ID
    LPLU1
    PRICE
    STOCK
    -->

    <xsl:template match="//winstrom/*">
	<xsl:if test="kodPlu != ''">
	<cenik>
	    <PLU_ID><xsl:value-of select="kodPlu"/></PLU_ID>
	    <BARCODE><xsl:value-of select="eanKod"/></BARCODE>
	    <NAME><xsl:value-of select="nazev"/></NAME>
            <DESC>0</DESC> <!--true pokud popisna polozka-->
            <UNIT_ID><xsl:value-of select="mj1"/></UNIT_ID>
            <DPT_ID><xsl:value-of select="skupZboz"/></DPT_ID>
            <SALE>3</SALE> <!-- možnost prodeje -->
            <!-- <HALO></HALO> -->
            <TAX_ID><xsl:choose>
			<xsl:when test="szbDph != ''"><xsl:value-of select="szbDph"/></xsl:when>
			<xsl:when test="typSzbDphK = 'typSzbDph.dphOsv'">0</xsl:when> <!-- toto je z historických důvodů - nyní již posíláme data v ceníku -->
			<xsl:when test="typSzbDphK = 'typSzbDph.dphSniz'">10</xsl:when>
			<xsl:otherwise>20</xsl:otherwise>
		</xsl:choose></TAX_ID> <!-- TODO -->
            <!-- <LPLU1></LPLU1> -->
            <xsl:choose>
            	<xsl:when test="typCenyDphK = 'typCeny.bezDph'">
            		<PRICE><xsl:value-of select="java:flexibee.Tool.round(cenaZakl * ((100 + szbDph) div 100), '2')"/></PRICE>
            	</xsl:when>
            	<xsl:otherwise>
            		<PRICE><xsl:value-of select="cenaZakl"/></PRICE>            	
            	</xsl:otherwise>
            </xsl:choose>
            <STOCK></STOCK> <!-- aktuální zásoba -->
	</cenik>
	</xsl:if>
    </xsl:template>

</xsl:stylesheet>