<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    <!-- import z ISP Admin -->
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:key name="cisloKey" match="row" use="field[@name='c_smlouvy']"/>

    <xsl:template match="resultset">
		<winstrom version="1.0" atomic="false">
			<xsl:apply-templates />
		</winstrom>
    </xsl:template>

    <xsl:template match="row">
        <xsl:if test="generate-id(.) = generate-id(key('cisloKey', field[@name='c_smlouvy'])[1])">
	    	<smlouva create="fail">
	    		<id>code:<xsl:value-of select="field[@name='c_smlouvy']" /></id>
	    		<polozkySmlouvyExt>
	    			<xsl:for-each select="key('cisloKey', field[@name='c_smlouvy'])">
		    			<smlouva-polozka>
		    				<nazev>VOIP<xsl:value-of select="field[@name='tel_from']" /></nazev>
		    				<kod>VOIP<xsl:value-of select="field[@name='tel_from']" /></kod>
		    				<cenaRucne>true</cenaRucne>
		    				<frekFakt>0</frekFakt>
		    				<mnozMj><xsl:value-of select="field[@name='cas']" /></mnozMj>
		    				<cenaMj><xsl:value-of select="field[@name='cena']" /></cenaMj>
		    				<datPoslFaktObd>2011-12-31</datPoslFaktObd>
		    				<typCenyDphK>typCeny.sDph</typCenyDphK>
		    				<typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
		    			</smlouva-polozka>
		    		</xsl:for-each>
	    		</polozkySmlouvyExt>
	    	</smlouva>
	    </xsl:if>
    </xsl:template>
</xsl:stylesheet>
