<?xml version="1.0" encoding="utf-8" ?>
<!-- nutno založit všechny sklady které jsou v PREMIERu -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:template match="winstrom">
    <winstrom version="1.0">
      <xsl:apply-templates select="cenik"/>
    </winstrom>
  </xsl:template>
  
    <!--

CISLO,N,11,0
POPIS,C,50
ZKRAT,C,20
POZN,M
MJ,C,10
UZIVCODE,C,6
GUID,C,38
KATALOG,C,20
BARCODE,C,20
BCTYP,C,2
TYPZARDOBY,C,1
ZARDOBA,N,5,0
SADA,L
EVZAS,L
ZACENSAD,L
EVDRUHY,L
EVVYRCIS,L
DESMIST,N,3,0
OBRAZEK,C,255
OBRAZEK2,C,255
ZAROVNAT,L
ZAROVNAT2,L
DRUH_ZAS.,C,1
ČINNOSTI,C,255
SDPH_NÁKUP,N,15,4
SDPH_PROD.,N,15,4
EV.MIN,L
EV.MAX,L
MINIMUM,N,15,4
MAXIMUM,N,15,4
SPUSOBZAO,C,1
VYCHA,C,1
VYCHB,C,1
SPUSOBZMA,C,1
SPUSOBZMB,C,1
SLEV1,N,15,4
LIM2,N,15,4
SLEV2,N,15,4
LIM3,N,15,4
SLEV3,N,15,4
LIM4,N,15,4
SLEV4,N,15,4
LIM5,N,15,4
SLEV5,N,15,4
SDPH,L
ZAOK,C,1
CENY,C,255
UCPRJNAKUP,C,10
UCPRJPRODE,C,10
UCPRPNAKUP,C,10
UCPRPPRODE,C,10
UCETMAT,C,6
UCETZBOZI,C,6
UCETVYROBA,C,6
UCETOST,C,6
NASTAV,L
SLAVEMASK,N,5,0
TYPOP,N,3,0
IN_CHANGED,L
POPIS1,C,50
POZN1,M
POPIS2,C,50
POZN2,M
POPIS3,C,50
POZN3,M
HMOTNOST,N,15,4
OBJEM,N,15,4
DATPOR,D
TIMPOR,C,5
KODKN,C,10
KODSTPUV,C,2
DOKUMENTY,M

    -->
  
  <xsl:template match="cenik">
  
    <xsl:if test="MJ != ''">
      <merna-jednotka update="ignore">
        <id>code:moneyS3:<xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></kod>
        <nazev><xsl:value-of select="MJ"/></nazev>
      </merna-jednotka>
    </xsl:if>
    
    <!--<xsl:if test="SKLAD != ''" >
      <sklad update="ignore">
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(SKLAD)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(SKLAD)"/></kod>
        <nazev><xsl:value-of select="SKLAD"/></nazev>
      </sklad>
    </xsl:if>-->
    
    <cenik>
      <id>code:moneyS3:<xsl:value-of select="CISLO"/></id>
      <kod><xsl:value-of select="java:flexibee.Tool.toUpper(ZKRAT)"/></kod>
      <nazev><xsl:value-of select="java:flexibee.Tool.trim(POPIS)"/></nazev>
      <popis><xsl:value-of select="POPIS"/></popis>
      <xsl:if test="MJ != ''">
        <mj1>code:<xsl:value-of select="java:flexibee.Tool.toUpper(MJ)"/></mj1>
      </xsl:if>
      <cenaZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(MINIMUM)"/></cenaZakl>
      <typSzbDphK><xsl:value-of select="java:flexibee.Tool.vatToCode(SDPH_PROD.)"/></typSzbDphK>
      <typZasobyK>typZasoby.skladem</typZasobyK>
      
      <skladKarty>
        <SkladKarta>
          <cenik>code:<xsl:value-of select="java:flexibee.Tool.toUpper(ZKRAT)"/></cenik>
          <typDokl>code:SKLAD</typDokl>
          <ucetObdobi>code:<xsl:value-of select="java:flexibee.Tool.formatDate(java:flexibee.Tool.currentDate(), 'yyyy')"/></ucetObdobi>
        </SkladKarta>
      </skladKarty>
    </cenik>
    
  </xsl:template>
</xsl:stylesheet>