<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
	
	<!-- 
  flexibee2xml-cli.exe -x predkontace-pohoda.xml -t predkontace-in.xslt -o predkontace.xml
   -->
	
	<xsl:template match="lst:listAccountingDoubleEntry">
	  <winstrom version="1.0">
			 <xsl:apply-templates select="lst:itemAccounting"/>
		</winstrom>
	</xsl:template>
 
  
  <xsl:template match="lst:itemAccounting">
    <xsl:if test="@agenda = 'issuedInvoice' or @agenda = 'receivedInvoice' or @agenda = 'claim' or @agenda = 'commitment' or @agenda = 'cashPaid' or @agenda = 'cashReceived' or @agenda = 'internalDocument'">
      <predpis-zauctovani>
        <id>ext:POHODA-STRED:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="@id"/></id>
        <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@code)"/></id>
        <kod><xsl:value-of select="java:flexibee.Tool.toUpper(@code)"/></kod>
        <nazev><xsl:value-of select="@accounting"/></nazev>
        <xsl:choose>
          <xsl:when test="@agenda = 'issuedInvoice'">
            <modulFav>true</modulFav>
            <protiUcetPrijem>code:<xsl:value-of select="@credit"/></protiUcetPrijem>
          </xsl:when>
          <xsl:when test="@agenda = 'receivedInvoice'">
            <modulFap>true</modulFap>
            <protiUcetVydej>code:<xsl:value-of select="@debit"/></protiUcetVydej>
          </xsl:when>
          <xsl:when test="@agenda = 'claim'">
            <modulPhl>true</modulPhl>
            <protiUcetPrijem>code:<xsl:value-of select="@credit"/></protiUcetPrijem>
          </xsl:when>
          <xsl:when test="@agenda = 'commitment'">
            <modulZav>true</modulZav>
            <protiUcetVydej>code:<xsl:value-of select="@debit"/></protiUcetVydej>
          </xsl:when>
          <xsl:when test="@agenda = 'cashPaid'">
            <modulPokV>true</modulPokV>
            <protiUcetVydej>code:<xsl:value-of select="@debit"/></protiUcetVydej>
          </xsl:when>
          <xsl:when test="@agenda = 'cashReceived'">
            <modulPokP>true</modulPokP>
            <protiUcetPrijem>code:<xsl:value-of select="@credit"/></protiUcetPrijem>
          </xsl:when>
          <xsl:when test="@agenda = 'internalDocument'">
            <modulInt>true</modulInt>
            <protiUcetPrijem>code:<xsl:value-of select="@credit"/></protiUcetPrijem>
            <protiUcetVydej>code:<xsl:value-of select="@debit"/></protiUcetVydej>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
        <dphZaklUcet>code:343019</dphZaklUcet>
        <dphSnizUcet>code:343009</dphSnizUcet>
      </predpis-zauctovani>
    </xsl:if>
  </xsl:template>
  
  <xsl:template match="text()"/>
</xsl:stylesheet>
