<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
xmlns:rsp="http://www.stormware.cz/schema/version_2/response.xsd" 
xmlns:rdc="http://www.stormware.cz/schema/version_2/documentresponse.xsd" 
xmlns:typ="http://www.stormware.cz/schema/version_2/type.xsd" 
xmlns:lst="http://www.stormware.cz/schema/version_2/list.xsd" 
xmlns:lStk="http://www.stormware.cz/schema/version_2/list_stock.xsd" 
xmlns:lAdb="http://www.stormware.cz/schema/version_2/list_addBook.xsd" 
xmlns:acu="http://www.stormware.cz/schema/version_2/accountingunit.xsd" 
xmlns:inv="http://www.stormware.cz/schema/version_2/invoice.xsd"
xmlns:vch="http://www.stormware.cz/schema/version_2/voucher.xsd"
xmlns:int="http://www.stormware.cz/schema/version_2/intDoc.xsd"
xmlns:stk="http://www.stormware.cz/schema/version_2/stock.xsd"
xmlns:ord="http://www.stormware.cz/schema/version_2/order.xsd"
xmlns:ofr="http://www.stormware.cz/schema/version_2/offer.xsd"
xmlns:enq="http://www.stormware.cz/schema/version_2/enquiry.xsd"
xmlns:vyd="http://www.stormware.cz/schema/version_2/vydejka.xsd"
xmlns:pri="http://www.stormware.cz/schema/version_2/prijemka.xsd"
xmlns:bal="http://www.stormware.cz/schema/version_2/balance.xsd"
xmlns:pre="http://www.stormware.cz/schema/version_2/prevodka.xsd"
xmlns:vyr="http://www.stormware.cz/schema/version_2/vyroba.xsd"
xmlns:pro="http://www.stormware.cz/schema/version_2/prodejka.xsd"
xmlns:con="http://www.stormware.cz/schema/version_2/contract.xsd"
xmlns:adb="http://www.stormware.cz/schema/version_2/addressbook.xsd"
xmlns:prm="http://www.stormware.cz/schema/version_2/parameter.xsd"
xmlns:lCon="http://www.stormware.cz/schema/version_2/list_contract.xsd"
xmlns:ctg="http://www.stormware.cz/schema/version_2/category.xsd"
xmlns:ipm="http://www.stormware.cz/schema/version_2/intParam.xsd"
xmlns:str="http://www.stormware.cz/schema/version_2/storage.xsd"
xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java">
    
	<xsl:output method="xml" encoding="utf-8" />
	
	
	<!-- 
  flexibee2xml-cli.exe -x sklady-pohoda.xml -t sklady-in.xslt -o sklady.xml
   -->
	
	<xsl:template match="lst:listStorage">
	  <winstrom version="1.0">
        <!-- aby pri vytvareni ceniku se nedelali skladove karty ktere nechceme-->
        <sklad create="ignore">
          <id>code:SKLAD</id>
          <automatickySklad>false</automatickySklad>
        </sklad>
    
			 <xsl:apply-templates select="lst:itemStorage" mode="sklady"/>
       <xsl:apply-templates select="lst:itemStorage" mode="uzly"/>
		</winstrom>
	</xsl:template>
 
  
  <xsl:template match="lst:itemStorage" mode="sklady">
    <sklad>
      <id>ext:POHODA-SKLAD:<xsl:value-of select="java:flexibee.Tool.params('year')"/>-<xsl:value-of select="@idStore"/></id>
      <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(@code)"/></id>
      <kod><xsl:value-of select="java:flexibee.Tool.toUpper(@code)"/></kod>
      <xsl:choose>
        <xsl:when test="descendant::*[@name and @name != ''][1]/@name != ''">
          <nazev><xsl:value-of select="descendant::*[@name and @name != ''][1]/@name"/></nazev>
        </xsl:when>
        <xsl:otherwise>
          <nazev><xsl:value-of select="@code"/></nazev>
        </xsl:otherwise>
      </xsl:choose>
      <automatickySklad>false</automatickySklad>
    </sklad>
  </xsl:template>
  
  <xsl:template match="lst:itemStorage" mode="uzly">
    <strom>
      <id>ext:POHODA-STROM:<xsl:value-of select="@idStore"/></id>
      <xsl:if test="@id != '0'">
        <id>ext:POHODA-STROM-UZEL:<xsl:value-of select="@id"/></id>
      </xsl:if>
      <nazev><xsl:value-of select="@code"/></nazev>
      <poradi>2147483647</poradi>
    </strom>
  
    <xsl:call-template name="vytvorPodzly">
      <xsl:with-param name="otec" select="@idStore"/>
    </xsl:call-template>
  </xsl:template>
  
  <xsl:template name="vytvorPodzly">
    <xsl:param name="otec" />
    
    <xsl:for-each select="lst:subStorages/lst:itemStorage">
      <strom>
        <id>ext:POHODA-STROM:<xsl:value-of select="$otec"/>-<xsl:value-of select="@code"/></id>
        <xsl:if test="@id != '0'">
          <id>ext:POHODA-STROM-UZEL:<xsl:value-of select="@id"/></id>
        </xsl:if>
        <otec>ext:POHODA-STROM:<xsl:value-of select="$otec"/></otec>
        <nazev><xsl:value-of select="@code"/></nazev>
        <poradi>2147483647</poradi>
      </strom>
      
      <xsl:call-template name="vytvorPodzly">
        <xsl:with-param name="otec" select="java:flexibee.Tool.join($otec, @code, '-')"/>
      </xsl:call-template>
    </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="text()"/>
</xsl:stylesheet>
