<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0">
            <xsl:apply-templates select="Ceník"/>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Ceník">
        <winstrom version="1.0">
            <xsl:apply-templates select="Ceník"/>
        </winstrom>
    </xsl:template>

<!--
.\flexibee2xml.exe -t cenik-in.xslt -x adresar.out.xml -o vystup.xml 2>a.out
kod, nazev
-->

    <xsl:template match="Ceník">
        <xsl:if test="java:flexibee.Tool.trim(Kód_EAN) != ''">
            <xsl:if test="java:flexibee.Tool.trim(Měrná_jednotka) != ''">
                <merna-jednotka update="ignore">
                    <id>ext:4DD-MJ:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Měrná_jednotka))"/></id>
                    <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Měrná_jednotka))"/></id>
                    <kod><xsl:value-of select="java:flexibee.Tool.toUpper(java:flexibee.Tool.trim(Měrná_jednotka))"/></kod>
                    <nazev><xsl:value-of select="java:flexibee.Tool.trim(Měrná_jednotka)"/></nazev>
                </merna-jednotka>
            </xsl:if>

            <cenik>
                <id>ext:4DD-CEN:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
                <id>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
                <kod><xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></kod>
                <xsl:choose>
                    <xsl:when test="java:flexibee.Tool.trim(Název_položky) != ''">
                        <nazev><xsl:value-of select="Název_položky"/></nazev>
                    </xsl:when>
                    <xsl:otherwise>
                        <nazev><xsl:value-of select="Kód_EAN"/></nazev>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                    <xsl:when test="Sazba_DPH = '0'">
                        <typSzbDphK>typSzbDph.dphOsv</typSzbDphK>
                    </xsl:when>
                    <xsl:when test="Sazba_DPH = '5'">
                        <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                    </xsl:when>
                    <xsl:when test="Sazba_DPH = '10'">
                        <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                    </xsl:when>
                    <xsl:when test="Sazba_DPH = '9'">
                        <typSzbDphK>typSzbDph.dphSniz</typSzbDphK>
                    </xsl:when>
                    <xsl:otherwise>
                        <typSzbDphK>typSzbDph.dphZakl</typSzbDphK>
                    </xsl:otherwise>
                </xsl:choose>
                <eanKod><xsl:value-of select="Kód_EAN"/></eanKod>
                <nakupCena><xsl:value-of select="java:flexibee.Tool.parseMoney(Cena_nákupní)"/></nakupCena>
                <cenaZakl><xsl:value-of select="java:flexibee.Tool.parseMoney(Cena4)"/></cenaZakl>
                <mj1 if-not-found="null">code:<xsl:value-of select="java:flexibee.Tool.toUpper(Měrná_jednotka)"/></mj1>
                <hmotMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Jedn.hmotnost)"/></hmotMj>
                <mjHmot if-not-found="null">code:KG</mjHmot>
                <xsl:choose>
                    <xsl:when test="Služba = 'Pravda' or Služba = 'true'">
                        <typZasobyK>typZasoby.sluzba</typZasobyK>
                    </xsl:when>
                    <xsl:when test="Má_rozpad = 'Pravda' or Má_rozpad = 'true'">
                        <typZasobyK>typZasoby.vyrobek</typZasobyK>
                    </xsl:when>
                    <xsl:otherwise>
                        <typZasobyK>typZasoby.zbozi</typZasobyK>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:if test="Záruční_doba != '0'">
                <zaruka><xsl:value-of select="Záruční_doba"/></zaruka>
                <xsl:choose>
                    <xsl:when test="Záruční_jedn. = '2'">
                        <mjZarukyK>mjZaruky.mesic</mjZarukyK>
                    </xsl:when>
                    <xsl:otherwise>
                        <mjZarukyK>mjZaruky.rok</mjZarukyK>
                    </xsl:otherwise>
                </xsl:choose>
                </xsl:if>
                <poznam><xsl:value-of select="Poznámka"/></poznam>
            </cenik>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>
