<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:template match="/Root">
        <winstrom version="1.0">
            <xsl:apply-templates select="Seznam_firem_Pobočky"/>
        </winstrom>
    </xsl:template>

    <xsl:template match="/Seznam_firem_Pobočky">
        <winstrom version="1.0">
            <xsl:apply-templates select="Seznam_firem_Pobočky"/>
        </winstrom>
    </xsl:template>

<!--
/usr/share/flexibee/bin/flexibee2xml -t misto-urceni-in.xslt -x pobocky.xml -o misto-urceni.xml
-->

<!--

        <Seznam_firem_Pobočky>
                <Název_pobočky>Centrum integrovaných služeb, spol. s r.o.</Název_pobočky>	X
                <Ulice></Ulice>									X
                <Sídlo>PLZEŇ - Doudlevce</Sídlo>						X
                <PSČ>301 34</PSČ>								X
                <Jméno_zástupce>Zborovská 37</Jméno_zástupce>					X
                <_Číslo_pobočky>1</_Číslo_pobočky>						X
                <Poznámka>tel. 377 487 121</Poznámka>						X
                <Fakturační>false</Fakturační>				
                <Stát></Stát>
        </Seznam_firem_Pobočky>

-->

    <xsl:template match="Seznam_firem_Pobočky">
        <misto-urceni>
	    <firma>code:0</firma>
	    <xsl:choose>
		<xsl:when test="Název_pobočky != ''">
        	    <nazev><xsl:value-of select="Název_pobočky"/></nazev>
        	    <popis><xsl:value-of select="Jméno_zástupce"/></popis>
		</xsl:when>
		<xsl:when test="Jméno_zástupce != ''">
                    <nazev><xsl:value-of select="Jméno_zástupce"/></nazev>
		</xsl:when>
		<xsl:when test="Ulice != ''">
                    <nazev><xsl:value-of select="Ulice"/></nazev>
		</xsl:when>
		<xsl:when test="Poznámka != ''">
                    <nazev><xsl:value-of select="Poznámka"/></nazev>
		</xsl:when>
		<xsl:otherwise>
                    <nazev><xsl:value-of select="_Číslo_pobočky"/></nazev>
		</xsl:otherwise>
	    </xsl:choose>
            <ulice><xsl:value-of select="Ulice"/></ulice>
            <mesto><xsl:value-of select="Sídlo"/></mesto>
            <psc><xsl:value-of select="PSČ"/></psc>

            <poznam><xsl:value-of select="Poznámka"/></poznam>
        </misto-urceni>
    </xsl:template>

</xsl:stylesheet>
