<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

<!--
        <Objedn.prij.>
                <Číslo_objedn.>988002</Číslo_objedn.> 	X
                <Odběr.č.obj.></Odběr.č.obj.>		X
                <Odběratel>1035</Odběratel>		X
                <Pobočka>0</Pobočka>                    ?
                <Zpracoval>12</Zpracoval>		?
                <Datum_příjmu>12.10.98</Datum_příjmu>	X
                <Obsahuje>chemie</Obsahuje>
                <Středisko>800</Středisko>		X
                <Ind.potvrzení>Nepravda</Ind.potvrzení>
                <Příjemce></Příjemce>
                <Způsob_dopravy></Způsob_dopravy>
                <Volba_adresy>Nepravda</Volba_adresy>
                <Úvodní_text></Úvodní_text>		X
                <Doplň.text></Doplň.text>		X
                <Bank.spojení>132644211/0100</Bank.spojení>
                <Termín_dodání>23.10.98</Termín_dodání>   	X
                <Ind.plnění>Pravda</Ind.plnění>
                <Hodnota_obj.>7662</Hodnota_obj.>		X
                <Ind.pln.naobj.>Nepravda</Ind.pln.naobj.>
                <Č.faktury>0</Č.faktury>			X
                <Typ_dodávky>1</Typ_dodávky>
                <Zablokována>Nepravda</Zablokována>
                <Kód_měny></Kód_měny>
                <Kurs>0</Kurs>
                <Zakázka></Zakázka>				X
                <V_jazyce>0</V_jazyce>
                <Smluvní_sleva>0</Smluvní_sleva>
                <Č.dealera></Č.dealera>
                <Jméno></Jméno>
                <Exportováno>Nepravda</Exportováno>
                <Poznámka></Poznámka>				X
                <K_expedici>Nepravda</K_expedici>
                <Platba>0</Platba>
                <Dodací_listy>Nepravda</Dodací_listy>		X
                <Vlastní_firma>Nepravda</Vlastní_firma>
                <Přepravní_list>0</Přepravní_list>
        </Objedn.prij.>
-->

    <xsl:variable name="radkyDoc" select="document('obj-prij-radky.xml')"/>

    <xsl:key name="cisloKey" match="Řádky_př.obj." use="Číslo_objedn."/>

    <xsl:template match="/Objedn.prij.">
        <winstrom version="1.0">
		<xsl:apply-templates select="*[local-name() = 'Objedn.prij.' and position() &lt; 100]"/>
        	<xsl:apply-templates select="Objedn.prij."/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t objednavka-prijata-in.xslt -x obj-prij.xml -o 5-objednavka-prijata.xml
-->

    <xsl:template match="Objedn.prij.">
	    <xsl:variable name="cislo" select="Číslo_objedn."/>

        <objednavka-prijata>
            <id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></id>
            <typDokl>code:HISTORICKÁ</typDokl>
            <kod><xsl:value-of select="java:flexibee.Tool.toUpper($cislo)"/></kod>
	    <cisDosle><xsl:value-of select="Odběr.č.obj."/></cisDosle>
            <datVyst><xsl:value-of select="java:flexibee.Tool.parseDate(Datum_příjmu, 'd.M.y')"/></datVyst>
            <datTermin><xsl:value-of select="java:flexibee.Tool.parseDate(Termín_dodání, 'd.M.y')"/></datTermin>

	    <xsl:if test="Odběratel != '' and Odběratel != 'False' and Odběratel != '0'">
        	<firma>ext:4DD-ADR:<xsl:value-of select="Odběratel"/></firma>
	    </xsl:if>

	    <xsl:choose>
		<xsl:when test="Zablokována = 'Pravda'">
		    <stavUzivK>stavDoklObch.storno</stavUzivK>
		</xsl:when>
		<xsl:when test="Ind.plnění = 'Pravda'">
		    <stavUzivK>stavDoklObch.hotovo</stavUzivK>
		</xsl:when>
		<xsl:when test="Ind.potvrzení = 'Pravda'">
		    <stavUzivK>stavDoklObch.schvaleno</stavUzivK>
		</xsl:when>
		<xsl:when test="K_expedici = 'Pravda'">
		    <stavUzivK>stavDoklObch.pripraveno</stavUzivK>
		</xsl:when>
	    </xsl:choose>

	    <stredisko if-not-found="null">ext:4DD-STRED:<xsl:value-of select="Středisko"/></stredisko>
	    <xsl:if test="Zakázka != ''">
	    	<zakazka>ext:4DD-ZAK:<xsl:value-of select="Zakázka"/></zakazka>
	    </xsl:if>

		<xsl:for-each select="$radkyDoc">
			<xsl:choose>
                    	    <xsl:when test="key('cisloKey',$cislo)[1]/Sklad_výdeje != ''">
                        	<bsp>code:<xsl:value-of select="java:flexibee.Tool.toUpper(key('cisloKey',$cislo)[1]/Sklad_výdeje)"/>_HISTORIE</bsp>
                    	    </xsl:when>
                    	    <xsl:otherwise>
                        	<bsp>code:XXX_HISTORIE</bsp>
			    </xsl:otherwise>
                        </xsl:choose>
		</xsl:for-each>


	    <xsl:if test="Smluvní_sleva != '0'">
		<slevaDokl><xsl:value-of  select="java:flexibee.Tool.parseMoney(Smluvní_sleva)"/></slevaDokl>
	    </xsl:if>

            <uvodTxt><xsl:value-of select="Úvodní_text"/></uvodTxt>
            <zavTxt><xsl:value-of select="Doplň.text"/></zavTxt>
            <poznam><xsl:value-of select="Poznámka"/></poznam>
	    <popis>Hodnota: <xsl:value-of select="Hodnota_obj"/>
		   <xsl:if test="Obsahuje != ''">, <xsl:value-of select="Obsahuje"/></xsl:if>
		   <xsl:if test="Bank.spojení != ''">, Bankovní spojení: <xsl:value-of select="Bank.spojení"/></xsl:if>
		   <xsl:if test="Č.faktury != '0'">, číslo faktury: <xsl:value-of select="Č.faktury"/></xsl:if>
		   <xsl:if test="Přepravní_list != '0'">, číslo přepravního listu: <xsl:value-of select="Přepravní_list"/></xsl:if>
		</popis>

	    <polozkyObchDokladu>

		<xsl:for-each select="$radkyDoc">
		    <xsl:for-each select="key('cisloKey',$cislo)">

<!--
        <Řádky_př.obj.>
                <Číslo_objedn.>988003</Číslo_objedn.>		X
                <Řádek>2</Řádek>
                <Kód_položky>5627500</Kód_položky>		X
                <Č.obj._řádek>988003/2</Č.obj._řádek>		X
                <J.cena_prod.>213</J.cena_prod.>		X
                <Celk.množství>1</Celk.množství>		X
                <Obal>0</Obal>
                <Sklad>002</Sklad>
                <Kód_odběr.></Kód_odběr.>
                <Proc.sleva>0</Proc.sleva>
                <Dodat>0</Dodat>
                <Název_položky>Purex K 10 kg</Název_položky>	X
                <Měrná_jednotka>ks</Měrná_jednotka>
                <Poznámka></Poznámka>
                <Výrobce></Výrobce>
                <Snížená_sazba_DPH>Nepravda</Snížená_sazba_DPH>
                <J.cena_nák.>0</J.cena_nák.>
                <Expedováno>0</Expedováno>
        </Řádky_př.obj.>
-->

			<xsl:if test="Množství != 0 or J.cena_nák. != 0 or Kód_položky != ''">
			    <objednavka-prijata-polozka>
				<id>ext:4DD-VYD:<xsl:value-of select="java:flexibee.Tool.toUpper(Číslo_objedn.)"/>-<xsl:value-of select="java:flexibee.Tool.toUpper(Řádek)"/></id>
				<xsl:choose>
				    <xsl:when test="Kód_položky != ''">
					<typPolozkyK>typPolozky.katalog</typPolozkyK>
					<cenik if-not-found="null">ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_položky)"/></cenik>
					<kod><xsl:value-of select="Kód_položky"/></kod>
					<xsl:choose>
                    			    <xsl:when test="Sklad != ''">
                        			<sklad>code:<xsl:value-of select="java:flexibee.Tool.toUpper(Sklad)"/>_HISTORIE</sklad>
                    			    </xsl:when>
                    			    <xsl:otherwise>
                        			<sklad>code:XXX_HISTORIE</sklad>
					    </xsl:otherwise>
                    			</xsl:choose>
				    </xsl:when>
				    <xsl:otherwise>
					<typPolozkyK>typPolozky.obecny</typPolozkyK>
				    </xsl:otherwise>
				</xsl:choose>
				<nazev><xsl:value-of select="Název_položky"/></nazev>
				<xsl:choose>
				    <xsl:when test="Celk.množství != '0'">
					<mnozMj><xsl:value-of select="java:flexibee.Tool.parseMoney(Celk.množství)"/></mnozMj>
				    </xsl:when>
				    <xsl:otherwise>
					<mnozMj>1</mnozMj>
				    </xsl:otherwise>
				</xsl:choose>
    				<cenaMj><xsl:value-of select="java:flexibee.Tool.parseMoney(J.cena_prod.)"/></cenaMj>
				<slevaPol><xsl:value-of select="Proc.sleva"/></slevaPol>
				<poznam><xsl:value-of select="Poznámka"/></poznam>


			    </objednavka-prijata-polozka>
			</xsl:if>
		    </xsl:for-each>
		</xsl:for-each>
	    </polozkyObchDokladu>
        </objednavka-prijata>

    </xsl:template>

</xsl:stylesheet>
