<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
     xmlns:java="http://xml.apache.org/xalan/java" exclude-result-prefixes="java"
>
    <xsl:output method="xml" indent="yes" encoding="utf-8" />

    <xsl:variable name="radkyDoc" select="document('prodejky-radky.xml')"/>

    <xsl:key name="cisloKey" match="_Řádky_prodejek" use="_Číslo_prodejky"/>

    <xsl:template match="/Root">
        <winstrom version="1.0" atomic="false">
            <!--<xsl:apply-templates select="*[local-name() = 'Prodejky' and position() &lt; 100]"/> -->
            <xsl:apply-templates select="Prodejky"/>
        </winstrom>
    </xsl:template>


<!--
/usr/share/flexibee/bin/flexibee2xml -t prodejka-skladova-karta-in.xslt -x prodejky.xml -o prodejky-karta.xml
kod, nazev
-->

    <xsl:template match="Prodejky">
      <xsl:if test="Datum_zdan.plnění != '0000-00-00'">
            <xsl:variable name="cislo" select="_Číslo_prodejky"/>
	    <xsl:variable name="datum" select="java:flexibee.Tool.formatDate(java:flexibee.Tool.parseDate(Datum_zdan.plnění, 'd.M.y'), 'yyyy')"/>

	<xsl:for-each select="$radkyDoc">
	    <xsl:for-each select="key('cisloKey',$cislo)">
                <xsl:if test="Kód_EAN != '' and Kód_EAN != ' '">
		    <skladova-karta update="ignore">
			<id>ext:4DD-SKL-<xsl:value-of select="$datum"/>-XXX_HISTORIE-<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
        		<ucetObdobi>code:<xsl:value-of select="$datum"/></ucetObdobi>
			<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
				<sklad>code:XXX_HISTORIE</sklad>
		    </skladova-karta>
                </xsl:if>
	    </xsl:for-each>
	</xsl:for-each>
	  </xsl:if>
	  <xsl:if test="Datum_zdan.plnění = '0000-00-00'">
            <xsl:variable name="cislo" select="_Číslo_prodejky"/>
	    <xsl:variable name="datum" select="java:flexibee.Tool.formatDate(java:flexibee.Tool.parseDate(Datum, 'd.M.y'), 'yyyy')"/>

	<xsl:for-each select="$radkyDoc">
	    <xsl:for-each select="key('cisloKey',$cislo)">
                <xsl:if test="Kód_EAN != '' and Kód_EAN != ' '">
		    <skladova-karta update="ignore">
			<id>ext:4DD-SKL-<xsl:value-of select="$datum"/>-XXX_HISTORIE-<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></id>
        		<ucetObdobi>code:<xsl:value-of select="$datum"/></ucetObdobi>
			<cenik>ean:<xsl:value-of select="java:flexibee.Tool.toUpper(Kód_EAN)"/></cenik>
				<sklad>code:XXX_HISTORIE</sklad>
		    </skladova-karta>
                </xsl:if>
	    </xsl:for-each>
	</xsl:for-each>
	  </xsl:if>
    </xsl:template>

</xsl:stylesheet>
